//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot.cpp
//

#include "general_header.h"
#include "usercmd.h"
#include <assert.h>

#ifdef classstuff
CBotManager *pBotManager = NULL;
#endif

#include <sys/types.h>
#include <sys/stat.h>

void ExecuteBotCommands(void);

//static FILE *fp;

#ifndef __linux__
extern HINSTANCE h_Library;
#else
extern void *h_Library;
#endif
extern edict_t *listenserver_edict;
extern bool debug_mode;

extern bool borg_mode;

extern float BotDebugAimXSpeed;
extern float BotDebugAimYSpeed;
extern float BotDebugAimDelay;
extern float BotDebugDelayForAimDelay;
extern float DebugAimFactor;

extern WAYPOINT waypoints[MAX_WAYPOINTS];
extern int num_waypoints;  // number of waypoints currently in use
extern int default_bot_skill;

extern int bot_chat_percent;
extern int bot_taunt_percent;
extern int bot_whine_percent;
extern int bot_chat_tag_percent;
extern int bot_chat_drop_percent;
extern int bot_chat_swap_percent;
extern int bot_chat_lower_percent;

extern bool should_bot_chat;
extern bool LockedAutoCam;

extern int bot_teleport_percent;

extern bot_chat_t bot_chat[MAX_BOT_CHAT];
extern bot_chat_t bot_whine[MAX_BOT_CHAT];
extern int bot_chat_count;
extern int bot_whine_count;
extern int recent_bot_chat[];
extern int recent_bot_whine[];

extern int whine_count;

extern float EnemySearchDelays[5][2];

extern ClientInfo_t ClientInfo[32];

extern edict_t *pHostViewPlayer;

extern BotPersonality_t BotPersonalities[9];
extern short DefaultPersonality;

bot_t bots[32];   // max of 32 bots in a game
SBotSettings_t SBotSettings[3];

#ifdef _DEBUG
//#define SBotFights
#endif

void CmdStart( const edict_t *player, const struct usercmd_s *cmd, unsigned int random_seed );
void CmdEnd ( const edict_t *player );

extern bool follow_mode;
 
bool b_observer_mode = FALSE;
bool b_botdontshoot = FALSE;
bool BotDontSearchEnemy = false;
bool BotShouldMove = true;
bool BotDoCombos = true;
bool BotsUseDiscs = true;
bool BotsAreIdle = false;
bool BotsAlwaysTryToAscend = false;

extern float OldPlCatchupValue;

extern int recent_bot_whine[5];

int number_names = 0;

#define MAX_BOT_NAMES 100

char bot_names[MAX_BOT_NAMES][BOT_NAME_LEN+1];

float AimDelays[5][2] =
{
	{0.15, 0.25},
	{0.25, 0.30},
	{0.30, 0.35},
	{0.45, 0.50},
	{0.90, 1.25}
};

float AimXSpeeds[5][2] =
{
	{230.0, 255.0},
	{200.0, 215.0},
	{140.0, 175.0},
	{105.0, 120.0},
	{60.0, 90.0}
};

float AimYSpeeds[5][2] =
{
	{210.0, 230.0},
	{175.0, 190.0},
	{125.0, 140.0},
	{100.0, 110.0},
	{90.0, 100.0}
};

float AimXOffsets[5][2] =
{
	{15.0f, 20.0f},
	{20.0f, 25.0f},
	{25.0f, 30.0f},
	{35.0f, 40.0f},
	{45.0f, 50.0f}
};

float AimYOffsets[5][2] =
{
	{10.0f, 15.0f},
	{15.0f, 20.0f},
	{20.0f, 25.0f},
	{25.0f, 30.0f},
	{30.0f, 35.0f}
};

inline edict_t *CREATE_FAKE_CLIENT( const char *netname )
{
   return (*g_engfuncs.pfnCreateFakeClient)( netname );
}

inline char *GET_INFOBUFFER( edict_t *e )
{
   return (*g_engfuncs.pfnGetInfoKeyBuffer)( e );
}

inline char *GET_INFO_KEY_VALUE( char *infobuffer, char *key )
{
   return (g_engfuncs.pfnInfoKeyValue( infobuffer, key ));
}

inline void SET_CLIENT_KEY_VALUE( int clientIndex, char *infobuffer,
                                  char *key, char *value )
{
   (*g_engfuncs.pfnSetClientKeyValue)( clientIndex, infobuffer, key, value );
}

// this is the LINK_ENTITY_TO_CLASS function that creates a player (bot)
void player( entvars_t *pev )
{
   static LINK_ENTITY_FUNC otherClassName = NULL;
   if (otherClassName == NULL)
      otherClassName = (LINK_ENTITY_FUNC)GetProcAddress(h_Library, "player");
   if (otherClassName != NULL)
   {
      (*otherClassName)(pev);
   }
}


void BotNameInit( void )
{
   FILE *bot_name_fp;
   char bot_name_filename[256];
   int str_index;
   char name_buffer[80];
   int length, index;

   UTIL_BuildFileName(bot_name_filename, "bot_names.txt", NULL);

   bot_name_fp = fopen(bot_name_filename, "r");

   (*g_engfuncs.pfnServerPrint) ("Reading bot_names file... ");
   if (bot_name_fp != NULL)
   {
      while ((number_names < MAX_BOT_NAMES) &&
             (fgets(name_buffer, 80, bot_name_fp) != NULL))
      {
         length = strlen(name_buffer);

         if (name_buffer[length-1] == '\n')
         {
            name_buffer[length-1] = 0;  // remove '\n'
            length--;
         }

         str_index = 0;
         while (str_index < length)
         {
            if ((name_buffer[str_index] < ' ') || (name_buffer[str_index] > '~') ||
                (name_buffer[str_index] == '"'))
            for (index=str_index; index < length; index++)
               name_buffer[index] = name_buffer[index+1];
 
            str_index++;
         }

         if (name_buffer[0] != 0)
         {
            strncpy(bot_names[number_names], name_buffer, BOT_NAME_LEN);

            number_names++;
         }
      }
      fclose(bot_name_fp);
	  (*g_engfuncs.pfnServerPrint) ("done\n");
   }
   else
	  (*g_engfuncs.pfnServerPrint) ("file not found\n");
}


void BotPickName( char *name_buffer )
{
   int name_index, index;
   bool used;
   edict_t *pPlayer;
   int attempts = 0;

   if (RANDOM_LONG(1, 100) <= 50)
   {
	   // see if a name exists from a kicked bot (if so, reuse it)
	   for (index=0; index < 32; index++)
	   {
		   if ((bots[index].is_used == FALSE) && (bots[index].name[0]))
		   {
			   strcpy(name_buffer, bots[index].name);
			   return;
		   }   
	   }
   }

   name_index = RANDOM_LONG(1, number_names) - 1;  // zero based

   // check make sure this name isn't used
   used = TRUE;

   while (used)
   {
      used = FALSE;

      for (index = 1; index <= gpGlobals->maxClients; index++)
      {
         pPlayer = INDEXENT(index);

         if (pPlayer && !pPlayer->free)
         {
            if (strcmp(bot_names[name_index], STRING(pPlayer->v.netname)) == 0)
            {
               used = TRUE;
               break;
            }
         }
      } 

      if (used)
      {
         name_index++;

         if (name_index == number_names)
            name_index = 0;

         attempts++;

         if (attempts == number_names)
            used = FALSE;  // break out of loop even if already used
      }
   }

   strcpy(name_buffer, bot_names[name_index]);
}

#ifdef classstuff

void CBot::CreateInit(short Team, short Class, short Skill, short Perso, short SBotVal)
{
	pEdict->v.flags |= FL_FAKECLIENT;
	m_eRespawnState = SPAWN_IDLE;
    m_fCreateTime = gpGlobals->time;
    m_bNotStarted = true;  // hasn't joined game yet
    m_eStartAction = START_IDLE;
	m_bNeedToInitialize = false;  // don't need to initialize yet

	m_pLastEnemy = NULL;

    SpawnInit();

    m_bBotSkill = Skill - 1;  // 0 based for array indexes

    m_sBotTeam = -1;
    m_sBotClass = -1;

	if ((Team == 1) || (Team == 2))
		m_sBotTeam = Team;

	if ((Class >= 1) && (Class <= 9))
		m_sBotClass = Class;

	if ((Perso < 1) || (Perso > 9))
	{
		if ((DefaultPersonality >= 1) && (DefaultPersonality <= 9))
			Perso = DefaultPersonality;
		else
			Perso = RANDOM_LONG(1, 9);
	}

	m_pPersonality = &BotPersonalities[Perso - 1];

	m_lVisiblePlayers = m_lPlayersChecked = 0;

	m_pCurrentBotTask = NULL;
	m_pCurrentBotSubTask = NULL;

	if (SBotVal > 3)
		SBotVal = RANDOM_LONG(1, 3);
	m_sSBotType = SBotVal;
}

void CBot::CheckSBotStuff()
{
	if (pEdict->v.renderfx != kRenderFxGlowShell)
		pEdict->v.rendermode = kRenderTransTexture;

	// when on low health, fade in - fade out or when transparency_val == -1
	if ((pEdict->v.health < 10) || (SBotSettings[m_sSBotType-1].transparency_val == -1) &&
		(pEdict->v.renderfx != kRenderFxGlowShell))
	{
		if (m_sTransparantValue < 20)
			m_sTransparantFactor = 1;
		else if (m_sTransparantValue >= 255)
			m_sTransparantFactor = -1;

		m_sTransparantValue += (3 * m_sTransparantFactor);
	
		if (m_sTransparantValue > 255)
			m_sTransparantValue = 255;
		else if (m_sTransparantValue < 0)
			m_sTransparantValue = 0;

		pEdict->v.renderamt = m_sTransparantValue;
	}
	else
	{
		if (pEdict->v.renderfx != kRenderFxGlowShell)
			pEdict->v.renderamt = SBotSettings[m_sSBotType-1].transparency_val;
	}

	if (m_fUpdateStatsDelay < gpGlobals->time)
	{
		m_fUpdateStatsDelay = gpGlobals->time + 1.0;
		if (GetPl() < SBotSettings[m_sSBotType-1].pl)
		{
			SetPl(SBotSettings[m_sSBotType-1].pl);
			SetRealPl(SBotSettings[m_sSBotType-1].pl);
		}
		
		if (GetKi() < 1000)
		{
			if (SBotSettings[m_sSBotType-1].ki_gain == -1)
				SetKi(1000);
			else
			{
				int NewKiValue = GetKi() + SBotSettings[m_sSBotType-1].ki_gain;
				if (NewKiValue > 1000)
					NewKiValue = 1000;
				SetKi(NewKiValue);
			}
		}

		if (GetHealth() < GetMaxHealth())
		{
			if (SBotSettings[m_sSBotType-1].health_gain == -1)
				SetHealth(GetMaxHealth());
			else
			{
				short NewHealth = pEdict->v.health + SBotSettings[m_sSBotType-1].health_gain;
				if (NewHealth > GetMaxHealth())
					NewHealth = GetMaxHealth();
				SetHealth(NewHealth);
			}
		}
	}


	char s[10];
	sprintf(s,"[SBot%i]",m_sSBotType);

	char BotName[32] = "";
	sprintf(BotName,STRING(pEdict->v.netname));

	bool NotDoubleNamed = true;

	if (strstr(BotName,s) == NULL)
		NotDoubleNamed = false;

    if ((strncmp(s, STRING(pEdict->v.netname), 7) != 0) &&
		(NotDoubleNamed == false))
	{
        char *infobuffer;
        int clientIndex;
        infobuffer = g_engfuncs.pfnGetInfoKeyBuffer( pEdict );
	    clientIndex = ENTINDEX( pEdict );
	    char newname[32];
 	    sprintf(newname, "%s%s", s, STRING(pEdict->v.netname));
  
        g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "name", newname );
    }
}

bool CBot::IsValidEnemy(CClient *pClient)
{
	if (UTIL_IsValidPlayer(pClient) == false)
		return false;

   	// is team play enabled?
	if (IsTeamPlay())
	{
		// don't target your teammates...
		if (GetTeam() == pClient->GetTeam())
		{
			return false;
		}	
	}

	Vector vecEnemy = pClient->GetGunPosition();

	Vector v_dist = vecEnemy - GetGunPosition();
	v_dist.z = 0;
	float distance = v_dist.Length();

	bool OnScouter = ((distance <= 2300.0) || (IsSuperBot()));
	bool InViewCone = (FInViewCone(&vecEnemy));

	if ((!InViewCone) && (!OnScouter) && (!MadeASound()))
		return false;

	// Check if there is an player list, saves us a traceline :)
	if (m_bMadePlayerList)
	{
		return ((m_lPlayersChecked & (ENTINDEX(pClient->pEdict) - 1)) != 0);
	}
	else
	{
		// We have to use a traceline :(
		return (FVisible(vecEnemy));
	}

	return false;
}

void CBot::BotStartGame()
{
	char c_team[32];
    char c_class[32];

    int index;

    edict_t *pPlayer;
    int team;

    if (m_eStartAction == START_MOTD)
    {
		if (RANDOM_LONG(1, 100) < 50)
			pEdict->v.button = IN_ATTACK;
	    return;
    }
  
    if ((m_eStartAction == START_IDLE) &&
        (m_fCreateTime + 3.0 <= gpGlobals->time))
    {
		m_eStartAction = START_TEAM_SELECT;  // force team selection
    }

    if (m_eStartAction == START_TEAM_SELECT)
    {
		m_eStartAction = START_IDLE;  // switch back to idle
        m_fCreateTime = gpGlobals->time;  // reset

        if ((m_sBotTeam != 1) && (m_sBotTeam != 2)) 
            m_sBotTeam = -1;

        if (m_sBotTeam == -1)
        {
			int CountGood, CountEvil;
			CountGood = CountEvil = 0;

			for(index=1;index<=gpGlobals->maxClients;index++)
			{
				pPlayer = INDEXENT(index);
				if (UTIL_IsValidPlayer(pPlayer), false)
				{
					if (UTIL_GetTeam(pPlayer) == 0)
						CountGood++;
					else
						CountEvil++;
				}
			}

			if (CountGood > CountEvil)
				m_sBotTeam = 2;
			else if (CountGood < CountEvil)
				m_sBotTeam = 1;
			else
				m_sBotTeam = RANDOM_LONG(1, 2);
		}

        // select the team the bot wishes to join...
        if (m_sBotTeam == 1)
            strcpy(c_team, "1");
        else if (m_sBotTeam == 2)
            strcpy(c_team, "2");
        else 
            strcpy(c_team, "5");

        FakeClientCommand(pEdict, "jointeam", c_team, NULL);
        m_eStartAction = START_CLASS_SELECT;
        return;
	}

    if (m_eStartAction == START_CLASS_SELECT)
    {
		char *cvar_realteams = (char *)CVAR_GET_STRING("mp_realteams");
		char *cvar_charlimit = (char *)CVAR_GET_STRING("mp_characterlimit");

		m_eStartAction = START_IDLE;  // switch back to idle
        m_fCreateTime = gpGlobals->time;  // reset

        if ((m_sBotClass < 1) || (m_sBotClass > 9))
            m_sBotClass = -1;

        if (m_sBotClass == -1)
            m_sBotClass = RANDOM_LONG(1, 9);

        team = UTIL_GetTeam(pEdict);

        if ((cvar_realteams && cvar_realteams[0]) && (strncmp(cvar_realteams, "1", 1) == 0) && 
			(IsTeamPlay()))
		{
			if (m_sBotTeam == 1)
			{
				if ((m_sBotClass != 2) && (m_sBotClass != 3) && (m_sBotClass != 4) &&
					(m_sBotClass != 6) && (m_sBotClass != 7))
				{
					if (RANDOM_LONG(1, 2) < 2)
						m_sBotClass = RANDOM_LONG(2, 4);
					else
						m_sBotClass = RANDOM_LONG(6, 7);
				}
			}
			else
			{
				if ((m_sBotClass != 1) && (m_sBotClass != 5) && (m_sBotClass != 8) &&
					(m_sBotClass != 9))
				 {
					int i = RANDOM_LONG(1, 3);

                    switch (i)
					{
					case 1:
						m_sBotClass = 1;
						break;
					case 2:
						m_sBotClass = 5;
						break;
					case 3:
						m_sBotClass = RANDOM_LONG(8, 9);
						break;
					default:
						break;
					}
				}
			}
		}

		// Is there a class limit?
		if ((cvar_charlimit && cvar_charlimit[0]) && (strncmp(cvar_charlimit, "0", 1) != 0))
		{
			short CharLimitCVarVal = static_cast<short>(CVAR_GET_FLOAT("mp_characterlimit"));

			if ((CharLimitCVarVal >= 1) && (CharLimitCVarVal <= 9))
				m_sBotClass = CharLimitCVarVal;
		}

        // select the class the bot wishes to use...
        if (m_sBotClass == 1)
            strcpy(c_class, "buu");
        else if (m_sBotClass == 2)
            strcpy(c_class, "goku");
        else if (m_sBotClass == 3)
            strcpy(c_class, "gohan");
        else if (m_sBotClass == 4)
            strcpy(c_class, "krillin");
        else if (m_sBotClass == 5)
            strcpy(c_class, "frieza");
        else if (m_sBotClass == 6)
            strcpy(c_class, "piccolo");
        else if (m_sBotClass == 7)
            strcpy(c_class, "trunks");
        else if (m_sBotClass == 8)
            strcpy(c_class, "vegeta");
        else if (m_sBotClass == 9)
            strcpy(c_class, "cell");
	    else 
	        strcpy(c_class, "randompc");

        FakeClientCommand(pEdict, c_class, NULL, NULL);

        // bot has now joined the game (doesn't need to be started)
        m_bNotStarted = false;

        return;
	}
}

void CBot::DeadThink()
{
	lcout << "Bot " << STRING(pEdict->v.netname) << " is dead :(\n";
    const char *bot_name;
   
    char chat_text[81];
    char chat_name[64];
    char temp_name[64];

	if (m_bNeedToInitialize)
	{
		m_bNeedToInitialize = false;
		SpawnInit();

        // did another player kill this bot AND bot whine messages loaded AND
        // has the bot been alive for at least 15 seconds AND
        if ((m_pKillerEdict != NULL) && (bot_whine_count > 0) &&
            ((m_fBotSpawnTime + 15.0) <= gpGlobals->time) && (pBotManager->m_bShouldBotsChat))
        {
            int whine_index = 0; //EEKHOORN GAVE THIS ONE A VALUE
            bool used;
            int i, recent_count;

            if ((RANDOM_LONG(1,100) <= m_pPersonality->whine_percent))
            {
				// set chat flag and time to chat...
                m_bBotShouldSay = true;
                m_fBotSayTime = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);

                recent_count = 0;

                while (recent_count < 5)
                {
					whine_index = RANDOM_LONG(0, bot_whine_count-1);

                    used = FALSE;

                    for (i=0; i < 5; i++)
					{
						if (recent_bot_whine[i] == whine_index)
						    used = TRUE;
					}

					if (used)
						recent_count++;
					else
						break;
                }
				
				for (i=4; i > 0; i--)
					recent_bot_whine[i] = recent_bot_whine[i-1];

                recent_bot_whine[0] = whine_index;

                if (bot_whine[whine_index].can_modify)
					BotChatText(bot_whine[whine_index].text, chat_text);
				else
					strcpy(chat_text, bot_whine[whine_index].text);

                if (m_pKillerEdict->v.netname)
                {
					strncpy(temp_name, STRING(m_pKillerEdict->v.netname), 31);
                    temp_name[31] = 0;

                    BotChatName(temp_name, chat_name);
                }
                else
					strcpy(chat_name, "NULL");

                bot_name = STRING(pEdict->v.netname);

                BotChatFillInName(m_szBotSayMsg, chat_text, chat_name, bot_name);
			}
		}
	}

	// Press randomly on fire so that the bot respawn
    if (RANDOM_LONG(1, 100) > 50)
		pEdict->v.button = IN_ATTACK;
}

void CBot::BotPreThink()
{
	char chat_text[81];
	char chat_name[64];
	const char *bot_name;

    if (m_bMadePlayerList == true)
		m_bMadePlayerList = false;

    if (m_bPlayerCount != 0)
		m_bPlayerCount = 0;

	// Auto client stuff disabled for now
/*
    if (pEdict == listenserver_edict)
    {
		char s[100];

	    if (LockedAutoCam)
			pEdict->v.fixangle = 1;
	   else
		   pEdict->v.fixangle = 0;

	   if (strncmp("[AUTO]", STRING(pEdict->v.netname), 6) != 0)
	   {
		   sprintf(pBot->old_name, STRING(pEdict->v.netname));

           char *infobuffer;
	       int clientIndex;
	       infobuffer = g_engfuncs.pfnGetInfoKeyBuffer( pEdict );
		   clientIndex = ENTINDEX( pEdict );
		   sprintf(s, "[AUTO]%s", STRING(pEdict->v.netname));
	  
	       g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "name", s );
	   }
   }
   else*/

	pEdict->v.flags |= FL_FAKECLIENT;

	if (m_szName[0] == 0)  // name filled in yet?
		strcpy(m_szName, STRING(pEdict->v.netname));

	// Leon Hartwig method to calculate the msec value....
    m_fMSecVal = (int) ((gpGlobals->time - m_fPrevPlayermoveTime) * 1000);
    if (m_fMSecVal > 255)
		m_fMSecVal = 255;
   
    m_fFrameTime = m_fMSecVal / 1000;  // calculate frame time
    m_fPrevPlayermoveTime = gpGlobals->time; // save date at which the last RunPlayerMove call happened

    pEdict->v.button = 0; // reset buttons
    m_fMoveSpeed = 0.0;

    // does bot need to say a message and time to say a message?
    if ((m_bBotShouldSay) && (m_fBotSayTime < gpGlobals->time))
    {
		m_bBotShouldSay = false;
		UTIL_HostSay(pEdict, 0, m_szBotSayMsg);
    }

	// Are there any chat messages AND is it time to chat AND should bot chats at all AND does
	// this bot has no enemy AND is this bot not a autoplayer?
    if ((bot_chat_count > 0) && (m_fBotChatTime < gpGlobals->time) && 
		(pBotManager->m_bShouldBotsChat) && (m_pBotEnemy == NULL) && 
		(pEdict != listenserver_edict))
    {
		m_fBotChatTime = gpGlobals->time + RANDOM_FLOAT(20, 40);

        if (RANDOM_LONG(1,100) <= m_pPersonality->chat_percent)
		{
			int chat_index = 0; //EEKHOORN GAVE THIS ONE A VALUE
			bool used;
			int i, recent_count;

            // set chat flag and time to chat...
			m_bBotShouldSay = true;
			m_fBotSayTime = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);
			
			recent_count = 0;

			while (recent_count < 5)
			{
				chat_index = RANDOM_LONG(0, bot_chat_count-1);

				used = FALSE;

				for (i=0; i < 5; i++)
				{
					if (recent_bot_chat[i] == chat_index)
						used = TRUE;
				}

				if (used)
					recent_count++;
				else
					break;
			}

			for (i=4; i > 0; i--)
				recent_bot_chat[i] = recent_bot_chat[i-1];

			recent_bot_chat[0] = chat_index;

			if (bot_chat[chat_index].can_modify)
				BotChatText(bot_chat[chat_index].text, chat_text);
			else
				strcpy(chat_text, bot_chat[chat_index].text);

			strcpy(chat_name, STRING(pEdict->v.netname));

			bot_name = STRING(pEdict->v.netname);

			FillInName(m_szBotSayMsg, chat_text, chat_name, bot_name);
		}
    }

    if (IsSuperBot())
		CheckSBotStuff();

#ifdef LOGBOTINFO
   if (pBot->CurrentBotTask)
	   clog << "Current task: " << int(pBot->CurrentBotTask->TaskIdentify()) << "\n";
   clog << "Prev task: " << int(pBot->PrevTask) << "\n";
#endif

    return;
}

void CBot::Think()
{
#ifdef LOGBOTINFO
	clog << "Begin bot think\n";
#endif

	CClient::Think();

    // if the bot hasn't selected stuff to start the game yet, go do that...
    if (m_bNotStarted)
    {
		BotStartGame();
		
		g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, 0.0,
                                   0, 0, pEdict->v.button, 0, m_fMSecVal);
		return;
    }

    if (IsAlive() == false)
    {
		DeadThink();
		
		g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, m_fMoveSpeed,
                                   0, 0, pEdict->v.button, 0, m_fMSecVal);
        return;
    }

	// set this for the next time the bot dies so it will initialize stuff
    if (m_bNeedToInitialize == false)
    {
		m_bNeedToInitialize = true;
		m_fBotSpawnTime = gpGlobals->time;
    }

	// Turn turbo off when the turbo time is passed
	if ((m_fTurboTime < gpGlobals->time) && (m_fTurboTime > 0.0))
    {
		m_fTurboTime = 0.0;
		ToggleTurbo(OFF);
    }

	// Do weed to select a cookie
    if (m_bSelectCookie)
    {
		// Wee dinner time
		char Command[15] = "";

	    switch (RANDOM_LONG(1, 3))
		{
		case 1:
			strcpy(Command, "cookie");
			break;
	    case 2:
			strcpy(Command, "chocolate");
			break;
	    case 3:
			strcpy(Command, "donut");
			break;
		}

	    FakeClientCommand(pEdict, Command, NULL, NULL);
	    m_bSelectCookie = false;
    }

    m_fMoveSpeed = GetMaxSpeed();  // set to max speed

    if (m_pCurrentBotTask)
    {
		if (m_pCurrentBotTask->GetTaskState() == done)
		{
			delete m_pCurrentBotTask;
			m_pCurrentBotTask = NULL;

		    // hack hack... Since its not possible to create a task in a task, we do it here
		    if (m_eTaskAfterTask != TaskNone)
			{
				MakeTask(m_eTaskAfterTask);
				m_eTaskAfterTask = TaskNone;
			}
		}
    }

#ifdef LOGBOTINFO
	clog << "Begin checks\n";
#endif

	CheckNecessarilyThings(); // Check for things like swoop and autopunching
    BotSense(); // Check our environment
    CheckBotInternalStatus(); // Check for things like ki and health
    CheckBotMiscThings(); // Check for things like enemies
	   
#ifdef LOGBOTINFO
	clog << "End checks\n";
#endif

    // Still nothing todo ?
    if (m_pCurrentBotTask == NULL)
    {
		// Shall we make some kame torpedo's ?
	    if ((RANDOM_LONG(1, 100) <= m_pPersonality->kametorp_percent) &&
			(m_fCheckKameTorpTime < gpGlobals->time))
		{
			if (BotShouldMakeKameTorps())
				MakeTask(TaskKameTorp);
			   
		    m_fCheckKameTorpTime = gpGlobals->time + RANDOM_FLOAT(12.0, 25.0);
		}
	    // No ? Time to pause then ?
	    else if (m_fPauseCheckTime < gpGlobals->time)
			MakeTask(TaskLookAround);
	    // Ok then we just fly through the map...
	    else
			MakeTask(TaskNormalMovement);
    }

    BotPerformTasks(); // do the job
    BotAim(); // Aim at the desired vector

    // save the previous speed (for checking if stuck)
    m_fPrevSpeed = m_fMoveSpeed;

    if (!pBotManager->m_bBotsMove)
    {
		m_fMoveSpeed = 0.0;
		m_fStrafeSpeed = 0.0;
		m_fUpDownSpeed = 0.0;
    }

    if (GetMaxSpeed() < m_fStrafeSpeed)
    {
		m_fStrafeSpeed = GetMaxSpeed();
    }

    if (GetMaxSpeed() < m_fMoveSpeed)
    {
		m_fMoveSpeed = GetMaxSpeed();
    }

    if (GetMaxSpeed() < m_fUpDownSpeed)
    {
		m_fUpDownSpeed = GetMaxSpeed();
    }

	// Set the right buttons so the animations get played...
    if (m_fMoveSpeed > 0.0)
		pEdict->v.button |= IN_FORWARD;
    else if (m_fMoveSpeed < 0.0)
		pEdict->v.button |= IN_BACK;

    if (m_fStrafeSpeed > 0.0)
	    pEdict->v.button |= IN_MOVERIGHT;
    else if (m_fStrafeSpeed < 0.0)
		pEdict->v.button |= IN_MOVELEFT;

    if (m_fUpDownSpeed > 0.0)
	    pEdict->v.button |= IN_JUMP;
    else if (m_fUpDownSpeed < 0.0)
		pEdict->v.button |= IN_DUCK;

    pEdict->v.maxspeed = m_fBotMaxSpeed; // FIX for not-move bug

    g_engfuncs.pfnRunPlayerMove(pEdict, pEdict->v.v_angle, m_fMoveSpeed, m_fStrafeSpeed,
								m_fUpDownSpeed, pEdict->v.button, 0, m_fMSecVal);

    // Reset vars
    m_fStrafeSpeed = 0.0;
    m_fUpDownSpeed = 0.0;

#ifndef _DEBUG
    pBot->VisiblePlayers = 0;
    pBot->PlayersChecked = 0;
#endif

#ifdef LOGBOTINFO
	clog << "End bot think\n";
#endif

    return;
}

// Fills an array of edicts with visible and valid players for the bot
void CBot::MakePlayerList()
{
	// Clear the list
    for (byte i=0;i<32;i++)
		m_pPlayerList[i] = NULL;

    m_bPlayerCount = 0;

	// Check each player in the player list, if valid add it to the list
	pClientManager->pClientList->ForEach(this, &CBot::CheckIfValidPlayer);

    // We made the list, don't need to do it more then once each frame
    m_bMadePlayerList = true; 
}

void CBot::CheckIfValidPlayer(CClient *pClient)
{
	int PlayerIndex = ENTINDEX(pClient->pEdict);

	// Already checked by a previous bot?
	if (m_lPlayersChecked & (1<<(PlayerIndex-1)))
	{
		if (m_lVisiblePlayers & (1<<(PlayerIndex-1)))
		{
			m_pPlayerList[m_bPlayerCount] = pClient;
			m_bPlayerCount++;
		}
		return;
	}

    // skip self (i.e. this bot)
    if (this != pClient)
	{
		Vector vecEnd = pClient->GetGunPosition();
		int BotPlayerIndex = ENTINDEX(pEdict);
		CBot *pOtherBot = pBotManager->GetBotFromClient(pClient);
			
		if (pClient->IsBot())
		{
			if (pOtherBot)
			{
				// This bot needs to think after this bot, so mark that this bot is valid for 
				// him to save some cpu usage.
				pOtherBot->m_lPlayersChecked |= (1<<(BotPlayerIndex-1));
			}
		}

		m_lPlayersChecked |= (1<<(PlayerIndex-1));

		// see if bot can see the player...
		if (FVisible(vecEnd))
		{
			m_pPlayerList[m_bPlayerCount] = pClient;
			m_bPlayerCount++;
			m_lVisiblePlayers |= (1<<(PlayerIndex-1));

			if (pClient->IsBot())
			{
				if (pOtherBot)
				{
					// Mark that this bot is visible for the other player to save some 
					// cpu usage.
					pOtherBot->m_lVisiblePlayers |= (1<<(BotPlayerIndex-1));
				}
			}
		}
	}
}

// returns the number of degrees left to turn toward ideal yaw...
float CBot::BotChangeYaw(float Speed, float Ideal)
{
	float current;
    float current_180;  // current +/- 180 degrees
    float diff;

   // turn from the current v_angle yaw to the ideal_yaw by selecting
   // the quickest way to turn to face that direction

    current = pEdict->v.v_angle.y;

    // find the difference in the current and ideal angle
    diff = abs(current - Ideal);

    // speed that we can turn during this frame...
    Speed = Speed * m_fFrameTime;

    // check if difference is less than the max degrees per turn
    if (diff < Speed)
		Speed = diff;  // just need to turn a little bit (less than max)

    // here we have four cases, both angle positive, one positive and
    // the other negative, one negative and the other positive, or
    // both negative.  handle each case separately...

    if ((current >= 0) && (Ideal >= 0))  // both positive
    {
		if (current > Ideal)
			current -= Speed;
		else
			current += Speed;
    }
	else if ((current >= 0) && (Ideal < 0))
	{
		current_180 = current - 180;

       if (current_180 > Ideal)
		   current += Speed;
	   else
		   current -= Speed;
    }
	else if ((current < 0) && (Ideal >= 0))
	{
		current_180 = current + 180;
		if (current_180 > Ideal)
			current += Speed;
		else
			current -= Speed;
    }
	else  // (current < 0) && (ideal < 0)  both negative
    {
		if (current > Ideal)
			current -= Speed;
		else
			current += Speed;
    }

    // check for wrap around of angle...
    if (current > 180)
		current -= 360;
	if (current < -180)
		current += 360;

    pEdict->v.v_angle.y = current;

    return diff;  // return number of degrees left to turn
}

// returns the number of degrees left to turn toward ideal pitch...
float CBot::BotChangePitch(float Speed, float Ideal)
{
	float current;
    float current_180;  // current +/- 180 degrees
    float diff;

   // turn from the current v_angle yaw to the ideal_yaw by selecting
   // the quickest way to turn to face that direction

    current = pEdict->v.v_angle.y;

    // find the difference in the current and ideal angle
    diff = abs(current - Ideal);

    // speed that we can turn during this frame...
    //Speed = Speed * m_fFrameTime; // for some reason the x angles are handled WAY slower

    // check if difference is less than the max degrees per turn
    if (diff < Speed)
		Speed = diff;  // just need to turn a little bit (less than max)

    // here we have four cases, both angle positive, one positive and
    // the other negative, one negative and the other positive, or
    // both negative.  handle each case separately...

    if ((current >= 0) && (Ideal >= 0))  // both positive
    {
		if (current > Ideal)
			current -= Speed;
		else
			current += Speed;
    }
	else if ((current >= 0) && (Ideal < 0))
	{
		current_180 = current - 180;

       if (current_180 > Ideal)
		   current += Speed;
	   else
		   current -= Speed;
    }
	else if ((current < 0) && (Ideal >= 0))
	{
		current_180 = current + 180;
		if (current_180 > Ideal)
			current += Speed;
		else
			current -= Speed;
    }
	else  // (current < 0) && (ideal < 0)  both negative
    {
		if (current > Ideal)
			current -= Speed;
		else
			current += Speed;
    }

    // check for wrap around of angle...
    if (current > 180)
		current -= 360;
	if (current < -180)
		current += 360;

    pEdict->v.v_angle.x = current;

    return diff;  // return number of degrees left to turn
}

void CBot::BotAim()
{
    if (m_fAimDelay > gpGlobals->time)
	   return;

	Vector v_aim = WrapAngles(m_vAimVec);

	Vector v_src = pEdict->v.origin;

    // Paulo-La-Frite - START bot aiming bug fix
    if (v_aim.y > 180)
      v_aim.y -=360;

    if (v_aim.x > 180)
      v_aim.x -=360;

	// Paulo-La-Frite - END

	float AimXSpeedMin;
	float AimXSpeedMax;
	float AimYSpeedMin;
	float AimYSpeedMax;

	if (IsSuperBot())
	{
		pEdict->v.v_angle = WrapAngles(v_aim);
	}
	else
	{
		AimXSpeedMin = AimXSpeeds[m_bBotSkill][0];
		AimXSpeedMax = AimXSpeeds[m_bBotSkill][1];

		AimYSpeedMin = AimYSpeeds[m_bBotSkill][0];
		AimYSpeedMax = AimYSpeeds[m_bBotSkill][1];

		if (BotDebugAimXSpeed > 0.0)
			m_fPitchSpeed = BotChangePitch(BotDebugAimXSpeed, v_aim.x);
		else
			m_fPitchSpeed = BotChangePitch(RANDOM_FLOAT(AimXSpeedMin, AimXSpeedMax), v_aim.x);

		if (BotDebugAimYSpeed > 0.0)
			m_fYawSpeed = BotChangeYaw(BotDebugAimYSpeed, v_aim.y);
		else
			m_fYawSpeed = BotChangeYaw(RANDOM_FLOAT(AimYSpeedMin, AimYSpeedMax), v_aim.y);
	}

	if (BotDebugAimDelay > 0.0)
		m_fAimDelay = gpGlobals->time + BotDebugAimDelay;
	
	//pBot->aim_delay = gpGlobals->time + 
	//		RANDOM_FLOAT(aim_delays[pBot->bot_skill][0],aim_delays[pBot->bot_skill][1]);

    return;
}

// returns true if bot should wall jump
bool CBot::CheckWallJump()
{
	if (m_bBotSkill > 2)
		return false; // lower skilled bots are stupid :D

	//if (pBot->WallJumpCheckDelay > gpGlobals->time)
	//	return false;

//	pBot->WallJumpCheckDelay = gpGlobals->time + 0.15;

	return ((ChargesWallJump()) || (WallJumps()) ||
		    (IsStuckAgainstWall()));
}

bool CBot::BotShouldFallDown()
{
	if ((m_bDangerLevel < danger_light) || (m_bDangerLevel > danger_medium))
		return false;

	if (RANDOM_LONG(1, 100) > m_pPersonality->stopfly_percent)
		return false;

	if (IsValidEnemy(m_pBotEnemy))
	{
		float EnemyDist = UTIL_Distance(pEdict->v.origin, m_pBotEnemy->pEdict->v.origin);

		if (EnemyDist < 1000.0)
		{
			if (m_pBotEnemy->pEdict->v.origin.z < (pEdict->v.origin.z - 200.0))
				return false;
		}
	}

	if (CheckForCollide(pEdict, dir_down, MIN_DIST_TO_FALL_DOWN))
		return false;

	return true;
}

bool CBot::BotCanAscend()
{
	if (HasTurboOn())
		return false;

	long MinPl = 999999999;
	char PlayerClass[32] = "";

	PlayerClassify(PlayerClass);

	if (FStrEq(PlayerClass, "buu"))
		MinPl = 3000000;
	else if (FStrEq(PlayerClass, "goku"))
		MinPl = 1750000;
	else if (FStrEq(PlayerClass, "gohan"))
		MinPl = 1000000;
	else if (FStrEq(PlayerClass, "krillin"))
		MinPl = 3000000;
	else if (FStrEq(PlayerClass, "frieza"))
		MinPl = 1800000;
	else if (FStrEq(PlayerClass, "piccolo"))
		MinPl = 1650000;
	else if (FStrEq(PlayerClass, "trunks"))
		MinPl = 1000000;
	else if (FStrEq(PlayerClass, "vegeta"))
		MinPl = 2000000;
	else if (FStrEq(PlayerClass, "cell"))
		MinPl = 1900000;
	else
		return false;

	return (GetPl() >= MinPl);
}

void CBotManager::ChangeBotBoolSetting(bool &Setting, short Choice, const char *VarName)
{
	if (Choice == 1)
		Setting = true;
	else if (Choice == 0)
		Setting = false;
	else if (Choice == -1)
		Setting ^= 1; // Toggle it

	if (Setting)
		cout << VarName << " is now ENABLED\n";
	else
		cout << VarName << " is now DISABLED\n";
}

void CBotManager::ChangePersoPercentSetting(short BotPersonality_t::*Setting, short Choice, const char *VarName)
{
	if (Choice == -1)
		Choice = RANDOM_LONG(0, 100); // -1 means take a random percent

	for (byte i=0;i<9;i++)
		BotPersonalities[i].*Setting = Choice;

	cout << "The personality setting " << VarName << " is now for each personality " << Choice <<
			"\n";
}

void CBotManager::ChangeBotSkill(short Skill)
{
	if (Skill == -1) // -1 means take a random value
		Skill = RANDOM_LONG(1, 5);

	if (Skill < 1 || Skill > 5)
	{
		cout << "Invalid botskill ! Choose a number between 1(best) and 5(worst)\n";
		return;
	}

	pClientManager->pClientList->ForEach(this, &CBotManager::SetSkillTo, Skill);

	m_sDefaultSkill = Skill - 1;

	char szSkillName[10] = "";
	switch(Skill)
	{
	case 1:
		strcpy(szSkillName, "Best");
		break;
	case 2:
		strcpy(szSkillName, "Good");
		break;
	case 3:
		strcpy(szSkillName, "Medium");
		break;
	case 4:
		strcpy(szSkillName, "Weak");
		break;
	case 5:
		strcpy(szSkillName, "Bad");
		break;
	}
	cout << "EVERY bot has now the skill " << szSkillName << "\n";
}

void CBotManager::ChangeAggressionLevel(AggressionLevel_e AggrLevel)
{
	for (byte i=0;i<9;i++)
		BotPersonalities[i].aggression_level = AggrLevel;

	char szAggrLevel[12] = "";
	switch(AggrLevel)
	{
	case Defensive:
		strcpy(szAggrLevel, "Defensive");
		break;
	case Normal:
		strcpy(szAggrLevel, "Normal");
		break;
	case Aggressive:
		strcpy(szAggrLevel, "Aggressive");
		break;
	}	
	cout << "The personality setting aggression level is now for each personality " << 
			szAggrLevel << "\n";
}

void CBotManager::KickBots(short Team)
{
	if ((IsTeamPlay() == false) || ((Team != 1) && (Team != 2)))
		Team = -1; // -1 means kick all bots

	CKickBots KickBotsClassFunc;
	KickBotsClassFunc.SetTeam(Team);
	pClientManager->pClientList->ForEach(this, &CBotManager::KickMultipleBots, Team);
}

void CBotManager::KickLastBot()
{
	CBot *pLastBot = GetLastBot();
	if (pLastBot)
		UTIL_KickPlayer(pLastBot->pEdict);
}

void CBotManager::DisconnectBot(CClient *pClient)
{
	if (!pClient->IsBot())
		return;

	CBot *pBot = dynamic_cast<CBot*>(pClient);

	if (!pBot)
		return;

	if (pBot->m_sSBotType > 0) // Is it a super bot?
		m_bSBotCount--;

	if (m_bSBotCount < 1)
	{
		RestoreOldPLCatchupValue();
	}

	SKickedBot *pKickedBot = new SKickedBot(pBot->m_bBotSkill, pBot->m_pPersonality, 
											pBot->m_sBotClass, pBot->m_sBotTeam, pBot->m_szName, 
											pBot->m_sSBotType, pBot->m_pLastEnemy,
											pBot->m_eRespawnState);

	m_pKickedBots->AddNode(pKickedBot);
}

void CBotManager::CreateBot(short Team, short Class, const char *Name, short Skill, short Perso)
{
	edict_t *BotEnt;
	CBot *pBot;
	char c_name[BOT_NAME_LEN+1];
	int i, j, length;

	if ((Name != NULL) && (*Name != 0))
    {
		strncpy(c_name, Name, BOT_NAME_LEN-1);
		c_name[BOT_NAME_LEN] = 0;  // make sure c_name is null terminated
    }
	else
	{
		if (number_names > 0)
			BotPickName(c_name);
		else
			strcpy(c_name, "Bot");
    }

	if ((Skill < 1) || (Skill > 5))
		Skill = m_sDefaultSkill + 1;

    length = strlen(c_name);

	// remove any illegal characters from name...
    for (i = 0; i < length; i++)
    {
		if ((c_name[i] < ' ') || (c_name[i] > '~') || (c_name[i] == '"'))
		{
			for (j = i; j < length; j++)  // shuffle chars left (and null)
				c_name[j] = c_name[j+1];
			length--;
		}               
    }

    BotEnt = CREATE_FAKE_CLIENT( c_name );

    if (FNullEnt( BotEnt ))
    {
		UTIL_Printf("Max. Players reached.  Can't create bot!\n");
	}
    else
    {
		char ptr[128];  // allocate space for message from ClientConnect
		char *infobuffer;
		int clientIndex;
		
		UTIL_Printf("Creating bot...\n");

		FREE_PRIVATE(BotEnt); // IMPORTANT: Fix the kick bot problem 
		BotEnt->pvPrivateData = NULL; 
		BotEnt->v.frags = 0;

		// create the player entity by calling MOD's player function
		// (from LINK_ENTITY_TO_CLASS for player object)
		player( VARS(BotEnt) );

		// I'm not sure if this block is needed.....
		infobuffer = GET_INFOBUFFER( BotEnt );
		clientIndex = ENTINDEX( BotEnt );
		SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "model", "gina" );

		// Connect the bot to the server
		ClientConnect( BotEnt, c_name, "127.0.0.1", ptr );

		// Pieter van Dijk - use instead of DispatchSpawn() - Hip Hip Hurray!
		ClientPutInServer( BotEnt );

		pBot = dynamic_cast<CBot*>(pClientManager->GetClientFromEdict(BotEnt));
		if (!pBot)
		{
			cout << "Error ! Couldn't create bot\n";
			return;
		}

		pBot->pEdict = BotEnt;

		// initialize all the variables for this bot...
		pBot->CreateInit(Team, Class, Skill, Perso, -1);

		m_bNumberOfBots++; // We created another bot :)
		m_fAddBotDelay = gpGlobals->time + 5.0;
	}   
}

void CBotManager::CreateSuperBot(short Class, const char *Name, short Perso, short SBotType)
{
	edict_t *BotEnt;
	CBot *pBot;
	char szTemp[100];
	char c_name[BOT_NAME_LEN+1];
	int i, j, length;

	if ((Name != NULL) && (*Name != 0))
    {
		strncpy(szTemp, Name, BOT_NAME_LEN-1);
		szTemp[BOT_NAME_LEN] = 0;  // make sure its null terminated
    }
	else
	{
		if (number_names > 0)
			BotPickName(szTemp);
		else
			strcpy(szTemp, "Bot");
    }

	strcpy(c_name, "[SBot%i]");
	strncat(c_name, szTemp, ((BOT_NAME_LEN-1) - strlen(c_name)));

    length = strlen(c_name);

	// remove any illegal characters from name...
    for (i = 0; i < length; i++)
    {
		if ((c_name[i] < ' ') || (c_name[i] > '~') || (c_name[i] == '"'))
		{
			for (j = i; j < length; j++)  // shuffle chars left (and null)
				c_name[j] = c_name[j+1];
			length--;
		}               
    }

    BotEnt = CREATE_FAKE_CLIENT( c_name );

    if (FNullEnt( BotEnt ))
    {
		UTIL_Printf("Max. Players reached.  Can't create bot!\n");
	}
    else
    {
		char ptr[128];  // allocate space for message from ClientConnect
		char *infobuffer;
		int clientIndex;
		
		UTIL_Printf("Creating bot...\n");

		FREE_PRIVATE(BotEnt); // IMPORTANT: Fix the kick bot problem 
		BotEnt->pvPrivateData = NULL; 
		BotEnt->v.frags = 0;

		// create the player entity by calling MOD's player function
		// (from LINK_ENTITY_TO_CLASS for player object)
		player( VARS(BotEnt) );

		// I'm not sure if this block is needed.....
		infobuffer = GET_INFOBUFFER( BotEnt );
		clientIndex = ENTINDEX( BotEnt );
		SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "model", "gina" );

		// Connect the bot to the server
		ClientConnect( BotEnt, c_name, "127.0.0.1", ptr );

		// Pieter van Dijk - use instead of DispatchSpawn() - Hip Hip Hurray!
		ClientPutInServer( BotEnt );

		pBot = dynamic_cast<CBot*>(pClientManager->GetClientFromEdict(BotEnt));
		if (!pBot)
		{
			cout << "Error ! Couldn't create bot\n";
			return;
		}

		pBot->pEdict = BotEnt;

		// initialize all the variables for this bot...
		pBot->CreateInit(2, Class, 1, Perso, SBotType);

		m_bNumberOfBots++; // We created another bot :)
		m_fAddBotDelay = gpGlobals->time + 5.0;

		if (m_bSBotCount == 0)
		{
			StoreOldPLCatchupValue();
			CVAR_SET_FLOAT("mp_plcathcup", 0.0);
		}

		m_bSBotCount++;
	}   
}

void CBotManager::RestoreBots()
{
	// are we currently respawning bots and is it time to spawn one yet?
    if ((m_fRestoreBotsTime > 1.0) && (m_fRestoreBotsTime <= gpGlobals->time))
    {
		if (!m_bRestoringBots)
			m_bRestoringBots = true;

        if (m_pKickedBots->Empty() == false)
		{
			SKickedBot *pKickedBot = m_pKickedBots->Pop();

			short PersoNr = -1;

			if (pKickedBot->pPersonality)
			{
				// Find the index of the personality the bot had
				for (byte i=0;i<9;i++)
				{
					if (&BotPersonalities[i] == pKickedBot->pPersonality)
					{
						PersoNr = i;
						break;
					}
				}
			}

			if (pKickedBot->SBotType > 0)
				CreateSuperBot(pKickedBot->BotClass, pKickedBot->BotName, PersoNr, 
							   pKickedBot->SBotType);
			else
				CreateBot(pKickedBot->BotTeam, pKickedBot->BotClass, pKickedBot->BotName, 
						  pKickedBot->Skill, PersoNr);
            
            m_fRestoreBotsTime = gpGlobals->time + 2.0;  // set next respawn time
			delete pKickedBot; // Clear this one because its respawned...
		}
        else
        {
            m_fRestoreBotsTime = 0.0;
			m_bRestoringBots = false;
		}
	}
	else if (m_bRestoringBots)
		m_bRestoringBots = false;
}

void CBotManager::FillAHalfTeam(byte Team)
{ 
	m_bFillHalfTeam = true; 
	m_bTeamToFill = Team;
	m_bBotsToCreate = (gpGlobals->maxClients / 2) - 1;
}

void CBotManager::FillATeam(byte Team)
{
	m_bFillTeam = true; 
	m_bTeamToFill = Team;
	m_bBotsToCreate = gpGlobals->maxClients - 1;
}

void CBotManager::FillServer(void)
{
	m_bFillWholeServer = true;
	m_bBotsToCreate = gpGlobals->maxClients - 1;
}

bool CBotManager::IsAddingMultipleBots(void)
{
	return ((m_bFillWholeServer) || (m_bFillHalfTeam) || (m_bFillTeam));
}

void CBotManager::BotFillThink()
{
	if (!IS_DEDICATED_SERVER() && !m_bSpawnTimeReset)
	{
		CClient *pHost = pClientManager->GetHost();
		if (pHost != NULL)
		{
			if (pHost->IsAlive())
			{
				m_bSpawnTimeReset = true;

				if (m_fRestoreBotsTime >= 1.0)
					m_fRestoreBotsTime = min(m_fRestoreBotsTime, gpGlobals->time + (float)1.0);

                if (m_fBotCFGPauseTime >= 1.0)
					m_fBotCFGPauseTime = min(m_fBotCFGPauseTime, gpGlobals->time + (float)1.0);
			}
		}
	}

	if (m_fAddBotDelay > gpGlobals->time)
		return; // Wait with adding bots

	RestoreBots();

	if (m_bRestoringBots)
		return;

	if (m_bCheckNumBotsCVar)
	{
		if (pClientManager->GetPlayerCount() < (gpGlobals->maxClients - 1))
		{
			float NumBotsCVarVal = CVAR_GET_FLOAT("numbots");

			if (NumBotsCVarVal < m_bNumberOfBots)
			{
				CreateBot(-1, -1, NULL, -1, -1);
				return;
			}
			else
				m_bCheckNumBotsCVar = false;
		}
		else
			m_bCheckNumBotsCVar = false;
	}

	// Are we filling the server?
	if (IsAddingMultipleBots())
	{
		// Reached the goal count or the max player count?
		if ((m_bBotsToCreate < 1) || 
			(pClientManager->GetPlayerCount() >= (gpGlobals->maxClients - 1)))
		{
			m_bFillHalfTeam = m_bFillTeam = m_bFillWholeServer = false;
			m_bTeamToFill = 0;
		}
		else
		{
			if ((m_bFillHalfTeam) || (m_bFillTeam))
			{
				CreateBot(m_bTeamToFill, -1, NULL, -1, -1);
				m_bBotsToCreate--;
				return;
			}
			else
			{
				CreateBot(-1, -1, NULL, -1, -1);
				m_bBotsToCreate--;
				return;
			}
		}
	}

    // if there are currently less than the maximum number of "players"
    // then add another bot using the default skill level...
    if ((pClientManager->GetPlayerCount() < m_sMaxBots) && (m_sMaxBots != -1))
	{
		CreateBot(-1, -1, NULL, -1, -1);
	}
}

void CBotManager::CheckIfABotShouldBeKicked()
{
	// if there are currently more than the minimum number of bots running
	// then kick one of the bots off the server...
    if ((pClientManager->GetPlayerCount() > m_sMinBots) && (m_sMinBots != -1))
	{
		KickLastBot();
	}
}

void CBotManager::BotBalanceTeamsThink()
{
	if (m_fBalanceTeamsDelay < gpGlobals->time)
	{
		m_fBalanceTeamsDelay = gpGlobals->time + 5.0;

		// Check if bots should balance teams?
		if ((m_bBalanceTeams) && (m_bNumberOfBots > 0) && (IsTeamPlay()))
		{
			byte TeamGoodCount = 0;
			byte TeamEvilCount = 0;

			pClientManager->pClientList->ForEach(pClientManager, &CClientManager::CountTeams,
												 &TeamGoodCount, &TeamEvilCount);

			CBotsSwitchTeams BotsSwitchTeamsFuncClass;

			short Count;
			short Team = 0;

			// More players on team good?
			if ((TeamGoodCount - 1) > TeamEvilCount)
			{
				Count = TeamGoodCount - TeamEvilCount;
				Team = 1;
			}
			// More players on team evil?
			else if ((TeamEvilCount - 1) > TeamGoodCount)
			{
				Count = TeamEvilCount - TeamGoodCount;
				Team = 2;
			}

			if (Team)
				pClientManager->pClientList->While(this, &CBotManager::ChangeBotsTeam, Team,
												   &Count);
		}
	}
}

void CBotManager::SBotRulesThink()
{
	if (m_fSBotRulesDelay > gpGlobals->time)
		return;

	if (AreSBotsIngame() == false)
		return; // There are no superbots ingame so return

	m_fSBotRulesDelay = gpGlobals->time + 0.75; // No need to do this every frame

	// Let all players join team good(if they weren't in team good)
	pClientManager->pClientList->ForEach(this, &CBotManager::LetRealPlayersJoinGood);

	// Check if mp_plcathcup is off, we don't want that normal player can beat superbots :)
	if (CVAR_GET_FLOAT("mp_plcatchup") == 1.0)
		CVAR_SET_FLOAT("mp_plcatchup", 0.0);
}

void CBotManager::LoadBotNames()
{
	FILE *bot_name_fp;
	char bot_name_filename[256];
	int str_index;
	char name_buffer[80];
	int length, index;

	UTIL_BuildFileName(bot_name_filename, "bot_names.txt", NULL);

	bot_name_fp = fopen(bot_name_filename, "r");

	(*g_engfuncs.pfnServerPrint) ("Reading bot_names file... ");
	if (bot_name_fp != NULL)
    {
		while ((number_names < MAX_BOT_NAMES) &&
			(fgets(name_buffer, 80, bot_name_fp) != NULL))
		{
			length = strlen(name_buffer);

			if (name_buffer[length-1] == '\n')
			{
				name_buffer[length-1] = 0;  // remove '\n'
				length--;
			}

			str_index = 0;
			while (str_index < length)
			{
				if ((name_buffer[str_index] < ' ') || (name_buffer[str_index] > '~') ||
					(name_buffer[str_index] == '"'))
				for (index=str_index; index < length; index++)
					name_buffer[index] = name_buffer[index+1];
 
				str_index++;
			}

			if (name_buffer[0] != 0)
			{
				strncpy(bot_names[number_names], name_buffer, BOT_NAME_LEN);

				number_names++;
			}
		}
		fclose(bot_name_fp);
		(*g_engfuncs.pfnServerPrint) ("done\n");
	}
	else
		(*g_engfuncs.pfnServerPrint) ("file not found\n");
}

// Make random super bot settings or read them out of the file
// 'sbot.cfg'
void CBotManager::CreateSuperbotSettings()
{
	char SBotFileName[256] = "";
	FILE *SBotFile = NULL;
	int SBotNr = 0;
    int value = 0;

	memset(SBotSettings,0,sizeof(SBotSettings));

	UTIL_BuildFileName(SBotFileName, "sbot.cfg", NULL);

	SBotFile = fopen(SBotFileName, "r");

	// make random sbot settings, in case the file doesnt exist or has 
	// missing settings
	for (SBotNr = 0;SBotNr < 3;SBotNr++)
	{
		SBotSettings[SBotNr].ki_gain = RANDOM_LONG(-1, 5);
		SBotSettings[SBotNr].health_gain = RANDOM_LONG(-1, 5);
		SBotSettings[SBotNr].pl = RANDOM_LONG(3500000, 10000000);
		SBotSettings[SBotNr].transparency_val = RANDOM_LONG(1, 255);
		SBotSettings[SBotNr].laser_percent = 100; //RANDOM_LONG(0, 100);
	}

	(*g_engfuncs.pfnServerPrint) ("Reading sbot.cfg file... ");

	if (SBotFile == NULL) // file doesn't exist
	{
		(*g_engfuncs.pfnServerPrint) ("file not found, random settings will be used\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	static char server_cmd[80];
	char *cmd, *arg1, *arg2, *arg3, *arg4;

	while (SBotFile)
	{    
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(SBotFile);

		// skip any leading blanks
		while (ch == ' ')
		ch = fgetc(SBotFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
		      ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(SBotFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') &&
		             (ch == ' '))      
         		ch = fgetc(SBotFile);

		      cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
			ch = fgetc(SBotFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
		    fclose(SBotFile);
			SBotFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		// copy the command line to a server command buffer...
		strcpy(server_cmd, cmd_line);
		strcat(server_cmd, "\n");

		cmd_index = 0;
		cmd = cmd_line;
		arg1 = arg2 = arg3 = arg4 = NULL;

		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		      cmd_index++;

		if (cmd_line[cmd_index] == ' ')
		{
		      cmd_line[cmd_index++] = 0;
		      arg1 = &cmd_line[cmd_index];

		      // skip to blank or end of string...
		      while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		         cmd_index++;

		      if (cmd_line[cmd_index] == ' ')
			  {
		         cmd_line[cmd_index++] = 0;
		         arg2 = &cmd_line[cmd_index];

		         // skip to blank or end of string...
		         while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		            cmd_index++;

		         if (cmd_line[cmd_index] == ' ')
		         {
		            cmd_line[cmd_index++] = 0;
		            arg3 = &cmd_line[cmd_index];

            		// skip to blank or end of string...
		            while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
            		   cmd_index++;

		            if (cmd_line[cmd_index] == ' ')
            		{
		               cmd_line[cmd_index++] = 0;
		               arg4 = &cmd_line[cmd_index];
            		}
				 }
			  }
		}
		if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
			continue;  // skip if comment or blank line


		if (strcmp(cmd, "[SUPERBOT]") == 0)
			SBotNr = 0; // sbot1
		else if (strcmp(cmd, "[MEGABOT]") == 0)
			SBotNr = 1; // sbot 2
		else if (strcmp(cmd, "[ULTIMATEBOT]") == 0)
			SBotNr = 2; // sbot 3

		if ((arg1 == NULL) || (*arg1 == 0))
		    continue;

		value = atoi(arg1);

		if (strcmp(cmd, "ki_gain") == 0)
		{
			if ((value >= -1) && (value <= 1000))
				SBotSettings[SBotNr].ki_gain = value;
			else
				SBotSettings[SBotNr].ki_gain = RANDOM_LONG(-1, 5);
		}
		else if (strcmp(cmd, "health_gain") == 0)
		{
			if ((value >= -1) && (value <= 250))
				SBotSettings[SBotNr].health_gain = value;
			else
				SBotSettings[SBotNr].health_gain = RANDOM_LONG(-1, 5);
		}
		else if (strcmp(cmd, "powerlevel") == 0)
		{
			if ((value >= 650000) && (value <= 999999999))
				SBotSettings[SBotNr].pl = value;
			else
				SBotSettings[SBotNr].pl = RANDOM_LONG(650000, 10000000);
		}
		else if (strcmp(cmd, "transparency_val") == 0)
		{
			if ((value == -1) || ((value >= 1) && (value <= 255)))
				SBotSettings[SBotNr].transparency_val = value;
			else
				SBotSettings[SBotNr].transparency_val = RANDOM_LONG(1, 255);
		}
		else if (strcmp(cmd, "sbotlaser_percent") == 0)
		{
			if ((value >= 0) && (value <= 100))
				SBotSettings[SBotNr].laser_percent = value;
			else
				SBotSettings[SBotNr].laser_percent = RANDOM_LONG(0, 100);
		}			 		
	}
	(*g_engfuncs.pfnServerPrint) ("done\n");
}

void CBotManager::CreateSkillData()
{
	extern float GeneralReactionDelays[5][2];

	char DelayFileName[256] = "";
	FILE *DelayFile = NULL;
	int SkillNr = 0;
    float value = 0;

	UTIL_BuildFileName(DelayFileName, "skill.cfg", NULL);

	DelayFile = fopen(DelayFileName, "r");

	(*g_engfuncs.pfnServerPrint) ("Reading skill.cfg file... ");

	if (DelayFile == NULL) // file doesn't exist
	{
		(*g_engfuncs.pfnServerPrint) ("file not found, default settings will be used\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	char *cmd, *arg1;

	while (DelayFile)
	{    
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(DelayFile);

		// skip any leading blanks
		while (ch == ' ')
		ch = fgetc(DelayFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
		      ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(DelayFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') &&
		             (ch == ' '))      
         		ch = fgetc(DelayFile);

		      cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
			ch = fgetc(DelayFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
		    fclose(DelayFile);
			DelayFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		cmd_index = 0;
		cmd = cmd_line;
		arg1 = NULL;

		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		      cmd_index++;

		if (cmd_line[cmd_index] == ' ')
		{
		      cmd_line[cmd_index++] = 0;
		      arg1 = &cmd_line[cmd_index];
		}

		if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
			continue;  // skip if comment or blank line


		if (strcmp(cmd, "[SKILL1]") == 0)
			SkillNr = 0;
		else if (strcmp(cmd, "[SKILL2]") == 0)
			SkillNr = 1;
		else if (strcmp(cmd, "[SKILL3]") == 0)
			SkillNr = 2;
		else if (strcmp(cmd, "[SKILL4]") == 0)
			SkillNr = 3;
		else if (strcmp(cmd, "[SKILL5]") == 0)
			SkillNr = 4;

		if ((arg1 == NULL) || (*arg1 == 0))
		    continue;

		value = atof(arg1);

		if (strcmp(cmd, "min_general_delay") == 0)
		{
			//clog << "GenMinDelay for skill " << SkillNr << " is " << value << "\n";
			GeneralReactionDelays[SkillNr][0] = value;
		}
		else if (strcmp(cmd, "max_general_delay") == 0)
		{
			//clog << "GenMaxDelay for skill " << SkillNr << " is " << value << "\n";
			GeneralReactionDelays[SkillNr][1] = value;
		}
		else if (strcmp(cmd, "min_aim_speed") == 0)
		{
			//clog << "MinAimSpeed for skill " << SkillNr << " is " << value << "\n";
			AimXSpeeds[SkillNr][0] = value / 2.0; // O_o
			AimYSpeeds[SkillNr][0] = value;
		}
		else if (strcmp(cmd, "max_aim_speed") == 0)
		{
			//clog << "MaxAimSpeed for skill " << SkillNr << " is " << value << "\n";
			AimXSpeeds[SkillNr][1] = value / 2.0; // O_o
			AimYSpeeds[SkillNr][1] = value;
		}
	}
	(*g_engfuncs.pfnServerPrint) ("done\n");
}

void CBotManager::MapInit()
{
	// Reset all timers
	m_fAddBotDelay = gpGlobals->time + 30.0;
	m_fRestoreBotsTime = 0.0;
	m_fBalanceTeamsDelay = 0.0;
	m_fSBotRulesDelay = 0.0;

	m_bFillWholeServer = false;
	m_bFillHalfTeam = false;
	m_bFillTeam = false;
	m_bTeamToFill = 0;
	m_bBotsToCreate = 0;
	m_bRestoringBots = false;
	m_bCheckNumBotsCVar = true;

    char filename[256];
    char mapname[64];

	// check if mapname_bot.cfg file exists...
    strcpy(mapname, STRING(gpGlobals->mapname));
	strcat(mapname, "_bot.cfg");

	sprintf(filename, "esf\\maps\\%s\\", mapname);

    if ((m_pBotCFGFile = fopen(filename, "r")) != NULL)
	{
		cout << "Executing " << filename << "\n";

		// Don't respawn any bots, just remove the list
		while (m_pKickedBots->Empty() == false)
			delete m_pKickedBots->Pop();
			

        if (IS_DEDICATED_SERVER())
			m_fBotCFGPauseTime = gpGlobals->time + 5.0;
		else
			m_fBotCFGPauseTime = gpGlobals->time + 20.0;
	}
    else
	{
		// set the respawn time
		if (IS_DEDICATED_SERVER())
			m_fRestoreBotsTime = gpGlobals->time + 5.0;
		else
			m_fRestoreBotsTime = gpGlobals->time + 30.0;
	}

	WaypointInit();
    WaypointLoad(NULL);

    PRECACHE_SOUND("weapons/xbow_hit1.wav");      // waypoint add
    PRECACHE_SOUND("weapons/mine_activate.wav");  // waypoint delete
    PRECACHE_SOUND("common/wpn_hudoff.wav");      // path add/delete start
    PRECACHE_SOUND("common/wpn_hudon.wav");       // path add/delete done
    PRECACHE_SOUND("common/wpn_moveselect.wav");  // path add/delete cancel
    PRECACHE_SOUND("common/wpn_denyselect.wav");  // path add/delete error
	PRECACHE_SOUND("weapons/basicbeam_chargeoriginal.wav"); // for sbot 'weapon'

	PRECACHE_MODEL( "models/mechgibs.mdl" );

	extern int m_spriteTexture;
	m_spriteTexture = PRECACHE_MODEL( "sprites/lgtning.spr");

	m_fBotCFGPauseTime = 0.0;
    m_fRestoreBotsTime = 0.0;
    m_bSpawnTimeReset = false;

    m_bPrevNumberBots = m_bNumberOfBots;
    m_bNumberOfBots = 0;

    m_fAddBotDelay = gpGlobals->time + 30.0;
}	

void CBotManager::GameInit()
{
	static cvar_t sv_num_bots = {"numbots",""};
	static cvar_t sv_bot_skill = {"bot_skill",""};

	CVAR_REGISTER (&sv_num_bots);
	CVAR_REGISTER (&sv_bot_skill);
	
	LoadBotNames(); // load bot names
	LoadChatTexts(); // load chat sentences
	CreateBotPersonalities(); // load/create bot personalities
	CreateSuperbotSettings(); // load/create sbot settings
	CreateSkillData();

    ADD_SERVER_COMMAND("esf_bot4", ExecuteBotCommands);
    ADD_SERVER_COMMAND("bot_help", UTIL_ShowInGameHelpWindow);
}

void CBotManager::SkillCVarCheck()
{
	if (m_fCheckSkillCVarDelay < gpGlobals->time)
	{
		m_fCheckSkillCVarDelay = gpGlobals->time + 0.8;

		if (m_bNumberOfBots > 0)
		{
			if (FStrEq(CVAR_GET_STRING("bot_skill"), "") == false)
			{
				float SkillCVarVal = CVAR_GET_FLOAT("bot_skill");
				if (m_sDefaultSkill != static_cast<short>(SkillCVarVal))
				{
					ChangeBotSkill(static_cast<short>(SkillCVarVal));
				}
			}
		}
	}
}

CBot *CBotManager::GetBotFromEdict(edict_t *pEdict)
{
	if (!pEdict)
		return NULL;

	CClient *pClient = pClientManager->GetClientFromEdict(pEdict);

	if (!pClient)
		return NULL;

	return GetBotFromClient(pClient);
}

CBotManager::CBotManager() : m_bNumberOfBots(0), m_bPrevNumberBots(0), m_fBalanceTeamsDelay(0.0),
							 m_bBotsSearchEnemies(true), m_bBotsShoot(true), m_bBotsMove(true),
							 m_bBotsUseDiscs(true), m_bObserverMode(false), m_bBotsAreIdle(false),
							 m_bBalanceTeams(false), m_bShouldBotsChat(true), 
							 m_bBotsFollowTeamMates(false), m_fAddBotDelay(30.0), 
							 m_bFillWholeServer(false), m_bFillHalfTeam(false), m_bFillTeam(false),
							 m_bTeamToFill(0), m_bBotsToCreate(0), m_sMinBots(-1), m_sMaxBots(-1),
							 m_fRestoreBotsTime(0.0), m_bRestoringBots(false), 
							 m_bSpawnTimeReset(false), m_fOldPLCatchupValue(0.0), m_bSBotCount(0),
							 m_fSBotRulesDelay(0.0), m_fBotCFGPauseTime(0.0), m_pBotCFGFile(NULL),
							 m_bCheckNumBotsCVar(true), m_fCheckSkillCVarDelay(0.0),
							 m_sDefaultSkill(1)
{
	m_pKickedBots = new TLinkedList<SKickedBot*>;
}

CBotManager::~CBotManager()
{
	if (m_pKickedBots)
	{
		while (m_pKickedBots->Empty() == false)
			delete m_pKickedBots->Pop();

		delete m_pKickedBots;
	}
}

// List operation functions
void CBotManager::SetSkillTo(CClient *pClient, short NewSkill)
{
	CBot *pBot = GetBotFromClient(pClient);
	if (pBot)
		pBot->SetSkill(NewSkill);
}

void CBotManager::KickMultipleBots(CClient *pClient, short Team)
{
	if ((pClient->IsBot()) && ((Team == -1) || (pClient->GetTeam() == Team)))
		UTIL_KickPlayer(pClient->pEdict);
}

bool CBotManager::ChangeBotsTeam(CClient *pClient, short Team, short *pCount)
{
	if ((pClient->IsBot()) && (pClient->GetTeam() != Team))
	{
		*pCount--;
		pClient->SetTeam(Team);
	}
	return(*pCount > 0);
}

void CBotManager::LetRealPlayersJoinGood(CClient *pClient)
{
	// A normal player AND in team good?
	if ((pClient->IsBot() == false) && (pClient->GetTeam() == 1))
		pClient->SetTeam(1);
}

CBot *CBotManager::GetLastBot()
{
	CClient *pClient = pClientManager->pClientList->FindIfLast(&UTIL_IsBot);
	return GetBotFromClient(pClient);
}

#endif
void BotSpawnInit( bot_t *pBot )
{
   pBot->prev_speed=0.0;

   pBot->ChargeBeamVal = 0;

   pBot->CombatNavDir = 0;
   pBot->CombatNavDelay = 0.0;

   pBot->pTouchEnt = NULL;
   pBot->SelectCookie = false;

   pBot->CheckKameTorpTime = 0.0;
   pBot->LastKameTorpLeftOverCheck = 0.0;

   pBot->pGoalDB = NULL;
   pBot->DBCheckDelay = 0.0f;
   pBot->SelectWish = false;
   pBot->MadeWish = false;

   pBot->AbsorbHealthTime = 0.0;
   pBot->LastSoundPlayedTime = 0.0;

   if (pBot->pBotCombo)
	   DeleteCombos(pBot);

   pBot->TaskAfterTask = TaskNone;
   if ((pBot->CurrentBotTask) || (pBot->CurrentBotSubTask))
	   KillCurrentTask(pBot);

   pBot->pEdict->v.renderfx = kRenderFxNone;
   pBot->pEdict->v.rendermode = kRenderTransTexture;
   pBot->pEdict->v.renderamt = 255;

   pBot->WallJumpCheckDelay = 0.0;

   pBot->f_search_enemy_delay = 0.0;
   pBot->LastEnemySwoopCheck = 0.0;
   pBot->HasAnEnemyTime = 0.0;

   pBot->JumpDir = 0;

   memset(pBot->EnemyList,0,sizeof(pBot->EnemyList));
   memset(pBot->PlayerList,0,sizeof(pBot->PlayerList));

   pBot->MadePlayerList = false;
   pBot->PlayerCount = 0;

   pBot->MoveDir = 0;

   pBot->CheckUpDownTime = 0.0;

   pBot->DangerLevel = 0;
   pBot->DangerType = 0;

   pBot->AimDelay = 0.0;
   pBot->DelayForAimDelay = 0.0f;
   pBot->f_aim_tracking_time = 0.0;
   pBot->f_aim_x_angle_delta = 0.0;
   pBot->f_aim_y_angle_delta = 0.0;
   pBot->AimVec = WrapAngles(pBot->pEdict->v.v_angle);
   pBot->BodyVec = pBot->AimVec;
   pBot->YawSpeed = 0.0;
   pBot->PitchSpeed = 0.0;

   pBot->SwoopType = SWOOP_NORMAL;
   pBot->SwoopOffset = g_vecZero;
   pBot->SwoopOffsetUpdateDelay = 0.0f;
   pBot->SwoopButton = 0;

   pBot->AscendTime = 0.0;
   pBot->BeamJumpSpot = g_vecZero;

   DeleteCombos(pBot);

   pBot->f_tele_combo_delay = 0.0;

   pBot->bot_powerstrug = 127;

   pBot->pHuntingEdict = NULL;
   pBot->HuntDelayTime = 0.0;
   pBot->pLastHuntEdict = NULL;

   pBot->HuntPos.Place = Vector(0,0,0);
   pBot->HuntPos.CreateTime = 0.0;
   pBot->PrevHuntDist = 0.0;
   pBot->UpdateHuntPosTime = 0.0;

   pBot->b_bot_say = FALSE;
   pBot->f_bot_say = 0.0;
   pBot->bot_say_msg[0] = 0;
   pBot->f_bot_chat_time = gpGlobals->time;
   pBot->flReplyDelay = gpGlobals->time;
   
   pBot->f_strafe_time = 0.0;
   pBot->StrafeDir = 0;

   pBot->f_strafe_speed = 0.0;
   pBot->f_updown_speed = 0.0;

   pBot->LastHitTime = 0.0;
   pBot->DamageTaken = 0;

   pBot->teleport_delay = 0.0;
   pBot->TeleportDir = 0;

   pBot->bot_ki = 1000;
   pBot->turbo_time = 0;
   pBot->BotPowerUpDelay = 0.0;
   pBot->v_prev_origin = Vector(9999.0, 9999.0, 9999.0);
   pBot->prev_time = gpGlobals->time;

   pBot->waypoint_origin = Vector(0, 0, 0);
   pBot->f_waypoint_time = 0.0;
   pBot->curr_waypoint_index = -1;
   pBot->prev_waypoint_index[0] = -1;
   pBot->prev_waypoint_index[1] = -1;
   pBot->prev_waypoint_index[2] = -1;
   pBot->prev_waypoint_index[3] = -1;
   pBot->prev_waypoint_index[4] = -1;

   pBot->f_random_waypoint_time = gpGlobals->time;
   pBot->waypoint_goal = -1;
   pBot->f_waypoint_goal_time = 0.0;
   pBot->prev_waypoint_distance = 0.0;

   pBot->msecnum = 0;
   pBot->msecdel = 0.0;
   pBot->msecval = 0.0;

   pBot->bot_health = 0;
   pBot->bot_weapons = 0;
   pBot->blinded_time = 0.0;

   pBot->f_max_speed = 180.000000; // player begins with it when spawnig 
                                   // so not really needed

   pBot->prev_speed = 0.0;  // fake "paused" since bot is NOT stuck

   pBot->f_dont_avoid_wall_time = 0.0;
   pBot->f_look_for_waypoint_time = 0.0;
   pBot->f_dont_check_stuck = 0.0;

   // pick a wander direction (50% of the time to the left, 50% to the right)
   if (RANDOM_LONG(1, 100) <= 50)
      pBot->wander_dir = WANDER_LEFT;
   else
      pBot->wander_dir = WANDER_RIGHT;

   pBot->pBotEnemy = NULL;
   
   pBot->pBotUser = NULL;
   pBot->pBotLastUser = NULL;
   pBot->movingusertime = 0.0;
   pBot->searchforuser = 0.0;
   pBot->UsingTime = 0.0;

   pBot->f_bot_use_time = 0.0;
   pBot->b_bot_say_killed = FALSE;
   pBot->f_bot_say_killed = 0.0;

   pBot->f_shoot_time = gpGlobals->time;
   pBot->f_primary_charging = -1.0;
   pBot->f_secondary_charging = -1.0;
   pBot->charging_weapon_id = 0;

   pBot->f_pause_time = 0.0;

   pBot->UpdateTransTime = 0.0;
   pBot->TransparantValue = 255;
   pBot->TransparantFactor = -1;
   pBot->LastBeamDrawTime = 0.0;

   memset(&(pBot->current_weapon), 0, sizeof(pBot->current_weapon));
   memset(&(pBot->m_rgAmmo), 0, sizeof(pBot->m_rgAmmo));
}

void BotCreate( edict_t *pPlayer, const char *arg1, const char *arg2,
                const char *arg3, const char *arg4, const char *arg5)
{
   edict_t *BotEnt;
   bot_t *pBot;
   char c_name[BOT_NAME_LEN+1];
   int skill;
   int i, j, length;
//   bool found = FALSE;

   if ((arg3 != NULL) && (*arg3 != 0))
   {
      strncpy( c_name, arg3, BOT_NAME_LEN-1 );
      c_name[BOT_NAME_LEN] = 0;  // make sure c_name is null terminated
   }
   else
   {
      if (number_names > 0)
         BotPickName( c_name );
      else
         strcpy(c_name, "Bot");
   }

   skill = 0;

   if ((arg4 != NULL) && (*arg4 != 0))
      skill = atoi(arg4);
         
   if ((skill < 1) || (skill > 5))
      skill = default_bot_skill;
   

   length = strlen(c_name);

   // remove any illegal characters from name...
   for (i = 0; i < length; i++)
   {
      if ((c_name[i] < ' ') || (c_name[i] > '~') ||
          (c_name[i] == '"'))
      {
         for (j = i; j < length; j++)  // shuffle chars left (and null)
            c_name[j] = c_name[j+1];
         length--;
      }               
   }

   BotEnt = CREATE_FAKE_CLIENT( c_name );

   if (FNullEnt( BotEnt ))
   {
	   UTIL_Printf("Max. Players reached.  Can't create bot!\n");
   }
   else
   {
      char ptr[128];  // allocate space for message from ClientConnect
      char *infobuffer;
      int clientIndex;
      int index;

      UTIL_Printf("Creating bot...\n");

      index = 0;
      while ((bots[index].is_used) && (index < 32))
         index++;

      if (index == 32)
      {
         UTIL_Printf("Can't create bot!\n");
         return;
      }

      // create the player entity by calling MOD's player function
      // (from LINK_ENTITY_TO_CLASS for player object)

      FREE_PRIVATE(BotEnt); // IMPORTANT: Fix the kick bot problem 
      BotEnt->pvPrivateData = NULL; 
	  BotEnt->v.frags = 0;

      player( VARS(BotEnt) );

      infobuffer = GET_INFOBUFFER( BotEnt );
      clientIndex = ENTINDEX( BotEnt );


      SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "model", "gina" );

      ClientConnect( BotEnt, c_name, "127.0.0.1", ptr );

      // Pieter van Dijk - use instead of DispatchSpawn() - Hip Hip Hurray!
      ClientPutInServer( BotEnt );

      BotEnt->v.flags |= FL_FAKECLIENT;

      // initialize all the variables for this bot...

      pBot = &bots[index];

      pBot->is_used = TRUE;
      pBot->respawn_state = RESPAWN_IDLE;
      pBot->create_time = gpGlobals->time;
      pBot->name[0] = 0;  // name not set by server yet

      pBot->NumberWeapons = 0;

	  pBot->f_prev_playermove_time = 0.0;

	  if (pBot->pBotWeaponList)
		  delete pBot->pBotWeaponList;

	  pBot->pBotWeaponList = new TLinkedList<short>;

      pBot->pEdict = BotEnt;
	  pBot->pBotClient = UTIL_GetClientPointer(BotEnt);
	  assert(pBot->pBotClient);

      pBot->not_started = 1;  // hasn't joined game yet

      pBot->start_action = MSG_IDLE;

      BotSpawnInit(pBot);

      pBot->need_to_initialize = FALSE;  // don't need to initialize yet

      BotEnt->v.idealpitch = BotEnt->v.v_angle.x;
      BotEnt->v.ideal_yaw = BotEnt->v.v_angle.y;

      pBot->idle_angle = 0.0;

      pBot->bot_skill = skill - 1;  // 0 based for array indexes

      pBot->bot_team = -1;
      pBot->bot_class = -1;

	  pBot->pLastEnemy = NULL;

      if ((arg1 != NULL) && (arg1[0] != 0))
      {
         pBot->bot_team = atoi(arg1);
      }

	  if ((arg2 != NULL) && (arg2[0] != 0))
	  {
          pBot->bot_class = atoi(arg2);
      }

	  if ((arg5 != NULL) && (arg5[0] != 0))
	  {
		  short temp = atoi(arg5);

		  if (temp >= 1 && temp <= 9)
			  pBot->Personality = temp - 1;
		  else
			  pBot->Personality = RANDOM_LONG(0, 8);
	  }
	  else if (DefaultPersonality > 0)
	  {
		  pBot->Personality = DefaultPersonality - 1;
	  }
	  else
	  {
		  pBot->Personality = RANDOM_LONG(0, 8);
	  }

	  pBot->MeleePercent = BotPersonalities[pBot->Personality].melee_percent;
	  pBot->TeleportPercent = BotPersonalities[pBot->Personality].teleport_percent;
	  pBot->SwoopPercent = BotPersonalities[pBot->Personality].swoop_percent;
	  pBot->FlyPercent = BotPersonalities[pBot->Personality].fly_percent;
	  pBot->AggressionLevel = BotPersonalities[pBot->Personality].aggression_level;

      pBot->chat_percent = BotPersonalities[pBot->Personality].chat_percent;
      pBot->taunt_percent = BotPersonalities[pBot->Personality].taunt_percent;
      pBot->whine_percent = BotPersonalities[pBot->Personality].whine_percent;
      pBot->chat_tag_percent = BotPersonalities[pBot->Personality].chat_tag_percent;
      pBot->chat_drop_percent = BotPersonalities[pBot->Personality].chat_drop_percent;
      pBot->chat_swap_percent = BotPersonalities[pBot->Personality].chat_swap_percent;
      pBot->chat_lower_percent = BotPersonalities[pBot->Personality].chat_lower_percent;

	  pBot->VisiblePlayers = 0;

	  pBot->CurrentBotTask = NULL;
	  pBot->CurrentBotSubTask = NULL;

	  pBot->SBotType = -1;
   }   
}

void SBotCreate( edict_t *pPlayer, const char *arg1, int type, const char *arg3)
{
#ifndef SBotFights
   if (IsTeamPlay() == false)
   {
	   cout << "You cannot make super bots in free fight\n";
	   return;
   }
#endif

   edict_t *BotEnt;
   bot_t *pBot;
   char c_name[BOT_NAME_LEN+1];
   char c[BOT_NAME_LEN+1];
   int skill;
   int i, j, length;
   int BotIndex = -1;
   bool AreSBotsInGame = false;

   if (number_names > 0)
      BotPickName( c );
   else
      strcpy(c, "Bot");

   sprintf(c_name,"[SBot%i]%s",type,c);

   skill = 1;

   length = strlen(c_name);

   // remove any illegal characters from name...
   for (i = 0; i < length; i++)
   {
      if ((c_name[i] <= ' ') || (c_name[i] > '~') ||
          (c_name[i] == '"'))
      {
         for (j = i; j < length; j++)  // shuffle chars left (and null)
            c_name[j] = c_name[j+1];
         length--;
      }               
   }

   BotEnt = CREATE_FAKE_CLIENT( c_name );

   if (FNullEnt( BotEnt ))
   {
	   UTIL_Printf("Max. Players reached.  Can't create bot!\n");
   }
   else
   {
	  char ptr[128];  // allocate space for message from ClientConnect
      char *infobuffer;
      int clientIndex;
      int index;

      if (IS_DEDICATED_SERVER())
         UTIL_Printf("Creating bot...\n");
      else if (pPlayer)
         ClientPrint( pPlayer, HUD_PRINTNOTIFY, "Creating bot...\n");

      index = 0;
      while ((bots[index].is_used) && (index < 32))
         index++;

      if (index == 32)
      {
         ClientPrint( pPlayer, HUD_PRINTNOTIFY, "Can't create bot!\n");
         return;
      }

      // create the player entity by calling MOD's player function
      // (from LINK_ENTITY_TO_CLASS for player object)

      FREE_PRIVATE(BotEnt); // IMPORTANT: Fix the kick bot problem 
      BotEnt->pvPrivateData = NULL; 
	  BotEnt->v.frags = 0;

      player( VARS(BotEnt) );

      infobuffer = GET_INFOBUFFER( BotEnt );
      clientIndex = ENTINDEX( BotEnt );

      SET_CLIENT_KEY_VALUE( clientIndex, infobuffer, "model", "gina" );

      ClientConnect( BotEnt, c_name, "127.0.0.1", ptr );

      // Pieter van Dijk - use instead of DispatchSpawn() - Hip Hip Hurray!
      ClientPutInServer( BotEnt );

      BotEnt->v.flags |= FL_FAKECLIENT;

      // initialize all the variables for this bot...

      pBot = &bots[index];
 
	  pBot->f_prev_playermove_time = 0.0;

	  if (pBot->pBotWeaponList)
		  delete pBot->pBotWeaponList;

	  pBot->pBotWeaponList = new TLinkedList<short>;

      pBot->is_used = TRUE;
      pBot->respawn_state = RESPAWN_IDLE;
      pBot->create_time = gpGlobals->time;
      pBot->name[0] = 0;  // name not set by server yet

	  pBot->NumberWeapons = 0;

      pBot->pEdict = BotEnt;
	  pBot->pBotClient = UTIL_GetClientPointer(BotEnt);
	  assert(pBot->pBotClient);

      pBot->not_started = 1;  // hasn't joined game yet

      pBot->start_action = MSG_IDLE;

      BotSpawnInit(pBot);

      pBot->need_to_initialize = FALSE;  // don't need to initialize yet

      BotEnt->v.idealpitch = BotEnt->v.v_angle.x;
      BotEnt->v.ideal_yaw = BotEnt->v.v_angle.y;

      pBot->idle_angle = 0.0;

      pBot->bot_skill = skill - 1;  // 0 based for array indexes

      pBot->bot_team = 2;
      pBot->bot_class = -1;

      pBot->pLastEnemy = NULL;

      if ((arg1 != NULL) && (arg1[0] != 0))
      {
         pBot->bot_class = atoi(arg1);
      }


      if ((arg3 != NULL) && (arg3[0] != 0))
	  {
		  pBot->Personality = atoi(arg3) - 1;
	  }
	  else if (DefaultPersonality > 0)
	  {
		  pBot->Personality = DefaultPersonality - 1;
	  }
	  else
	  {
		  pBot->Personality = RANDOM_LONG(0, 8);
	  }

	  if (pBot->Personality < 0)
		  pBot->Personality = 0;
	  else if (pBot->Personality > 8)
		  pBot->Personality = 8;

	  pBot->MeleePercent = BotPersonalities[pBot->Personality].melee_percent;
	  pBot->TeleportPercent = BotPersonalities[pBot->Personality].teleport_percent;
	  pBot->SwoopPercent = BotPersonalities[pBot->Personality].swoop_percent;
	  pBot->FlyPercent = BotPersonalities[pBot->Personality].fly_percent;
	  pBot->AggressionLevel = BotPersonalities[pBot->Personality].aggression_level;

      pBot->chat_percent = BotPersonalities[pBot->Personality].chat_percent;
      pBot->taunt_percent = BotPersonalities[pBot->Personality].taunt_percent;
      pBot->whine_percent = BotPersonalities[pBot->Personality].whine_percent;
      pBot->chat_tag_percent = BotPersonalities[pBot->Personality].chat_tag_percent;
      pBot->chat_drop_percent = BotPersonalities[pBot->Personality].chat_drop_percent;
      pBot->chat_swap_percent = BotPersonalities[pBot->Personality].chat_swap_percent;
      pBot->chat_lower_percent = BotPersonalities[pBot->Personality].chat_lower_percent;

	  pBot->VisiblePlayers = 0;

	  pBot->CurrentBotTask = NULL;
	  pBot->CurrentBotSubTask = NULL;

	  if ((type >= 1) && (type <= 3))
		  pBot->SBotType = type;
	  else
		  pBot->SBotType = RANDOM_LONG(1, 3);

	  pBot->UpdateTransTime = 0.0;
	  pBot->TransparantValue = 255;
	  pBot->TransparantFactor = -1;
	  pBot->f_check_sbot_delay = gpGlobals->time + 1.0f;

	  for (int i=1;i<=gpGlobals->maxClients;i++)
	  {
		  pPlayer = INDEXENT(i);

		  if (pPlayer == pBot->pEdict)
			  continue;

		  if (IsNull(pPlayer))
			  continue;

		  BotIndex = UTIL_GetBotIndex(pPlayer);
		  if (BotIndex > -1)
		  {
			  if (bots[BotIndex].SBotType > -1)
			  {
				  AreSBotsInGame = true;
				  break;
			  }
		  }
	  }
	  if (!AreSBotsInGame)
	      OldPlCatchupValue = CVAR_GET_FLOAT("mp_plcatchup");	
   }
}

void BotStartGame( bot_t *pBot )
{
   char c_team[32];
   char c_class[32];

   int index;

   edict_t *pPlayer;
   int team;

   edict_t *pEdict = pBot->pEdict;

   if (pBot->start_action == MSG_MOTD)
   {
	   if (RANDOM_LONG(1, 100) < 50)
		   pEdict->v.button = IN_ATTACK;
	   return;
   }
  
   if ((pBot->start_action == MSG_IDLE) &&
       (pBot->create_time + 3.0 <= gpGlobals->time))
   {
	   pBot->start_action = MSG_TEAM_SELECT;  // force team selection
   }

   if (pBot->start_action == MSG_TEAM_SELECT)
   {
         pBot->start_action = MSG_IDLE;  // switch back to idle
         pBot->create_time = gpGlobals->time;  // reset

         if ((pBot->bot_team != 1) && (pBot->bot_team != 2)) 
            pBot->bot_team = -1;

         if (pBot->bot_team == -1)
         {
			 int CountGood, CountEvil;
			 CountGood = CountEvil = 0;

			 for(index=1;index<=gpGlobals->maxClients;index++)
			 {
				pPlayer = INDEXENT(index);
				if (UTIL_IsValidPlayer(pPlayer, false, false))
				{
					if (UTIL_GetTeam(pPlayer) == 0)
						CountGood++;
					else
						CountEvil++;
				}
			 }

			 if (CountGood > CountEvil)
				pBot->bot_team = 2;
			 else if (CountGood < CountEvil)
				pBot->bot_team = 1;
			 else
				pBot->bot_team = RANDOM_LONG(1, 2);
		 }

         // select the team the bot wishes to join...
         if (pBot->bot_team == 1)
            strcpy(c_team, "1");
         else if (pBot->bot_team == 2)
            strcpy(c_team, "2");
         else 
            strcpy(c_team, "5");

         FakeClientCommand(pEdict, "jointeam", c_team, NULL);
         pBot->start_action = MSG_CLASS_SELECT;
         return;
      }

      if (pBot->start_action == MSG_CLASS_SELECT)
      {
         char cvar_realteams[33] = "";
		 char cvar_charlimit[33] = "";

		 strcpy(cvar_realteams, (char *)CVAR_GET_STRING("mp_realteams"));
		 strcpy(cvar_charlimit, (char *)CVAR_GET_STRING("mp_characterlimit"));

		 int ValidClasses = ((1<<1) | (1<<2) | (1<<3) | (1<<4) | (1<<5) | (1<<6) | (1<<7) |
							 (1<<8) | (1<<9));

		 pBot->start_action = MSG_IDLE;  // switch back to idle
         pBot->create_time = gpGlobals->time;  // reset

         if ((pBot->bot_class < 1) || (pBot->bot_class > 9))
            pBot->bot_class = RANDOM_LONG(1, 9);

         team = UTIL_GetTeam(pEdict);

         if ((cvar_realteams && cvar_realteams[0]) && (strncmp(cvar_realteams, "1", 1) == 0) && 
			 (IsTeamPlay()))
         {
			 if (pBot->bot_team == 1)
			 {
				 ValidClasses = 0;
				 ValidClasses = ((1<<2) | (1<<3) | (1<<4) | (1<<6) | (1<<7));
				 if ((pBot->bot_class != 2) && (pBot->bot_class != 3) && (pBot->bot_class != 4) &&
					 (pBot->bot_class != 6) && (pBot->bot_class != 7))
				 {
					 if (RANDOM_LONG(1, 2) < 2)
						 pBot->bot_class = RANDOM_LONG(2, 4);
					 else
						 pBot->bot_class = RANDOM_LONG(6, 7);
				 }
			 }
			 else
			 {
				 ValidClasses = 0;
				 ValidClasses = ((1<<1) | (1<<5) | (1<<8) | (1<<9));
				 if ((pBot->bot_class != 1) && (pBot->bot_class != 5) && (pBot->bot_class != 8) &&
					 (pBot->bot_class != 9))
				 {
					 int i = RANDOM_LONG(1, 3);

                     switch (i)
					 {
					 case 1:
     					 pBot->bot_class = 1;
						 break;
					 case 2:
						 pBot->bot_class = 5;
						 break;
					 case 3:
						 pBot->bot_class = RANDOM_LONG(8, 9);
						 break;
					 default:
						 break;
					 }
				 }
			 }
		 }

		 // Is there a class limit?
		 if ((cvar_charlimit && cvar_charlimit[0]) && (strncmp(cvar_charlimit, "0", 1) != 0))
		 {
			 short CharLimit = static_cast<short>(CVAR_GET_FLOAT("mp_characterlimit"));
			 byte BuuCount = 0;
			 byte GokuCount = 0;
			 byte GohanCount = 0;
			 byte KrillinCount = 0;
			 byte FriezaCount = 0;
			 byte PiccoloCount = 0;
			 byte TrunksCount = 0;
			 byte VegetaCount = 0;
			 byte CellCount = 0;
			 byte PlayerClass = 0;

			 // Count all the classes
			 for (index=1;index<=gpGlobals->maxClients;index++)
			 {
				 pPlayer = INDEXENT(index);
				 if (pPlayer == pBot->pEdict)
					 continue;

				 if (UTIL_IsValidPlayer(pPlayer, false, false))
				 {
					 PlayerClass = UTIL_GetClass(pPlayer);
					 if (PlayerClass == 1)
					 {
						 BuuCount++;
						 if (BuuCount >= CharLimit)
							 ValidClasses &= ~(1<<1);
					 }
					 else if (PlayerClass == 2)
					 {
						 GokuCount++;
						 if (GokuCount >= CharLimit)
							 ValidClasses &= ~(1<<2);
					 }
					 else if (PlayerClass == 3)
					 {
						 GohanCount++;
						 if (GohanCount >= CharLimit)
							 ValidClasses &= ~(1<<3);
					 }
					 else if (PlayerClass == 4)
					 {
						 KrillinCount++;
						 if (KrillinCount >= CharLimit)
							 ValidClasses &= ~(1<<4);
					 }
					 else if (PlayerClass == 5)
					 {
						 FriezaCount++;
						 if (FriezaCount >= CharLimit)
							 ValidClasses &= ~(1<<5);
					 }
					 else if (PlayerClass == 6)
					 {
						 PiccoloCount++;
						 if (PiccoloCount >= CharLimit)
							 ValidClasses &= ~(1<<6);
					 }
					 else if (PlayerClass == 7)
					 {
						 TrunksCount++;
						 if (TrunksCount >= CharLimit)
							 ValidClasses &= ~(1<<7);
					 }
					 else if (PlayerClass == 8)
					 {
						 VegetaCount++;
						 if (VegetaCount >= CharLimit)
							 ValidClasses &= ~(1<<8);
					 }
					 else if (PlayerClass == 9)
					 {
						 CellCount++;
						 if (CellCount >= CharLimit)
							 ValidClasses &= ~(1<<9);
					 }
				 }
			 }

			 if ((ValidClasses & (1<<pBot->bot_class)) == 0)
			 {
				 int ClassesChecked = 0;
				 short attempts = 999;
				 short RandNr;

				 do
				 {
					 attempts--;
					 if (attempts == 0) // just in case...
					 {
						 cout << "Error! bot: " << STRING(pEdict->v.netname) << 
								 " couldn't pick a class\n";
						 break;
					 }

					 RandNr = RANDOM_LONG(1, 9);
					 if (ClassesChecked & (1<<RandNr))
						 continue;

					 ClassesChecked |= (1<<RandNr);
					 if (ValidClasses & (1<<RandNr))
					 {
						 pBot->bot_class = RandNr;
						 break;
					 }
				 }
				 while (((ClassesChecked & (1<<1)) == 0) || ((ClassesChecked & (1<<2)) == 0) ||
						((ClassesChecked & (1<<3)) == 0) || ((ClassesChecked & (1<<4)) == 0) ||
						((ClassesChecked & (1<<5)) == 0) || ((ClassesChecked & (1<<6)) == 0) ||
						((ClassesChecked & (1<<7)) == 0) || ((ClassesChecked & (1<<8)) == 0) ||
						((ClassesChecked & (1<<9)) == 0));
			 }
		 }

         // select the class the bot wishes to use...
         if (pBot->bot_class == 1)
            strcpy(c_class, "buu");
         else if (pBot->bot_class == 2)
            strcpy(c_class, "goku");
         else if (pBot->bot_class == 3)
            strcpy(c_class, "gohan");
         else if (pBot->bot_class == 4)
            strcpy(c_class, "krillin");
         else if (pBot->bot_class == 5)
            strcpy(c_class, "frieza");
         else if (pBot->bot_class == 6)
            strcpy(c_class, "piccolo");
         else if (pBot->bot_class == 7)
            strcpy(c_class, "trunks");
         else if (pBot->bot_class == 8)
            strcpy(c_class, "vegeta");
         else if (pBot->bot_class == 9)
            strcpy(c_class, "cell");
	     else 
	        strcpy(c_class, "randompc");

         FakeClientCommand(pEdict, c_class, NULL, NULL);

         // bot has now joined the game (doesn't need to be started)
         pBot->not_started = 0;

		 if (RANDOM_LONG(1, 100) <= 50)
			 pChatClass->LetBotSayAWelcomeSentence(pBot); // Let him greet

         return;
      }
}

// Make random super bot settings or read them out of the file
// 'sbot.cfg'
void MakeSBotSettings()
{
	char SBotFileName[256] = "";
	FILE *SBotFile = NULL;
	int SBotNr = -1;
    int value = 0;

	memset(SBotSettings,0,sizeof(SBotSettings));

	UTIL_BuildFileName(SBotFileName, "sbot.cfg", NULL);

	SBotFile = fopen(SBotFileName, "r");

	// make random sbot settings, in case the file doesnt exist or has 
	// missing settings
	for (SBotNr = 0;SBotNr < 3;SBotNr++)
	{
		SBotSettings[SBotNr].ki_gain = RANDOM_LONG(-1, 5);
		SBotSettings[SBotNr].health_gain = RANDOM_LONG(-1, 5);
		SBotSettings[SBotNr].pl = RANDOM_LONG(3500000, 10000000);
		SBotSettings[SBotNr].transparency_val = RANDOM_LONG(1, 255);
		SBotSettings[SBotNr].laser_percent = RANDOM_LONG(0, 100);
	}

	(*g_engfuncs.pfnServerPrint) ("Reading sbot.cfg file... ");

	if (SBotFile == NULL) // file doesn't exist
	{
		(*g_engfuncs.pfnServerPrint) ("file not found, random settings will be used\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	static char server_cmd[80];
	char *cmd, *arg1, *arg2, *arg3, *arg4;

	while (SBotFile)
	{    
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(SBotFile);

		// skip any leading blanks
		while (ch == ' ')
		ch = fgetc(SBotFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
		      ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(SBotFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') &&
		             (ch == ' '))      
         		ch = fgetc(SBotFile);

		      cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
			ch = fgetc(SBotFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
		    fclose(SBotFile);
			SBotFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		// copy the command line to a server command buffer...
		strcpy(server_cmd, cmd_line);
		strcat(server_cmd, "\n");

		cmd_index = 0;
		cmd = cmd_line;
		arg1 = arg2 = arg3 = arg4 = NULL;

		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		      cmd_index++;

		if (cmd_line[cmd_index] == ' ')
		{
		      cmd_line[cmd_index++] = 0;
		      arg1 = &cmd_line[cmd_index];

		      // skip to blank or end of string...
		      while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		         cmd_index++;

		      if (cmd_line[cmd_index] == ' ')
			  {
		         cmd_line[cmd_index++] = 0;
		         arg2 = &cmd_line[cmd_index];

		         // skip to blank or end of string...
		         while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		            cmd_index++;

		         if (cmd_line[cmd_index] == ' ')
		         {
		            cmd_line[cmd_index++] = 0;
		            arg3 = &cmd_line[cmd_index];

            		// skip to blank or end of string...
		            while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
            		   cmd_index++;

		            if (cmd_line[cmd_index] == ' ')
            		{
		               cmd_line[cmd_index++] = 0;
		               arg4 = &cmd_line[cmd_index];
            		}
				 }
			  }
		}
		if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
			continue;  // skip if comment or blank line


		if (strcmp(cmd, "[SUPERBOT]") == 0)
			SBotNr = 0; // sbot1
		else if (strcmp(cmd, "[MEGABOT]") == 0)
			SBotNr = 1; // sbot 2
		else if (strcmp(cmd, "[ULTIMATEBOT]") == 0)
			SBotNr = 2; // sbot 3

		if ((arg1 == NULL) || (*arg1 == 0))
		    continue;

		if (SBotNr == -1)
			continue;

		value = atoi(arg1);

		if (strcmp(cmd, "ki_gain") == 0)
		{
			if ((value >= -1) && (value <= 1000))
				SBotSettings[SBotNr].ki_gain = value;
			else
				SBotSettings[SBotNr].ki_gain = RANDOM_LONG(-1, 5);
		}
		else if (strcmp(cmd, "health_gain") == 0)
		{
			if ((value >= -1) && (value <= 250))
				SBotSettings[SBotNr].health_gain = value;
			else
				SBotSettings[SBotNr].health_gain = RANDOM_LONG(-1, 5);
		}
		else if (strcmp(cmd, "powerlevel") == 0)
		{
			if ((value >= 650000) && (value <= 99999999))
				SBotSettings[SBotNr].pl = value;
			else
				SBotSettings[SBotNr].pl = RANDOM_LONG(650000, 10000000);
		}
		else if (strcmp(cmd, "transparency_val") == 0)
		{
			if ((value == -1) || ((value >= 1) && (value <= 255)))
				SBotSettings[SBotNr].transparency_val = value;
			else
				SBotSettings[SBotNr].transparency_val = RANDOM_LONG(1, 255);
		}
		else if (strcmp(cmd, "sbotlaser_percent") == 0)
		{
			if ((value >= 0) && (value <= 100))
				SBotSettings[SBotNr].laser_percent = value;
			else
				SBotSettings[SBotNr].laser_percent = RANDOM_LONG(0, 100);
		}			 		
	}
	(*g_engfuncs.pfnServerPrint) ("done\n");
}

void DoSBotStuff(bot_t *pBot)
{
	if (pBot->SBotType < 1)
		return;

	edict_t *pEdict = pBot->pEdict;

	if (IsAlive(pBot->pEdict))
	{
		if (pEdict->v.renderfx != kRenderFxGlowShell)
			pEdict->v.rendermode = kRenderTransTexture;

		// when on low health, fade in - fade out or when transparency_val == -1
		if ((pEdict->v.health < 10) || (SBotSettings[pBot->SBotType-1].transparency_val == -1) &&
			(pEdict->v.renderfx != kRenderFxGlowShell))
		{
			if (pBot->UpdateTransTime < gpGlobals->time)
			{
				pBot->UpdateTransTime = gpGlobals->time + 0.0;

				if (pBot->TransparantValue < 20)
					pBot->TransparantFactor = 1;
				else if (pBot->TransparantValue >= 255)
					pBot->TransparantFactor = -1;

				pBot->TransparantValue += (3 * pBot->TransparantFactor);
		
				if (pBot->TransparantValue > 255)
					pBot->TransparantValue = 255;
				else if (pBot->TransparantValue < 0)
					pBot->TransparantValue = 0;
			}
			pEdict->v.renderamt = pBot->TransparantValue;
		}
		else
		{
			if (pEdict->v.renderfx != kRenderFxGlowShell)
				pEdict->v.renderamt = SBotSettings[pBot->SBotType-1].transparency_val;
		}

	    if (pBot->PL < SBotSettings[pBot->SBotType-1].pl)
		{
			UTIL_ChangePl(pEdict, SBotSettings[pBot->SBotType-1].pl);
			UTIL_ChangeRealPl(pEdict, SBotSettings[pBot->SBotType-1].pl);
		}
		
		if (pBot->bot_ki < 1000)
		{
			if (SBotSettings[pBot->SBotType-1].ki_gain == -1)
				UTIL_ChangeKi(pEdict, 1000);
			else if (pBot->f_check_sbot_delay < gpGlobals->time)
			{
				int NewKiValue = pBot->bot_ki + SBotSettings[pBot->SBotType-1].ki_gain;
				if (NewKiValue > 1000)
					NewKiValue = 1000;
				UTIL_ChangeKi(pEdict, NewKiValue);
			}
		}
	
		if (pEdict->v.health < pBot->max_health)
		{
			if (SBotSettings[pBot->SBotType-1].health_gain == -1)
				pEdict->v.health = pBot->max_health;
			else if (pBot->f_check_sbot_delay < gpGlobals->time)
			{
				int NewHealth = pEdict->v.health + SBotSettings[pBot->SBotType-1].health_gain;
				if (NewHealth > pBot->max_health)
					NewHealth = pBot->max_health;
				pEdict->v.health = NewHealth;
			}
		}
	}

	if (pBot->f_check_sbot_delay < gpGlobals->time)
	{
		pBot->f_check_sbot_delay = gpGlobals->time + 1.0;
#ifndef SBotFights
		edict_t *pPlayer = NULL;
		int bot_index = -1;
		short Team; 

		for (int i=1;i<=gpGlobals->maxClients;i++)
		{
			pPlayer = INDEXENT(i);

			if (pPlayer == pEdict)
				continue;

			if (IsNull(pPlayer))
				continue;

			Team = UTIL_GetTeam(pPlayer);

			if (pPlayer->v.flags & FL_FAKECLIENT)
			{
				bot_index = UTIL_GetBotIndex(pPlayer);

				if (bot_index != -1)
				{
					if (bots[bot_index].SBotType > 0)
						FakeClientCommand(pPlayer,"jointeam","2",NULL);
					else if (pPlayer == listenserver_edict)
						FakeClientCommand(pPlayer,"jointeam","1",NULL);
				}
			}
			else if (Team == 1)
				FakeClientCommand(pPlayer, "jointeam", "1", NULL);
		}
#endif
	}


	if (CVAR_GET_FLOAT("mp_plcatchup")==1)
		CVAR_SET_FLOAT("mp_plcatchup",0);

	char s[10];
	sprintf(s,"[SBot%i]",pBot->SBotType);

	char BotName[32] = "";
	sprintf(BotName,STRING(pEdict->v.netname));

	bool NotDoubleNamed = true;

	if (strstr(BotName,s) == NULL)
		NotDoubleNamed = false;

    if ((strncmp(s, STRING(pEdict->v.netname), 7) != 0) &&
		(NotDoubleNamed == false))
	{
        char *infobuffer;
        int clientIndex;
        infobuffer = g_engfuncs.pfnGetInfoKeyBuffer( pEdict );
	    clientIndex = ENTINDEX( pEdict );
	    char newname[32];
 	    sprintf(newname, "%s%s", s, STRING(pEdict->v.netname));
  
        g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "name", newname );
    }
}

void BotPreThink( bot_t *pBot )
{
   edict_t *pEdict = pBot->pEdict;
   
#ifdef _DEBUG
   if (IsNull(pEdict))
   {   
	   clog << "Corrupt bot ! name: " << pBot->name << " ind: " << UTIL_GetBotIndex(pEdict) << "\n";
	   _asm int 3;
   }
#endif 

   if (pBot->MadePlayerList == true)
	  pBot->MadePlayerList = false;

   if (pBot->PlayerCount != 0)
	   pBot->PlayerCount = 0;

   if (pEdict == listenserver_edict)
   {
	   char s[100];

	   if (LockedAutoCam)
 		   pEdict->v.fixangle = 1;
	   else
		   pEdict->v.fixangle = 0;

	   if (strncmp("[AUTO]", STRING(pEdict->v.netname), 6) != 0)
	   {
		   sprintf(pBot->old_name, STRING(pEdict->v.netname));

           char *infobuffer;
	       int clientIndex;
	       infobuffer = g_engfuncs.pfnGetInfoKeyBuffer( pEdict );
		   clientIndex = ENTINDEX( pEdict );
		   sprintf(s, "[AUTO]%s", STRING(pEdict->v.netname));
	  
	       g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "name", s );
	   }
   }
   else
	   pEdict->v.flags |= FL_FAKECLIENT;

   if (pBot->name[0] == 0)  // name filled in yet?
      strcpy(pBot->name, STRING(pBot->pEdict->v.netname));

   if ((pBot->waypoint_goal != -1) && (debug_mode))
	  UTIL_DrawBeam(listenserver_edict, pEdict->v.origin, waypoints[pBot->waypoint_goal].origin,
				    5, 0, 255, 0, 0, 250, 5);

/*
// TheFatal - START from Advanced Bot Framework (Thanks Rich!)

   // adjust the millisecond delay based on the frame rate interval...
   if (pBot->msecdel <= gpGlobals->time)
   {
      pBot->msecdel = gpGlobals->time + 0.5;
      if (pBot->msecnum > 0)
         pBot->msecval = 450.0/pBot->msecnum;
      pBot->msecnum = 0;
   }
   else
      pBot->msecnum++;

   if (pBot->msecval < 1)    // don't allow msec to be less than 1...
      pBot->msecval = 1;

   if (pBot->msecval > 100)  // ...or greater than 100
      pBot->msecval = 100;

// TheFatal - END
*/

   // or the Leon Hartwig method....
   pBot->msecval = (int) ((gpGlobals->time - pBot->f_prev_playermove_time) * 1000);
   if (pBot->msecval > 255)
      pBot->msecval = 255;
   else if (pBot->msecval < 0)
	   pBot->msecval = 0;
   
   pBot->f_frame_time = pBot->msecval / 1000;  // calculate frame time
   pBot->f_prev_playermove_time = gpGlobals->time; // save date at which the last RunPlayerMove call happened

   pEdict->v.button = 0; // reset buttons
   pBot->f_move_speed = 0.0;

   // does bot need to say a message and time to say a message?
   if ((pBot->b_bot_say) && (pBot->f_bot_say < gpGlobals->time))
   {
      pBot->b_bot_say = FALSE;

	  if (should_bot_chat)
		  UTIL_HostSay(pEdict, 0, pBot->bot_say_msg);
   }

   pBot->bot_ki = int(pEdict->v.fuser4);

   if (pBot->SBotType > 0)
	   DoSBotStuff(pBot);

#ifdef LOGBOTINFO
   if (pBot->CurrentBotTask)
	   clog << "Current task: " << int(pBot->CurrentBotTask->TaskIdentify()) << "\n";
   clog << "Prev task: " << int(pBot->PrevTask) << "\n";
#endif

   return;
}

void BotThink( bot_t *pBot )
{
#ifdef LOGBOTINFO
		clog << "Begin bot think\n";
#endif

   edict_t *pEdict = pBot->pEdict;
  
   // if the bot hasn't selected stuff to start the game yet, go do that...
   if (pBot->not_started)
   {
      BotStartGame( pBot );

      g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, 0.0,
                                   0, 0, pEdict->v.button, 0, pBot->msecval);

      return;
   }
 
   // if the bot is dead, randomly press fire to respawn...
   if ((pEdict->v.health < 1) || (pEdict->v.deadflag != DEAD_NO))
   {
	  if (pBot->need_to_initialize)
      {
         BotSpawnInit(pBot);

         // did another player kill this bot AND bot whine messages loaded AND
         // has the bot been alive for at least 15 seconds AND

         pBot->need_to_initialize = false;
         if ((pBot->killer_edict != NULL) && (RANDOM_LONG(1,100) <= pBot->whine_percent) &&
			 ((pBot->f_bot_spawn_time + 15.0) <= gpGlobals->time) && (should_bot_chat))
         {
			 pChatClass->LetBotWhine(pBot, pBot->killer_edict);
         }
      }
      if (RANDOM_LONG(1, 100) > 50)
         pEdict->v.button = IN_ATTACK;

      g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, pBot->f_move_speed,
                                   0, 0, pEdict->v.button, 0, pBot->msecval);

      return;
   }

   // set this for the next time the bot dies so it will initialize stuff
   if (pBot->need_to_initialize == FALSE)
   {
      pBot->need_to_initialize = TRUE;
      pBot->f_bot_spawn_time = gpGlobals->time;
   }
/*
   if (pBot->BlockTime >= gpGlobals->time)
   {
	  g_engfuncs.pfnRunPlayerMove( pEdict, pEdict->v.v_angle, 0, 0, 0, pEdict->v.button, 0, pBot->msecval);

	  if (pBot->bot_ki < 10) //Eekhoorn: Makes our block problems dissapear.
	   FakeClientCommand(pEdict, "-block", NULL, NULL);
	  else
	   FakeClientCommand(pEdict, "+block", NULL, NULL);

      if (pBot->bot_powerstrug < 127)
	  {
		 pEdict->v.button |= IN_ATTACK;
		 pBot->BlockTime = gpGlobals->time + 1.5;

		 if (pBot->bot_ki > 2)
		 {
			ToggleTurbo(pEdict,1);
			pBot->turbo_time = gpGlobals->time + 1.5;
		 }

	  }
      return;
   }*/
  
   if ((pBot->turbo_time < gpGlobals->time) && (pBot->turbo_time > 0))
   {
      pBot->turbo_time = 0; 
      ToggleTurbo(pEdict,0);
   }

   if (pBot->SelectCookie)
   {
	   // Cookie choice suggested by Shad0w

	   char Command[15] = "";

	   // Low on health?
	   if (pEdict->v.health < 80)
		   strcpy(Command, "cookie"); // Take a cookie(recovers all health)
	   else if (pEdict->v.health < 120) // Did the bot lost a bit health?
		   strcpy(Command, "chocolate"); // Take a choco, recovers a bit health and gives a bit pl
	   else
		   strcpy(Command, "donut"); // Take a donut when the bot has fair enough health(gives pl)

	   FakeClientCommand(pEdict, Command, NULL, NULL);
	   pBot->SelectCookie = false;
   }
   else if (pBot->SelectWish)
   {
	   char Command[15] = "";

	   switch (RANDOM_LONG(1, 3))
	   {
	   case 1:
		   strcpy(Command, "immortality");
		   break;
	   case 2:
		   strcpy(Command, "strength");
		   break;
	   case 3:
		   strcpy(Command, "friendship");
		   break;
	   }

	   FakeClientCommand(pEdict, Command, NULL, NULL);
	   pBot->SelectWish = false;
	   pBot->MadeWish = true;
   }


   pBot->f_move_speed = pBot->f_max_speed;  // set to max speed

#ifdef LOGBOTINFO
	clog << "Begin checks\n";
#endif

   CheckNesseserelyThings(pBot); // Check for things like swoop and autopunching
#ifdef USE_NEW_BOT_SENSE
   BotSenseNew(pBot);
#else
   BotSense(pBot); // Check our environment
#endif
   CheckBotInternalStatus(pBot); // Check for things like ki and health
   CheckBotMiscThings(pBot); // Check for things like enemies
	   
#ifdef LOGBOTINFO
	clog << "End checks\n";
#endif

   // Still nothing todo ?
   if (pBot->CurrentBotTask == NULL)
   {
	   // Shall we make some kame torpedo's ?
	   if (pBot->CheckKameTorpTime < gpGlobals->time)
	   {
		   if (BotShouldMakeKameTorps(pBot))
			   MakeTask(pBot, TaskKameTorp);
			   
		   pBot->CheckKameTorpTime = gpGlobals->time + RANDOM_FLOAT(22.0, 40.0);
	   }
	   // No ? Time to pause then ?
	   else if (pBot->f_pause_time < gpGlobals->time)
		   MakeTask(pBot, TaskLookAround);
	   // Ok then we just fly through the map...
	   else
		   MakeTask(pBot, TaskNormalMovement);
   }

   BotPerformTasks(pBot); // do the job
   BotAim(pBot); // Aim at the desired vector

   if (!BotShouldMove)
   {
	   pBot->f_move_speed = 0.0;
	   pBot->f_strafe_speed = 0.0;
	   pBot->f_updown_speed = 0.0;
   }

   if (pBot->f_max_speed < pBot->f_strafe_speed)
   {
	   pBot->f_strafe_speed = pBot->f_max_speed;
   }

   if (pBot->f_max_speed < pBot->f_move_speed)
   {
	   pBot->f_move_speed = pBot->f_max_speed;
   }

   if (pBot->f_move_speed > 0.0)
	   pEdict->v.button |= IN_FORWARD;
   else if (pBot->f_move_speed < 0.0)
	   pEdict->v.button |= IN_BACK;
   if (pBot->f_strafe_speed > 0.0)
	   pEdict->v.button |= IN_MOVERIGHT;
   else if (pBot->f_strafe_speed < 0.0)
	   pEdict->v.button |= IN_MOVELEFT;

   // save the previous forward-move speed.
   pBot->prev_speed = pBot->f_move_speed;


   pEdict->v.maxspeed = pBot->f_max_speed; // FIX for not-move bug

   g_engfuncs.pfnRunPlayerMove(pEdict, pEdict->v.v_angle, pBot->f_move_speed, 
							   pBot->f_strafe_speed, pBot->f_updown_speed, pEdict->v.button,
							   0, pBot->msecval);

   // Reset vars
   pBot->f_strafe_speed = 0.0;
   pBot->f_updown_speed = 0.0;

#ifndef _DEBUG
   pBot->VisiblePlayers = 0;
   pBot->PlayersChecked = 0;
#endif

#ifdef LOGBOTINFO
		clog << "End bot think\n";
#endif

   return;
}

void ResetChargeAttacks(bot_t *pBot)
{
	pBot->f_primary_charging = -1;
	pBot->f_secondary_charging = -1;
	pBot->charging_weapon_id = 0;
}
/*
// Bots follow code handled here. They search some one who's on their team
// and who haven't got a user already or don't use someone 
// so the bots should get in pairs. Bots stop following someone after a while
// or if their 'user' hasn't moved a while
CClient *CBot::BotFindUser()
{
	if (!pBotManager->m_bBotsFollowTeamMates)
		return NULL;

	Vector vecEnd;
	Vector v_dist;
	edict_t *pent = NULL;
	edict_t *pNewUser;
	float nearestdistance;
	float distance;
    bool UserVisible;
    float Distance;
    int IsBot = -1;
    int n = 0;
    bool HasAUser = FALSE;
	CClient *pClient;
	CBot *pUserBot = NULL;

    if ((m_fUsingTime <= gpGlobals->time) && (m_fUsingTime > 0.0))
    {
		m_fUsingTime = 0.0;
		m_pBotLastUser = m_pBotUser;
		m_pBotUser = NULL;
		m_fSearchForUserDelay = gpGlobals->time + 50;
		return NULL;
    }

    if (((m_fTimeUserMoved + 10) <= gpGlobals->time) && (m_fTimeUserMoved > 0.0))
    {
		m_fSearchForUserDelay = gpGlobals->time + 30;
		m_fTimeUserMoved = 0.0;

		if (m_pBotUser != NULL)
			m_pBotLastUser = m_pBotUser;

	    m_fUsingTime = 0.0;
	    return NULL;
    }
    
    if (m_fSearchForUserDelay > gpGlobals->time)
		return NULL;

    if (UTIL_IsValidPlayer(m_pBotUser))
    {
		if (m_pBotUser->IsBot())
		{
			// does the bot already have a user?
			pUserBot = pBotManager->GetBotFromClient(m_pBotUser);
			if ((pUserBot) && (pUserBot->m_pBotUser))
			{
				m_pBotLastUser = m_pBotUser;
				m_pBotUser = NULL;
			}
		}

		// Had the user not a user?
		if (m_pBotUser)
		{
			vecEnd = m_pBotUser->GetGunPosition();

			// Get the 2d distance...
			v_dist = (m_pBotUser->GetOrigin() - GetOrigin());
			v_dist.x = 0.0;
			Distance = v_dist.Length();

			UserVisible = false;
			// Is he visible? (only check bot didn't saw him more then 5 secs)
			if ((m_fBotUseTime + 5) <= gpGlobals->time)
				UserVisible = ((Distance < 2300.0) || (FInViewCone(&vecEnd)) ||
							  (FVisible(vecEnd)));

			if (((m_fBotUseTime + 5) > gpGlobals->time) || (UserVisible)) 
			{
				Vector vecEnd = m_pBotUser->GetOrigin() - GetOrigin();

				// face the user
				m_vAimVec = WrapAngles(UTIL_VecToAngles(vecEnd));
				m_vBodyVec = m_vAimVec;

				// Get the 3d distance...
				Distance = GetDistance(m_pBotUser->GetOrigin());
			
				// turn turbo on if 'user' is far away
				if ((Distance > 1000) && (GetKi() > 20))
				{
					ToggleTurbo(ON);
					m_fTurboTime = gpGlobals->time + 1.5;
					m_fTimeUserMoved = gpGlobals->time;
				}
				else if (Distance > 600)      // run if distance to user is far
				{
					m_fMoveSpeed = GetMaxSpeed();
					m_fTimeUserMoved = gpGlobals->time;
				}
				else if (Distance > 400)  // walk if distance is closer
				{
					m_fMoveSpeed = GetMaxSpeed() / 2;
					m_fTimeUserMoved = gpGlobals->time;
				}
				else if (Distance > 100)   // don't move if close enough
					m_fMoveSpeed = 0.0;
				else if (Distance > 0)
				{
					m_fMoveSpeed = -GetMaxSpeed(); // go back if 'user' comes to close
					m_fTimeUserMoved = gpGlobals->time;
				}
				// keep track of when we last saw an user
				if (UserVisible)
					m_fBotUseTime = gpGlobals->time;

				return (m_pBotUser);
			}
			else
				m_pBotLastUser = m_pBotUser; 
		}
	}

    pNewUser = NULL;
    CClient *pPlayer = NULL;
	CClient *pClient;

    if (pNewUser == NULL)
    {
		nearestdistance = 2500;

		if (!m_bMadePlayerList)
			MakePlayerList();

		for (byte i=0;i<pBot->PlayerCount;i++)
		{
			pPlayer = pBot->PlayerList[i];

			// skip self (i.e. this bot)
			if (pPlayer != this)
			{
				if (pPlayer->IsBot())
				{
					pUserBot = pBotManager->GetBotFromClient(pPlayer);

					// Is this player a bot and does he already follow someone?
					if (pUserBot)
					{
						if (pUserBot->m_pBotUser != NULL)
							continue;
					}
				}

				pClientManager->pClientList->ResetEntryListing();

				// Check if another bot follows this player
				while(pClientManager->pClientList->GetNextEntry(pClient))
				{
					if ((pClient->IsBot()) && (this != pClient))
					{
						pUserBot = pBotManager->GetBotFromClient(pClient);

						if (pUserBot->m_pBotUser == pClient)
						{
							HasAUser = TRUE;
							break;
						}
					}
				}

				if (HasAUser)
					continue;

				if ((pBot->pBotLastUser == pPlayer) && (RANDOM_LONG(1, 100) < 80))
					continue;

				// is team play enabled?
				if (IsTeamPlay())
				{
					int player_team = UTIL_GetTeam(pPlayer);
					int bot_team = UTIL_GetTeam(pEdict);

					// only target your teammates...
					if (bot_team != player_team)
						continue;
				}

				vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;

				// see if bot can see the player...
			
				distance = (pPlayer->v.origin - pEdict->v.origin).Length();
				if ((FInViewCone( &vecEnd, pEdict )) || (distance < 2100))
				{
					if (distance < nearestdistance)
					{
						nearestdistance = distance;
						pNewUser = pPlayer;
					}
				}
			}
		}
    }

    if (pNewUser)
    {
		pBot->AimVec = WrapAngles(UTIL_VecToAngles(pNewUser->v.origin - pEdict->v.origin));
		pBot->BodyVec = pBot->AimVec;

		// keep track of when we last saw an user
		pBot->f_bot_use_time = gpGlobals->time;
		pBot->UsingTime = gpGlobals->time + 60;
    }
    return (pNewUser);
}
*/
// Bots follow code handled here. They search some one who's on their team
// and who haven't got a user already or don't use someone 
// so the bots should get in pairs. Bots stop following someone after a while
// or if their 'user' hasn't moved a while
edict_t *BotFindUser( bot_t *pBot )
{
   if (!follow_mode)
	   return NULL;

   Vector vecEnd;
   edict_t *pent = NULL;
   edict_t *pNewUser;
   float nearestdistance;
   float distance;
   bool user_visible;
   float f_distance;
   int IsBot = -1;
   int n = 0;
   bool HasAUser = FALSE;

   edict_t *pEdict = pBot->pEdict;

   if ((pBot->UsingTime <= gpGlobals->time) && (pBot->UsingTime > 0.0))
   {
	   pBot->UsingTime = 0.0;
	   pBot->pBotLastUser = pBot->pBotUser;
	   pBot->pBotUser = NULL;
	   pBot->searchforuser = gpGlobals->time + 50;
	   return NULL;
   }

   if (((pBot->movingusertime + 10) <= gpGlobals->time) && (pBot->movingusertime > 0.0))
   {
	   pBot->searchforuser = gpGlobals->time + 30;
	   pBot->movingusertime = 0.0;
	   if (pBot->pBotUser != NULL)
		   pBot->pBotLastUser = pBot->pBotUser;
	   pBot->UsingTime = 0.0;
	   return NULL;
   }
    
   if (pBot->searchforuser > gpGlobals->time)
	   return NULL;

   if (pBot->pBotUser != NULL)  // does the bot already have an user?
   {
      Vector v_user = pBot->pBotUser->v.origin - pEdict->v.origin;
      Vector bot_angles = UTIL_VecToAngles( v_user );

	  vecEnd = pBot->pBotUser->v.origin + pBot->pBotUser->v.view_ofs;
      f_distance = v_user.Length( );
	  user_visible = ((FInViewCone( &vecEnd, pEdict ) || (f_distance < 2100)) &&
                     FVisible( vecEnd, pEdict ));

      IsBot = UTIL_GetBotIndex(pBot->pBotUser);

   	  if (IsBot != -1)
      {
	      if (bots[IsBot].pBotUser != NULL)
	  		HasAUser = true;
      }
  	  if (HasAUser)
	  {
		  pBot->pBotLastUser = pBot->pBotUser;
		  pBot->pBotUser = NULL;
	  }
      else
      // if the user is dead?
      if (!IsAlive(pBot->pBotUser))
      {
         pBot->pBotLastUser = pBot->pBotUser;
         pBot->pBotUser = NULL;
      }
      else if ((bots[IsBot].is_used == FALSE) && (IsBot != -1))
      {
		  pBot->pBotLastUser = pBot->pBotUser;
		  pBot->pBotUser = NULL;
      }
	  else if (user_visible || (pBot->f_bot_use_time + 5 > gpGlobals->time))
      {
         // if user is still visible and in field of view, keep it

         // face the user
	
         pBot->AimVec = WrapAngles(UTIL_VecToAngles( v_user ));
		 pBot->BodyVec = pBot->AimVec;

         f_distance = v_user.Length( );  // how far away is the "user"?

         if ((f_distance > 1000) && (pBot->bot_ki > 2)) // turn turbo on if 'user' is far away
         {
			ToggleTurbo(pEdict,1);
	        pBot->turbo_time = gpGlobals->time + 1.5;
			pBot->movingusertime = gpGlobals->time;
         }
		 else if (f_distance > 600)      // run if distance to user is far
         {
            pBot->f_move_speed = pBot->f_max_speed;
			pBot->movingusertime = gpGlobals->time;
		 }
         else if (f_distance > 400)  // walk if distance is closer
         {
			 pBot->f_move_speed = pBot->f_max_speed / 2;
   			 pBot->movingusertime = gpGlobals->time;
	     }
         else if (f_distance > 100)   // don't move if close enough        
            pBot->f_move_speed = 0.0;
         else if (f_distance > 0)
         {
            pBot->f_move_speed = -pBot->f_max_speed; // go back if 'user' comes to close
			pBot->movingusertime = gpGlobals->time;
		 }
         // keep track of when we last saw an user
         if (user_visible)
            pBot->f_bot_use_time = gpGlobals->time;

         return (pBot->pBotUser);
      }
	  else
	     pBot->pBotLastUser = pBot->pBotUser; 
   }

   pent = NULL;
   pNewUser = NULL;
   edict_t *pPlayer = NULL;

   if (pNewUser == NULL)
   {
      nearestdistance = 2500;

	if (!pBot->MadePlayerList)
		MakePlayerList(pBot);

      for (int i=0;i<pBot->PlayerCount;i++)
	  {
	      pPlayer = pBot->PlayerList[i];

         // skip invalid players and skip self (i.e. this bot)
         if ((UTIL_IsValidPlayer(pPlayer)) && (pPlayer != pEdict))
         {
            IsBot = UTIL_GetBotIndex(pPlayer);

			if (IsBot != -1)
            {
		        if (bots[IsBot].pBotUser != NULL)
					continue;
            }
            else
            {      
	         for (n=0;n<=gpGlobals->maxClients;n++)
	         {
		      if ((bots[n].pBotUser == pPlayer) && (bots[n].pEdict != pEdict) && 
				  (bots[n].is_used))
		      {
				HasAUser = TRUE;
				break;
		      }
	         }
           }

			if ((pBot->pBotLastUser == pPlayer) && (RANDOM_LONG(1, 100) < 80))
				continue;

			if (HasAUser)
				continue;

            // is team play enabled?
            if (IsTeamPlay())
            {
               int player_team = UTIL_GetTeam(pPlayer);
               int bot_team = UTIL_GetTeam(pEdict);

               // only target your teammates...
               if (bot_team != player_team)
                  continue;
            }

            vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;

            // see if bot can see the player...
			
            distance = (pPlayer->v.origin - pEdict->v.origin).Length();
            if ((FInViewCone( &vecEnd, pEdict )) || (distance < 2100))
            {
               if (distance < nearestdistance)
               {
                  nearestdistance = distance;
                  pNewUser = pPlayer;
               }
            }
         }
      }
   }

   if (pNewUser)
   {
      // face the user
      Vector v_user = pNewUser->v.origin - pEdict->v.origin;
      Vector bot_angles = UTIL_VecToAngles( v_user );

      pBot->AimVec = WrapAngles(bot_angles);
	  pBot->BodyVec = pBot->AimVec;

      // keep track of when we last saw an user
      pBot->f_bot_use_time = gpGlobals->time;
	  pBot->UsingTime = gpGlobals->time + 60;
   }
   return (pNewUser);
}

// I gave the following IsxxAttack functions a try and a catch block;
// the functions where giving crashes for an unknown reason...

bool IsAttack(edict_t *pent)
{
	try
	{
		if ((pent == NULL) || (IsNull(pent)))
			return false;

		if (pent->v.classname == 0)
			return false;
	}
	catch (...)
	{
#ifdef _DEBUG
		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "IsAttack() Error\n");
		fclose(fp);
#endif

		return false;
	}

	return ((IsBeamAttack(pent)) || (IsNonBeamAttack(pent)) || (IsKiBall(pent)) || 
			(IsOtherAttack(pent)));
}

bool IsBeamAttack(edict_t *pent)
{
	try
	{
		if ((pent == NULL) || (IsNull(pent)))
			return false;

		if (pent->v.classname == 0)
			return false;

		char name[80]="";
		strcpy(name,STRING(pent->v.classname));
	
		return ((FStrEq(name,"blueattack")) || (FStrEq(name,"burningattack")) ||
			    (FStrEq(name,"greenattack")) || (FStrEq(name,"purpleattack")) ||
				(FStrEq(name,"yellowattack")) || (FStrEq(name,"kamehameha")) ||
				(FStrEq(name,"gallitgun")) || (FStrEq(name,"masenko")) ||
				(FStrEq(name,"powerbeam")) || (FStrEq(name,"mouthblast")) ||
				(FStrEq(name,"finalflash")));
	}
	catch (...)
	{
#ifdef _DEBUG
		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "IsBeamAttack() Error\n");
		fclose(fp);
#endif

		return false;
	}
}

bool IsNonBeamAttack(edict_t *pent)
{
	try
	{
		if ((pent == NULL) || (IsNull(pent)))
			return false;

		if (pent->v.classname == 0)
			return false;

		char name[80]=""; 
		strcpy(name,STRING(pent->v.classname));

		return ((FStrEq(name,"bigbang")) || (FStrEq(name,"finishingbuster")) || (FStrEq(name,"Spirit Bomb")) || 
			    (FStrEq(name,"Special Beam Cannon")) || (FStrEq(name,"Death Ball")) || 
				(FStrEq(name,"shieldattack")) || (FStrEq(name,"Kame Torpedo")) || (FStrEq(name,"Scattering Beam")));
	}
	catch(...)
	{
#ifdef _DEBUG
		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "IsNonBeamAttack() Error\n");
		fclose(fp);
#endif

		return false;
	}
}

bool IsKiBall(edict_t *pent)
{
	try
	{
		if ((pent == NULL) || (IsNull(pent)))
			return false;

		if (pent->v.classname == 0)
			return false;

		char name[80]="";
		strcpy(name,STRING(pent->v.classname));

		return ((FStrEq(name,"kiblast")) || (FStrEq(name,"scattershot")) ||
			    (FStrEq(name,"renzoku")));
	}
	catch (...)
	{
#ifdef _DEBUG
		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "IsKiBall() Error\n");
		fclose(fp);
#endif

		return false;
	}
}

bool IsOtherAttack(edict_t *pent)
{
	try
	{
		if ((pent == NULL) || (IsNull(pent)))
			return false;

		if (pent->v.classname == 0)
			return false;

		char name[80]="";
		strcpy(name,STRING(pent->v.classname));

		return ((FStrEq(name,"Destructo Disc")) || (FStrEq(name,"Frieza Disc")) || 
				(FStrEq(name,"rock")));
	}
	catch (...)
	{
#ifdef _DEBUG
		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "IsOtherAttack() Error\n");
		fclose(fp);
#endif

		return false;
	}
}

// Fills an array of edicts with visible and valid players for the bot
void MakePlayerList(bot_t *pBot)
{
   edict_t *pEdict = pBot->pEdict;
   Vector vecEnd;
   byte i;
   short BotIndex = UTIL_GetBotIndex(pEdict);
   short BotPlayerIndex = ENTINDEX(pEdict);
   short OtherBotIndex = -1;

   for (i=0;i<32;i++)
	   pBot->PlayerList[i] = NULL;

   pBot->PlayerCount = 0;

   // search the world for players...
   for (i = 1; i <= gpGlobals->maxClients; i++)
   {
	   edict_t *pPlayer = INDEXENT(i);
	   // Already checked by a previous bot?
	   if (pBot->PlayersChecked & (1<<(i-1)))
	   {
		   if (pBot->VisiblePlayers & (1<<(i-1)))
		   {
			   pBot->PlayerList[pBot->PlayerCount] = pPlayer;
			   pBot->PlayerCount++;
		   }
		   continue;
	   }

      // skip invalid players and skip self (i.e. this bot)
      if ((pEdict != pPlayer) && (UTIL_IsValidPlayer(pPlayer)))
      {
         vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;
			
		 if (pPlayer->v.flags & FL_FAKECLIENT)
		 {
			 OtherBotIndex = UTIL_GetBotIndex(pPlayer);
			 if (OtherBotIndex > BotIndex)
			 {
				 // This bot needs to think after this bot, so mark that this bot is valid for him
				 // to save some cpu usage.
				 bots[OtherBotIndex].PlayersChecked |= (1<<(BotPlayerIndex-1));
			 }
		 } 

		 pBot->PlayersChecked |= (1<<(i-1));

         // see if bot can see the player...
         if (FVisible( vecEnd, pEdict ))
         {
			pBot->PlayerList[pBot->PlayerCount] = pPlayer;
			pBot->PlayerCount++;
			pBot->VisiblePlayers |= (1<<(i-1));

			if (pPlayer->v.flags & FL_FAKECLIENT)
			{
				if (OtherBotIndex > BotIndex)
				{
					// This bot needs to think after this bot, so mark that this bot is visible
					// for him to save some cpu usage.
					bots[OtherBotIndex].VisiblePlayers |= (1<<(BotPlayerIndex-1));
				}
			}
		 }
      }
   }

   // We made the list, don't need to do it more then once each frame
   pBot->MadePlayerList = true; 
}

bool IsTurboOn(edict_t *pEdict)
{
	if (*((int *)pEdict->pvPrivateData + TURBO_OFFSET) == 1)
		return true;
	
	return false;
}

void ToggleTurbo(edict_t *pEdict, bool on) // 1 = on, 0 = off
{
	if (on)
	{
		if (!IsTurboOn(pEdict))
			FakeClientCommand(pEdict,"turbo",NULL,NULL);
	}
	else
	{
		if (IsTurboOn(pEdict))
			FakeClientCommand(pEdict,"turbo",NULL,NULL);
	}
}

short GetBestEscapeSwoopDir(bot_t *pBot, bool CheckBackwards)
{
	edict_t *pEdict = pBot->pEdict;

	Vector v_src = pEdict->v.origin;
	Vector v_end;

	TraceResult tr1, tr2, tr3, tr4, tr5;

	v_end = v_src + gpGlobals->v_up * 750;
	UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEdict->v.pContainingEntity,&tr1);
	
	v_end = v_src - gpGlobals->v_up * 750;
	UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEdict->v.pContainingEntity,&tr2);

	v_end = v_src + gpGlobals->v_right * 750;
	UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEdict->v.pContainingEntity,&tr3);

	v_end = v_src - gpGlobals->v_right * 750;
	UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEdict->v.pContainingEntity,&tr4);

	tr5.flFraction = 0.0;

	if (CheckBackwards)
	{
		v_end = v_src - gpGlobals->v_forward * 750;
		UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEdict->v.pContainingEntity,
					   &tr5);
	}

	int SwoopUpVal = int(tr1.flFraction*10.0);
	int SwoopDownVal = int(tr2.flFraction*10.0);
	int SwoopRightVal = int(tr3.flFraction*10.0);
	int SwoopLeftVal = int(tr4.flFraction*10.0);
	int SwoopBackVal = int(tr5.flFraction*10.0);

	if ((UTIL_IsValidPlayer(pBot->pBotEnemy)) && (PlayerSwoops(pBot->pBotEnemy)))
	{
		Vector v_src = pEdict->v.origin;
		Vector v_predict = PredictEntityPos(pBot->pBotEnemy,1.0);
		Vector v_dir;

		float DirDist = 0.0;
		float PredictDist = UTIL_Distance(v_src,v_predict);

		UTIL_MakeVectors(pEdict->v.angles);

		// Predict if enemy get closer when we swoop back...
		v_dir = v_src - gpGlobals->v_forward * 100;
		DirDist = UTIL_Distance(pEdict->v.origin,v_dir);

		if ((DirDist-200.0) < PredictDist)
			SwoopBackVal--;

		// Predict if enemy get closer when we swoop up...
		v_dir = v_src + gpGlobals->v_up * 100;
		DirDist = UTIL_Distance(pEdict->v.origin,v_dir);

		if ((DirDist-200.0) < PredictDist)
			SwoopUpVal--;

		// Predict if enemy get closer when we swoop down...
		v_dir = v_src - gpGlobals->v_up * 100;
		DirDist = UTIL_Distance(pEdict->v.origin,v_dir);

		if ((DirDist-200.0) < PredictDist)
			SwoopDownVal--;

		// Predict if enemy get closer when we swoop right...
		v_dir = v_src + gpGlobals->v_right * 100;
		DirDist = UTIL_Distance(pEdict->v.origin,v_dir);

		if ((DirDist-200.0) < PredictDist)
			SwoopRightVal--;

		// Predict if enemy get closer when we swoop left...
		v_dir = v_src - gpGlobals->v_right * 100;
		DirDist = UTIL_Distance(pEdict->v.origin,v_dir);

		if ((DirDist-200.0) < PredictDist)
			SwoopLeftVal--;
	}

	if (!pBot->MadePlayerList)
		MakePlayerList(pBot);

	if (pBot->PlayerCount > 0)
	{
		int i;

		// Sort the direction where the least players are
		for (i=0;i<pBot->PlayerCount;i++)
		{
			int EntDir = UTIL_VecDir(pEdict, pBot->PlayerList[i]->v.origin);

			if (EntDir & dir_back)
				SwoopBackVal--;
			if (EntDir & dir_left)
				SwoopLeftVal--;
			if (EntDir & dir_right)
				SwoopRightVal--;
			if (EntDir & dir_up)
				SwoopUpVal--;
			if (EntDir & dir_down)
				SwoopDownVal--;
		}
	}

	if ((SwoopUpVal > SwoopDownVal) && (SwoopUpVal > SwoopRightVal) &&
		(SwoopUpVal > SwoopLeftVal) && (SwoopUpVal > SwoopBackVal))
		return dir_up;
	else if ((SwoopDownVal > SwoopUpVal) && (SwoopDownVal > SwoopRightVal) &&
			 (SwoopDownVal > SwoopLeftVal) && (SwoopDownVal > SwoopBackVal))
		return dir_down;
	else if ((SwoopRightVal > SwoopUpVal) && (SwoopRightVal > SwoopDownVal) &&
			 (SwoopRightVal > SwoopLeftVal) && (SwoopRightVal > SwoopBackVal))
		return dir_right;
	else if ((SwoopLeftVal > SwoopUpVal) && (SwoopLeftVal > SwoopDownVal) &&
			 (SwoopLeftVal > SwoopRightVal) && (SwoopLeftVal > SwoopBackVal))
		return dir_left;
	else if ((SwoopBackVal > SwoopUpVal) && (SwoopBackVal > SwoopDownVal) &&
			 (SwoopBackVal > SwoopRightVal) && (SwoopBackVal > SwoopLeftVal))
		return dir_back;

	// if no 'best' direction, return a random one
	int RandNr;

	if (CheckBackwards)
		RandNr = RANDOM_LONG(0, 4);
	else
		RandNr = RANDOM_LONG(0, 3);

	switch(RandNr)
	{
	case 0:
		return dir_up;
		break;
	case 1:
		return dir_down;
		break;
	case 2:
		return dir_right;
		break;
	case 3:
		return dir_left;
		break;
	case 4:
		return dir_back;
	}

	return dir_up; // to avoid a warning message :|
}

// returns the number of degrees left to turn toward ideal pitch...
float BotChangePitch( bot_t *pBot, float speed, float ideal )
{
   edict_t *pEdict = pBot->pEdict;
   float current;
   float current_180;  // current +/- 180 degrees
   float diff;

   // turn from the current v_angle pitch to the idealpitch by selecting
   // the quickest way to turn to face that direction
   
   current = -pEdict->v.v_angle.x;

   // find the difference in the current and ideal angle
   diff = fabs(current - ideal);

   speed = speed * pBot->f_frame_time;  // angles per second

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   // here we have four cases, both angle positive, one positive and
   // the other negative, one negative and the other positive, or
   // both negative.  handle each case separately...

   if ((current >= 0) && (ideal >= 0))  // both positive
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;

      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else  // (current < 0) && (ideal < 0)  both negative
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   if (current > 180)
      current -= 360;
   if (current < -180)
      current += 360;

   pEdict->v.v_angle.x = current;

   return diff;  // return number of degrees left to turn
}

// returns the number of degrees left to turn toward ideal yaw...
float BotChangeYaw( bot_t *pBot, float speed, float ideal )
{
   edict_t *pEdict = pBot->pEdict;
   float current;
   float current_180;  // current +/- 180 degrees
   float diff;

   // turn from the current v_angle yaw to the ideal_yaw by selecting
   // the quickest way to turn to face that direction

   current = pEdict->v.v_angle.y;

   // find the difference in the current and ideal angle
   diff = fabs(current - ideal);

   // speed that we can turn during this frame...
   speed = speed * pBot->f_frame_time;

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   // here we have four cases, both angle positive, one positive and
   // the other negative, one negative and the other positive, or
   // both negative.  handle each case separately...

   if ((current >= 0) && (ideal >= 0))  // both positive
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;

      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else  // (current < 0) && (ideal < 0)  both negative
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   if (current > 180)
      current -= 360;
   if (current < -180)
      current += 360;

   pEdict->v.v_angle.y = current;

   return diff;  // return number of degrees left to turn
}

void BotAimOrig(bot_t *pBot)
{
    if (pBot->AimDelay > gpGlobals->time)
	   return;

    edict_t *pEdict = pBot->pEdict;

	Vector v_src = pEdict->v.origin;
	Vector v_aim = WrapAngles(pBot->AimVec);

    // Paulo-La-Frite - START bot aiming bug fix
    if (v_aim.y > 180)
      v_aim.y -=360;

    if (v_aim.x > 180)
      v_aim.x -=360;

	// Paulo-La-Frite - END

	float AimXSpeedMin;
	float AimXSpeedMax;
	float AimYSpeedMin;
	float AimYSpeedMax;

	if (pBot->SBotType > 1)
	{
		pEdict->v.v_angle = WrapAngles(v_aim);
	}
	else
	{
		if (BotDebugAimXSpeed)
		{
			AimXSpeedMin = AimXSpeedMax = BotDebugAimXSpeed;
		}
		else
		{
			AimXSpeedMin = AimXSpeeds[pBot->bot_skill][0];
			AimXSpeedMax = AimXSpeeds[pBot->bot_skill][1];
		}

		if (BotDebugAimYSpeed)
		{
			AimYSpeedMin = AimYSpeedMax = BotDebugAimYSpeed;
		}
		else
		{
			AimYSpeedMin = AimYSpeeds[pBot->bot_skill][0];
			AimYSpeedMax = AimYSpeeds[pBot->bot_skill][1];
		}

		float AimXSpeed = AimXSpeedMin + (pBot->PitchSpeed * 0.75f);
		float AimYSpeed = AimYSpeedMin + (pBot->YawSpeed * 0.75f);

//		lcout << "AimXSpeed: " << AimXSpeed << "\n";
//		lcout << "AimYSpeed: " << AimYSpeed << "\n";

		pBot->PitchSpeed = BotChangePitch(pBot, AimXSpeed, v_aim.x);
		pBot->YawSpeed = BotChangeYaw(pBot, AimYSpeed, v_aim.y);

//		pBot->PitchSpeed = BotChangePitch(pBot, RANDOM_FLOAT(AimXSpeedMin, AimXSpeedMax), v_aim.x);
//		pBot->YawSpeed = BotChangeYaw(pBot, RANDOM_FLOAT(AimYSpeedMin, AimYSpeedMax), v_aim.y);
	}

	if (BotDebugAimDelay)
		pBot->AimDelay = gpGlobals->time + BotDebugAimDelay;

	// set the body angles to aim correctly
	pEdict->v.angles.x = pEdict->v.v_angle.x / 3;
	pEdict->v.angles.y = pEdict->v.v_angle.y;
	pEdict->v.angles.z = 0;

	pEdict->v.v_angle.x = -pEdict->v.v_angle.x; // Aim bug-fix

    return;
}

// returns true if bot should wall jump
bool CheckWallJump(bot_t *pBot)
{
	if (pBot->bot_skill > 2)
		return false; // lower skilled bots are stupid :D

	//if (pBot->WallJumpCheckDelay > gpGlobals->time)
	//	return false;

	pBot->WallJumpCheckDelay = gpGlobals->time + 0.15;

	return ((pBot->pBotClient->ChargesWallJump) || (pBot->pBotClient->WallJumps) ||
		    (pBot->pBotClient->IsStuckAgainstWall));

/*	if (PlayerChargesWallJump(pEdict))
		return true;

	if (PlayerWallJumps(pEdict))
		return true;

	return (PlayerIsStuckAgainstWall(pEdict));
		return false;

	Vector v_src = pEdict->v.origin;

	Vector v_temp = pEdict->v.angles;
	v_temp.x = 0;
	UTIL_MakeVectors(v_temp);

	Vector v_end;

	TraceResult tr;

	v_end = v_src - gpGlobals->v_forward * 10.0;
	UTIL_TraceHull(v_src,v_end,ignore_monsters,human_hull,pEdict->v.pContainingEntity,&tr);

	return (tr.flFraction < 1.0);*/
}

void MakeAvoidSwoopTask(bot_t *pBot)
{
	bool CheckBack = false;

	if (RANDOM_LONG(0,1))
		CheckBack = true;

	short SwoopDir = GetBestEscapeSwoopDir(pBot, CheckBack);

	switch(SwoopDir)
	{
	case dir_left:
		MakeCombo(pBot, startleftswoop);
		break;
	case dir_right:
		MakeCombo(pBot, startrightswoop);
		break;
	case dir_up:
		MakeCombo(pBot, startupswoop);
		break;
	case dir_down:
		MakeCombo(pBot, startdownswoop);
		break;
	case dir_back:
		MakeCombo(pBot, startbackwardswoop);
		break;
	}
}

int ReturnTurnedAngle( bot_t *pBot, float speed, float current, float ideal) 
{
    float current_180;  // current +/- 180 degrees 
    float diff; 

    // turn from the current v_angle pitch to the idealpitch by selecting 
    // the quickest way to turn to face that direction

    // find the difference in the current and ideal angle 

    diff = abs(current - ideal); 

    // check if the bot is already facing the idealpitch direction... 

    if (diff <= 1)
		return current;  // return number of degrees turned 

    // check if difference is less than the max degrees per turn 
    if (diff < speed) 
       speed = diff;  // just need to turn a little bit (less than max) 

    // here we have four cases, both angle positive, one positive and 
    // the other negative, one negative and the other positive, or 
    // both negative.  handle each case separately... 

    if ((current >= 0) && (ideal >= 0))  // both positive 
	{
		if (current > ideal)
			current -= speed; 
		else
			current += speed; 

    } 
    else if ((current >= 0) && (ideal < 0)) 
    { 
		current_180 = current - 180; 

        if (current_180 > ideal) 
           current += speed; 
        else 
           current -= speed; 
    } 
    else if ((current < 0) && (ideal >= 0)) 
    {
		current_180 = current + 180; 

        if (current_180 > ideal)
			current += speed;
        else 
			current -= speed; 
    } 
    else  // (current < 0) && (ideal < 0)  both negative 
    {
		if (current > ideal)
			current -= speed;
		else 
			current += speed; 
    }

    // check for wrap around of angle... 
    if (current > 180)
		current -= 360; 
    if (current < -180) 
	    current += 360; 

    return current;  // return what it should be 
}

// Let bot completely focus on target (head & Body) (from stefanhendriks)
void BotAims(bot_t *pBot) 
{
    edict_t *pEdict = pBot->pEdict; 

    pEdict->v.v_angle = pBot->AimVec;
	
	if (pEdict->v.v_angle.y > 180) 
		pEdict->v.v_angle.y -=360; 

    // Paulo-La-Frite - START bot aiming bug fix 

    if (pEdict->v.v_angle.x > 180)
		pEdict->v.v_angle.x -=360;

    Vector v_shouldbe = pEdict->v.angles;

    // Vector how it should be, however, we don't allow such a fast turn! 
    v_shouldbe.x = pEdict->v.v_angle.x / 3; 
    v_shouldbe.y = pEdict->v.v_angle.y; 
    v_shouldbe.z = 0;

    // set the body angles to point the gun correctly 

    pEdict->v.angles.x = ReturnTurnedAngle( pBot, 5, pEdict->v.angles.x, v_shouldbe.x); 
    pEdict->v.angles.y = ReturnTurnedAngle( pBot, 5, pEdict->v.angles.y, v_shouldbe.y); 
    pEdict->v.angles.z = 0;

    // adjust the view angle pitch to aim correctly (MUST be after body v.angles stuff) 
    pEdict->v.v_angle.x = -pEdict->v.v_angle.x; 

    // Paulo-La-Frite - END 
    
	pEdict->v.ideal_yaw = pEdict->v.v_angle.y;
    pEdict->v.idealpitch= pEdict->v.v_angle.x;
} 

bool BotCanBeamJump(bot_t *pBot, bool AttackIsReleashed)
{
	edict_t *pEdict = pBot->pEdict;
	edict_t *pAttack = NULL;
	Vector v_src;
	Vector v_end;

	if (AttackIsReleashed)
	{
		if (pBot->pBotClient->ControlsAttack == false)
			return false;

		pAttack = pAttackManager->SearchLastAttack(pEdict);
		if (!pAttack)
		{
			return false;
		}
		v_src = pAttack->v.origin;
	}
	else
	{
		v_src = pEdict->v.origin;
	}

	// Weee lag :)
	Vector v_nearest = GetNearestCollision((pAttack) ? pAttack : pEdict, 200.0f);

	if (v_nearest != g_vecZero)
	{
		pBot->BeamJumpSpot = v_nearest;
		pBot->AimVec = WrapAngles(UTIL_VecToAngles(v_nearest - pEdict->v.origin));
		return true;
	}

	return false;
}

bool BotShouldFallDown(bot_t *pBot)
{
#ifdef USE_NEW_BOT_SENSE
	if (pBot->DangerLevel > DANGER_HARD_MAX_VAL)
		return false;
#else
	if ((pBot->DangerLevel < danger_light) || (pBot->DangerLevel > danger_medium))
		return false;
#endif

	if (RANDOM_LONG(1, 100) > BotPersonalities[pBot->Personality].stopfly_percent)
		return false;

	edict_t *pEdict = pBot->pEdict;

	if (((pBot->DangerType == DangerEnemy) || (pBot->DangerType == DangerCurrentEnemy)) &&
		(UTIL_IsValidEnemy(pBot, pBot->pBotEnemy)))
	{
		float EnemyDist = UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin);

		if (EnemyDist < 1000.0)
		{
			if (pBot->pBotEnemy->v.origin.z < (pEdict->v.origin.z - 350.0f))
				return false;
		}
	}

	if (CheckForCollide(pEdict, dir_down, MIN_DIST_TO_FALL_DOWN))
		return false;

	return true;
}

void LoadSkillData()
{
	extern float GeneralReactionDelays[5][2];

	char DelayFileName[256] = "";
	FILE *DelayFile = NULL;
	int SkillNr = -1;
    float value = 0;

	UTIL_BuildFileName(DelayFileName, "skill.cfg", NULL);

	DelayFile = fopen(DelayFileName, "r");

	(*g_engfuncs.pfnServerPrint) ("Reading skill.cfg file... ");

	if (DelayFile == NULL) // file doesn't exist
	{
		(*g_engfuncs.pfnServerPrint) ("file not found, default settings will be used\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	char *cmd, *arg1;

	while (DelayFile)
	{    
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(DelayFile);

		// skip any leading blanks
		while (ch == ' ')
			ch = fgetc(DelayFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
		      ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(DelayFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') &&
		             (ch == ' '))      
         		ch = fgetc(DelayFile);

		      cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
			ch = fgetc(DelayFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
		    fclose(DelayFile);
			DelayFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		cmd_index = 0;
		cmd = cmd_line;
		arg1 = NULL;

		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		      cmd_index++;

		if (cmd_line[cmd_index] == ' ')
		{
		      cmd_line[cmd_index++] = 0;
		      arg1 = &cmd_line[cmd_index];
		}

		if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
			continue;  // skip if comment or blank line


		if (stricmp(cmd, "[SKILL1]") == 0)
			SkillNr = 0;
		else if (stricmp(cmd, "[SKILL2]") == 0)
			SkillNr = 1;
		else if (stricmp(cmd, "[SKILL3]") == 0)
			SkillNr = 2;
		else if (stricmp(cmd, "[SKILL4]") == 0)
			SkillNr = 3;
		else if (stricmp(cmd, "[SKILL5]") == 0)
			SkillNr = 4;

		if ((arg1 == NULL) || (*arg1 == 0))
		    continue;

		if (SkillNr == -1) // Not in a skill block yet?
			continue;

		value = atof(arg1);

		if (stricmp(cmd, "min_general_delay") == 0)
		{
//			clog << "GenMinDelay for skill " << SkillNr << " is " << value << "\n";
			GeneralReactionDelays[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_general_delay") == 0)
		{
//			clog << "GenMaxDelay for skill " << SkillNr << " is " << value << "\n";
			GeneralReactionDelays[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_x_aim_speed") == 0)
		{
//			clog << "MinAimSpeed for skill " << SkillNr << " is " << value << "\n";
			AimXSpeeds[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_x_aim_speed") == 0)
		{
//			clog << "MaxAimSpeed for skill " << SkillNr << " is " << value << "\n";
			AimXSpeeds[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_y_aim_speed") == 0)
		{
//			clog << "MinAimSpeed for skill " << SkillNr << " is " << value << "\n";
			AimYSpeeds[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_y_aim_speed") == 0)
		{
//			clog << "MaxAimSpeed for skill " << SkillNr << " is " << value << "\n";
			AimYSpeeds[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_x_aim_offset") == 0)
		{
//			clog << "MinXAimOffset for skill " << SkillNr << " is " << value << "\n";
			AimXOffsets[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_x_aim_offset") == 0)
		{
//			clog << "MinXAimOffset for skill " << SkillNr << " is " << value << "\n";
			AimXOffsets[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_y_aim_offset") == 0)
		{
//			clog << "MinYAimOffset for skill " << SkillNr << " is " << value << "\n";
			AimYOffsets[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_y_aim_offset") == 0)
		{
//			clog << "MaxYAimOffset for skill " << SkillNr << " is " << value << "\n";
			AimYOffsets[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_attack_delay") == 0)
		{
//			clog << "min attack delay for skill " << SkillNr << " is " << value << "\n";
			AttackDelays[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_attack_delay") == 0)
		{
//			clog << "max attack delay for skill " << SkillNr << " is " << value << "\n";
			AttackDelays[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_beam_explode_distance") == 0)
		{
//			clog << "min beam explode dist for skill " << SkillNr << " is " << value << "\n";
			ExplodeBeamDistances[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_beam_explode_distance") == 0)
		{
//			clog << "max beam explode dist for skill " << SkillNr << " is " << value << "\n";
			ExplodeBeamDistances[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "min_enemy_search_delay") == 0)
		{
//			clog << "min enemy search delay for skill " << SkillNr << " is " << value << "\n";
			EnemySearchDelays[SkillNr][0] = value;
		}
		else if (stricmp(cmd, "max_enemy_search_delay") == 0)
		{
//			clog << "max enemy search delay for skill " << SkillNr << " is " << value << "\n";
			EnemySearchDelays[SkillNr][1] = value;
		}
		else if (stricmp(cmd, "random_combo_button_percent") == 0)
		{
//			clog << "random combo button for skill " << SkillNr << " is " << value << "\n";
			RandomComboButtonPercent[SkillNr] = static_cast<short>(value);
		}
	}

	(*g_engfuncs.pfnServerPrint) ("done\n");
}

bool KeepAttacksAwayFromBot(bot_t *pBot, bool BotMayDrawBeams)
{
	edict_t *pEdict = pBot->pEdict;

	CAttackManager::TAttackListNode *pNode = NULL;
	bool FoundAttack = false;

	while ((pNode = pAttackManager->GetNextHostileAttack(pNode, pEdict, false)) != NULL)
	{
		if ((IsTeamPlay()) && (IsNull(pNode->Entry->pAttack->v.owner) == false))
		{
			if (pNode->Entry->pAttack->v.owner->v.team == pEdict->v.team)
			{
				continue;
			}
		}
		if ((UTIL_Distance(pEdict->v.origin, pNode->Entry->pAttack->v.origin) < 600.0) &&
			(pNode->Entry->pAttack->v.owner != pEdict) && (IsOtherAttack(pNode->Entry->pAttack) == false))
		{
			if (pEdict->v.fuser4 > 1.0)
			{
				if (!FoundAttack)
					FoundAttack = true;

				if (pNode->Entry->Attacked == false)
				{
					pNode->Entry->Attacked = true;
					pNode->Entry->OldVelocity = pNode->Entry->pAttack->v.velocity;
				}

				pNode->Entry->AttackedTime = gpGlobals->time;

				if (UTIL_Distance(pEdict->v.origin, pNode->Entry->pAttack->v.origin) == 600.0)
				{
					UTIL_MakeVectors(pNode->Entry->pAttack->v.angles);
					TraceResult tr;
					Vector v_src = pNode->Entry->pAttack->v.origin;
					Vector v_end = v_src + gpGlobals->v_forward * 10;

					UTIL_TraceHull(v_src, v_end, dont_ignore_monsters, human_hull, pNode->Entry->pAttack, &tr);

					SET_ORIGIN(pNode->Entry->pAttack, tr.vecEndPos);
				}

				pNode->Entry->pAttack->v.velocity.x = pNode->Entry->OldVelocity.x / 100.0;
				pNode->Entry->pAttack->v.velocity.y = pNode->Entry->OldVelocity.y / 100.0;
				pNode->Entry->pAttack->v.velocity.z = pNode->Entry->OldVelocity.z / 100.0;

				if (BotMayDrawBeams)
					UTIL_DrawBeamToAll(pEdict->v.origin + pEdict->v.view_ofs, 
									   pNode->Entry->pAttack->v.origin, 20, 8, 125, 255, 255, 250, 5);

				if (RANDOM_LONG(0, 3) == 0)
				{
					short DamageDrain = (pBot->pBotClient->PL / 1000000) * ABSORB_DAMAGE_VALUE;
					pNode->Entry->pAttack->v.dmg -= DamageDrain;
				}
/*
				char s[100] = "";
				sprintf(s,"dmg: %f\n",pNode->Entry->pAttack->v.dmg);
				ClientPrint(listenserver_edict,HUD_PRINTCENTER,s);
*/
	
				if (pNode->Entry->pAttack->v.dmg < 0)
				{
					pNode->Entry->pAttack->v.dmg = 0;
					DispatchTouch(pNode->Entry->pAttack, pEdict);
				}

				pEdict->v.fuser4 -= 10.0;
				if (pEdict->v.fuser4 < 0.0)
					pEdict->v.fuser4 = 0.0;

				long NewBotPl = pBot->PL;

				if (IsTurboOn(pEdict))
					NewBotPl /= 1.25;

				NewBotPl += ABSORB_PL_GAIN;
				UTIL_ChangePl(pEdict, NewBotPl);
				UTIL_ChangeRealPl(pEdict, NewBotPl);
			}
			else 
			{
				if (pNode->Entry->pAttack->v.velocity.Length() < 700.0)
				{
					pNode->Entry->pAttack->v.velocity = pNode->Entry->OldVelocity;
				}
			}
		}
	}

	return FoundAttack;
}

bool BotCanAscend(bot_t *pBot)
{
	edict_t *pEdict = pBot->pEdict;
	if (IsTurboOn(pEdict))
		return false;

	if (BotsAlwaysTryToAscend)
		return true; // For custom plugins like EEA/EVM

	long BotPl = GetPlayerPl(pEdict), MinPl = 999999999;
	char PlayerClass[32] = "";

	PlayerClassify(pEdict, PlayerClass);

	if (FStrEq(PlayerClass, "fatbuu"))
		MinPl = 3000000;
	else if (FStrEq(PlayerClass, "goku"))
		MinPl = 1750000;
	else if (FStrEq(PlayerClass, "gohan"))
		MinPl = 1000000;
	else if (FStrEq(PlayerClass, "krillin"))
		MinPl = 3000000;
	else if (FStrEq(PlayerClass, "frieza"))
		MinPl = 1800000;
	else if (FStrEq(PlayerClass, "piccolo"))
		MinPl = 1650000;
	else if (FStrEq(PlayerClass, "trunks"))
		MinPl = 1000000;
	else if (FStrEq(PlayerClass, "vegeta"))
		MinPl = 2000000;
	else if (FStrEq(PlayerClass, "cell"))
		MinPl = 1900000;
	else
		return false;

	return (BotPl >= MinPl);
}

void SetButtonsFromAComboChargeButton(bot_t *pBot, EComboChargeButton Button)
{
	switch(Button)
	{
	case COMBO_BUTTON_PUNCH_LEFT:
	case COMBO_BUTTON_KICK_LEFT:
	case COMBO_BUTTON_PUNCH_LEFT_UP:
	case COMBO_BUTTON_KICK_LEFT_UP:
	case COMBO_BUTTON_PUNCH_LEFT_DOWN:
	case COMBO_BUTTON_KICK_LEFT_DOWN:
//		clog << "Pressing left\n";
//		rcout << "Pressing left\n";
		pBot->f_strafe_speed = -pBot->f_max_speed;
		pBot->pEdict->v.button |= (IN_MOVELEFT);
		break;
	case COMBO_BUTTON_PUNCH_RIGHT:
	case COMBO_BUTTON_KICK_RIGHT:
	case COMBO_BUTTON_PUNCH_RIGHT_UP:
	case COMBO_BUTTON_KICK_RIGHT_UP:
	case COMBO_BUTTON_PUNCH_RIGHT_DOWN:
	case COMBO_BUTTON_KICK_RIGHT_DOWN:
//		clog << "Pressing right\n";
//		rcout << "Pressing right\n";
		pBot->f_strafe_speed = pBot->f_max_speed;
		pBot->pEdict->v.button |= (IN_MOVERIGHT);
		break;
	case COMBO_BUTTON_PUNCH_UP:
	case COMBO_BUTTON_KICK_UP:
//		clog << "Pressing forward\n";
//		rcout << "Pressing forward\n";
		pBot->f_move_speed = pBot->f_max_speed;
		pBot->pEdict->v.button |= (IN_FORWARD);
		break;
	case COMBO_BUTTON_PUNCH_DOWN:
	case COMBO_BUTTON_KICK_DOWN:
//		clog << "Pressing back\n";
//		rcout << "Pressing back\n";
		pBot->f_move_speed = -pBot->f_max_speed;
		pBot->pEdict->v.button |= (IN_BACK);
		break;
	}

	return;
}

bool AttacksWillCollide(edict_t *pAttack1, edict_t *pAttack2)
{
	float Dist = UTIL_Distance(pAttack1->v.origin, pAttack2->v.origin);

	return ((Dist < 2000.0f) && (FInViewCone(&pAttack2->v.origin, pAttack1)) &&
			(FInViewCone(&pAttack1->v.origin, pAttack2)));
}

int GetRandomTeleDir(bot_t *pBot)
{
	TMultiChoice<int> TeleDirChoices;
	edict_t *pEdict = pBot->pEdict; // Shortcut

	// Less chance for left & right since this doesn't confuse the enemy very much
	if (CheckForCollide(pEdict, dir_left, 350.0f) == false)
		TeleDirChoices.Insert(dir_left, 30);

	if (CheckForCollide(pEdict, dir_right, 350.0f) == false)
		TeleDirChoices.Insert(dir_right, 30);

	// More chance for up & down teleport because it confuses the enemy more :)
	if (CheckForCollide(pEdict, dir_up, 650.0f) == false)
		TeleDirChoices.Insert(dir_up, 75);
	
	if (CheckForCollide(pEdict, dir_down, 650.0f) == false)
		TeleDirChoices.Insert(dir_down, 75);

	if (CheckForCollide(pEdict, dir_left_back, 650.0f) == false)
		TeleDirChoices.Insert((dir_back | dir_left), 40);

	if (CheckForCollide(pEdict, dir_right_back, 650.0f) == false)
		TeleDirChoices.Insert((dir_back | dir_right), 40);

	if (CheckForCollide(pEdict, dir_back, 650.0f) == false)
		TeleDirChoices.Insert(dir_back, 40);

	int TeleChoice = 0;
	TeleDirChoices.GetSelection(TeleChoice);
	return TeleChoice;
}

void BotAimPMB (bot_t *pBot)
{
	edict_t *pEdict = pBot->pEdict;
   // this function is called every frame for every bot. Its purpose is to make the bot
   // move its crosshair to the direction where it wants to look. There is some kind of
   // filtering for the view, to make it human-like.

   // OMG, .weirdest .engine .bug .ever here - Thanks to botman and all the people at botman's
   // forums for helping us together setting things straight once for all !!!

   float speed, turn_skill, da_deadly_math; // speed : 0.1 - 1
   Vector v_deviation;
   Vector v_current = pEdict->v.v_angle;
//   v_current.x = -v_current.x;

   byte OtherBotSkill = (5 - pBot->bot_skill);
   v_deviation = WrapAngles (pBot->AimVec - v_current);
   turn_skill = OtherBotSkill * 2;

   // if bot is aiming at something, aim fast, else take our time...
   if (pBot->pBotEnemy)
      speed = 0.7 + (turn_skill - 1) / 10; // fast aim
   else
      speed = 0.2 + (turn_skill - 1) / 20; // slow aim

   // thanks Tobias "Killaruna" Heimann and Johannes "@$3.1415rin" Lampel for this one
   da_deadly_math = exp (log (speed / 2) * pBot->msecval / 50);

   pBot->aim_speed.y = (pBot->aim_speed.y * da_deadly_math
                                  + speed * v_deviation.y * (1 - da_deadly_math))
                                 * pBot->msecval / 50;
   pBot->aim_speed.x = (pBot->aim_speed.x * da_deadly_math
                                  + speed * v_deviation.x * (1 - da_deadly_math))
                                 * pBot->msecval / 50;

   // influence of y movement on x axis and vice versa (less influence than x on y since it's
   // easier and more natural for the bot to "move its mouse" horizontally than vertically)
   pBot->aim_speed.x += pBot->aim_speed.y / (1.5 * (1 + turn_skill));
   pBot->aim_speed.y += pBot->aim_speed.x / (1 + turn_skill);

   pBot->pEdict->v.v_angle = WrapAngles (pBot->pEdict->v.v_angle + pBot->aim_speed);

   // set the body angles to point the gun correctly
   pBot->pEdict->v.angles.x = pBot->pEdict->v.v_angle.x / 3;
   pBot->pEdict->v.angles.y = pBot->pEdict->v.v_angle.y;
   pBot->pEdict->v.angles.z = 0;

   pEdict->v.v_angle.x = -pEdict->v.v_angle.x;
   return;
}

void BotAim(bot_t *pBot)
{
    if (pBot->AimDelay > gpGlobals->time)
	   return;

    edict_t *pEdict = pBot->pEdict;

	Vector v_src = pEdict->v.origin;
	Vector v_aim = WrapAngles(pBot->AimVec);

    // Paulo-La-Frite - START bot aiming bug fix
    if (v_aim.y > 180)
      v_aim.y -=360;

    if (v_aim.x > 180)
      v_aim.x -=360;

	// Paulo-La-Frite - END

	if (pBot->SBotType > 1)
	{
		pEdict->v.v_angle = WrapAngles(v_aim);
	}
	else
	{
		float MaxXSpeed = RANDOM_FLOAT(AimXSpeeds[pBot->bot_skill][0],
									   AimXSpeeds[pBot->bot_skill][1]);
		float MaxYSpeed = RANDOM_FLOAT(AimYSpeeds[pBot->bot_skill][0],
									   AimYSpeeds[pBot->bot_skill][1]);
		float XOffset = RANDOM_FLOAT(AimXOffsets[pBot->bot_skill][0],
									 AimXOffsets[pBot->bot_skill][1]);
		float YOffset = RANDOM_FLOAT(AimYOffsets[pBot->bot_skill][0],
									 AimYOffsets[pBot->bot_skill][1]);

#ifdef _DEBUG
		if (BotDebugAimXSpeed)
			MaxXSpeed = BotDebugAimXSpeed;
		if (BotDebugAimYSpeed)
			MaxYSpeed = BotDebugAimYSpeed;
#endif

		float RealXOffset, RealYOffset;
		float AimXSpeed = MaxXSpeed, AimYSpeed = MaxYSpeed;
		float XDiff = fabs(v_aim.x - -pEdict->v.v_angle.x);
		float YDiff = fabs(v_aim.y - pEdict->v.v_angle.y);

		// How higher the diff, how higher the offsets and aim speed

		if (XOffset)
		{
			if (RANDOM_LONG(0, 1))
				RealXOffset = XDiff * (XOffset / 100.0f);
			else
				RealXOffset = -(XDiff * (XOffset / 100.0f));
		}
		else
			RealXOffset = 0.0f;

		if (YOffset)
		{
			if (RANDOM_LONG(0, 1))
				RealYOffset = YDiff * (YOffset / 100.0f);
			else
				RealYOffset = -(YDiff * (YOffset / 100.0f));
		}
		else
			RealYOffset = 0.0f;

		if (XDiff >= 1.0f)
			AimXSpeed *= (XDiff / 70.0f);
		else
			AimXSpeed *= 0.01f;

		if (YDiff >= 1.0f)
			AimYSpeed *= (YDiff / 60.0f);
		else
			AimYSpeed *= 0.015f;

/*
		if (XDiff >= 1.0f)
			AimXSpeed = 10.0f + (AimXSpeed * (XDiff / 180.0f)); 
		else
			AimXSpeed *= 0.01f;

		if (YDiff >= 1.0f)
			AimYSpeed = 15.0f + (AimYSpeed * (YDiff / 180.0f));
		else
			AimYSpeed *= 0.015f;
*/
//		rcout << "AimXSpeed: " << AimXSpeed << "\n";
//		rcout << "AimYSpeed: " << AimYSpeed << "\n";

		v_aim.x = UTIL_WrapAngle(v_aim.x + RealXOffset);
		v_aim.y = UTIL_WrapAngle(v_aim.y + RealYOffset);

//		rcout << "XOffset: " << fabs(XOffset) << "\n";
//		rcout << "YOffset: " << fabs(YOffset) << "\n";

		pBot->PitchSpeed = BotChangePitch(pBot, AimXSpeed, v_aim.x);
		pBot->YawSpeed = BotChangeYaw(pBot, AimYSpeed, v_aim.y);

//		pBot->PitchSpeed = BotChangePitch(pBot, RANDOM_FLOAT(AimXSpeedMin, AimXSpeedMax), v_aim.x);
//		pBot->YawSpeed = BotChangeYaw(pBot, RANDOM_FLOAT(AimYSpeedMin, AimYSpeedMax), v_aim.y);
	}

	if (BotDebugAimDelay)
		pBot->AimDelay = gpGlobals->time + BotDebugAimDelay;

	// set the body angles to aim correctly
	pEdict->v.angles.x = pEdict->v.v_angle.x / 3;
	pEdict->v.angles.y = pEdict->v.v_angle.y;
	pEdict->v.angles.z = 0;

	pEdict->v.v_angle.x = -pEdict->v.v_angle.x; // Aim bug-fix
    return;
}
