//
// HPB_bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot.h
//

#ifndef BOT_H
#define BOT_H

//#define LOGBOTINFO
//#define USEBSPSHIT

#include "client.h"
#include "bot_io.h"
//#include "profiler.h"

#ifdef _DEBUG
#define _CRTDBG_MAP_ALLOC

#include <stdlib.h>
#include <crtdbg.h>
#endif

// stuff for Win32 vs. Linux builds
#ifndef __linux__

typedef int (FAR *GETENTITYAPI)(DLL_FUNCTIONS *, int);
typedef int (FAR *GETNEWDLLFUNCTIONS)(NEW_DLL_FUNCTIONS *, int *);
typedef void (DLLEXPORT *GIVEFNPTRSTODLL)(enginefuncs_t *, globalvars_t *);
typedef void (FAR *LINK_ENTITY_FUNC)(entvars_t *);
typedef int (DLLEXPORT *SERVER_GETBLENDINGINTERFACE) (int, struct sv_blending_interface_s **, struct engine_studio_api_s *, float (*)[3][4], float (*)[MAXSTUDIOBONES][3][4]);

#else

#include <dlfcn.h>

#define GetProcAddress dlsym

typedef int BOOL;

typedef int (*GETENTITYAPI)(DLL_FUNCTIONS *, int);
typedef int (*GETNEWDLLFUNCTIONS)(NEW_DLL_FUNCTIONS *, int *);
typedef void (*GIVEFNPTRSTODLL)(enginefuncs_t *, globalvars_t *);
typedef void (*LINK_ENTITY_FUNC)(entvars_t *);
typedef int (*SERVER_GETBLENDINGINTERFACE) (int, struct sv_blending_interface_s **, struct engine_studio_api_s *, float (*)[3][4], float (*)[MAXSTUDIOBONES][3][4]);

#endif

// define some function prototypes...
BOOL ClientConnect( edict_t *pEntity, const char *pszName,
                    const char *pszAddress, char szRejectReason[ 128 ] );
void ClientPutInServer( edict_t *pEntity );
void ClientCommand( edict_t *pEntity );

void FakeClientCommand(edict_t *pBot, char *arg1, char *arg2, char *arg3);

const char *Cmd_Args( void );
const char *Cmd_Argv( int argc );
int Cmd_Argc( void );

#define WANDER_LEFT  1
#define WANDER_RIGHT 2

#define RESPAWN_IDLE             1
#define RESPAWN_NEED_TO_RESPAWN  2
#define RESPAWN_IS_RESPAWNING    3

// game start messages
#define MSG_IDLE          1
#define MSG_TEAM_SELECT   2
#define MSG_CLASS_SELECT  3
#define MSG_MOTD          4

#define BOT_NAME_LEN 32
#define MAX_BOT_WEAPONS 30

#define dir_left				(1<<1)
#define dir_right				(1<<2)
#define dir_back				(1<<3)
#define dir_forward				(1<<4)
#define dir_up					(1<<5)
#define dir_down				(1<<6)
#define dir_all					(1<<7)
#define dir_upforward			(1<<8)
#define dir_downforward			(1<<9)
#define dir_left_forward_up		(1<<10)
#define dir_right_forward_up	(1<<11)
#define dir_left_back_up		(1<<12)
#define dir_right_back_up		(1<<13)
#define dir_left_forward_down	(1<<14)
#define dir_right_forward_down	(1<<15)
#define dir_left_back_down		(1<<16)
#define dir_right_back_down		(1<<17)
#define dir_left_back			(1<<18)
#define dir_right_back			(1<<19)
#define dir_left_forward		(1<<18)
#define dir_right_forward		(1<<19)

enum ESwoopType
{
	SWOOP_NORMAL,
	SWOOP_OFFSET,
	SWOOP_RANDOM_OFFSET
};

#define swoop_begin_delay	0.07
#define tap_delay			0.07
#define tap_lifetime		0.08

#define eye_width 19//29//53

/*

	danger levels:
	danger_very_heavy	:	for strong or multiple beams, multiple teleport should be the first choice
	danger_heavy		:	best reaction would be teleport or block
	danger_hard			:	teleport or block is better then swoop, but swoop is possible
	danger_medium		:	swoop or teleport/block doesnt matter
	danger_light		:	don't react, just look out, lower the poweruptime for example

*/

#define danger_light		1
#define danger_medium		2
#define danger_hard			3
#define danger_heavy		4
#define danger_very_heavy	5

#define min_swoop_speed 600.0

#define MIN_DIST_TO_FALL_DOWN	1200.0

extern float AttackDelays[5][2];
extern short RandomComboButtonPercent[5];

typedef struct
{
     float distance;
     int contents;
     Vector endVec;
	 Vector vecPlaneNormal;
} eye_t;

typedef enum{
	go_left,
	go_right,
	go_back,
	go_forward,
	go_up,
	go_down,
	go_random
} TeleDir;

typedef enum{
	Aggressive = 0,
	Normal,
	Defensive
} AggressionLevel_e;

enum State
{
	not_started,
	busy,
	done
};

typedef struct
{
	short Priority;
	edict_t *pEnemy;
} EnemyPriority_t;

class BotCombo;
class CBaseTask;
class CBaseSubTask;
enum ETaskCode;
enum SoundType_e;
struct BotPersonality_t;
enum ComboTypes;

typedef struct
{
   bool is_used;
   int respawn_state;
   edict_t *pEdict;
   bool need_to_initialize;
   char name[BOT_NAME_LEN+1];
   char old_name[BOT_NAME_LEN+1];
   int bot_skill;
   int not_started;
   int start_action;
   float kick_time;
   float create_time;

   ClientInfo_t *pBotClient;

   Vector v_GoToVector;

   int ChargeBeamVal;
   int NumberWeapons;

   CBaseTask *CurrentBotTask;
   CBaseSubTask *CurrentBotSubTask;
   ETaskCode TaskAfterTask; // Since its not possible to create a task in a task...

   float CheckKameTorpTime;
   bool ChargeKameTorp;
   float LastKameTorpLeftOverCheck;

   ETaskCode PrevTask;

   int JumpDir;

   float f_search_enemy_delay;
   float LastEnemySwoopCheck;
   float HasAnEnemyTime;
   EnemyPriority_t EnemyList[4];

   float WallJumpCheckDelay;

   AggressionLevel_e AggressionLevel;
   int MoveDir;
   float MoveTime;

   int Personality;

   short FlyPercent;

   int SBotType;
   float f_check_sbot_delay;
   float UpdateTransTime;
   int TransparantValue;
   char TransparantFactor;
   float LastBeamDrawTime;

   float CombatNavDelay;
   int CombatNavDir;

   bool ShouldFly;
   float CheckFlyDelay;

   long VisiblePlayers;
   long PlayersChecked;

   short DangerLevel;
   int DangerType;

   bool MadePlayerList;
   edict_t *PlayerList[32];
   int PlayerCount;
      
   BotCombo *pBotCombo;
   float f_tele_combo_delay;
   
   float CheckUpDownTime;

   edict_t *pGoalDB;
   float DBCheckDelay;
   bool SelectWish;
   bool MadeWish;

   float AimDelay;
   float DelayForAimDelay;
   float f_aim_tracking_time;
   float f_aim_x_angle_delta;
   float f_aim_y_angle_delta;
   Vector AimVec;
   Vector BodyVec;
   float YawSpeed;
   float PitchSpeed;

   bool LetBeamExplode;
   Vector BeamJumpSpot;

   ESwoopType SwoopType;
   Vector SwoopOffset;
   float SwoopOffsetUpdateDelay;
   short MeleePercent;
   int SwoopButton;
   bool BotHoldsSecondary;

   short SwoopPercent;
   Vector aim_speed;

// TheFatal - START
   int msecnum;
   float msecdel;
   float msecval;
// TheFatal - END

   float f_prev_playermove_time;

   float f_frame_time;

   int chat_percent;
   int taunt_percent;
   int whine_percent;
   int chat_tag_percent;
   int chat_drop_percent;
   int chat_swap_percent;
   int chat_lower_percent;

   bool  b_bot_say;
   float f_bot_say;
   char  bot_say_msg[256];
   float f_bot_chat_time;
   float flReplyDelay;

   bool BotPowerUps;
   float BotPowerUpDelay;

   float turbo_time;

   float LastHitTime;
   short DamageTaken;

   float teleport_delay;
   int TeleportDir;
   short TeleportPercent;

   float AscendTime;
   float LastAscendCheck;

   int bot_ki;
   int bot_powerstrug;
   long int PL;

   int bot_team;
   int bot_class;
   int bot_health;
   int max_health;
   int bot_weapons;      // bit map of weapons the bot is carrying
   float idle_angle;
   float blinded_time;

   float f_strafe_speed;
   float f_strafe_time;
   short StrafeDir; // 1 == left; 2 == right (used for CheckBotStrafe())

   float f_updown_speed;
   float f_move_speed;

   float f_max_speed;
   float prev_speed;
   float prev_time;
   Vector v_prev_origin;

   float f_dont_avoid_wall_time;
   float f_look_for_waypoint_time;
   float f_dont_check_stuck;
   float f_look_delay;

   eye_t eye[eye_width];

   int wander_dir;

   Vector waypoint_origin;
   float f_waypoint_time;
   int curr_waypoint_index;
   int prev_waypoint_index[5];
   float f_random_waypoint_time;
   int waypoint_goal;
   float f_waypoint_goal_time;
   float prev_waypoint_distance;

   edict_t *pBotEnemy;
   edict_t *pLastEnemy;
   
   edict_t *pBotUser;
   float movingusertime;
   float searchforuser;
   edict_t *pBotLastUser;
   float UsingTime;

   edict_t *pHuntingEdict;
   float HuntDelayTime;
   edict_t *pLastHuntEdict;

   OldPosition_t HuntPos;
   OldPosition_t LastHuntPos;
   float PrevHuntDist;
   float UpdateHuntPosTime;

   float f_bot_use_time;
   float f_bot_spawn_time;
   edict_t *killer_edict;
   bool  b_bot_say_killed;
   float f_bot_say_killed;  

   // Super bot stuff...
   float AbsorbHealthTime;
   float LastSoundPlayedTime;

   float f_shoot_time;
   float f_primary_charging;
   float f_secondary_charging;
   int   charging_weapon_id;

   float f_pause_time;

   bool SelectCookie; // Yummie!

   edict_t *pTouchEnt;

   TLinkedList<short> *pBotWeaponList;
   SCurrentWeapon current_weapon;  // one current weapon for each bot
   int m_rgAmmo[MAX_AMMO_SLOTS];  // total ammo amounts (1 array for each bot)

} bot_t;

enum EMoveDir
{
	MOVE_LEFT,
	MOVE_RIGHT
};

enum ESpawnState
{
	SPAWN_IDLE,
	SPAWN_NEED_TO_RESPAWN,
	SPAWN_IS_RESPAWNING,
	SPAWN_NOTHING
};

enum EStartMessage
{
	START_IDLE,
	START_TEAM_SELECT,
	START_CLASS_SELECT,
	START_MOTD
};

enum ESwoopOffsetType
{
	SWOOP_OFFSET_LEFT,
	SWOOP_OFFSET_RIGHT,
	SWOOP_OFFSET_UP,
	SWOOP_OFFSET_DOWN,
};

enum ESwitch
{
	ON, OFF
};

#ifdef classstuff
bool UTIL_IsValidPlayer(CClient *pClient, bool CheckAlive = true, bool CheckObserver = true);
bool UTIL_IsBot(CClient *pClient);
class CBotManager;
class CBot: public CClient
{
	// Private member vars

	// Spawn variabeles
	ESpawnState m_eRespawnState;
	bool m_bNeedToInitialize;
	bool m_bNotStarted;
	EStartMessage m_eStartAction;
    short m_sBotTeam; // team the bot wants to join
    short m_sBotClass; // class the bot wants to choose
    float m_fBotSpawnTime; // Time the bot (re)spawned
	float m_fCreateTime;

	// Settings
	byte m_bBotSkill;
	BotPersonality_t *m_pPersonality;

	// Misc stuff
	float m_fKickTime;
    bool m_bShouldFly;
    float m_fCheckFlyDelay;
    byte m_bDangerLevel;
    int m_iDangerTypes;
    bool m_bMadePlayerList;
    CClient *m_pPlayerList[32];
    long m_lVisiblePlayers;
    long m_lPlayersChecked;
    byte m_bPlayerCount;
    BotCombo *m_pBotCombo;
    float m_fTeleComboDelay;
    float m_fTurboTime;
    float m_fLastHitTime;
    edict_t *m_pTouchEnt;
	char m_szName[BOT_NAME_LEN+1];

	// Task vars
	CBaseTask *m_pCurrentBotTask;
	CBaseSubTask *m_pCurrentBotSubTask;
	ETaskCode m_eTaskAfterTask; // Since its not possible to create a task in a task...
	ETaskCode m_ePrevTask;

	// 'Global' task vars
	float m_fCheckKameTorpTime;
	bool m_bChargeKameTorp;
	float m_fLastKameTorpLeftOverCheck;
	short m_sJumpDir;
	float m_fWallJumpCheckDelay;
	short m_sMoveDir;
	float m_fMoveTime;
    float m_fTeleportDelay;
    int m_iTeleportDir;
    float m_fBotPowerUpDelay;
	bool m_bLetBeamExplode;
    ESwoopOffsetType m_eSwoopType;
    int m_iSwoopButton;
    bool m_bBotHoldsSecondary;
    float m_fLastAscendCheck;
    bool m_bSelectCookie; // Yummie!
    float m_fPauseCheckTime;

	// Combat vars
	float m_fSearchEnemyDelay;
	float m_fLastEnemySwoopCheck;
	float m_fHasAnEnemyTime;
	EnemyPriority_t m_EnemyList[4];
	float m_fCombatNavDelay;
	short m_sCombatNavDir;
    CClient *m_pBotEnemy;
    CClient *m_pLastEnemy;
    float m_fShootDelay;
    float m_fPrimaryChargeTime;
    float m_fSecondaryChargeTime;
    int m_iChargingWeaponId;
    bot_current_weapon_t m_CurrentWeapon;  // one current weapon for each bot
	__int64 m_i64AvailableWeapons;

	// Super bot vars
	short m_sSBotType;
	float m_fUpdateStatsDelay;
	short m_sTransparantValue;
	short m_sTransparantFactor;
	float m_fLastBeamDrawTime;
    float m_fAbsorbHealthTime;
    float m_fLastSoundPlayedTime;
	char m_szOldName[BOT_NAME_LEN+1];

	// Variabeles for aiming
    float m_fAimDelay;
    float m_fAimTrackingTime;
    float m_fAimXAngleDelta;
    float m_fAimYAngleDelta;
    Vector m_vAimVec;
    Vector m_vBodyVec;
    float m_fYawSpeed;
    float m_fPitchSpeed;
    Vector m_vAimSpeed;

	// Variabeles for calculating the frame time
    int m_iMSecNum;
    float m_fMSecDel;
    float m_fMSecVal;
    float m_fPrevPlayermoveTime;
    float m_fFrameTime;

    // chat variabeles
    bool  m_bBotShouldSay;
    float m_fBotSayTime;
    char  m_szBotSayMsg[256];
    float m_fBotChatTime;
    edict_t *m_pKillerEdict;
    bool  m_bBotSayKilled;
    float m_fBotSayKilledTime;

	// Movement variabeles
    float m_fStrafeTime;
    EMoveDir m_eStrafeDir;
	float m_fStrafeSpeed;
    float m_fUpDownSpeed;
    float m_fMoveSpeed;
	float m_fBotMaxSpeed; // special var set in pfnSetMaxSpeed to fix the not move bug for bots

	// Unstuck variabeles(unused atm)
    float prev_time;
    Vector v_prev_origin;
    float f_dont_check_stuck;
	float m_fPrevSpeed;

	// Navigation variabeles
    float m_fDontAvoidWallTime;
    float m_fLookDelay;
    eye_t m_eye[eye_width];
    EMoveDir m_eWanderDir;
	float m_fCheckUpDownTime;

	// Waypoint variabeles
    Vector m_vCurrentWaypointOrigin;
    float m_fWaypointTime;
    int m_iCurrentWaypointIndex;
    int m_iPrevWaypointIndexes[5];
    float m_fRandomWaypointTime;
    int m_iCurrentWaypointGoalIndex;
    float m_fWaypointGoalTime;
    float m_fPrevWaypointDistance;
	float m_fLookForWaypointTime;

	// Team mate following variabeles
    CClient *m_pBotUser;
	CClient *m_pBotLastUser;
    float m_fTimeUserMoved; // Last time the team mate moved
    float m_fSearchForUserDelay; // Delay for searching a new team mate to follow
    float m_fUsingTime; // Time that the bot may follow his current team mate
    float m_fBotUseTime; // Last time the bot has someone to follow

	// Hunting variabeles
    CClient *m_pHuntingEdict;
    CClient *m_pLastHuntEdict;
    OldPosition_t m_HuntPos;
    OldPosition_t m_LastHuntPos;
	float m_fHuntDelayTime;
    float m_fPrevHuntDist;
    float m_fUpdateHuntPosTime;

	friend CBotManager;

public:
	CBot(edict_t *pEdict) : CClient(pEdict){}; // construction
	virtual ~CBot(void){}; // destruction
	virtual bool IsBot(void){ return true; };

	void BotPreThink(void);
	void DeadThink(void);
	virtual void Think(void);

	void CreateInit(short Team, short Class, short Skill, short Perso, short SBotVal);

	// Misc stuff
	void MakePlayerList(void);
	int ReturnTurnedAngle(float speed, float current, float ideal);
	bool CheckForEnemyTraces(void);
	CClient *BotFindEnemy(void);
	CClient *BotFindUser(void) { return NULL; };
	CClient *GetBestEnemyFromList(void) { return NULL; };
	void MakeCombo(ComboTypes CT);
	void DeleteCombos();
	void SelectWeapon(char *item_name);
	bool IsValidEnemy(CClient *pClient);
	bool IsSuperBot(void)					{ return (m_sSBotType > 0); };
	void SetSkill(byte NewSkill)			{ m_bBotSkill = NewSkill - 1; };
	byte GetSkill(void)						{ return m_bBotSkill; };
	float BotChangeYaw(float Speed, float Ideal);
	float BotChangePitch(float Speed, float Ideal);
	bool DangerousPlForBot(long EnemyPl);
	bool BotHasWeapon(int iId);
	virtual void SetTeam(short Team)		{ CClient::SetTeam(Team); m_sBotTeam = Team; };

	// Functions to determine if a task should be made.
	bool BotShouldFallDown(void);
	bool BotCanAscend(void);
	bool CheckWallJump(void);
	bool BotCanBeamJump(bool AttackIsReleashed);
	bool MakeKameTorps(short DesiredTorpCount);
	bool BotShouldMakeKameTorps(void);

	// Functions used by multiple tasks
	void SetMoveDir(int MoveDir);
	Vector BotBodyTarget(edict_t *pBotEnemy, bool PredictEnemyPos = true);
	float AddShootDelay(void);
	short GetBestEscapeSwoopDir(bool CheckBackwards);
	int UTIL_GetRandTeleDir(TeleDir TeleportBF);

	// Task functions
	void MakeTask(ETaskCode TaskCode);
	void KillCurrentTask(void);
	void MakeAvoidSwoopTask(void);

	// Functions called from the think function
	void BotAim(void);
	void BotSense(void);
	void CheckNecessarilyThings(void);
	void CheckBotInternalStatus(void);
	void CheckBotMiscThings(void);
	void BotPerformTasks(void);
	void SpawnInit(void) {};
	void BotStartGame(void);
	void CheckSBotStuff(void);

	// Client message hook functions
	virtual void ClientMsgVGUI(void *pValue){};
	void ClientMsgWeaponList(void *pValue);
	void ClientMsgCurrentWeapon(void *pValue);
	void ClientMsgAmmoX(void *pValue);
	void ClientMsgAmmoPickup(void *pValue);
	void ClientMsgWeaponPickup(void *pValue);
	void ClientMsgItemPickup(void *pValue);
	void ClientMsgHealth(void *pValue);
	void ClientMsgWeapUpdate(void *pValue);
	void ClientMsgMOTD(void *pValue) {};

	// List operation functions
	void CheckIfValidPlayer(CClient *pClient);
	bool CheckPlayersForKameTorps(CClient *pClient);

	// Class functions
	class CMakePlayerList
	{
		CClient *pPlayers[32];
		CBot *pBot;
		long PlayersChecked;
		long VisPlayers;
		byte PlayerCount;

	public:
		CMakePlayerList(void) : PlayersChecked(0), VisPlayers(0), PlayerCount(0), pBot(NULL)
		{
			memset(pPlayers, 0, sizeof(pPlayers));
		};

		void SetPlayersChecked(long l) { PlayersChecked = l; };
		void SetVisPlayers(long l) { VisPlayers = l; };

		void operator ()(CClient *pClient);
	};
};

#endif


#define MAX_FLAGS  5

typedef struct {
   bool mdl_match;
   int  team_no;
   edict_t *edict;
} FLAG_S;

typedef struct
{
   bool can_modify;
   char text[81];
} bot_chat_t;

// 3D referential structure definition
typedef struct
{
    Vector v_forward; // normalized vector pointing forward, perpendicular both to v_up and v_right
    Vector v_up; // normalized vector pointing upwards, perpendicular both to v_forward and v_right
	Vector v_right; // normalized vector pointing right, perpendicular both to v_forward and v_up
} referential_t;

typedef struct
{
	short ki_gain;
	short health_gain;
	long pl;
	int transparency_val;
	short laser_percent;
} SBotSettings_t;

class CBaseEntity;

// new UTIL.CPP functions...
edict_t *UTIL_FindEntityInSphere( edict_t *pentStart, const Vector &vecCenter, float flRadius );
edict_t *UTIL_FindEntityByString( edict_t *pentStart, const char *szKeyword, const char *szValue );
edict_t *UTIL_FindEntityByClassname( edict_t *pentStart, const char *szName );
edict_t *UTIL_FindEntityByTargetname( edict_t *pentStart, const char *szName );
void ClientPrint( edict_t *pEdict, int msg_dest, const char *msg_name);
void UTIL_SayText( const char *pText, edict_t *pEdict );
void UTIL_HostSay( edict_t *pEntity, int teamonly, char *message );
int UTIL_GetTeam(edict_t *pEntity);
int UTIL_GetClass(edict_t *pEntity);
int UTIL_GetBotIndex(edict_t *pEdict);
bot_t *UTIL_GetBotPointer(edict_t *pEdict);
bool IsAlive(edict_t *pEdict);
bool FInViewCone(Vector *pOrigin, edict_t *pEdict);
bool FVisible( const Vector &vecOrigin, edict_t *pEdict );
Vector Center(edict_t *pEdict);
Vector GetGunPosition(edict_t *pEdict);
void UTIL_SelectItem(edict_t *pEdict, char *item_name);
Vector VecBModelOrigin(edict_t *pEdict);
void UTIL_ShowMenu( edict_t *pEdict, int slots, int displaytime, bool needmore, char *pText );
void UTIL_BuildFileName(char *filename, char *arg1, char *arg2);
bool UTIL_IsValidPlayer(edict_t *pEdict, bool CheckAlive = true, bool CheckObserver = true);
float UTIL_Distance(Vector vec1, Vector vec2);

void UTIL_DrawBeam(edict_t *pEntity, Vector start, Vector end, int width,
        int noise, int red, int green, int blue, int brightness, int speed, int life = 4);
void UTIL_DrawBeamToAll(Vector start, Vector end, int width, int noise, int red, int green, int blue, 
						int brightness, int speed);

bool IsNull (edict_t *pEdict);
referential_t ReferentialOfAngles (Vector &v_angles);
void UTIL_GetModel(edict_t *pEdict, char *model_name);
edict_t *UTIL_SearchForEnemy(bot_t *pBot, edict_t *pEnemy);
int UTIL_GetClientIndex(edict_t *pEdict);
ClientInfo_t *UTIL_GetClientPointer(edict_t *pEdict);
bool UTIL_IsValidEnemy(bot_t *pBot, edict_t *pEnemy);
void UTIL_PrintEntity (edict_t *pEntity, const char *szFileName = NULL);
void UTIL_ChangePl(edict_t *pEdict, long NewPl);
void UTIL_ChangeRealPl(edict_t *pEdict, long NewPl);
void UTIL_ChangeKi(edict_t *pEdict, int NewKi);
short UTIL_EntDir(edict_t *pPlayer, edict_t *pEntity);
int UTIL_VecDir(edict_t *pEdict, Vector v_vec);
void UTIL_DamagePlayer(edict_t *pKiller, edict_t *pVictim, const char *Weapon, float Damage);
// Thanx to Cheesy:
CBaseEntity *UTIL_CreateEnt( char *szName, const Vector &vecOrigin, const Vector &vecAngles, edict_t *pentOwner );
// Thanx to harSens
int UTIL_LookUpSequence(void *pModel, const char *Label);
bool UTIL_VecIsInLava(Vector vec);
void UTIL_Printf(const char *msg, int type = HUD_PRINTNOTIFY, edict_t *pEntity = NULL);
void UTIL_KickBots(short team);
void UTIL_KickPlayer(edict_t *pEdict);
void UTIL_ShowInGameHelpWindow();
bool IsTeamPlay();
bool CheckForCollide(edict_t *pEdict, int dir, float distance);
short UTIL_GetHeadingPercentage(edict_t *pEnt1, edict_t *pEnt2);
byte UTIL_GetNumPlayers(void);

void LoadBotChat(void);
void BotTrimBlanks(char *in_string, char *out_string);
int BotChatTrimTag(char *original_name, char *out_name);
void BotDropCharacter(char *in_string, char *out_string);
void BotSwapCharacter(char *in_string, char *out_string);
void BotChatName(char *original_name, char *out_name);
void BotChatText(char *in_text, char *out_text);
void BotChatFillInName(char *bot_say_msg, char *chat_text, char *chat_name, const char *bot_name);

bool IsAttack(edict_t *pent);
bool IsBeamAttack(edict_t *pent);
bool IsNonBeamAttack(edict_t *pent);
bool IsKiBall(edict_t*pent);
bool IsOtherAttack(edict_t *pent);

void BotRecoverHP(bot_t *pBot);
void MakePlayerList(bot_t *pBot);
bool IsTurboOn(edict_t *pEdict);
void ToggleTurbo(edict_t *pEdict, bool on);

Vector SearchBestThrowSpot(bot_t *pBot);
short GetBestEscapeSwoopDir(bot_t *pBot, bool CheckBackwards);

void BotAim (bot_t *pBot);
int ReturnTurnedAngle( bot_t *pBot, float speed, float current, float ideal) ;

bool CheckWallJump(bot_t *pBot);
bool BotCanBeamJump(bot_t *pBot, bool AttackIsReleashed);
bool AttacksWillCollide(edict_t *pAttack1, edict_t *pAttack2);

void ClientKill( edict_t *pEntity );

void MakeAvoidSwoopTask(bot_t *pBot);
int GetRandomTeleDir(bot_t *pBot);

bool BotShouldFallDown(bot_t *pBot);

bool KeepAttacksAwayFromBot(bot_t *pBot, bool BotMayDrawBeams);

bool BotCanAscend(bot_t *pBot);

void SetButtonsFromAComboChargeButton(bot_t *pBot, EComboChargeButton Button);

void LogBotInfo(bot_t *pBot);

enum EComboUse
{
	UseCombo,
	DontUseCombo,
	RandomComboUse
};

#ifdef classstuff
extern CBotManager *pBotManager;

class CBotManager
{
	struct SKickedBot
	{
		byte Skill;
		BotPersonality_t *pPersonality;
		short BotClass;
		short BotTeam;
		char BotName[256];
		short SBotType;
		CClient *pLastEnemy;
		float KickTime;
		ESpawnState RespawnState;

		// construction
		SKickedBot(void){};
		SKickedBot(byte CurrentSkill, BotPersonality_t *pPerso, short Class, short Team,
				   const char *PrevName, short SType, CClient *pPrevEnemy, 
				   ESpawnState SpState) : Skill(CurrentSkill), pPersonality(pPerso), 
				   BotClass(Class), BotTeam(Team), SBotType(SType), 
				   KickTime(gpGlobals->time), RespawnState(SpState)
		{ 
			strncpy(BotName, PrevName, 256);
			BotName[256] = 0;
		};

		bool operator == (SKickedBot KB)
		{
			return ((Skill == KB.Skill) && (pPersonality == KB.pPersonality) && 
					(BotClass == KB.BotClass) && (strcmp(BotName, KB.BotName) == 0) &&
					(SBotType == KB.SBotType) && (pLastEnemy == KB.pLastEnemy) &&
					(KickTime == KB.KickTime) && (RespawnState == KB.RespawnState));
		};

		bool operator != (SKickedBot KB)
		{
			return ((Skill != KB.Skill) || (pPersonality != KB.pPersonality) || 
					(BotClass != KB.BotClass) || (strcmp(BotName, KB.BotName) != 0) ||
					(SBotType != KB.SBotType) || (pLastEnemy != KB.pLastEnemy) ||
					(KickTime != KB.KickTime) || (RespawnState != KB.RespawnState));
		};
	};

	// List to store kicked bots, so we can restore them on mapchange
	TLinkedList<SKickedBot*> *m_pKickedBots;

	byte m_bNumberOfBots;
	byte m_bPrevNumberBots;
	float m_fBalanceTeamsDelay;

	// General bot settings
	bool m_bBotsSearchEnemies;
	bool m_bBotsShoot;
	bool m_bBotsMove;
	bool m_bBotsUseDiscs;
	bool m_bObserverMode;
	bool m_bBotsAreIdle;
	bool m_bBalanceTeams;
	bool m_bShouldBotsChat;
	bool m_bBotsFollowTeamMates;

	// Fill variabeles
	float m_fAddBotDelay;
	bool m_bFillWholeServer;
	bool m_bFillHalfTeam;
	bool m_bFillTeam;
	byte m_bTeamToFill;
	byte m_bBotsToCreate;
	short m_sMinBots;
	short m_sMaxBots;
	float m_fRestoreBotsTime;
	bool m_bRestoringBots;
	bool m_bSpawnTimeReset;

	// Super bot stuff
	float m_fOldPLCatchupValue;
	byte m_bSBotCount;
	float m_fSBotRulesDelay;

	float m_fBotCFGPauseTime;
	FILE *m_pBotCFGFile;

	// CVar stuff
	bool m_bCheckNumBotsCVar;
	float m_fCheckSkillCVarDelay;
	short m_sDefaultSkill;
		
	friend CBot;

public:
	bool BotsSearchEnemies(void)		{ return m_bBotsSearchEnemies; };
	bool BotsShoot(void)				{ return m_bBotsShoot; };
	bool BotsMove(void)					{ return m_bBotsMove; };
	bool BotsUseDiscs(void)				{ return m_bBotsUseDiscs; };
	bool ObserverMode(void)				{ return m_bObserverMode; };
	bool BotsAreIdle(void)				{ return m_bBotsAreIdle; };
	bool BotsBalanceTeams(void)			{ return m_bBalanceTeams; };
	bool ShouldBotsChat(void)			{ return m_bShouldBotsChat; };
	bool BotsFollowTeamMates(void)		{ return m_bBotsFollowTeamMates; };

	// Note: the following functions have effect on ALL bots
	void ChangeMeleePercent(short NewPercent);
	void ChangeTeleportPercent(short NewPercent);
	void ChangeSwoopPercent(short NewPercent);
	void ChangeFlyPercent(short NewPercent);
	void ChangeChatPercent(short NewPercent);
	void ChangeTauntPercent(short NewPercent);
	void ChangeWhinePercent(short NewPercent);
	void ChangeChatTagPercent(short NewPercent);
	void ChangeChatDropPercent(short NewPercent);
	void ChangeChatSwapPercent(short NewPercent);
	void ChangeChatLowerPercent(short NewPercent);
	void ChangeSBotLaserPercent(short NewPercent);
	void ChangeBotBoolSetting(bool &Setting, short Choice, const char *VarName);
	void ChangePersoPercentSetting(short BotPersonality_t::*Setting, short Choice, 
								   const char *VarName);
	void ChangeBotSkill(short Skill);
	void ChangeAggressionLevel(AggressionLevel_e AggrLevel);

	void SetMinBots(short MinBots)		{ m_sMinBots = MinBots; };
	void SetMaxBots(short MaxBots)		{ m_sMaxBots = MaxBots; };

	void KickBots(short Team); // if team == -1 kick all bots
	void KickLastBot(void);
	void DisconnectBot(CClient *pClient);

	void CreateBot(short Team, short Class, const char *Name, short Skill, short Perso);
	void CreateSuperBot(short Class, const char *Name, short Perso, short SBotType);
 
	void RestoreBots(void); // Add the kicked bots again because of a map change

	void FillAHalfTeam(byte Team);
	void FillATeam(byte Team);
	void FillServer(void);
	bool IsAddingMultipleBots(void);
	void BotFillThink(void);
	void CheckIfABotShouldBeKicked(void);

	void BotBalanceTeamsThink(void);

	// Superbot stuff
	void RestoreOldPLCatchupValue(void) { CVAR_SET_FLOAT("mp_plcatchup", m_fOldPLCatchupValue); };
	void StoreOldPLCatchupValue(void) { m_fOldPLCatchupValue = CVAR_GET_FLOAT("mp_plcatchup"); };
	bool AreSBotsIngame(void) { return (m_bSBotCount > 0); };
	void SBotRulesThink(void);

	void LoadChatTexts(void);
	void LoadBotNames(void);
	void CreateBotPersonalities(void);
	void MakeRandomPersonalities(void);
	void CreateSuperbotSettings(void);
	void CreateSkillData(void);
	void BotCFGFileThink(void);
	void OpenBotCFGFile(void);

	void MapInit(void);
	void GameInit(void);

	void SkillCVarCheck(void);

	// Function to hook the global network message DeathMsg
	void GlobalNetworkMsgDeathMsg(void *pValue);

	CBot *GetBotFromClient(CClient *pClient)	{ return dynamic_cast<CBot*>(pClient); };
	CBot *GetBotFromEdict(edict_t *pEdict);
	CBot *GetLastBot(void);

	// Construction/destruction
	CBotManager(void);
	~CBotManager(void);

	// List operation functions
	void SetSkillTo(CClient *pClient, short NewSkill);
	void KickMultipleBots(CClient *pClient, short Team);
	bool ChangeBotsTeam(CClient *pClient, short Team, short *pCount);
	void LetRealPlayersJoinGood(CClient *pClient);

	// Class functions...
	class CChangeSkill
	{
		short NewSkill;
	public:
		CChangeSkill(void) : NewSkill(0) {};

		void SetSkill(short sk) { NewSkill = sk - 1; };

		operator()(CClient *pClient)
		{
			CBot *pBot = pBotManager->GetBotFromClient(pClient);
			if (pBot)
				pBot->SetSkill(NewSkill);
		};
	};

	class CKickBots
	{
		short Team;
	public:
		CKickBots(void) : Team(-1) {};
		void SetTeam(short T) { Team = T; };
		operator()(CClient *pClient)
		{
			if (pClient->IsBot())
			{
				if ((Team == -1) || (pClient->GetTeam() == Team))
					UTIL_KickPlayer(pClient->pEdict);
			}
		};
	};

	class CKickLastBot
	{
	public:
		bool operator()(CClient *pClient)
		{
			if (pClient->IsBot())
			{
				UTIL_KickPlayer(pClient->pEdict);
				return false; // We are done
			}
			return true; // We are not done...
		};
	};

	class CBotsSwitchTeams
	{
		byte BotCount; // Number of bots that should join the other team.
		byte Team; // Team that the bots should join

	public:
		CBotsSwitchTeams(void) : BotCount(0), Team(0) {};

		void SetBotCount(byte BCount) { BotCount = BCount; };
		void SetTeam(byte T) { Team = T; };

		bool operator ()(CClient *pClient)
		{
			if ((pClient->IsBot()) && (pClient->GetTeam() == Team))
			{
				char szTeam[15] = "";
				itoa(Team, szTeam, 10);
				BotCount--;
				FakeClientCommand(pClient->pEdict, "jointeam", szTeam, NULL);
			}
			return (BotCount > 0);
		};
	};

	class CLetNormalClientsJoinGood
	{
	public:
		operator ()(CClient *pClient)
		{
			if ((pClient->IsBot() == false) && (pClient->GetTeam() == 2))
				FakeClientCommand(pClient->pEdict, "jointeam", "1", NULL);
		};
	};
};

#endif

#endif // BOT_H