#ifndef bot_action_h
#define bot_action_h

#include "bot.h"

// actions
#define do_teleport				(1<<1) // ported
#define do_block				(1<<2) // ported
#define do_aim_enemy			(1<<3) // ported
#define do_powerup				(1<<4) // ported
#define do_start_swoop			(1<<5) // prolly unneeded
#define do_meleekickenemy		(1<<6) // ported 
#define do_meleemodestuff		(1<<7) // ported
#define do_shoot_enemy			(1<<8) // ported
#define do_shoot_laser1			(1<<9) // ported
#define do_normal_navagation	(1<<10) // ported
#define do_controlfriezadisc 	(1<<11) // ported
#define do_follow				(1<<12) // ported
#define do_charge				(1<<13) // ported
#define do_swoop				(1<<14) // ported
#define do_control_beam			(1<<15) // ported
#define do_ascend				(1<<16) // ported
#define do_powerstruggle		(1<<17) // ported
#define do_combat_nav			(1<<18) // ported
#define do_combo				(1<<19) // ported
#define do_look_around			(1<<20) // ported
#define do_recover_hp			(1<<21) // ported
#define do_avoid				(1<<22) // can be removed
#define do_move_dir				(1<<23) // ported
#define do_blinded				(1<<24) // ported
#define do_finishmelee			(1<<25) // ported
#define do_walljump				(1<<26) // unused
#define do_keepdangeraway		(1<<27)
#define do_absorbhealth			(1<<28)

// tasks
#define task_normal_nav			1 // ported
#define task_teleport			2 // ported
#define task_block				3 // ported
#define task_powerup			4 // ported
#define task_combat				5 // ported
#define task_melee				6 //unneeded
#define task_charge				7 // ported
#define task_swoop				8 // ported
#define task_follow				9 // ported
#define task_control_beam		10 // ported
#define task_ascend				11 // ported
#define task_powerstruggle		12 // ported
#define task_combo				13 // ported
#define task_look_around		14 // ported
#define task_recover_hp			15 // ported
#define task_avoid				16 // unneeded
#define task_move_dir			17 // ported
#define task_blinded			18 // ported
#define task_finishmelee		19 // ported
#define task_meleekickenemy		20 // ported
#define task_meleemodestuff		21 // ported
#define task_controlfriezadisc	22 // ported
#define task_keepdangeraway		23 // ported
#define task_absorbhealth		24
#define task_shoot_laser1		25 // ported

// checks
#define check_ki		(1<<1)
#define check_hit		(1<<2)
#define check_enemy		(1<<3)
#define check_stop_hit	(1<<4)
#define check_descend	(1<<5)
#define check_sound		(1<<6) // unused
#define check_attacks	(1<<7)
#define check_fly		(1<<8)
#define check_combos	(1<<9)
#define check_ascend	(1<<10)
#define check_unstuck	(1<<11) // ???
#define check_walljump	(1<<12) // ???

// subchecks
#define check_for_sound_reaction	(1<<1)

void Reset_Actions(bot_t *pBot);
void Make_Action(bot_t *pBot, int action);
void do_action(bot_t *pBot);
void CheckForActions(bot_t *pBot);

#endif