//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_client.cpp
//

#include "general_header.h"

// types of damage to ignore...
#define IGNORE_DAMAGE (DMG_CRUSH | DMG_FREEZE | DMG_FALL | DMG_SHOCK | \
                       DMG_DROWN | DMG_NERVEGAS | DMG_RADIATION | \
                       DMG_DROWNRECOVER | DMG_ACID | DMG_SLOWBURN | \
                       DMG_SLOWFREEZE | 0xFF000000)

extern bot_t bots[32];
extern int bot_taunt_count;
extern int recent_bot_taunt[];
extern bot_chat_t bot_taunt[MAX_BOT_CHAT];
extern bool should_bot_chat;
extern ClientInfo_t ClientInfo[32];
extern edict_t *listenserver_edict;

static FILE *fp;

bot_weapon_t weapon_defs[MAX_WEAPONS]; // array of weapon definitions


// This message is sent when the ESF VGUI menu is displayed.

void BotClient_ESF_VGUI(void *p, int bot_index)
{
	if ((*(int *)p) == 2)  // is it a team select menu?
		bots[bot_index].start_action = MSG_TEAM_SELECT;
    else if ((*(int *)p) == 3)  // is it a class selection menu?
		bots[bot_index].start_action = MSG_CLASS_SELECT;
    else if ((*(int *)p) == 31) // is it a wish menu?
	{
		bots[bot_index].SelectWish = true;
		bots[bot_index].MadeWish = false;
	}
    else if ((*(int *)p) == 32)  // is it a candy selection menu?
		bots[bot_index].SelectCookie = true;
}


// This message is sent when a client joins the game.  All of the weapons
// are sent with the weapon ID and information about what ammo is used.
void BotClient_ESF_WeaponList(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static bot_weapon_t bot_weapon;

   if (state == 0)
   {
      state++;
      strcpy(bot_weapon.szClassname, (char *)p);
   }
   else if (state == 1)
   {
      state++;
      bot_weapon.iSlot = *(int *)p;  // slot for this weapon
   }
   else if (state == 2)
   {
      state++;
      bot_weapon.iPosition = *(int *)p;  // position in slot
   }
   else if (state == 3)
   {
      state++;
      bot_weapon.iId = *(int *)p;  // weapon ID
   }
   else if (state == 4)
   {
      state = 0;

      bot_weapon.iFlags = *(int *)p;  // flags for weapon (WTF???)

      // store away this weapon with it's ammo information...
      weapon_defs[bot_weapon.iId] = bot_weapon;
   }
}

// This message is sent when a weapon is selected (either by the bot chosing
// a weapon or by the server auto assigning the bot a weapon).
void BotClient_ESF_CurrentWeapon(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int iState;
   static int iId;
   static int iClip;

   if (state == 0)
   {
      state++;
      iState = *(int *)p;  // state of the current weapon
   }
   else if (state == 1)
   {
      state++;
      iId = *(int *)p;  // weapon ID of current weapon
   }
   else if (state == 2)
   {
      state = 0;

      iClip = *(int *)p;  // ammo currently in the clip for this weapon

      if (iId <= 31)
      {
         bots[bot_index].bot_weapons |= (1<<iId);  // set this weapon bit

         if (iState == 1)
         {
            bots[bot_index].current_weapon.iId = iId;
            bots[bot_index].current_weapon.iClip = iClip;

            // update the ammo counts for this weapon...
            bots[bot_index].current_weapon.iAmmo1 =
               bots[bot_index].m_rgAmmo[weapon_defs[iId].iAmmo1];
            bots[bot_index].current_weapon.iAmmo2 =
               bots[bot_index].m_rgAmmo[weapon_defs[iId].iAmmo2];
         }
      }
   }
}

// This message is sent whenever ammo ammounts are adjusted (up or down).
void BotClient_ESF_AmmoX(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int index;
   static int ammount;
   int ammo_index;

   if (state == 0)
   {
      state++;
      index = *(int *)p;  // ammo index (for type of ammo)
   }
   else if (state == 1)
   {
      state = 0;

      ammount = *(int *)p;  // the ammount of ammo currently available

      bots[bot_index].m_rgAmmo[index] = ammount;  // store it away

      ammo_index = bots[bot_index].current_weapon.iId;

      // update the ammo counts for this weapon...
      bots[bot_index].current_weapon.iAmmo1 =
         bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo1];
      bots[bot_index].current_weapon.iAmmo2 =
         bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo2];
   }
}

// This message is sent when the bot picks up some ammo (AmmoX messages are
// also sent so this message is probably not really necessary except it
// allows the HUD to draw pictures of ammo that have been picked up.  The
// bots don't really need pictures since they don't have any eyes anyway.
void BotClient_ESF_AmmoPickup(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int index;
   static int ammount;
   int ammo_index;

   if (state == 0)
   {
      state++;
      index = *(int *)p;
   }
   else if (state == 1)
   {
      state = 0;

      ammount = *(int *)p;

      bots[bot_index].m_rgAmmo[index] = ammount;

      ammo_index = bots[bot_index].current_weapon.iId;

      // update the ammo counts for this weapon...
      bots[bot_index].current_weapon.iAmmo1 =
         bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo1];
      bots[bot_index].current_weapon.iAmmo2 =
         bots[bot_index].m_rgAmmo[weapon_defs[ammo_index].iAmmo2];
   }
}

// This message gets sent when the bot picks up a weapon.
void BotClient_ESF_WeaponPickup(void *p, int bot_index)
{
   int index;

   index = *(int *)p;

   // set this weapon bit to indicate that we are carrying this weapon
   bots[bot_index].bot_weapons |= (1<<index);
}



// This message gets sent when the bot picks up an item (like a battery
// or a healthkit)
void BotClient_ESF_ItemPickup(void *p, int bot_index)
{
}


// This message gets sent when the bots health changes.
void BotClient_ESF_Health(void *p, int bot_index)
{
   int temp_health;

   temp_health = bots[bot_index].bot_health;
   if (temp_health > (*(int *)p))
   {
	   bots[bot_index].LastHitTime = gpGlobals->time;
	   bots[bot_index].DamageTaken = temp_health - *(int *)p;
   }
	  		
   bots[bot_index].bot_health = *(int *)p;  // health ammount
}

// This message gets sent when the bots max health changes.
void BotClient_ESF_MaxHealth(void *p, int bot_index)
{
   bots[bot_index].max_health = *(int *)p;  // max health ammount
}

void BotClient_ESF_ScreenFade(void *p, int bot_index)
{
   static int state = 0;   // current state machine state
   static int duration;
   static int hold_time;
   static int fade_flags;
   int length;

   if (state == 0)
   {
      state++;
      duration = *(int *)p;
   }
   else if (state == 1)
   {
      state++;
      hold_time = *(int *)p;
   }
   else if (state == 2)
   {
      state++;
      fade_flags = *(int *)p;
   }
   else if (state == 6)
   {
      state = 0;

      length = (duration + hold_time) / 4096;
      bots[bot_index].blinded_time = gpGlobals->time + length - 2.0;
   }
   else
   {
      state++;
   }
}

void BotClient_ESF_Ki(void *p, int bot_index)
{
   bots[bot_index].bot_ki = *(int *)p;  // Ki ammount
     
//   fp=fopen("bot.txt","a"); fprintf(fp,"ki: %i\n", bots[bot_index].bot_ki); fclose(fp); 	
}

void BotClient_ESF_PowerStruggle(void *p, int bot_index)
{
   int psval = *(int *)p;

   bots[bot_index].bot_powerstrug = psval;  
}

void BotClient_ESF_Speed(void *p, int bot_index)
{
//   bots[bot_index].f_max_speed = *(int *)p;
}

void BotClient_ESF_WeapUpdate(void *p, int bot_index)
{
#ifdef trycatchshit
	try{
#endif
	if (!bots[bot_index].pBotWeaponList)
		return;

   int iId = *(int *)p;

   if (iId < 0)
   {
	   bots[bot_index].pBotWeaponList->DeleteEntry(abs(iId));
	   bots[bot_index].NumberWeapons--;
   }
   else if (iId >= 1)
   {
	   bots[bot_index].pBotWeaponList->AddNode(iId);
	   bots[bot_index].NumberWeapons++;
   }
#ifdef trycatchshit
	}
	catch(...)
	{
		clog << "LIST ERROR!\nFor bot " << bots[bot_index].name << "\nWeap Id: " << *(int *)p << "\n";
		lcout << "LIST ERROR!\nFor bot " << bots[bot_index].name << "\nWeap Id: " << *(int *)p << "\n";

		bots[bot_index].pBotWeaponList->LogList();
	}
#endif
}

// This message gets sent when the MOTD gets displayed
void BotClient_ESF_MOTD(void *p, int bot_index)
{
    //bots[bot_index].start_action = MSG_MOTD;
}

void BotClient_ESF_TextMsg(void *p, int bot_index)
{
   int i;
   char message[200] = "";
   static int state = 0;   // current state machine state

   if (p == NULL)  // handle pfnMessageEnd case
   {
      state = 0;
      return;
   }

   if (state == 0)
   {
      state++;
   }
   else if (state == 1)
   {
       strcpy(message, (char *)p);
       int blagh = strlen(message);

       for (i=1;i <= blagh;i++)
       {
           if (!strncmp("is targeted", &message[i], strlen("is targeted")))
           { 
               bots[bot_index].pEdict->v.button |= IN_ATTACK;
           }
       }
   }
}

void BotClient_ESF_PL(void *p, int bot_index)
{
   //static int state = 0;   // current state machine state

   bots[bot_index].PL = *(long int*)p;
/*   if (state == 0)
   {
      state++;
   }
   else if (state == 1)
   {
      state = 0;
     // bots[bot_index].PL = *(long *)p;
   }*/
}

void BotClient_ESF_ChargeBeam(void *p, int bot_index)
{
	bots[bot_index].ChargeBeamVal = *(int*)p;
}

#ifdef classstuff
// This message gets sent when the bots get killed
void CBotManager::GlobalNetworkMsgDeathMsg(void *pValue)
{
	static int state = 0;   // current state machine state
    static int killer_index;
    static int victim_index;
    static edict_t *killer_edict;
    static edict_t *victim_edict;
    static int index;

    char chat_text[81];
    char chat_name[64];
    char temp_name[64];
    const char *bot_name;
   
    if (state == 0)
    {
		state++;
		killer_index = *(int *)pValue;  // ENTINDEX() of killer
    }
    else if (state == 1)
    {
		state++;
		victim_index = *(int *)pValue;  // ENTINDEX() of victim
    }
	else if (state == 2)
    {
		state = 0;

        killer_edict = INDEXENT(killer_index);
		victim_edict = INDEXENT(victim_index);

		CClient *pKiller = pClientManager->GetClientFromEdict(killer_edict);
		CClient *pVictim = pClientManager->GetClientFromEdict(victim_edict);
		CBot *pKillerBot = GetBotFromEdict(killer_edict);

        // is this message about a bot killing someone?
        if (pKillerBot)
		{
			if (pVictim)
			{
				// are there any taunt messages and should the bot taunt?
				if ((bot_taunt_count > 0) &&
					(RANDOM_LONG(1, 100) <= pKillerBot->m_pPersonality->taunt_percent))
				{
					int taunt_index = 0;  //EEKHOORN GAVE THIS ONE A VALUE
					bool used;
					int i, recent_count;

					// set chat flag and time to chat...
					pKillerBot->m_bBotShouldSay = true;
					pKillerBot->m_fBotSayTime = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);

					recent_count = 0;

					while (recent_count < 5)
					{
						taunt_index = RANDOM_LONG(0, bot_taunt_count-1);

						used = FALSE;

						for (i=0; i < 5; i++)
						{
							if (recent_bot_taunt[i] == taunt_index)
								used = TRUE;
						}

						if (used)
							recent_count++;
						else
							break;
					}

					for (i=4; i > 0; i--)
						recent_bot_taunt[i] = recent_bot_taunt[i-1];

					recent_bot_taunt[0] = taunt_index;

					if (bot_taunt[taunt_index].can_modify)
						BotChatText(bot_taunt[taunt_index].text, chat_text);
					else
						strcpy(chat_text, bot_taunt[taunt_index].text);

					if (victim_edict->v.netname)
					{
						strncpy(temp_name, STRING(victim_edict->v.netname), 31);
						temp_name[31] = 0;

						BotChatName(temp_name, chat_name);
					}
					else
						strcpy(chat_name, "NULL");

					bot_name = STRING(pKiller->pEdict->v.netname);

					FillInName(pKillerBot->m_szBotSayMsg, chat_text, chat_name, bot_name);
				}
			}
		}

		CBot *pVictimBot = GetBotFromClient(pVictim);

		// is this message about a bot being killed?
		if (pVictimBot)
		{
			if ((killer_index == 0) || (killer_index == victim_index))
			{
				// bot killed by world (worldspawn) or bot killed self...
				pVictimBot->m_pKillerEdict = NULL;
			}
			else
			{
				// store edict of player that killed this bot...
				pVictimBot->m_pKillerEdict = killer_edict;
				pVictimBot->m_pLastEnemy = pKiller;
			}
		}

	    // Clear the traces the player made.....
		if (pVictim)
			pVictim->ClearOldPositions();
	}
}
#endif