//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_combat.cpp
//

#include "general_header.h"

extern bool b_botdontshoot;
extern bool BotDontSearchEnemy;
extern bool BotDoCombos;
extern bool BotsUseDiscs;

extern SBotSettings_t SBotSettings[3];

extern int bot_melee_percent;
extern int bot_teleport_percent;
extern bool b_observer_mode;

extern enginefuncs_t g_engfuncs;

extern bot_t bots[32];
extern ClientInfo_t ClientInfo[32];
extern BotPersonality_t BotPersonalities[9];

extern edict_t *listenserver_edict;

extern bool debug_mode;

extern float AimYSpeeds[5][2];

float ExplodeBeamDistances[5][2] =
{
	{150.0, 200.0}, {165.0, 215.0}, {230.0, 280.0}, {250.0, 310.0}, {340.0, 420.0}
};

float AttackDelays[5][2] = 
{
	{0.1, 0.4}, {0.3, 0.6}, {0.5, 1.1}, {1.2, 1.6}, {1.5, 2.0}
};

float EnemySearchDelays[5][2] =
{
	{0.09, 0.12},
	{0.12, 0.17},
	{0.18, 0.22},
	{0.25, 0.30},
	{0.30, 0.36}
};

short RandomComboButtonPercent[5] =
{
	0,
	15,
	25,
	50,
	75
};

#ifdef _DEBUG
unsigned long MeleeCalls = 0;
unsigned long KiAttackCalls = 0;
#endif

struct SWeaponInfo
{
	short WeaponId; // The mods weapon id
	char WeaponName[64]; // The weapon name
	float MinDist; // Minimal distance to use this weapon
	float MaxDist; // Maximal distance to use this weapon
	short PrimaryPercent; // Percentage of using primary fire to use this weapon
	float PrimaryChargeTime; // Time to charge when using primary fire
	float SecondaryChargeTime; // Time to charge when using secondary fire
	bool IsABeam; // Is this attack a beam?
	bool CanBeamJumpWithit; // Can we beam jump with this attack?
	bool NonChargeble; // Do we need to charge this attack or just hold fire for a while?
};

typedef struct
{
   int iId;  // the weapon ID value
   char  weapon_name[64];  // name of the weapon when selecting it
   int   skill_level;   // bot skill must be less than or equal to this value
   float primary_min_distance;   // 0 = no minimum
   float primary_max_distance;   // 9999 = no maximum
   float secondary_min_distance; // 0 = no minimum
   float secondary_max_distance; // 9999 = no maximum
   int   use_percent;   // times out of 100 to use this weapon when available
   bool  can_use_underwater;     // can use this weapon underwater
   int   primary_fire_percent;   // times out of 100 to use primary fire
   int   min_primary_ammo;       // minimum ammout of primary ammo needed to fire
   int   min_secondary_ammo;     // minimum ammout of seconday ammo needed to fire
   bool  primary_fire_hold;      // hold down primary fire button to use?
   bool  secondary_fire_hold;    // hold down secondary fire button to use?
   bool  primary_fire_charge;    // charge weapon using primary fire?
   bool  secondary_fire_charge;  // charge weapon using secondary fire?
   float primary_charge_delay;   // time to charge weapon
   float secondary_charge_delay; // time to charge weapon
} AttackSelectTable_t;

AttackSelectTable_t AttackSelectTable[] = {
   {ESF_WEAPON_MELEE, "weapon_melee", 5, 15.0, 5000, 0.0, 0.0,
    0, TRUE, 100, 0, 0, FALSE, FALSE, FALSE, FALSE, 4.0, 0.0},  
   {ESF_WEAPON_SWORD, "weapon_sword", 5, 15.0, 5000, 0.0, 0.0,
    0, TRUE, 100, 0, 0, FALSE, FALSE, FALSE, FALSE, 4.0, 0.0},  
   {ESF_WEAPON_KIBLAST, "weapon_kiblast", 5, 5.0, 1000.0, 34, 1000.0,
    50, TRUE, 25, 0, 0, FALSE, FALSE, TRUE, TRUE, 2.5, 2.5},
   {ESF_WEAPON_GENERIC_BEAM, "weapon_genericbeam", 5, 50.0, 5000, 50.0, 5000.0,
    30, TRUE, 50, 0, 0, FALSE, FALSE, TRUE, TRUE, 2.5, 2.5},
   {ESF_WEAPON_GALLIT_GUN, "weapon_gallitgun", 5, 300.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.5, 0.0},
   {ESF_WEAPON_KAMEHAMEHA, "weapon_kamehameha", 5, 300.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 6.0, 0.0},
   {ESF_WEAPON_DESTRUCTO_DISC, "weapon_destructodisc", 5, 30.0, 4000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 3.0, 0.0},
   {ESF_WEAPON_EYELASER, "weapon_eyelaser", 5, 50.0, 1000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 1.0, 0.0},
   {ESF_WEAPON_FRIEZADISC, "weapon_friezadisc", 5, 30.0, 4000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.5, 0.0},
   {ESF_WEAPON_SPECIALBEAM_CANNON, "weapon_specialbeamcannon", 5, 300.0, 5000, 0.0, 0.0,
    40, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.5, 0.0},
   {ESF_WEAPON_SPIRIT_BOMB, "weapon_spiritbomb", 5, 430.0, 3000, 430.0, 5000.0,
    30, TRUE, 25, 0, 0, FALSE, FALSE, TRUE, TRUE, 11.0, 8.0},
   {ESF_WEAPON_BIGBANG, "weapon_bigbang", 5, 430.0, 3000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 6.0, 0.0},
   {ESF_WEAPON_FINGERLASER, "weapon_fingerlaser", 5, 50.0, 3000, 30.0, 2000.0,
    30, TRUE, 50, 0, 0, FALSE, FALSE, FALSE, TRUE, 0.0, 1.5},
   {ESF_WEAPON_FINAL_FLASH, "weapon_finalflash", 5, 430.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 7.0, 0.0},
   {ESF_WEAPON_MASENKO, "weapon_masenko", 5, 330.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.0, 0.0},
   {ESF_WEAPON_DEATHBALL, "weapon_deathball", 5, 430.0, 3000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 6.0, 0.0},
   {ESF_WEAPON_BURNINGATTACK, "weapon_burningattack", 5, 350.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 3.0, 0.0},
   {ESF_WEAPON_SCATTERBEAM, "weapon_scatterbeam", 5, 430.0, 3000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 6.0, 0.0},
   {ESF_WEAPON_POWERBEAM, "weapon_powerbeam", 5, 330.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.0, 0.0},
   {ESF_WEAPON_MOUTHBLAST, "weapon_mouthblast", 5, 430.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 6.0, 0.0},
   {ESF_WEAPON_FINISHING_BUSTER, "weapon_finishingbuster", 5, 430.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 6.0, 0.0},
   {ESF_WEAPON_RENZOKU, "weapon_renzoku", 5, 30.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.0, 0.0},
   {ESF_WEAPON_SOLARFLARE, "weapon_solarflare", 5, 5.0, 50, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, FALSE, FALSE, 0.0, 0.0},
   {ESF_WEAPON_KAMETORPEDO, "weapon_kametorpedo", 5, 1330.0, 5000, 0.0, 0.0,
    0, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 4.0, 0.0},
   {ESF_WEAPON_TELEKINESIS, "weapon_telekinesis", 5, 300.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 5.5, 0.0},
   {ESF_WEAPON_CANDY, "weapon_candy", 4, 5.0, 50, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, FALSE, FALSE, 0.0, 0.0},
   {ESF_WEAPON_SCATTERSHOT, "weapon_scattershot", 5, 70.0, 6000.0, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 1.25, 0.0},
   {SBOT_WEAPON_LASER1, "weapon_genericbeam", 5, 300.0, 5000, 0.0, 0.0,
    30, TRUE, 100, 0, 0, FALSE, FALSE, TRUE, FALSE, 5.5, 0.0},
   // terminator 
   {0, "", 0, 0.0, 0.0, 0.0, 0.0, 0, TRUE, 0, 1, 1, FALSE, FALSE, FALSE, FALSE, 0.0, 0.0}};


bool EnemyIsInList(bot_t *pBot, edict_t *pEnemy)
{
#ifdef LOGBOTINFO
	clog << "Enemy in list?\n";
#endif

	for (int i=0;i<4;i++)
	{
		if (pBot->EnemyList[i].pEnemy == pEnemy)
			return true;
	}

	return false;
}

// Find an enemy for the enemy list
edict_t *BotFindEnemy( bot_t *pBot )
{
#ifdef LOGBOTINFO
	clog << "BotFindEnemy()\n";
#endif

   if (BotDontSearchEnemy)
	  return NULL;

   Vector vecEnd;
   Vector vecEnd2;

   edict_t *pNewEnemy = NULL;
   ClientInfo_t *pClient;

   float nearestdistance;
   float distance;
   int i;

   bool OnScouter = false;
   bool BotIsInViewCone = false;
   bool InViewCone = false;
   bool JustMadeASound = false;

   edict_t *pEdict = pBot->pEdict;
   edict_t *pPlayer = NULL;

   short EnemyVal = 0;
   short BestEnemyVal = -100;

   pBot->pBotEnemy = NULL;

   if (pBot->f_search_enemy_delay <= gpGlobals->time)
   {
	   float MinDelay = EnemySearchDelays[pBot->bot_skill][0];
	   float MaxDelay = EnemySearchDelays[pBot->bot_skill][1];

	   pBot->f_search_enemy_delay = gpGlobals->time + RANDOM_FLOAT(MinDelay, MaxDelay);

	   if (!pBot->MadePlayerList)
		  MakePlayerList(pBot);

	   if (pBot->PlayerCount)
	   {
			nearestdistance = 9000.0;

			for (i = 0; i < pBot->PlayerCount; i++)
			{
				pPlayer = pBot->PlayerList[i];
				EnemyVal = 1;

				if (IsNull(pPlayer))
					continue;

				// Is this player already in the list ?
				if (EnemyIsInList(pBot, pPlayer))
					continue;

			   	// is team play enabled?
				if (IsTeamPlay())
				{
           			int player_team = UTIL_GetTeam(pPlayer);
					int bot_team = UTIL_GetTeam(pEdict);

					// don't target your teammates...
					if (bot_team == player_team)
					{
//						cout << "Enemy: " << STRING(pPlayer->v.netname) << 
//							    " is in the other team\n";
					    continue;
					}	
				}

				vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;
				vecEnd2 = pEdict->v.origin + pEdict->v.view_ofs;

				Vector v_dist = vecEnd - GetGunPosition(pEdict);
				v_dist.z = 0;
				distance = v_dist.Length();

				OnScouter = ((distance <= 2300.0) || (pBot->SBotType > 0));
				InViewCone = (FInViewCone(&vecEnd, pEdict));
				BotIsInViewCone = (FInViewCone(&vecEnd2,pPlayer));

				distance = UTIL_Distance(pEdict->v.origin, pPlayer->v.origin);

				pClient = UTIL_GetClientPointer(pPlayer);
				if (!pClient)
					continue;

				JustMadeASound = ((pClient->LastSoundTime > (gpGlobals->time - 1.0)) &&
								  (pClient->SoundName[0] != 0) && (distance < 3000.0));

				if ((!InViewCone) && (!OnScouter) && (!JustMadeASound))
				{
//					lcout << "Enemy is not sensable\n";
					continue;
				}

				if (nearestdistance > distance)
				{
					nearestdistance = distance;
					EnemyVal+=2;
				}
			
				if (InViewCone)
					EnemyVal+=2;

				if (BotIsInViewCone)
					EnemyVal+=2;

				if ((pBot->pLastEnemy) && (pPlayer == pBot->pLastEnemy))
					EnemyVal += RANDOM_LONG(1,4);
			
				if ((pClient->IsInMeleeMode) || (pClient->IsAutoPunching) ||
					(pClient->GetAutoPunched) || (pClient->Powerstruggles) ||
					(pClient->MeleeStruggles))
				{
//					lcout << "Enemy: " << STRING(pPlayer->v.netname) << " is busy\n";
					if ((BestEnemyVal == 0) && (RANDOM_LONG(0, 5) == 0))
						EnemyVal = 1;
					else
						continue;
				}

				if (pClient->Ascends)
					EnemyVal -= RANDOM_LONG(1,2);

				if (pClient->FlysAfterHit)
					EnemyVal--;

				if (pClient->LaysOnGround)
					EnemyVal--;

				if (pClient->IsStuckAgainstWall)
					EnemyVal--;

				if (pClient->PL > pBot->PL)
				{
					if (pEdict->v.health < 30)
						EnemyVal--;
					else
						EnemyVal++;
				}

	            for (int n=0;n<gpGlobals->maxClients;n++)
				{ 
		            if ((bots[n].pBotEnemy == pPlayer) && (bots[n].pEdict != pEdict) && 
				        (bots[n].is_used))
					{
                        if (EnemyVal > 0)
							EnemyVal--;
						else
							break;
					}
				}

				if (EnemyVal > BestEnemyVal)
				{
					pNewEnemy = pPlayer;
					BestEnemyVal = EnemyVal;
				}
			}
		}
   }

   if (pNewEnemy)
   {
	  if (debug_mode)
	  	  ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"I've got a new enemy\n");

      pBot->pBotUser = NULL;  // don't follow user when enemy found
      pBot->UsingTime = 0;
     
      pBot->pHuntingEdict = NULL;
      pBot->HuntDelayTime = 0.0;
   }
   return pNewEnemy;
}


Vector BotBodyTarget( edict_t *pBotEnemy, bot_t *pBot, bool PredictEnemyPos )
{
#ifdef LOGBOTINFO
	clog << "BodyTarget()\n";
#endif

   Vector target;
   float f_distance;
   float f_scale;
   int d_x, d_y, d_z;
   float Time;

   edict_t *pEdict = pBot->pEdict;

   f_distance = (pBotEnemy->v.origin - pEdict->v.origin).Length();

   if ((PredictEnemyPos) && (pBot->SBotType < 1))
   {
	   Vector v_end = pBotEnemy->v.origin;
	   bool EnemyIsInViewCone = (FInViewCone(&v_end, pEdict));
	   
	   // Don't predict the enemy position if the bot isn't a super bot and the enemy is not in
	   // field of view.
	   if (EnemyIsInViewCone == false)
		   PredictEnemyPos = false;
   }

   if (f_distance > 1000)
      f_scale = 1.0;
   else if (f_distance > 100)
      f_scale = f_distance / 1000.0;
   else
      f_scale = 0.1;

   if (PredictEnemyPos)
	   PredictEnemyPos = (f_distance > (pBotEnemy->v.velocity.Length() + 35.0f));

   d_x = 0;  // no offset
   d_y = 0;
   d_z = 0;
   
   if (pBot->SBotType > 1)
   {
	   if (PredictEnemyPos)
	   {
		   if (pBot->pBotClient->Swoops)
			   Time = RANDOM_FLOAT(0.7, 1.1);
		   else
			   Time = RANDOM_FLOAT(0.2, 0.4);

		   return PredictEntityPos(pBotEnemy, Time);
	   }
	   else
		   return pBotEnemy->v.origin;
   }

   target = pBotEnemy->v.origin;  // aim for the body

   switch (pBot->bot_skill)
   {
   case 0:
	   if (pBot->pBotClient->Swoops)
		   Time = RANDOM_FLOAT(0.6, 1.1);
	   else
		   Time = RANDOM_FLOAT(0.2, 0.4);

	   // predict where the enemy will be
	   if (PredictEnemyPos)
		   target = PredictEntityPos(pBotEnemy, Time);

	   if (pEdict->v.velocity.Length() > 50.0)
	   {
		   d_x = RANDOM_FLOAT(-1.25, 1.25) * f_scale;
		   d_y = RANDOM_FLOAT(1.25, 1.25) * f_scale;
		   d_z = RANDOM_FLOAT(-2.5, 2.5) * f_scale;
	   }
	   break;
   case 1:
	   if (pBot->pBotClient->Swoops)
		   Time = RANDOM_FLOAT(0.4, 0.8);
	   else
		   Time = RANDOM_FLOAT(0.1, 0.2);

	   // predict where the enemy will be
	   if (PredictEnemyPos)
		   target = PredictEntityPos(pBotEnemy, RANDOM_FLOAT(0.7, 1.2));

	   if (pEdict->v.velocity.Length() > 30.0)
	   {
		   d_x = RANDOM_FLOAT(-4, 4) * f_scale;
		   d_y = RANDOM_FLOAT(-4, 4) * f_scale;
		   d_z = RANDOM_FLOAT(-8, 8) * f_scale;
	   }
	   break;
   case 2:
       // FAIR, offset somewhat for x, y, and z
       d_x = RANDOM_FLOAT(-10, 10) * f_scale;
       d_y = RANDOM_FLOAT(-10, 10) * f_scale;
       d_z = RANDOM_FLOAT(-18, 18) * f_scale;
       break;
   case 3:
       // POOR, offset for x, y, and z
       d_x = RANDOM_FLOAT(-20, 20) * f_scale;
       d_y = RANDOM_FLOAT(-20, 20) * f_scale;
       d_z = RANDOM_FLOAT(-32, 32) * f_scale;
       break;
    case 4:
       // BAD, offset lots for x, y, and z
       d_x = RANDOM_FLOAT(-35, 35) * f_scale;
       d_y = RANDOM_FLOAT(-35, 35) * f_scale;
       d_z = RANDOM_FLOAT(-50, 50) * f_scale;
       break;
   }
   //target = target + Vector(d_x, d_y, d_z);

#ifdef LOGBOTINFO
   clog << "End bodytarget()\n";
#endif

   return target;
}

bool bot_has_weapon(int iId, bot_t *pBot)
{
	if (((iId == ESF_WEAPON_DESTRUCTO_DISC) || (iId == ESF_WEAPON_FRIEZADISC)) &&
	    (!BotsUseDiscs))
		return false;

	if (iId == SBOT_WEAPON_LASER1)
		return (pBot->SBotType > 0);

	if (pBot->pEdict->v.playerclass == 2) // player class is goku ?
	{
      	char model_name[64];
	
		UTIL_GetModel(pBot->pEdict, model_name);

		if ((iId == ESF_WEAPON_SPIRIT_BOMB) && (FStrEq(model_name, "ssjgoku")))
		  return false; // if playerclass == goku and the bot is ssj then he doesn't have a SB
 	}

	// if the bot is an autobot he can only use kiblasts
	if ((pBot->pEdict == listenserver_edict) && (iId != ESF_WEAPON_KIBLAST))
		return false;

	return (pBot->pBotWeaponList->IsInList(iId));
}

void AvoidAttackWhenSwoop(bot_t *pBot)
{
	edict_t *pEdict = pBot->pEdict;

	edict_t *pNearestAttack = pAttackManager->GetNearestHostileAttack(pEdict, 50.0f, 750.0,
																	  true);

	if (pNearestAttack)
	{
		if (pBot->SwoopType == SWOOP_OFFSET)
		{
			if (pBot->SwoopOffset.x < 0)
				pBot->AimVec.x = UTIL_WrapAngle(pBot->AimVec.x - RANDOM_FLOAT(85.0, 95.0));
			else if (pBot->SwoopOffset.x > 0)
				pBot->AimVec.x = UTIL_WrapAngle(pBot->AimVec.x + RANDOM_FLOAT(85.0, 95.0));
			else if (pBot->SwoopOffset.y < 0)
				pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y - RANDOM_FLOAT(85.0, 95.0));
			else if (pBot->SwoopOffset.y > 0)
				pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y + RANDOM_FLOAT(85.0, 95.0));
		}
		else
		{
			if (pBot->wander_dir == WANDER_LEFT)
				pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y + RANDOM_FLOAT(85.0, 95.0));
			else
				pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y - RANDOM_FLOAT(85.0, 95.0));
		}
	}
}

bool ShootAbsorbHealthBeams(bot_t *pBot)
{
	edict_t *pEdict = pBot->pEdict;
	edict_t *pPlayer = NULL;
	ClientInfo_t *pClient;

	if (!pBot->MadePlayerList)
		MakePlayerList(pBot);

	if (pBot->PlayerCount == 0)
		return false;

	bool FreezeBot = false;

	for (int i=0;i<pBot->PlayerCount;i++)
	{
		pPlayer = pBot->PlayerList[i];

		if (IsNull(pPlayer))
			continue;

	   	// is team play enabled?
		if (IsTeamPlay())
		{
   			int player_team = UTIL_GetTeam(pPlayer);
			int bot_team = UTIL_GetTeam(pEdict);

			// don't target your teammates...
			if (bot_team == player_team)
			{
			    continue;
			}	
		}

		if (!FreezeBot)
			FreezeBot = true;

		pClient = UTIL_GetClientPointer(pPlayer);
		if (!pClient)
			continue;

		if ((pClient->Ascends) && (BotPersonalities[pBot->Personality].transkiller == false))
			continue;

		if (pClient->IsInMeleeMode)
			continue;

		if (pClient->MeleeStruggles)
			continue;

		if (pClient->IsAutoPunching)
			continue;

		if (pClient->GetAutoPunched)
			continue;

		if (pClient->Powerstruggles)
			continue;

		float VelocityFactor = 0.95f;
		long PlDiff = pBot->PL - pClient->PL;

		if (PlDiff > 0)
			VelocityFactor = float(PlDiff) / 10000000.0f;

		if (VelocityFactor < 0.05)
			VelocityFactor = 0.05; // Player should be atleast 5% slowed down
		else if (VelocityFactor > 0.95f)
			VelocityFactor = 0.95f; // But he should be able to move aswell...

		pPlayer->v.velocity = pPlayer->v.velocity - pPlayer->v.velocity.Normalize() * (pPlayer->v.velocity.Length() * VelocityFactor);

		ShootHealthBeam(pBot, pPlayer);

		if (pEdict->v.health >= pBot->max_health) // we drained enough :-)
			return false;
	}

	if (pBot->LastBeamDrawTime <= gpGlobals->time)
		pBot->LastBeamDrawTime = gpGlobals->time + 0.19;

	return FreezeBot;
}

void ShootHealthBeam(bot_t *pBot, edict_t *pPlayer)
{
	edict_t *pEdict = pBot->pEdict;

	if (pEdict->v.fuser4 < LASER1_KICOST)
		return;
	
	if (pBot->AbsorbHealthTime < gpGlobals->time)
	{
		pBot->AbsorbHealthTime = gpGlobals->time + 0.1;
		pEdict->v.fuser4 -= LASER1_KICOST;
		pEdict->v.health += 2;
		UTIL_DamagePlayer(pEdict, pPlayer, "Super bot laser", 2);
	}

	if (pBot->LastBeamDrawTime <= gpGlobals->time)
	{
		UTIL_DrawBeamToAll(pEdict->v.origin + pEdict->v.view_ofs, pPlayer->v.origin,
						   40, 20, 125, 255, 255, 250, 0);
	}
}

int EnemyPriorityCmp(const void *p, const void *q)
{
	int Pr1 = static_cast<const EnemyPriority_t*>(p)->Priority;
	int Pr2 = static_cast<const EnemyPriority_t*>(q)->Priority;

	return Pr2 - Pr1;
}

void ManageEnemyList(bot_t *pBot)
{
#ifdef LOGBOTINFO
	clog << "Manage enemies\n";
#endif

	short i = 0;
	short EnemyVal;
	edict_t *pEdict = pBot->pEdict;
	edict_t *pEnemy = NULL;
	ClientInfo_t *pClient;
	float NearestDist = 9999.9;

	// Filter out bad enemys and search new ones
	for (i=0;i<4;i++)
	{
		bool SearchNewOne = false;
		edict_t *pNewEnemy = NULL;

		pEnemy = pBot->EnemyList[i].pEnemy;
		bool ValidEnemy = UTIL_IsValidEnemy(pBot, pEnemy);

		if (ValidEnemy == false)
			SearchNewOne = true;
		else
		{
			pClient = UTIL_GetClientPointer(pEnemy);
			if (pClient)
			{
				if (pClient->IsInMeleeMode)
					SearchNewOne = true;
				else if (pClient->MeleeStruggles)
					SearchNewOne = true;
				else if (pClient->Powerstruggles)
					SearchNewOne = true;
				else if (pClient->GetAutoPunched)
					SearchNewOne = true;
				else if (pClient->IsAutoPunching)
					SearchNewOne = true;
			}
		}

		if (SearchNewOne)
		{
			pNewEnemy = BotFindEnemy(pBot);

			if (pNewEnemy)
				pBot->EnemyList[i].pEnemy = pNewEnemy;
			else if (ValidEnemy == false)
			{
				if (UTIL_IsValidPlayer(pBot->EnemyList[i].pEnemy, false))
					pBot->pLastEnemy = pBot->EnemyList[i].pEnemy;

				pBot->EnemyList[i].pEnemy = NULL;
			}
		}
	}
	
	// Give every enemy in the list an priority
	for (i=0;i<4;i++)
	{
		EnemyVal = 1;
		pEnemy = pBot->EnemyList[i].pEnemy;

		if (pEnemy == NULL)
		{
			pBot->EnemyList[i].Priority = -100; // never interesting...
		}
		else
		{
			ClientInfo_t *pClient = UTIL_GetClientPointer(pEnemy);
			if (!pClient)
				continue;

			if (pClient->Ascends)
				EnemyVal--;

			if (pEnemy->v.flags & FL_FAKECLIENT)
			{
				int BotInd = UTIL_GetBotIndex(pEnemy);

				if (BotInd > -1)
				{
					if ((bots[BotInd].pBotEnemy != pEdict) &&
					    (UTIL_IsValidPlayer(bots[BotInd].pBotEnemy) == false))
						EnemyVal-=2;
				}
			}

			if (pClient->Swoops)
				EnemyVal+=2;

			if (pClient->ChargesAttack)
				EnemyVal+=2;

			if (EntityHeadsToPlayer(pEdict, pEnemy))
				EnemyVal++;

			Vector v_end = pEnemy->v.origin;
			if (FInViewCone(&v_end, pEdict))
				EnemyVal++;

			float Distance = UTIL_Distance(pEdict->v.origin, pEnemy->v.origin);

			if (NearestDist > Distance)
			{
				float DistDiff = fabs(NearestDist - Distance);

				if (DistDiff > 300.0)
					EnemyVal++;
				else if (DistDiff > 800.0)
					EnemyVal += 2;
				else
					EnemyVal += 3;

				NearestDist = Distance;
			}

			if (Distance < 400.0)
				EnemyVal+=2;
			else if (Distance < 800.0)
				EnemyVal++;

			if (pClient->MeleeStruggles)
				EnemyVal--;

			if (pClient->IsInMeleeMode)
				EnemyVal--;

			if (pClient->Ascends)
				EnemyVal--;

			if (pClient->LaysOnGround)
				EnemyVal--;

			if (pClient->IsStuckAgainstWall)
				EnemyVal--;

			if (pClient->FlysAfterHit)
				EnemyVal--;

			if (pClient->Powerstruggles)
				EnemyVal--;

			pBot->EnemyList[i].Priority = EnemyVal;
		}
	}

	// Sort the list out with the good ol' C func :)
	qsort(pBot->EnemyList, 4, sizeof(EnemyPriority_t), EnemyPriorityCmp);
}

edict_t *GetBestEnemyFromList(bot_t *pBot)
{
#ifdef LOGBOTINFO
	clog << "GetBestEnemy()\n";
#endif

	edict_t *pEdict = pBot->pEdict;
	ManageEnemyList(pBot);

	if (pBot->EnemyList[0].pEnemy)
	{
#ifdef LOGBOTINFO
		clog << "Aim @ enemy\n";
#endif
		// Aim at it
		Vector v_aim = BotBodyTarget(pBot->EnemyList[0].pEnemy, pBot) - pEdict->v.origin;
		pBot->AimVec = WrapAngles(UTIL_VecToAngles(v_aim));

		pBot->HasAnEnemyTime = gpGlobals->time; // save the time that the bot has an enemy
		return pBot->EnemyList[0].pEnemy;
	}

#ifdef LOGBOTINFO
	clog << "End getbestenemy\n";
#endif
	return NULL;
}

void CKameTorpTask::TaskThink()
{
	ResetMoveSpeed(pBot);

	if ((LifeTime < gpGlobals->time) && (LifeTime > 0.0))
	{
		KameTorpState = STATE_RELEASING;
		LifeTime = 0.0;
		ShootLifeTime = gpGlobals->time + 3.0;
	}

	if (pBot->bot_ki < 150)
	{
		KameTorpState = STATE_POWERUP;
		pBot->ChargeKameTorp = false;
	}

	if (KameTorpState == STATE_POWERUP)
	{
		if (pBot->bot_ki > 700)
		{
			KameTorpState = STATE_CHARGING;
			FakeClientCommand(pEdict, "-powerup", NULL, NULL);
		}
		else if (!pBot->BotPowerUps)
			FakeClientCommand(pEdict, "+powerup", NULL, NULL);
//		rcout << "Torp state: POWERUP\n";
	}
	else if (KameTorpState == STATE_RELEASING)
	{
		if ((!pBot->pBotEnemy) && (LifeTime >= gpGlobals->time))
			KameTorpState = STATE_LOOK_AROUND;
		else
		{
			if (!pBot->pBotEnemy)
			{
				if (!PickedAnAimSpot)
				{
					pBot->AimVec = WrapAngles(UTIL_VecToAngles
										(GetFarthestCollision(pEdict, 1000.0f) - pEdict->v.origin));
					PickedAnAimSpot = true;
				}
			}
			else if ((LifeTime >= gpGlobals->time) && (pBot->bot_ki > 10))
			{
				ClientInfo_t *pClient = UTIL_GetClientPointer(pBot->pBotEnemy);
				if (pClient)
				{
					if ((pClient->IsAutoPunching) || (pClient->IsInMeleeMode) || 
						(pClient->MeleeStruggles) || (pClient->Powerstruggles) ||
						(pClient->GetAutoPunched))
						return; // Wait untill the enemy can be hit again.

					// Is the enemy transforming and is the bot NOT a transkiller?
					if ((pClient->Ascends) && (!BotPersonalities[pBot->Personality].transkiller))
						return; // Don't attack the enemy
				}
			}				

			if (RANDOM_LONG(0, 4) == 0)
				pEdict->v.button |= IN_ATTACK2;

			if (ShootLifeTime < gpGlobals->time)
				TaskState = done;

			short TorpCount = pAttackManager->CountAttacksByName(pEdict, "Kame Torpedo");
			if (TorpCount == 0)
				TaskState = done;

//			rcout << "Torp state: RELEASE\n";
		}
	}
	else if (KameTorpState == STATE_CHARGING)
	{	
		ChargeKameTorps();
//		rcout << "Torp state: CHARGE\n";
	}
	else if (KameTorpState == STATE_MOVE)
	{
		SetMoveDir(pBot, MoveAwayDir);

		if (MoveAwayTime <= gpGlobals->time)
		{
			MoveAwayDir = 0;
			KameTorpState = STATE_CHARGING;
		}
//		rcout << "Torp state: MOVE\n";
	}
	else if (KameTorpState == STATE_LOOK_AROUND)
	{
		if (pBot->pBotEnemy)
			KameTorpState = STATE_RELEASING;
		else
		{
			if (MoveAwayDelay < gpGlobals->time)
			{
				MoveAwayDelay = gpGlobals->time + RANDOM_FLOAT(1.75, 2.75);

				bool PickedADirection = SetMoveAwayDir();
				if (PickedADirection) // Found a direction to move at?
				{
					KameTorpState = STATE_MOVE;
					MoveAwayTime = gpGlobals->time + RANDOM_FLOAT(0.13f, 0.25f);
					LookDelay = MoveAwayTime + RANDOM_FLOAT(0.2, 0.45);
				}
			}
			else if (LookDelay < gpGlobals->time)
			{
				LookDelay = gpGlobals->time + RANDOM_FLOAT(0.35, 0.75);

				if (pBot->wander_dir == WANDER_LEFT)
					pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y + RANDOM_FLOAT(40.0f, 50.0f));
				else
					pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y - RANDOM_FLOAT(40.0f, 50.0f));
			}
		}
//		rcout << "Torp state: LOOK_AROUND\n";
	}

//	rcout << "Torp lifetime: " << (LifeTime - gpGlobals->time) << "\n";
}

void CKameTorpTask::ChargeKameTorps()
{
	if ((pBot->ChargeBeamVal < 100) && (pBot->ChargeKameTorp))
	{
		pEdict->v.button |= IN_ATTACK;
		return;
	}

	if (pBot->ChargeBeamVal == 100)
	{
		pBot->ChargeKameTorp = false;
		bool PickedADirection = SetMoveAwayDir();

		if (PickedADirection) // Found a direction to move at?
		{
			KameTorpState = STATE_MOVE;
			MoveAwayTime = gpGlobals->time + RANDOM_FLOAT(0.13f, 0.25f);
		}
		return;
	}

	short TorpCount = pAttackManager->CountAttacksByName(pEdict, "Kame Torpedo");

	if (TorpCount >= DesiredTorpCount)
	{
		KameTorpState = STATE_RELEASING;
		ShootLifeTime = gpGlobals->time + 4.0;
		return;
	}

	// Not enough kame torps yet. Make a new one.
	pBot->ChargeKameTorp = true;

	if (pBot->current_weapon.iId != ESF_WEAPON_KAMETORPEDO)
		UTIL_SelectItem(pEdict, "weapon_kametorpedo");

	pEdict->v.button |= IN_ATTACK;
}

bool CKameTorpTask::SetMoveAwayDir()
{
	MoveAwayDir = 0;
	bool PickedADirection = false;
	byte RandNr = RANDOM_LONG(0, 2);

	// Go back or forward?
	if (RandNr > 0)
	{
		if (RandNr == 1) // First check forward then backward
		{
			if (CheckForCollide(pEdict, dir_forward, 35.0) == false)
			{
				MoveAwayDir |= dir_forward;
				PickedADirection = true;
			}
			else if (CheckForCollide(pEdict, dir_back, 35.0) == false)
			{
				MoveAwayDir |= dir_back;
				PickedADirection = true;
			}
		}
		else // First check backward then forward
		{
			if (CheckForCollide(pEdict, dir_back, 35.0) == false)
			{
				MoveAwayDir |= dir_back;
				PickedADirection = true;
			}
			else if (CheckForCollide(pEdict, dir_forward, 35.0) == false)
			{
				MoveAwayDir |= dir_forward;
				PickedADirection = true;
			}
		}
	}

	if (PickedADirection)
		RandNr = RANDOM_LONG(0, 2);
	else
		RandNr = RANDOM_LONG(1, 2);

	// Go left or right?
	if (RandNr > 0)
	{
		if (RandNr == 1) // First check left then right
		{
			if (CheckForCollide(pEdict, dir_left, 35.0) == false)
			{
				MoveAwayDir |= dir_left;
				PickedADirection = true;
			}
			else if (CheckForCollide(pEdict, dir_right, 35.0) == false)
			{
				MoveAwayDir |= dir_right;
				PickedADirection = true;
			}
		}
		else // First check right then left
		{
			if (CheckForCollide(pEdict, dir_right, 35.0) == false)
			{
				MoveAwayDir |= dir_right;
				PickedADirection = true;
			}
			else if (CheckForCollide(pEdict, dir_left, 35.0) == false)
			{
				MoveAwayDir |= dir_left;
				PickedADirection = true;
			}
		}
	}

	if (PickedADirection)
		RandNr = RANDOM_LONG(0, 2);
	else
		RandNr = RANDOM_LONG(1, 2);

	// Go up or down?
	if (RandNr > 0)
	{
		if (RandNr == 1) // First check up then down
		{
			if (CheckForCollide(pEdict, dir_up, 35.0) == false)
			{
				MoveAwayDir |= dir_up;
				PickedADirection = true;
			}
			else if (CheckForCollide(pEdict, dir_down, 35.0) == false)
			{
				MoveAwayDir |= dir_down;
				PickedADirection = true;
			}
		}
		else // First check backward then forward
		{
			if (CheckForCollide(pEdict, dir_down, 35.0) == false)
			{
				MoveAwayDir |= dir_down;
				PickedADirection = true;
			}
			else if (CheckForCollide(pEdict, dir_up, 35.0) == false)
			{
				MoveAwayDir |= dir_up;
				PickedADirection = true;
			}
		}
	}
	return PickedADirection;
}

// returns true when done
bool MakeKameTorps(bot_t *pBot, short DesiredTorpCount)
{
	edict_t *pEdict = pBot->pEdict;

	if ((pBot->ChargeBeamVal < 100) && (pBot->ChargeKameTorp))
	{
		pEdict->v.button |= IN_ATTACK;
		return false;
	}

	if (pBot->ChargeBeamVal == 100)
	{
		pBot->ChargeKameTorp = false;

		if (RANDOM_LONG(0, 1))
		{
			if (RANDOM_LONG(0, 1))
				pBot->f_move_speed = pBot->f_max_speed;
			else
				pBot->f_move_speed = -pBot->f_max_speed;
		}
		else
		{
			if (pBot->wander_dir == WANDER_RIGHT)
				pBot->f_strafe_speed = pBot->f_max_speed;
			else
				pBot->f_strafe_speed = -pBot->f_max_speed;
		}

		return false; // Skip one frame
	}

	short TorpCount = pAttackManager->CountAttacksByName(pEdict, "Kame Torpedo");

	if (TorpCount >= DesiredTorpCount)
		return true;

	// Not enough kame torps yet. Make a new one.
	pBot->ChargeKameTorp = true;

	if (pBot->current_weapon.iId != ESF_WEAPON_KAMETORPEDO)
		UTIL_SelectItem(pEdict, "weapon_kametorpedo");

	pEdict->v.button |= IN_ATTACK;

	return false;
}

// Should the bot make a few kame torps when he doesn't have an enemy ?
bool BotShouldMakeKameTorps(bot_t *pBot)
{
#ifdef LOGBOTINFO
	clog << "Make kame torps?\n";
#endif

	if ((b_botdontshoot) || (BotDontSearchEnemy))
		return false;

	if (RANDOM_LONG(1, 100) > BotPersonalities[pBot->Personality].kametorp_percent)
		return false;

	edict_t *pEdict = pBot->pEdict;
	
	if (UTIL_GetClass(pEdict) != 2)
		return false;

	if (bot_has_weapon(ESF_WEAPON_KAMETORPEDO, pBot) == false)
		return false;

	edict_t *pPlayer = NULL;
	float Dist = 0.0;
	int ClInd = -1;

	for (int i=1;i<=gpGlobals->maxClients;i++)
	{
		pPlayer = INDEXENT(i);

		if (UTIL_IsValidPlayer(pPlayer) == false)
			continue;

		Dist = UTIL_Distance(pEdict->v.origin, pPlayer->v.origin);
		if (Dist > 5000.0)
			continue;

		if (IsTeamPlay())
		{
			int player_team = UTIL_GetTeam(pPlayer);
			int bot_team = UTIL_GetTeam(pEdict);

			// skip if the team of the player is equal to the team of the bot and the player is
			// visible.
			if ((bot_team == player_team) && (FVisible(pPlayer->v.origin, pEdict)))
				continue;
		}

		ClInd = UTIL_GetClientIndex(pPlayer);
		if (ClInd > -1)
		{
			// Did the player just made a sound ?
			if (ClientInfo[ClInd].LastSoundTime > (gpGlobals->time - 6.0))
				return true; // Ok lets do it
		}

		// Is the player visible on the scouter ?
		if (Dist < 2300.0)
			return true; // Ok lets make some torpedo's

	}

	// Look for a bot-team mate, if found one and he has an enemy; return true
	if (IsTeamPlay())
	{
		if (!pBot->MadePlayerList)
			MakePlayerList(pBot);

		if (pBot->PlayerCount)
		{
			for (i=0;i<pBot->PlayerCount;i++)
			{
				pPlayer = pBot->PlayerList[i];

				if (pPlayer->v.flags & FL_FAKECLIENT)
				{
					int player_team = UTIL_GetTeam(pPlayer);
					int bot_team = UTIL_GetTeam(pEdict);

					if (bot_team == player_team)
					{
						int BotInd = UTIL_GetBotIndex(pPlayer);

						if (BotInd > -1)
						{
							if (UTIL_IsValidPlayer(bots[BotInd].pBotEnemy))
								return true;
						}
					}
				}
			}
		}
	}

	return false;
}

bool CheckForEnemyTraces(bot_t *pBot)
{
#ifdef LOGBOTINFO
	clog << "CheckForEnemyTraces()\n";
#endif
	edict_t *pEdict = pBot->pEdict;

	if (pEdict->v.gravity > 0.1)
		return false; // don't hunt when we don't fly...

	if (pBot->waypoint_goal != -1)
		return false; // Bot already hunt...with the use of waypoints

	if (BotDontSearchEnemy)
		return false;

	edict_t *pPlayer = NULL;
	int ClInd = -1;
	Vector v_src = pEdict->v.origin;

	short PosVal = 0;
	short BestPosVal = 0;

	short BestPosIndex = -1;
	int BestPosOwnerIndex = -1;

	float NearestDistToEnemy = 9999.9;
	float NearestDistToBot = 9999.9;
	float Dist = 0.0;

	int i, j;

	// Already have something to hunt at ?
	if (pBot->pHuntingEdict)
	{
		if (UTIL_IsValidPlayer(pBot->pHuntingEdict))
		{
			Dist = UTIL_Distance(v_src, pBot->HuntPos.Place);
			bool Done = false;

			if (Dist < 60.0)
				Done = true;

			if ((pBot->PrevHuntDist > 0.0) && (Dist > pBot->PrevHuntDist))
				Done = true;

			pBot->PrevHuntDist = Dist;

			// Did we reached the point ?
			if (Done == false)
			{
				// Guess not

				// Time to look for another one ?
				if (pBot->UpdateHuntPosTime < gpGlobals->time)
				{
					pBot->UpdateHuntPosTime = gpGlobals->time + 0.8;

					ClInd = UTIL_GetClientIndex(pBot->pHuntingEdict);

					if (ClInd > -1)
					{
						for (j=MaxOldPositions-1;j>=0;j--)
						{
							PosVal = 1;
							Vector OldPos = ClientInfo[ClInd].OldPositions[j].Place;

							if (ClientInfo[ClInd].OldPositions[j].CreateTime < 
								(gpGlobals->time-MaxOldPositionLifeTime))
								continue;

							Dist = UTIL_Distance(v_src, OldPos);
							if ((Dist > 6000.0) || (Dist < 300.0))
								continue;

							if (pBot->LastHuntPos.Place == ClientInfo[ClInd].OldPositions[j].Place)
								continue;

							if (FVisible(OldPos, pEdict) == false)
								continue;

							if (Dist < NearestDistToEnemy)
							{
								NearestDistToEnemy = Dist;
								PosVal++;
							}

							if (Dist < NearestDistToBot)
							{
								NearestDistToBot = Dist;
								PosVal++;
							}

							if (PosVal >= BestPosVal)
							{
								BestPosVal = PosVal;
								BestPosIndex = j;
							}
						}
					}
					if (BestPosIndex > -1)
					{
						OldPosition_t NewOldPos = ClientInfo[ClInd].OldPositions[BestPosIndex];
						pBot->HuntPos = NewOldPos;
					}
				}

				// Aim at it
				Vector v_aim = pBot->HuntPos.Place - v_src;
				pBot->AimVec = WrapAngles(UTIL_VecToAngles(v_aim));

				// Turn turbo on
				ToggleTurbo(pEdict, true);

#ifdef LOGBOTINFO
				clog << "Hunt @ enemy\n";
#endif

				return true;
			}

		}
		pBot->pHuntingEdict = NULL;
	}

	BestPosIndex = -1;
    for (i=1;i<=gpGlobals->maxClients;i++)
	{
		pPlayer = INDEXENT(i);

		if (pPlayer == pEdict)
			continue;

		if (UTIL_IsValidPlayer(pPlayer) == false)
			continue;

		if (UTIL_VecIsInLava(pPlayer->v.origin))
			continue;

		if (IsTeamPlay())
		{
			int bot_team = UTIL_GetTeam(pEdict);
			int player_team = UTIL_GetTeam(pPlayer);

			// don't hunt your team mates...
			if (bot_team == player_team)
				continue;
		}

		ClInd = UTIL_GetClientIndex(pPlayer);

		if (ClInd > -1)
		{
			for (j=MaxOldPositions-1;j>=0;j--)
			{
				PosVal = 1;
				Vector OldPos = ClientInfo[ClInd].OldPositions[j].Place;

				if (ClientInfo[ClInd].OldPositions[j].CreateTime < 
					(gpGlobals->time-MaxOldPositionLifeTime))
					continue;

				Dist = UTIL_Distance(v_src, OldPos);
				if ((Dist > 6000.0) || (Dist < 300.0))
					continue;

				if (Dist < NearestDistToEnemy)
				{
					NearestDistToEnemy = Dist;
					PosVal++;
				}

				if (Dist < NearestDistToBot)
				{
					NearestDistToBot = Dist;
					PosVal++;
				}

				if (pBot->LastHuntPos.Place == ClientInfo[ClInd].OldPositions[j].Place)
					continue;

				if ((PosVal >= BestPosVal) && (FVisible(OldPos, pEdict)))
				{
					BestPosVal = PosVal;
					BestPosIndex = j;
					BestPosOwnerIndex = ClInd;
				}
			}
		}
	}

	if (BestPosIndex > -1)
	{
		pBot->pHuntingEdict = ClientInfo[BestPosOwnerIndex].pEdict;
		pBot->LastHuntPos = pBot->HuntPos;
		pBot->HuntPos = ClientInfo[BestPosOwnerIndex].OldPositions[BestPosIndex];
		pBot->PrevHuntDist = 0.0;

		// Aim at the enemy trace
		Vector v_aim = pBot->HuntPos.Place - v_src;
		pBot->AimVec = WrapAngles(UTIL_VecToAngles(v_aim));

		// Turn turbo on
		ToggleTurbo(pEdict, true);
#ifdef LOGBOTINFO
		clog << "New person to hunt\n";
#endif

		return true;
	}

#ifdef LOGBOTINFO
	clog << "Noone to hunt @\n";
#endif

	return false; // Noone to hunt :(
}

float CCombatTask::GetMinDistForAttack(int AttackId)
{
	float BaseDist = 0.0;

	if ((AttackId == ESF_WEAPON_MELEE) || (AttackId == ESF_WEAPON_SWORD))
		BaseDist = 80.0;

	if ((AttackId == ESF_WEAPON_KIBLAST) || (AttackId == ESF_WEAPON_RENZOKU) ||
		(AttackId == ESF_WEAPON_SCATTERSHOT))
	    BaseDist = 150.0;

	if ((AttackId == ESF_WEAPON_GENERIC_BEAM) || (AttackId == ESF_WEAPON_BURNINGATTACK))
	    BaseDist = 300.0;

	if ((AttackId == ESF_WEAPON_POWERBEAM) || (AttackId == ESF_WEAPON_MASENKO))
	    BaseDist = 400.0;

	if ((AttackId == ESF_WEAPON_GALLIT_GUN) || (AttackId == ESF_WEAPON_KAMEHAMEHA) ||
	    (AttackId == ESF_WEAPON_FINAL_FLASH) || (AttackId == ESF_WEAPON_MOUTHBLAST))
	    BaseDist = 800.0;

	if ((AttackId == ESF_WEAPON_DESTRUCTO_DISC) || (AttackId == ESF_WEAPON_FRIEZADISC))
	    BaseDist = 200.0;

	if ((AttackId == ESF_WEAPON_EYELASER) || (AttackId == ESF_WEAPON_FINGERLASER))
	    BaseDist = 200.0;

	if ((AttackId == ESF_WEAPON_SPECIALBEAM_CANNON) || (AttackId == ESF_WEAPON_SPIRIT_BOMB) ||
	    (AttackId == ESF_WEAPON_BIGBANG) || (AttackId == ESF_WEAPON_DEATHBALL) ||
	    (AttackId == ESF_WEAPON_SCATTERBEAM) || (AttackId == ESF_WEAPON_FINISHING_BUSTER))
	    BaseDist = 800.0;

	if (AttackId == ESF_WEAPON_TELEKINESIS)
	    BaseDist = 400.0;

	if (AttackId == ESF_WEAPON_KAMETORPEDO)
	    BaseDist = 1500.0;

	if (AttackId == SBOT_WEAPON_LASER1)
		BaseDist = 1500.0;

	if (AttackId == ESF_WEAPON_SOLARFLARE)
		BaseDist = 30.0;

	if (AttackId == ESF_WEAPON_CANDY)
		BaseDist = 200.0;

	switch(pBot->AggressionLevel)
	{
	case Aggressive:
		BaseDist *= 0.8;
		break;
	case Normal:
		break;
	case Defensive:
		BaseDist *= 1.2;
	}

	return BaseDist;
}

float CCombatTask::GetMaxDistForAttack(int AttackId)
{
	float MaxDist = 0.0;

	if ((AttackId == ESF_WEAPON_MELEE) || (AttackId == ESF_WEAPON_SWORD))
		MaxDist = 4800.0;

	if ((AttackId == ESF_WEAPON_KIBLAST) || (AttackId == ESF_WEAPON_RENZOKU) ||
		(AttackId == ESF_WEAPON_SCATTERSHOT))
	    MaxDist = 2500.0;

	if ((AttackId == ESF_WEAPON_GENERIC_BEAM) || (AttackId == ESF_WEAPON_BURNINGATTACK))
	    MaxDist = 4500.0;

	if ((AttackId == ESF_WEAPON_POWERBEAM) || (AttackId == ESF_WEAPON_MASENKO))
	    MaxDist = 4800.0;

	if ((AttackId == ESF_WEAPON_GALLIT_GUN) || (AttackId == ESF_WEAPON_KAMEHAMEHA) ||
	    (AttackId == ESF_WEAPON_FINAL_FLASH) || (AttackId == ESF_WEAPON_MOUTHBLAST))
	    MaxDist = 5200.0;

	if ((AttackId == ESF_WEAPON_DESTRUCTO_DISC) || (AttackId == ESF_WEAPON_FRIEZADISC))
	    MaxDist = 3500.0;

	if ((AttackId == ESF_WEAPON_EYELASER) || (AttackId == ESF_WEAPON_FINGERLASER))
	    MaxDist = 2500.0;

	if ((AttackId == ESF_WEAPON_SPECIALBEAM_CANNON) || (AttackId == ESF_WEAPON_SPIRIT_BOMB) ||
	    (AttackId == ESF_WEAPON_BIGBANG) || (AttackId == ESF_WEAPON_DEATHBALL) ||
	    (AttackId == ESF_WEAPON_SCATTERBEAM) || (AttackId == ESF_WEAPON_FINISHING_BUSTER))
	    MaxDist = 5500.0;

	if (AttackId == ESF_WEAPON_TELEKINESIS)
	    MaxDist = 4400.0;

	if (AttackId == ESF_WEAPON_KAMETORPEDO)
	    MaxDist = 4500.0;

	if (AttackId == SBOT_WEAPON_LASER1)
		MaxDist = 5500.0;

	if (AttackId == ESF_WEAPON_SOLARFLARE)
		MaxDist = 230.0;

	if (AttackId == ESF_WEAPON_CANDY)
		MaxDist = 950.0;

	return MaxDist;
}

void CCombatTask::CombatThink()
{
	if (pBot->pBotEnemy == NULL)
	{
		TaskState = done;
		return;
	}

#ifdef LOGBOTINFO
		clog << "Begin combat think\n";
#endif

	edict_t *pEnemy = pBot->pBotEnemy;
	ClientInfo_t *pClient = UTIL_GetClientPointer(pEnemy);
	if (!pClient)
	{
		TaskState = done;
		return;
	}

	float EnemyDist = UTIL_Distance(pEdict->v.origin, pEnemy->v.origin);
	bool EnemyIsToFar = true;

	Vector v_end = pEdict->v.origin;

	// Check if the bot isn't facing the enemy and the enemy isn't facing the bot
	if ((EntIsInFieldOfView(pEdict, pBot->pBotEnemy) == false) &&
		(EntIsInFieldOfView(pBot->pBotEnemy, pEdict) == false))
	{
#ifdef _DEBUG
		lcout << "Stop moving for aim\n";
#endif
		ResetMoveSpeed(pBot); // Give the bot some time to aim at his enemy.
		return;
	}

	// Turn turbo on when the enemys is close
	if ((pBot->bot_skill <= 2) && (EnemyDist < 800.0f))
		ToggleTurbo(pEdict, true);

	if (pBot->f_shoot_time > gpGlobals->time)
	{
		//lcout << "Enemy delay; " << (pBot->f_shoot_time - gpGlobals->time) << "\n";
		return; // nope, we have to wait a bit
	}
/*
	if ((pClient->Ascends) && (BotPersonalities[pBot->Personality].transkiller == false))
		return; // Enemy ascends and bot is no transkiller, so don't attack

	if (pClient->IsInMeleeMode)
		return; // Bot can't attack this enemy

	if (pClient->MeleeStruggles)
		return; // Bot can't attack this enemy

	if (pClient->IsAutoPunching)
		return; // Bot can't attack this enemy

	if (pClient->Powerstruggles)
		return; // Bot can't attack his enemy
*/
	if ((b_botdontshoot) || (CVAR_GET_FLOAT("mp_ceasefire") == 1.0f))
	{
		//lcout << "Bots may not attack\n";
		return; // Bots may not attack
	}

	if ((!pBot->pBotWeaponList) || (pBot->pBotWeaponList->Empty()))
		return; // Bot has just respawned and don't has his weapons yet.

	// Has the player a dragonball? (If so the bot couldn't find the gather spot)
	if (pBot->pBotClient->HasDB)
		pEdict->v.button |= IN_ATTACK; // Throw the dragonball away

#ifdef LOGBOTINFO
		clog << "Start attacking\n";
#endif

	if ((pBot->SBotType > 0) && (pEdict->v.health < 70) && (pBot->bot_ki > 150) &&
		(pBot->f_max_speed > 0.0f) &&
		(RANDOM_LONG(1, 100) <= SBotSettings[pBot->SBotType-1].laser_percent))
	{
		pBot->TaskAfterTask = TaskAbsorbHealth;
		TaskState = done;
		return;
	}

	int MeleeId;
	if (pEdict->v.playerclass == 7)
		MeleeId = ESF_WEAPON_SWORD;
	else
		MeleeId = ESF_WEAPON_MELEE;

	bool AbleToMelee = ((EnemyDist >= GetMinDistForAttack(MeleeId)) && 
		                (EnemyDist <= GetMaxDistForAttack(MeleeId)) &&
						(pClient->Ascends == false) && (pClient->IsStuckAgainstWall == false) &&
						(pClient->LaysOnGround == false) && (pClient->IsInMeleeMode == false) &&
						(pClient->MeleeStruggles == false) && (pClient->IsAutoPunching == false) &&
						(pClient->Powerstruggles == false) && (CVAR_GET_FLOAT("mp_melee") == 1.0f));

	// Bot ONLY uses melee
	if (pBot->MeleePercent == 100)
	{
		if (AbleToMelee)
			PrepareAttack(MeleeId, RandomComboUse);
		return;
	}

	// Bot is goku?
	if (pEdict->v.playerclass == 2)
	{
		// Check if this bot has kame torp 'left overs'
		CAttackManager::TAttackListNode *pNode = pAttackManager->GetFirstAttack();
		if (pNode)
		{
			edict_t *pAttack;

			for (;pNode;pNode=pNode->next)
			{
				pAttack = pNode->Entry->pAttack; // Shortcut

				if (!pAttack) // What the...
					continue;

				if (pAttack->v.owner != pEdict) // Attack isn't owned by the bot
					continue;

				if (pAttack->v.velocity.Length() > 0.0f) // Attack is moving so is fired already
					continue;

				// Attack is a kametorp at all?
				if (FStrEq("Kame Torpedo", STRING(pAttack->v.classname)))
				{
					// Okay...throw one torp at the enemy(assume that the enemy 'caused danger' so
					// lets 'cause danger' aswell...)
					pEdict->v.button |= IN_ATTACK2;
					
					// Make the kametorp task
					TaskState = done;
					pBot->TaskAfterTask = TaskKameTorp;
					return;
				}
			}
		}
	}

	float MeleePercent = float(pBot->MeleePercent);

	bool EnemySwoops = pClient->Swoops;
	bool EnemyIsBlinded = pClient->IsBlinded;

	if ((EnemySwoops) && (EnemyDist < 2500.0))
	{
		MeleePercent *= 1.5;
	}

	// Is the bot a defensive bot and low on health?
	if ((pBot->AggressionLevel == Defensive) && (pEdict->v.health < 20))
		MeleePercent *= 0.75; // Lower melee percent

	if (AbleToMelee == false)
		MeleePercent = 0.0;

	// Check if the bot wants to melee
	if (RANDOM_FLOAT(1.0, 100.0) <= MeleePercent)
	{
		PrepareAttack(MeleeId, RandomComboUse);
		return;
	}

	Vector v_src = pEdict->v.origin + pEdict->v.view_ofs;
	Vector v_enemy = pEnemy->v.origin;
	TraceResult tr;

	UTIL_TraceHull(v_src, v_enemy, ignore_monsters, human_hull, pEdict, &tr);
	if (tr.flFraction < 1.0)
	{
		// If the bot can see the bot the enemy his head(view_ofs)
		// (called in UTIL_IsValidEnemy, see BotPerformTask()) but NOT his body, press jump and 
		// don't attack
		pEdict->v.button |= IN_JUMP;
		pBot->f_updown_speed = pBot->f_max_speed;
		return;
	}

	TMultiChoice<int> AttackChoice;

	int SelectIndex = 0;
	AttackSelectTable_t *pSelect = &AttackSelectTable[0];

	bool BotMayUseACombo = ((RANDOM_LONG(1, 100) <= pBot->TeleportPercent) && (BotDoCombos));

	while (pSelect[SelectIndex].iId != 0)
	{ 
		// is the bot NOT skilled enough to use this weapon?
		if ((pBot->bot_skill+1) > pSelect[SelectIndex].skill_level)
    	{
			SelectIndex++;  // skip to next weapon
            continue;
		}

		// is the bot NOT carrying this weapon?
		if (bot_has_weapon(pSelect[SelectIndex].iId, pBot) == false)
   		{
            SelectIndex++; // skip to next weapon
       		continue;
		}

		if ((pSelect[SelectIndex].iId == ESF_WEAPON_SOLARFLARE) && (EnemyIsBlinded))
		{
			SelectIndex++;
			continue;
		}

		short AttackPercent = GetAttackPercent(pEnemy, pSelect[SelectIndex].iId);

		float MinDistToAttack = GetMinDistForAttack(pSelect[SelectIndex].iId);

		// Is the enemy to close ?
		if (EnemyDist < MinDistToAttack)
		{
			// Skip this attack if the bot may not use a teleport combo.
			// Otherwise just lower the use percent
			if (BotMayUseACombo)
				AttackPercent *= 0.75;
			else
			{
				SelectIndex++;
				continue;
			}
		}

		float MaxDistToAttack = GetMaxDistForAttack(pSelect[SelectIndex].iId);

		// Or to far?
		if (EnemyDist > MaxDistToAttack)
		{
			SelectIndex++;
			continue;
		}

		if (EnemyIsToFar == true)
			EnemyIsToFar = false;

		if ((pSelect[SelectIndex].iId == ESF_WEAPON_SPIRIT_BOMB) &&
            (CheckForCollide(pBot->pEdict, dir_up, 250.0f)))
		{
			SelectIndex++;  // skip to next weapon
            continue; // don't make a spirit bomb if theres a roof near the bot
		}
		else if (((pSelect[SelectIndex].iId == ESF_WEAPON_KIBLAST) ||
				  (pSelect[SelectIndex].iId == ESF_WEAPON_SCATTERSHOT) ||
				  (pSelect[SelectIndex].iId == ESF_WEAPON_RENZOKU)) &&
				 (CheckForCollide(pBot->pEdict, (dir_left | dir_right), 225.0f)))
		{
			SelectIndex++; // Skip to next weapon
			continue; // Don't fire a kiblast if there is a near wall(or bot might hurt hisself)
		}

		AttackChoice.Insert(pSelect[SelectIndex].iId, AttackPercent);

		SelectIndex++;
	}
	
	int AttackSelection = 0;
	AttackChoice.GetSelection(AttackSelection);

	if (EnemyIsToFar)
	{
		const short GoSwoop = 1;
		const short GoTeleport = 2;

		TMultiChoice<short> GetCloserChoice;

		GetCloserChoice.Insert(GoSwoop, pBot->SwoopPercent);
		GetCloserChoice.Insert(GoTeleport, pBot->TeleportPercent);

		short Choice = 0;
		GetCloserChoice.GetSelection(Choice);

		switch (Choice)
		{
		case GoSwoop:
			MakeCombo(swoopforward);
			return;
		case GoTeleport:
			MakeCombo(teleforward);
			return;
		}
		return;
	}

	if (AttackSelection == 0)
		return; // No attack found :(

	float MinDistToAttack = GetMinDistForAttack(AttackSelection);

	if (EnemyDist < MinDistToAttack)
	{
		if (BotMayUseACombo)
			PrepareAttack(AttackSelection, UseCombo);
	}
	else
		PrepareAttack(AttackSelection, RandomComboUse);

#ifdef LOGBOTINFO
		clog << "End combat think\n";
#endif

	return;
}

void CCombatTask::PrepareAttack(int AttackId, EComboUse ComboUse)
{
#ifdef LOGBOTINFO
		clog << "Prepare attack; " << AttackId << "\n";
#endif

	bool MakeACombo = false;

	if (ComboUse == UseCombo)
		MakeACombo = true;
	else if ((ComboUse == RandomComboUse) && (BotDoCombos) && (pBot->bot_skill < 2) &&
			 (pBot->TeleportPercent > 0))
	{
		float ComboPercent = float(pBot->TeleportPercent);

		ComboPercent *= (1 + (gpGlobals->time - pBot->f_tele_combo_delay));

		if (pBot->bot_ki < 200)
			ComboPercent = 0.0;
		else if (pBot->bot_ki < 400)
			ComboPercent *= 0.6;
		else if (pBot->bot_ki < 600)
			ComboPercent *= 0.8;
		else if (pBot->bot_ki < 700)
			ComboPercent *= 0.9;

		float EnemyDist = UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin);

		if ((AttackId == ESF_WEAPON_MELEE) || (AttackId == ESF_WEAPON_SWORD))
		{
			if ((EnemyDist > 2100) || (pBot->bot_skill > 0))
				ComboPercent = 0.0;

			Vector v_end = pEdict->v.origin;
			if (FInViewCone(&v_end,pBot->pBotEnemy) == false)
				ComboPercent *= 1.5;
		}
		else
		{
			if (EnemyDist < 500.0f)
				ComboPercent *= 1.25f;
			else if (EnemyDist < 1000.0f)
				ComboPercent *= 1.05f;
			else if (EnemyDist < 1750.0f)
				ComboPercent *= 0.85f;
			else
				ComboPercent = 0.0f;
		}
		if (RANDOM_FLOAT(1.0, 100.0) <= ComboPercent)
			MakeACombo = true;
	}

	int AttackIndex = GetAttackIndex(AttackId);
	AttackSelectTable_t AttackInfo = AttackSelectTable[AttackIndex];

	// select this weapon if it isn't already selected
	if (pBot->current_weapon.iId != AttackId)
		UTIL_SelectItem(pEdict, AttackInfo.weapon_name);

	if ((AttackId == ESF_WEAPON_MELEE) || (AttackId == ESF_WEAPON_SWORD))
	{
		AttackWithMelee(MakeACombo);
		return;
	}

#ifdef _DEBUG
	KiAttackCalls++;
#endif

    if (AttackId == ESF_WEAPON_KAMETORPEDO)
	{
		pBot->TaskAfterTask = TaskKameTorp;
		TaskState = done;
		return;
	}

	if (AttackId == SBOT_WEAPON_LASER1)
	{
		pBot->TaskAfterTask = TaskShootLaser1;
		TaskState = done;
		return;
	}

	if (AttackId == ESF_WEAPON_CANDY)
	{
		pBot->TaskAfterTask = TaskShootCandy;
		TaskState = done;
		return;
	}

	if (AttackId == ESF_WEAPON_SCATTERSHOT)
	{
		pBot->TaskAfterTask = TaskShootScatterShots;
		TaskState = done;
		return;
	}

    short primary_percent = RANDOM_LONG(1, 100);

	bool UsePrimaryFire, UseSecondaryFire;
	UsePrimaryFire = UseSecondaryFire = false;

   	// is primary percent less than weapon primary percent AND
    // the bot is far enough away to use primary fire AND
	// the bot is close enough to the enemy to use primary fire

    if (primary_percent <= AttackInfo.primary_fire_percent)
	{
		UsePrimaryFire = TRUE;
	}

	// see if the bot is far enough away to use secondary fire AND
	// the bot is close enough to the enemy to use secondary fire

	else if (CanUseSecondaryFire(AttackId))
	{
		UseSecondaryFire = TRUE;
	}

    if ((UsePrimaryFire) || (UseSecondaryFire))
	{
	    if ((AttackInfo.primary_fire_charge) || (AttackInfo.secondary_fire_charge))
		{
			pBot->charging_weapon_id = AttackId;

			if (UsePrimaryFire)
			{
			    // release primary fire after the appropriate delay...
				pBot->f_primary_charging = AttackInfo.primary_charge_delay;
			}
			else
			{
				// Bots want to make a gen ball?
				if (AttackId == ESF_WEAPON_GENERIC_BEAM)
				{
					if (RANDOM_LONG(1, 100) <= pBot->MeleePercent)
					{
						MakeCombo(ChargeGBallSwoop);
						return;
					}
				}

				// release secondary fire after the appropriate delay...
				pBot->f_secondary_charging = AttackInfo.secondary_charge_delay;
			}

			bool IsChargeble = ((AttackId == ESF_WEAPON_GENERIC_BEAM) ||
								(AttackId == ESF_WEAPON_GALLIT_GUN) ||
								(AttackId == ESF_WEAPON_KAMEHAMEHA) ||
								(AttackId == ESF_WEAPON_DESTRUCTO_DISC) ||
								(AttackId == ESF_WEAPON_FRIEZADISC) ||
								(AttackId == ESF_WEAPON_SPECIALBEAM_CANNON) ||
								(AttackId == ESF_WEAPON_SPIRIT_BOMB) ||
								(AttackId == ESF_WEAPON_BIGBANG) ||
								(AttackId == ESF_WEAPON_FINAL_FLASH) ||
								(AttackId == ESF_WEAPON_MASENKO) ||
								(AttackId == ESF_WEAPON_DEATHBALL) ||
								(AttackId == ESF_WEAPON_BURNINGATTACK) ||
								(AttackId == ESF_WEAPON_SCATTERBEAM) ||
								(AttackId == ESF_WEAPON_POWERBEAM) ||
								(AttackId == ESF_WEAPON_MOUTHBLAST) ||
								(AttackId == ESF_WEAPON_FINISHING_BUSTER) ||
								(AttackId == ESF_WEAPON_RENZOKU) ||
								(AttackId == ESF_WEAPON_TELEKINESIS));

			pBot->f_shoot_time = gpGlobals->time;
	
			if (MakeACombo == false)
			{
				if (pBot->bot_ki < 450)
				{
					if (IsChargeble)
						MakeCombo(powerupattack);
					else
						MakeCombo(powerupattack2);
				}
				else
				{
					if (IsChargeble)
						pBot->TaskAfterTask = TaskChargeAttack;
					else
						pBot->TaskAfterTask = TaskShootNonChargeble;

					TaskState = done;
				}
				return;
			}
			if (IsChargeble)
				MakeCombo(teleattack);
			else
				MakeCombo(teleattack2);

			pBot->f_tele_combo_delay = gpGlobals->time + RANDOM_FLOAT(10, 20);
		}
      	else 
		{
			if (UsePrimaryFire)
		       	pEdict->v.button |= IN_ATTACK;  // use primary attack
			else
				pEdict->v.button |= IN_ATTACK2;  // use secondary attack

			// set next time to shoot
			if ((AttackInfo.primary_fire_hold) || (AttackInfo.secondary_fire_hold))
		       	pBot->f_shoot_time = gpGlobals->time;  // don't let button up
		    else
			{
				pBot->f_shoot_time = AddShootDelay(pBot);
			}
		}
	}
}

void CCombatTask::AttackWithMelee(bool MakeACombo)
{
    if ((b_botdontshoot == 1) || (BotDontSearchEnemy))
	   return; // Bot may not attack

	if (pBot->MeleePercent == 0)
		return; // Bot may not use melee

    if (pBot->pBotEnemy == NULL)
		return; // No enemy
	
	if ((pBot->YawSpeed >= 25.0) && (pBot->bot_skill > 2))
	{
		return; // Lower skilled bots won't attack when they turn
	}

	if (pBot->f_max_speed == 0)
		return; // The bot can't move
 
#ifdef LOGBOTINFO
		clog << "Start preparing melee\n";
#endif

#ifdef _DEBUG
	MeleeCalls++;
#endif

	int iId = 0;

	if (pEdict->v.playerclass == 7)
	{
		iId = ESF_WEAPON_SWORD;

		if (pBot->current_weapon.iId != iId)
			UTIL_SelectItem(pEdict, "weapon_sword");
	}
    else
	{
		iId = ESF_WEAPON_MELEE;

		if (pBot->current_weapon.iId != iId)
			UTIL_SelectItem(pEdict, "weapon_melee");
    }

#ifdef LOGBOTINFO
		clog << "Selected melee\n";
#endif

	if (RANDOM_LONG(1, 100) <= BotPersonalities[pBot->Personality].meleekick_percent)
		pBot->BotHoldsSecondary = true;
	else
		pBot->BotHoldsSecondary = false;
	
	if ((pBot->MeleePercent < 100) &&
	    (RANDOM_LONG(1, 100) <= BotPersonalities[pBot->Personality].lightbeam_percent))
		MakeCombo(ChargeGBallSwoop);

	if (MakeACombo == false)
	{
		if (pBot->bot_ki < 150)
			MakeCombo(powerupmelee);
		else
			MakeCombo(startforwardswoop);

#ifdef LOGBOTINFO
		clog << "Melee without combo\n";
#endif

		return;
	}

	short TeleMelee1Percent = 50;
	short TeleMelee2Percent = 50;
	short TeleMelee3Percent = 25;
	short TeleMelee4Percent = 50;
	short TeleKickPercent = 25;

	float dist = UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin);

	if (dist > 1200.0)
		TeleKickPercent = 0;
	else if (EntityHeadsToPlayer(pEdict, pBot->pBotEnemy))
		TeleKickPercent *= 0.25f;

	ClientInfo_t *pClient = UTIL_GetClientPointer(pBot->pBotEnemy);
	if (pClient)
	{
		if (pClient->Swoops)
			TeleKickPercent = TeleMelee3Percent = 0;
	
		if (pClient->FlysAfterHit)
			TeleKickPercent *= 1.5;
	}

	int TeleCount = (int(dist) / 400);

	if (TeleCount > ((pBot->bot_ki / 200)-1))
		TeleKickPercent = 0;

	if (GetTeleCountForTeleMelee4(pBot) > ((pBot->bot_ki / 200)-1))
		TeleMelee4Percent = 0;

	if (dist < 1250.0f)
		TeleMelee2Percent = 0;
	
	if ((dist < 850.0f) || (dist > 1750.0f))
		TeleMelee1Percent = 0;

	TMultiChoice<ComboTypes> ComboChoice;

	ComboChoice.Insert(telemelee1, TeleMelee1Percent);
	ComboChoice.Insert(telemelee2, TeleMelee2Percent);
	ComboChoice.Insert(telemelee3, TeleMelee3Percent);
	ComboChoice.Insert(telemelee4, TeleMelee4Percent);
	ComboChoice.Insert(telekick, TeleKickPercent);

	ComboTypes ComboSelection;
	if (ComboChoice.GetSelection(ComboSelection))
		MakeCombo(ComboSelection);
	else
		MakeCombo(startforwardswoop);

	pBot->f_tele_combo_delay = gpGlobals->time + RANDOM_FLOAT(10, 20);
#ifdef LOGBOTINFO
		clog << "End preparing melee\n";
#endif

}


short CCombatTask::GetAttackPercent(edict_t *pEnemy, int iId)
{
	if (b_botdontshoot)
		return 0;

	float LightBeamPercent = BotPersonalities[pBot->Personality].lightbeam_percent;
	float MediumBeamPercent = BotPersonalities[pBot->Personality].mediumbeam_percent;
	float HeavyBeamPercent = BotPersonalities[pBot->Personality].heavybeam_percent;
	float HeavyProjectilePercent = BotPersonalities[pBot->Personality].heavyprojectile_percent;
	float KiblastPercent = BotPersonalities[pBot->Personality].kiblast_percent;
	float DiscPercent = BotPersonalities[pBot->Personality].disc_percent;
	float LaserPercent = BotPersonalities[pBot->Personality].laser_percent;
	float KameTorpPercent = BotPersonalities[pBot->Personality].kametorp_percent;

	// First check if we should alter the percents...

	ClientInfo_t *pClient = UTIL_GetClientPointer(pEnemy);
	if (pClient)
	{
		if (pClient->ChargesAttack)
		{
			short ChargeValue = pClient->ChargeBeamVal;
			short PredictedChargeVal = ChargeValue;

			switch(pBot->bot_skill)
			{
			case 0:
				PredictedChargeVal += RANDOM_LONG(-10,10);
				break;
			case 1:
				PredictedChargeVal += RANDOM_LONG(-15,15);
				break;
			case 2:
				PredictedChargeVal += RANDOM_LONG(-20,20);
				break;
			case 3:
				PredictedChargeVal += RANDOM_LONG(-25,25);
				break;
			case 4:
				PredictedChargeVal += RANDOM_LONG(-30,30);
				break;
			}

			if ((PredictedChargeVal > 0) && (pClient->LastSoundTime > (gpGlobals->time - 4.5)))
			{
				SoundType_e SoundType = ClassifySound(pClient->SoundName);

				if (SoundType == ChargingLightBeam)
					LightBeamPercent *= 1.75;
				else if (SoundType == ChargingMediumBeam)
					MediumBeamPercent *= 1.75;
				else if (SoundType == ChargingBigBeam)
					HeavyBeamPercent *= 1.75;
				else if (SoundType == ChargingNonBeam)
					HeavyProjectilePercent *= 1.75;
			}
		}
		else if ((pClient->LaysOnGround) || (pClient->IsStuckAgainstWall))
		{
			// muhahaha
			KiblastPercent *= 1.75;
			LaserPercent *= 1.75;
		}
		else if (pEnemy->v.maxspeed == 0.0f)
		{
			KiblastPercent *= 1.25f;
			LaserPercent *= 1.25f;
		}
	}

	if ((iId == ESF_WEAPON_MELEE) || (iId == ESF_WEAPON_SWORD))
		return 0; // This is handled differently

	if ((iId == ESF_WEAPON_KIBLAST) || (iId == ESF_WEAPON_RENZOKU) ||
		(iId == ESF_WEAPON_SCATTERSHOT))
	    return KiblastPercent;

	if ((iId == ESF_WEAPON_GENERIC_BEAM) || (iId == ESF_WEAPON_BURNINGATTACK))
	    return LightBeamPercent;

	if ((iId == ESF_WEAPON_POWERBEAM) || (iId == ESF_WEAPON_MASENKO))
	    return MediumBeamPercent;

	if ((iId == ESF_WEAPON_GALLIT_GUN) || (iId == ESF_WEAPON_KAMEHAMEHA) ||
	    (iId == ESF_WEAPON_FINAL_FLASH) || (iId == ESF_WEAPON_MOUTHBLAST))
	    return HeavyBeamPercent;

	if ((iId == ESF_WEAPON_DESTRUCTO_DISC) || (iId == ESF_WEAPON_FRIEZADISC))
	    return DiscPercent;

	if ((iId == ESF_WEAPON_EYELASER) || (iId == ESF_WEAPON_FINGERLASER) ||
		(iId == ESF_WEAPON_CANDY))
	    return LaserPercent;

	if ((iId == ESF_WEAPON_SPECIALBEAM_CANNON) || (iId == ESF_WEAPON_SPIRIT_BOMB) ||
	    (iId == ESF_WEAPON_BIGBANG) || (iId == ESF_WEAPON_DEATHBALL) ||
	    (iId == ESF_WEAPON_SCATTERBEAM) || (iId == ESF_WEAPON_FINISHING_BUSTER) ||
		(iId == ESF_WEAPON_TELEKINESIS))
	    return HeavyProjectilePercent;

	if (iId == ESF_WEAPON_KAMETORPEDO)
	    return KameTorpPercent;

	if (iId == SBOT_WEAPON_LASER1)
	{
		if (pBot->SBotType > 0)
			return SBotSettings[pBot->SBotType-1].laser_percent;
		else
			return 0;
	}

	if (iId == ESF_WEAPON_SOLARFLARE)
		return BotPersonalities[pBot->Personality].solarflare_percent;


#ifdef _DEBUG
	lcout << "Attack not found in GetAttackPercent()!\n";
#endif

	return 0; // Attack not found :S
}

int CCombatTask::GetAttackIndex(int AttackId)
{
	AttackSelectTable_t *pSelect = &AttackSelectTable[0];
	int SelectIndex = 0;

    while (pSelect[SelectIndex].iId)
	{
		if (pSelect[SelectIndex].iId == AttackId)
			return SelectIndex;

		SelectIndex++;
	}

#ifdef _DEBUG
	ALERT(at_console, "Attack not found in GetAttackIndex()!\n");
#endif

	return 0; // Not found
}

bool CCombatTask::CanUseSecondaryFire(int AttackId)
{
	return ((AttackId == ESF_WEAPON_KIBLAST) || (AttackId == ESF_WEAPON_RENZOKU) ||
		    (AttackId == ESF_WEAPON_GENERIC_BEAM) || (AttackId == ESF_WEAPON_SPIRIT_BOMB) ||
			(AttackId == ESF_WEAPON_FINGERLASER));
}

bool AttackIsBeamJumpable(int iId, bool UseSecondary)
{
	if (UseSecondary)
		return false;

	return ((iId == ESF_WEAPON_GALLIT_GUN) || (iId == ESF_WEAPON_KAMEHAMEHA) ||
		    (iId == ESF_WEAPON_MOUTHBLAST) || (iId == ESF_WEAPON_GENERIC_BEAM) || 
			(iId == ESF_WEAPON_BURNINGATTACK) || (iId == ESF_WEAPON_POWERBEAM) || 
			(iId == ESF_WEAPON_MASENKO));
}

bool AttackIsBeam(int iId, bool UseSecondary)
{
	if (UseSecondary)
		return false;

	return ((iId == ESF_WEAPON_GALLIT_GUN) || (iId == ESF_WEAPON_KAMEHAMEHA) || 
		    (iId == ESF_WEAPON_MOUTHBLAST) || (iId == ESF_WEAPON_GENERIC_BEAM) ||
			(iId == ESF_WEAPON_BURNINGATTACK) || (iId == ESF_WEAPON_POWERBEAM) ||
			(iId == ESF_WEAPON_MASENKO) || (iId == ESF_WEAPON_FINAL_FLASH));
}


float AddShootDelay(bot_t *pBot)
{
	float min_delay = AttackDelays[pBot->bot_skill][0];
	float max_delay = AttackDelays[pBot->bot_skill][1];

	float base_delay = 0.5 + RANDOM_FLOAT(min_delay, max_delay);

	switch (pBot->AggressionLevel)
	{
	case Defensive:
		base_delay *= 1.2;
		break;
	case Aggressive:
		base_delay *= 0.8;
		break;
	}

	base_delay += gpGlobals->time;

	return base_delay;
}

bool EnemyIsInMeleeRange(bot_t *pBot, edict_t *pEnemy)
{
	Vector2D vec2LOS;
	float flDot;

	UTIL_MakeVectors (pBot->pEdict->v.angles);

	vec2LOS = (pEnemy->v.origin - pBot->pEdict->v.origin ).Make2D();
	vec2LOS = vec2LOS.Normalize();

	flDot = DotProduct (vec2LOS , gpGlobals->v_forward.Make2D() );

	return (flDot < 0.9);
}

#ifdef classstuff

bool CBot::BotHasWeapon(int iId)
{
	if (((iId == ESF_WEAPON_DESTRUCTO_DISC) || (iId == ESF_WEAPON_FRIEZADISC)) &&
	    (!pBotManager->m_bBotsUseDiscs))
		return false;

	if (iId == SBOT_WEAPON_LASER1)
		return (IsSuperBot());

	if (GetClass() == 2) // player class is goku ?
	{
      	char model_name[64];
	
		GetModel(model_name);

		if ((iId == ESF_WEAPON_SPIRIT_BOMB) && (FStrEq(model_name, "ssjgoku")))
		  return false; // if playerclass == goku and the bot is ssj then he doesn't have a SB
 	}

	// if the bot is an autobot he can only use kiblasts
	if ((pEdict == listenserver_edict) && (iId != ESF_WEAPON_KIBLAST))
		return false;

	return ((m_i64AvailableWeapons & (1<<iId)) != 0);
}

// Should the bot make a few kame torps when he doesn't have an enemy ?
bool CBot::BotShouldMakeKameTorps()
{
#ifdef LOGBOTINFO
	clog << "Make kame torps?\n";
#endif

	return (pClientManager->pClientList->Untill(this, &CBot::CheckPlayersForKameTorps));
/*
	if ((pBotManager->m_bBotsShoot == false) || (pBotManager->m_bBotsSearchEnemies == false))
		return false;

	if (GetClass() != 2)
		return false;

	CClient *pPlayer = NULL;
	float Dist = 0.0;
	int ClInd = -1;

	pClientManager->pClientList->ResetEntryListing();
	while(pClientManager->pClientList->GetNextEntry(pPlayer))
	{
		Dist = UTIL_Distance(GetOrigin(), pPlayer->GetOrigin());
		if (Dist > 5000.0)
			continue;

		if ((IsTeamPlay()) && (FVisible(pPlayer->GetOrigin())))
		{
			// skip if the team of the player is equal to the team of the bot
			if (GetTeam() == pPlayer->GetTeam())
				continue;
		}

		// Did the player just made a sound ?
		if (pPlayer->MadeASound())
			return true; // Ok lets do it

		// Is the player visible on the scouter ?
		if (Dist < 2300.0)
			return true; // Ok lets make some torpedo's

	}

	CBot *pTeamMateBot = NULL;

	// Look for a bot-team mate, if found one and he has an enemy; return true
	if (IsTeamPlay())
	{
		if (!m_bMadePlayerList)
			MakePlayerList();

		if (m_bPlayerCount)
		{
			for (byte i=0;i<m_bPlayerCount;i++)
			{
				pPlayer = m_pPlayerList[i];

				if (pPlayer->IsBot())
				{
					if (GetTeam() == pPlayer->GetTeam())
					{
						pTeamMateBot = pBotManager->GetBotFromClient(pPlayer);

						if (pTeamMateBot)
						{
							if (pTeamMateBot->m_pBotEnemy)
								return true;
						}
					}
				}
			}
		}
	}

	return false;*/
}

bool CBot::CheckPlayersForKameTorps(CClient *pClient)
{
	float Dist = UTIL_Distance(GetOrigin(), pClient->GetOrigin());
	
	if (Dist > 5000.0)
		return false;

	if ((IsTeamPlay()) && (FVisible(pClient->GetOrigin())))
	{
		// skip if the team of the player is equal to the team of the bot
		if (GetTeam() == pClient->GetTeam())
			return false;
	}

	// Did the player just made a sound ?
	if (pClient->MadeASound())
		return true; // Ok lets do it

	// Is the player visible on the scouter ?
	if (Dist < 2300.0)
		return true; // Ok lets make some torpedo's

	// Look for a bot-team mate, if found one and he has an enemy; return true
	// Only do this sometimes
	if ((pClient->IsBot()) && (GetTeam() == pClient->GetTeam()))
	{
		short LookForTeamMatePercent = 50;

		if (m_pPersonality->aggression_level == Defensive)
			LookForTeamMatePercent = 70;
		else if (m_pPersonality->aggression_level == Normal)
			LookForTeamMatePercent = 50;
		else if (m_pPersonality->aggression_level == Aggressive)
			LookForTeamMatePercent = 30;

		if (RANDOM_LONG(1, 100) < LookForTeamMatePercent)
		{
			CBot *pTeamMateBot = pBotManager->GetBotFromClient(pClient);

			if (pTeamMateBot)
			{
				if (pTeamMateBot->m_pBotEnemy)
					return true;
			}
		}
	}

	return false;
}

#endif