//
// HPB_bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_func.h
//

#ifndef BOT_FUNC_H
#define BOT_FUNC_H


//prototypes of bot functions...

void BotSpawnInit( bot_t *pBot );
void BotCreate( edict_t *pPlayer, const char *arg1, const char *arg2,
                const char *arg3, const char *arg4, const char *arg5 );
void BotBorgCreate(edict_t *pPlayer);
void SBotCreate( edict_t *pPlayer, const char *arg1, int type, const char *arg3);

void MakeSBotSettings(void);
void LoadSkillData(void);

void BotStartGame( bot_t *pBot );

void BotPreThink( bot_t *pBot );
void BotThink( bot_t *pBot );

void ResetChargeAttacks(bot_t *pBot);

bool BotFindWaypoint( bot_t *pBot );
bool BotHeadTowardWaypoint( bot_t *pBot );
void BotTurnAtWall( bot_t *pBot, Vector *vecPlaneNormal );
Vector WrapAngles (Vector angles_to_wrap);
float UTIL_WrapAngle (float angle_to_wrap);
void BotTurnAround(bot_t *pBot);
void BotNormalNavagation(bot_t *pBot);
void Bot_Look(bot_t *pBot);
void CheckFOV(bot_t *pBot);
void CheckSkyBox(bot_t *pBot);
void BotCombatMovement(bot_t *pBot);
void CheckBotStrafe(bot_t *pBot);
void BotCheckUpDown(bot_t *pBot);
Vector GetNearestCollision(edict_t *pEdict, float Range);
Vector GetFarthestCollision(edict_t *pEdict, float Range);
void SetMoveDir(bot_t *pBot, int MoveDir);
void ResetMoveSpeed(bot_t *pBot);
bool GoToVec(bot_t *pBot, Vector v_dest);

bool EnemyIsInList(bot_t *pBot, edict_t *pEnemy);

edict_t *BotFindEnemy( bot_t *pBot );
edict_t *BotFindUser( bot_t *pBot );

Vector BotBodyTarget( edict_t *pBotEnemy, bot_t *pBot, bool PredictEnemyPos = true );
bool bot_has_weapon(int iId, bot_t *pBot);

void AvoidAttackWhenSwoop(bot_t *pBot);

edict_t *GetBestEnemyFromList(bot_t *pBot);

//bool MakeKameTorps(bot_t *pBot, short DesiredTorpCount);
bool BotShouldMakeKameTorps(bot_t *pBot);

bool CheckForEnemyTraces(bot_t *pBot);

bool ShootAbsorbHealthBeams(bot_t *pBot);
void ShootHealthBeam(bot_t *pBot, edict_t *pPlayer);

bool AttackIsBeamJumpable(int iId, bool UseSecondary);
bool AttackIsBeam(int iId, bool UseSecondary);
float AddShootDelay(bot_t *pBot);

bool EnemyIsInMeleeRange(bot_t *pBot, edict_t *pEnemy);
#endif // BOT_FUNC_H

