#include "general_header.h"

CBaseOutput cout;
CLeftOutput lcout;
CRightOutput rcout;
CMiddleOutput mcout;
CLog clog;

extern edict_t *listenserver_edict;
extern bool IsPlayingMessage; 

void CBaseOutput::Display()
{
	if (FStrEq(TextToDisplay, "") == false)
	{
		char chunk[128] = "";

		if ( strlen( TextToDisplay) < 127)
		{
			strcpy(chunk, TextToDisplay);
		}
		else
		{
			strncpy( chunk, TextToDisplay, 127);
			chunk[127] = 0;		// strncpy doesn't always append the null terminator
		}

		// Throw out the message		
		UTIL_Printf(chunk);

		// Reset the message
		strcpy(TextToDisplay, "");
	}
}

CLog::CLog(void) : CursedVar(false), Started(false), fLogFile(NULL)
{
};

CLog::~CLog(void)
{
	if (Started && fLogFile)
		fclose(fLogFile);
};

void CLog::AddToTextString(const char *NewStr)
{
	// 'Display' the text. Just write it to a file :)
//	strcpy(TextToDisplay, NewStr);
//	Display();
}

void CLog::Display()
{
/*	FILE *fp = fopen("bot_log.txt", "a");
	fprintf(fp, "log write start\n");
	if (FStrEq(TextToDisplay, "") == false)
	{
		if (!Started)
		{
			Started = true;
			char LogFileName[256] = "";
			UTIL_BuildFileName(LogFileName, "bot_log.txt", NULL);
			fLogFile = fopen(LogFileName, "a");
			fprintf(fLogFile, "\n----------------------------------------------------------\n\n");
		}

		// Throw out the message
		fprintf(fLogFile, TextToDisplay);

		// Reset the message
		strcpy(TextToDisplay, "");
		fprintf(fp, "log write end\n");
		fclose(fp);
	}*/
}

void CScreenOutput::AddToTextString(const char *NewStr)
{
	short CurrentLength = strlen(TextToDisplay);
	short NewLength = strlen(NewStr);
	char temp[512];

	strcpy(temp, "");
	// don't allow the string to have more then 512 chars otherwise the message might overflow
	if ((CurrentLength + NewLength) > 512)
	{
		strncpy(temp, NewStr, 511);
		temp[511] = 0;
	}
	else
		strcpy(temp, NewStr);

	CheckForThrowOut(temp);

	strcat(TextToDisplay, temp);
};

void CScreenOutput::Display()
{
	if (FStrEq(TextToDisplay, "") == false)
	{
		if ((IS_DEDICATED_SERVER()) || (listenserver_edict == NULL))
			UTIL_Printf(TextToDisplay);
		else
		{
			if (IsPlayingMessage)
			{
				clog << "Tried to display text when there is already a message active\n";
				return;
			}

			// Throw out the message
			pfnMessageBegin (MSG_ONE, 23, NULL, listenserver_edict);
				pfnWriteByte (TE_TEXTMESSAGE);
				pfnWriteByte (TextChannel); // channel
				pfnWriteShort (xpos); // x coordinates * 8192
				pfnWriteShort (ypos); // y coordinates * 8192
				pfnWriteByte (0); // effect (fade in/out)
				pfnWriteByte (R); // initial RED
				pfnWriteByte (G); // initial GREEN
				pfnWriteByte (B); // initial BLUE
				pfnWriteByte (1); // initial ALPHA
				pfnWriteByte (0); // effect RED
				pfnWriteByte (0); // effect GREEN
				pfnWriteByte (255); // effect BLUE
				pfnWriteByte (1); // effect ALPHA
				pfnWriteShort (1); // fade-in time in seconds * 256
				pfnWriteShort (1); // fade-out time in seconds * 256
				pfnWriteShort (1024); // hold time in seconds * 256
				pfnWriteString (TextToDisplay); // send message
			pfnMessageEnd (); // end
		}

		// Reset the message
		strcpy(TextToDisplay, "");
	}
}
