//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_navigate.cpp
//

#include "general_header.h"

extern bool g_waypoint_on;

float aim_tracking_x_scale[5] = {5.0, 4.0, 3.2, 2.5, 2.0};
float aim_tracking_y_scale[5] = {5.0, 4.0, 3.2, 2.5, 2.0};

extern WAYPOINT waypoints[MAX_WAYPOINTS];
extern int num_waypoints;  // number of waypoints currently in use
extern FLAG_S flags[MAX_FLAGS];

extern bot_t bots[32];
extern bool b_observer_mode;
extern bool BotDoCombos;
extern bool BotShouldMove;

extern bool debug_mode;
extern edict_t *listenserver_edict;

// copied from botman's source (HPB_bot 2.11)
bool BotFindWaypoint( bot_t *pBot )
{
   int index, select_index;
   int team;
   PATH *pPath = NULL;
   int path_index;
   float distance, min_distance[3];
   int min_index[3];

   edict_t *pEdict = pBot->pEdict;

   team = UTIL_GetTeam(pEdict);

   for (index=0; index < 3; index++)
   {
      min_distance[index] = 9999.0;
      min_index[index] = -1;
   }

   index = WaypointFindPath(&pPath, &path_index, pBot->curr_waypoint_index, team);

   while (index != -1)
   {
      // if index is not a current or recent previous waypoint...
      if ((index != pBot->curr_waypoint_index) &&
          (index != pBot->prev_waypoint_index[0]) &&
          (index != pBot->prev_waypoint_index[1]) &&
          (index != pBot->prev_waypoint_index[2]) &&
          (index != pBot->prev_waypoint_index[3]) &&
          (index != pBot->prev_waypoint_index[4]))
      {
         // find the distance from the bot to this waypoint
         distance = (pEdict->v.origin - waypoints[index].origin).Length();

         if (distance < min_distance[0])
         {
            min_distance[2] = min_distance[1];
            min_index[2] = min_index[1];

            min_distance[1] = min_distance[0];
            min_index[1] = min_index[0];

            min_distance[0] = distance;
            min_index[0] = index;
         }
         else if (distance < min_distance [1])
         {
            min_distance[2] = min_distance[1];
            min_index[2] = min_index[1];

            min_distance[1] = distance;
            min_index[1] = index;
         }
         else if (distance < min_distance[2])
         {
            min_distance[2] = distance;
            min_index[2] = index;
         }
      }

      // find the next path to a waypoint
      index = WaypointFindPath(&pPath, &path_index, pBot->curr_waypoint_index, team);
   }

   select_index = -1;

   // about 20% of the time choose a waypoint at random
   // (don't do this any more often than every 10 seconds)

   if ((RANDOM_LONG(1, 100) <= 20) &&
       (pBot->f_random_waypoint_time <= gpGlobals->time))
   {
      pBot->f_random_waypoint_time = gpGlobals->time + 10.0;

      if (min_index[2] != -1)
         index = RANDOM_LONG(0, 2);
      else if (min_index[1] != -1)
         index = RANDOM_LONG(0, 1);
      else if (min_index[0] != -1)
         index = 0;
      else
         return FALSE;  // no waypoints found!

      select_index = min_index[index];
   }
   else
   {
      // use the closest waypoint that has been recently used
      select_index = min_index[0];
   }

   if (select_index != -1)  // was a waypoint found?
   {
      pBot->prev_waypoint_index[4] = pBot->prev_waypoint_index[3];
      pBot->prev_waypoint_index[3] = pBot->prev_waypoint_index[2];
      pBot->prev_waypoint_index[2] = pBot->prev_waypoint_index[1];
      pBot->prev_waypoint_index[1] = pBot->prev_waypoint_index[0];
      pBot->prev_waypoint_index[0] = pBot->curr_waypoint_index;

      pBot->curr_waypoint_index = select_index;
      pBot->waypoint_origin = waypoints[select_index].origin;

      pBot->f_waypoint_time = gpGlobals->time;

      return TRUE;
   }

   return FALSE;  // couldn't find a waypoint
}

// copied from botman's source (HPB_bot 2.11)
bool BotHeadTowardWaypoint( bot_t *pBot )
{
   int i;
   Vector v_src, v_dest;
   TraceResult tr;
   int index;
   bool status;
   float waypoint_distance, min_distance;
   int team; 
   bool touching;

   edict_t *pEdict = pBot->pEdict;

   if (IsTeamPlay())
      team = UTIL_GetTeam(pEdict);
   else
      team = -1;  // not team play (all waypoints are valid for everyone)

   // check if the bot has been trying to get to this waypoint for a while...
   if ((pBot->f_waypoint_time + 5.0) < gpGlobals->time)
   {
      pBot->curr_waypoint_index = -1;  // forget about this waypoint
      pBot->waypoint_goal = -1;  // also forget about a goal
   }

   
   // check if we need to find a waypoint...
   if (pBot->curr_waypoint_index == -1)
   {
      // find the nearest reachable waypoint
      i = WaypointFindReachable(pEdict, REACHABLE_RANGE, team);

      if (i == -1)
      {
         pBot->curr_waypoint_index = -1;
         return FALSE;
      }

      pBot->curr_waypoint_index = i;
      pBot->waypoint_origin = waypoints[i].origin;

      pBot->f_waypoint_time = gpGlobals->time;
   }
   else
   {
         // check if we can still see our target waypoint...

         v_src = pEdict->v.origin + pEdict->v.view_ofs;
         v_dest = waypoints[pBot->curr_waypoint_index].origin;

         // trace a line from bot's eyes to destination...
         UTIL_TraceLine( v_src, v_dest, ignore_monsters,
                         pEdict->v.pContainingEntity, &tr );

         // check if line of sight to object is blocked (i.e. not visible)
         if (tr.flFraction < 1.0)
         {
            i = WaypointFindReachable(pEdict, REACHABLE_RANGE, team);

            if (i == -1)
            {
               pBot->curr_waypoint_index = -1;
               return FALSE;
            }

            pBot->curr_waypoint_index = i;
            pBot->waypoint_origin = waypoints[i].origin;

            pBot->f_waypoint_time = gpGlobals->time;
         }
      
   }

   // find the distance to the target waypoint
   waypoint_distance = (pEdict->v.origin - pBot->waypoint_origin).Length();

   // set the minimum distance from waypoint to be considered "touching" it
   min_distance = 50.0;

   if (waypoints[pBot->curr_waypoint_index].flags & W_FL_JUMP)
      min_distance = 25.0;

   // if this is a ladder waypoint, bot must be fairly close to get on ladder
   if (waypoints[pBot->curr_waypoint_index].flags & W_FL_LADDER)
      min_distance = 20.0;

   touching = FALSE;

   // did the bot run past the waypoint? (prevent the loop-the-loop problem)
   if ((pBot->prev_waypoint_distance > 1.0) &&
       (waypoint_distance > pBot->prev_waypoint_distance))
      touching = TRUE;

   // are we close enough to a target waypoint...
   if (waypoint_distance < min_distance)
      touching = TRUE;

   // save current distance as previous
   pBot->prev_waypoint_distance = waypoint_distance;

   if (touching)
   {
      bool waypoint_found = FALSE;

      pBot->prev_waypoint_distance = 0.0;

      // check if the waypoint is a door waypoint
      if (waypoints[pBot->curr_waypoint_index].flags & W_FL_DOOR)
      {
         pBot->f_dont_avoid_wall_time = gpGlobals->time + 5.0;
      }

      // check if the next waypoint is a jump waypoint...
      if (waypoints[pBot->curr_waypoint_index].flags & W_FL_JUMP)
      {
         pEdict->v.button |= IN_JUMP;  // jump here
      }

       // check if the bot has reached the goal waypoint...
      if (pBot->curr_waypoint_index == pBot->waypoint_goal)
      {
         pBot->waypoint_goal = -1;  // forget this goal waypoint

		 pBot->pHuntingEdict = NULL;
      }
 
      // if the bot doesn't have a goal waypoint then pick one...
      if ((pBot->waypoint_goal == -1) &&
          (pBot->f_waypoint_goal_time < gpGlobals->time))
      {
         // don't pick a goal more often than every 10 seconds...
         pBot->f_waypoint_goal_time = gpGlobals->time + 10.0;

		 if (pBot->bot_skill < 4)
		 {
		     edict_t *pNewEnemy = NULL;
		     float NearestDistance = 9000;
			 float f_distance;

		     for (int i=1;i<=gpGlobals->maxClients;i++)
			 {
		 		 edict_t *pPlayer = INDEXENT(i);

		         if (pPlayer == pEdict)
			        continue;

	             if (!UTIL_IsValidPlayer(pPlayer))
		            continue;

	 	         f_distance = UTIL_Distance(pEdict->v.origin,pPlayer->v.origin);
				 if ((pBot->bot_skill > 1) && (f_distance < 2200))
					 continue;
          
	             // is team play enabled?
		         if (IsTeamPlay())
				 {
					  int player_team = UTIL_GetTeam(pPlayer);
	                  int bot_team = UTIL_GetTeam(pEdict);
	
		              // don't target your teammates...
	      	          if (bot_team == player_team)
		           	    continue;
				 }
	      			 
 			     if (f_distance < NearestDistance)
				 {
					 pNewEnemy = pPlayer;
				     NearestDistance = f_distance;
				 }
			 }

		     if (pNewEnemy)
			 {
				  index = WaypointFindNearest(pNewEnemy->v.origin, pNewEnemy, 
											1000, team);

		          pBot->waypoint_goal = index;
				  pBot->pHuntingEdict = pNewEnemy;
			 }
		 }
      }
      // check if the bot has a goal waypoint...
      if (pBot->waypoint_goal != -1)
      {
         if ((pBot->pHuntingEdict) && (pBot->HuntDelayTime < gpGlobals->time))
		 {
			 if (UTIL_IsValidPlayer(pBot->pHuntingEdict))
			 {
				index = WaypointFindNearest(pBot->pHuntingEdict->v.origin, pBot->pHuntingEdict, 
							 			    1000, team);
				if ((index != -1) && (index != pBot->waypoint_goal))
				   pBot->waypoint_goal = index;
				pBot->HuntDelayTime = gpGlobals->time + 1.5;
			 }
			 else
				 pBot->pHuntingEdict = NULL;
		 }

         // get the next waypoint to reach goal...
         i = WaypointRouteFromTo(pBot->curr_waypoint_index,
                                 pBot->waypoint_goal, team);

         if (i != WAYPOINT_UNREACHABLE)  // can we get to the goal from here?
         {
            waypoint_found = TRUE;
            pBot->curr_waypoint_index = i;
            pBot->waypoint_origin = waypoints[i].origin;

            pBot->f_waypoint_time = gpGlobals->time;
         }
      }

      if (waypoint_found == FALSE)
      {
         index = 4;

         // try to find the next waypoint
         while (((status = BotFindWaypoint( pBot )) == FALSE) &&
                (index > 0))
         {
            // if waypoint not found, clear oldest prevous index and try again

            pBot->prev_waypoint_index[index] = -1;
            index--;
         }

         if (status == FALSE)
         {
            pBot->curr_waypoint_index = -1;  // indicate no waypoint found

            // clear all previous waypoints...
            for (index=0; index < 5; index++)
               pBot->prev_waypoint_index[index] = -1;

            return FALSE;
         }
      }
   }

   // keep turning towards the waypoint...

   Vector v_direction = pBot->waypoint_origin - pEdict->v.origin;
   Vector v_angles = UTIL_VecToAngles(v_direction);
   pBot->AimVec = WrapAngles(v_angles);

   return true;
}

void BotTurnAtWall( bot_t *pBot, Vector *vecPlaneNormal )
{
   edict_t *pEdict = pBot->pEdict;
   Vector Normal;
   float Y, Y1, Y2, D1, D2, Z;
 
   // Find the normal vector from the trace result.  The normal vector will
   // be a vector that is perpendicular to the surface from the TraceResult.

   Normal = UTIL_VecToAngles(*vecPlaneNormal);

   // Since the bot keeps it's view angle in -180 < x < 180 degrees format,
   // and since TraceResults are 0 < x < 360, we convert the bot's view
   // angle (yaw) to the same format at TraceResult.

   Y = pEdict->v.v_angle.y;
   Y = Y + 180;
   if (Y > 359) Y -= 360;

   // Turn the normal vector around 180 degrees (i.e. make it point towards
   // the wall not away from it.  That makes finding the angles that the
   // bot needs to turn a little easier.

   Normal.y = Normal.y - 180;
   if (Normal.y < 0)
   Normal.y += 360;

   // Here we compare the bots view angle (Y) to the Normal - 90 degrees (Y1)
   // and the Normal + 90 degrees (Y2).  These two angles (Y1 & Y2) represent
   // angles that are parallel to the wall surface, but heading in opposite
   // directions.  We want the bot to choose the one that will require the
   // least amount of turning (saves time) and have the bot head off in that
   // direction.

   Y1 = Normal.y - 90;
   if (RANDOM_LONG(1, 100) <= 50)
   {
      Y1 = Y1 - RANDOM_FLOAT(5.0, 20.0);
   }
   if (Y1 < 0) Y1 += 360;

   Y2 = Normal.y + 90;
   if (RANDOM_LONG(1, 100) <= 50)
   {
      Y2 = Y2 + RANDOM_FLOAT(5.0, 20.0);
   }
   if (Y2 > 359) Y2 -= 360;

   // D1 and D2 are the difference (in degrees) between the bot's current
   // angle and Y1 or Y2 (respectively).

   D1 = abs(Y - Y1);
   if (D1 > 179) D1 = abs(D1 - 360);
   D2 = abs(Y - Y2);
   if (D2 > 179) D2 = abs(D2 - 360);

   // If difference 1 (D1) is more than difference 2 (D2) then the bot will
   // have to turn LESS if it heads in direction Y1 otherwise, head in
   // direction Y2.  I know this seems backwards, but try some sample angles
   // out on some graph paper and go through these equations using a
   // calculator, you'll see what I mean.

   if (D1 > D2)
      Z = Y1;
   else
      Z = Y2;

   // convert from TraceResult 0 to 360 degree format back to bot's
   // -180 to 180 degree format.

   if (Z > 180)
      Z -= 360;

   // set the direction to head off into...
   pBot->AimVec.y = UTIL_WrapAngle(Z);
   pBot->BodyVec = pBot->AimVec;
}

bool CheckForCollide(edict_t *pEdict, int dir, float distance)
{
   TraceResult tr;
  
   Vector v_src, v_dir, v_dest;

   UTIL_MakeVectors( pEdict->v.v_angle );

   if ((dir & dir_left) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
      v_dir = v_src + gpGlobals->v_right * -distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
      v_dir = v_src + gpGlobals->v_right * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_back) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
      v_dir = v_src + gpGlobals->v_forward * -distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_forward) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_up) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
      v_dir = v_src + gpGlobals->v_up * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_down) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
      v_dir = v_src - gpGlobals->v_up * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_upforward) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;
	  v_aim.x = -45.0;
	  
	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_downforward) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;
	  v_aim.x = 45.0;

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_left_forward_up) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_forward_up) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_back_up) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_back_up) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_forward_down) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_forward_down) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_back_down) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_back_down) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_left_back) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_right_back) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_right_forward) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_right_forward) || (dir == dir_all))
   { 
      v_src = pEdict->v.origin;
	  Vector v_aim = pEdict->v.v_angle;

	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      pEdict->v.pContainingEntity, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   return false;
}

bool CheckForCollide(const Vector v_src, Vector LookAngle, int dir, float distance)
{
   TraceResult tr;
  
   Vector v_dir, v_dest;

   UTIL_MakeVectors(LookAngle);

   if ((dir & dir_left) || (dir == dir_all))
   { 
      v_dir = v_src + gpGlobals->v_right * -distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right) || (dir == dir_all))
   { 
      v_dir = v_src + gpGlobals->v_right * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_back) || (dir == dir_all))
   { 
      v_dir = v_src + gpGlobals->v_forward * -distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_forward) || (dir == dir_all))
   { 
      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_up) || (dir == dir_all))
   { 
      v_dir = v_src + gpGlobals->v_up * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_down) || (dir == dir_all))
   { 
      v_dir = v_src - gpGlobals->v_up * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_upforward) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;
	  v_aim.x = -45.0;
	  
	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_downforward) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;
	  v_aim.x = 45.0;

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_left_forward_up) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_forward_up) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_back_up) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_back_up) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = -45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_forward_down) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_forward_down) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src + gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_back_down) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull, NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_right_back_down) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.x = 45.0;
	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull, NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }
   if ((dir & dir_left_back) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.y = UTIL_WrapAngle(v_aim.y - 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   if ((dir & dir_right_back) || (dir == dir_all))
   { 
	  Vector v_aim = LookAngle;

	  v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);

	  UTIL_MakeVectors(v_aim);

      v_dir = v_src - gpGlobals->v_forward * distance;

      UTIL_TraceHull( v_src, v_dir, dont_ignore_monsters, human_hull,
                      NULL, &tr);

      // check if the trace hit something...
      if (tr.flFraction < 1.0)
      {
         return true;  
      }
   }

   return false;
}

// copied from PMB's racc bot (= BAD ;) )
Vector WrapAngles (Vector angles_to_wrap) 
{
   // this function adds or substracts 360 enough times needed to every of the three components
   // of the axial angles structure angles_to_wrap in order to set them into the range -180/+180
   // and returns the resulting axial angles structure

   static Vector angles;

   angles = angles_to_wrap; // update this function's static variable with the angles to wrap

   // check for wraparound of angles
   if (angles.x > 180)
      angles.x -= 360 * ((int) (angles.x / 360) + 1);
   if (angles.x < -180)
      angles.x += 360 * ((int) (angles.x / 360) + 1);
   if (angles.y > 180)
      angles.y -= 360 * ((int) (angles.y / 360) + 1);
   if (angles.y < -180)
      angles.y += 360 * ((int) (angles.y / 360) + 1);
   if (angles.z > 180)
      angles.z -= 360 * ((int) (angles.z / 360) + 1);
   if (angles.z < -180)
      angles.z += 360 * ((int) (angles.z / 360) + 1);

   return (angles);
}

// blah again sumtin of PMB :P
float UTIL_WrapAngle (float angle_to_wrap)
{
   float angle = angle_to_wrap;

   // check for wraparound of angle
   if (angle > 180)
      angle -= 360 * ((int) (angle / 360) + 1);
   if (angle < -180)
      angle += 360 * ((int) (angle / 360) + 1);

   return angle;
}

void BotTurnAround(bot_t *pBot)
{
	float y = pBot->AimVec.y + 180.0f + RANDOM_FLOAT(-15.0, 15.0);
	pBot->AimVec.y = UTIL_WrapAngle(y);
}

void BotNormalNavagation(bot_t *pBot)
{
   edict_t *pEdict = pBot->pEdict;
 
   pEdict->v.idealpitch = 0;

   pEdict->v.v_angle.z = 0;  // reset roll to 0 (straight up and down)

   //pEdict->v.angles.x = 0;
   pEdict->v.angles.y = pEdict->v.v_angle.y;
   pEdict->v.angles.z = 0;

   bool found_waypoint = FALSE;
   float moved_distance;

   if (pBot->prev_time <= gpGlobals->time)
   {
       // see how far bot has moved since the previous position...
       Vector v_diff = pBot->v_prev_origin - pEdict->v.origin;
       moved_distance = v_diff.Length();

       // save current position as previous
       pBot->v_prev_origin = pEdict->v.origin;
       pBot->prev_time = gpGlobals->time + 0.2;
   }
   else
   {
       moved_distance = 2.0;
   }

   // If the bot can't move.... return
   if ((pBot->f_max_speed == 0.0) || (BotShouldMove == false))
	   return;

   // if it is time to look for a waypoint AND
   // if there are waypoints in this level...

   if ((pBot->f_look_for_waypoint_time <= gpGlobals->time) &&
       (num_waypoints != 0))
   {
       found_waypoint = BotHeadTowardWaypoint(pBot);
   }

   // if the bot isn't headed toward a waypoint...
   // then do the unwaypointed navagation :-)
   if (found_waypoint == false)
   {
        if (pBot->CheckUpDownTime <= gpGlobals->time)
          BotCheckUpDown(pBot);

		CheckBotStrafe(pBot);

		// check if we should be avoiding walls
		if (pBot->f_dont_avoid_wall_time <= gpGlobals->time)
		{
           if (pBot->f_look_delay < gpGlobals->time)
		   {
			   Bot_Look(pBot);    // first do our magical and much cpu intensive look...
			   CheckFOV(pBot);    // then look what we do with the results...
			   pBot->f_look_delay = gpGlobals->time + RANDOM_FLOAT(0.8, 1.2);
		   }

           CheckSkyBox(pBot); // and after that look for and avoid skyboxes...
		}
   }	  
}

// Function: fire (to) many tracelines to determine what the best move direction is;
// The best direction is the spot whith the highest distance
void Bot_Look(bot_t *pBot)
{
    if (pBot->f_dont_avoid_wall_time > gpGlobals->time)
 	   return;

	Vector vecLeft, vecForward, vecRight, vecBetween;
	edict_t *pEdict = pBot->pEdict;
	TraceResult tr;

	referential_t referential;

	UTIL_MakeVectors( pEdict->v.v_angle );

	Vector v_src = pEdict->v.origin;

	float angle;

    float distance = 0;
    float nearestdistance = 0;

    int count = 0;
    int DesiredAngleIndex = 0;

    // scan 90 degrees of bot's field of view...
	for (angle =-45; angle <=45; angle+=5) //-70 -- +70
	{
         v_src = WrapAngles(pEdict->v.v_angle); // restore bot's current v_angle
         v_src.y = UTIL_WrapAngle (v_src.y + angle); // pan it from left to right
         referential = ReferentialOfAngles (v_src);

         // trace line slightly under eyes level
         UTIL_TraceHull (pEdict->v.origin + pEdict->v.view_ofs,
                        (pEdict->v.origin + pEdict->v.view_ofs) + (referential.v_forward * 10000),
                         ignore_monsters, human_hull, pEdict, &tr);

         distance = tr.flFraction; // store distance to obstacle

         // save our results...
         pBot->eye[count].distance = distance * 10000;
         pBot->eye[count].contents = UTIL_PointContents( tr.vecEndPos );
         pBot->eye[count].endVec = tr.vecEndPos;
		 pBot->eye[count].vecPlaneNormal = tr.vecPlaneNormal;

         // now take the most logical direction:
         // take the endVec with the largest distance
         if (pBot->eye[count].distance > nearestdistance)
         {
             DesiredAngleIndex = count;
             nearestdistance = pBot->eye[count].distance;
         }

         count++;
   }

   if (DesiredAngleIndex > 0)
   { 
	   int FinalDestIndex = DesiredAngleIndex;
       Vector LookAngle = UTIL_VecToAngles(pBot->eye[FinalDestIndex].endVec - pEdict->v.origin);
       pBot->AimVec = WrapAngles(LookAngle);
       pBot->BodyVec = pBot->AimVec;
   }

   return;
}

void CheckFOV(bot_t *pBot)
{
   if (pBot->f_dont_avoid_wall_time > gpGlobals->time)
	   return;

   // first check if bot is in a corner....
   if ((pBot->eye[0].distance < 70) && (pBot->eye[eye_width-1].distance < 70) &&
	   (pBot->eye[(eye_width+1)/2].distance < 70)) // he is..
   {
	   TraceResult tr;
	   Vector v_src, v_end;
	   edict_t *pEdict = pBot->pEdict;

	   // check if we can jump up if when we're not flying and not under water...
	   if ((pEdict->v.gravity > 0.1) && (pEdict->v.waterlevel != 3) &&
		   (pBot->eye[(eye_width+1)/2].distance < 45.0) && (!(pEdict->v.flags & FL_ONGROUND)))
	   {
		   UTIL_MakeVectors(pEdict->v.v_angle);

		   v_src = pEdict->v.origin + Vector(0,0,200);
		   v_end = v_src + gpGlobals->v_forward * 80;

		   UTIL_TraceHull(v_src, v_end, ignore_monsters, human_hull, 
					  pEdict->v.pContainingEntity, &tr);

	       if (tr.flFraction >= 1.0)
		   {
			   pEdict->v.button |= IN_JUMP;
			   return;
		   }
	   }

       pBot->AimVec = WrapAngles (pEdict->v.v_angle);
       pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y+180);
	   pBot->BodyVec = pBot->AimVec;
	   
	   pBot->f_dont_avoid_wall_time = gpGlobals->time + 1.0;

	   if (debug_mode)
		   ClientPrint( listenserver_edict, HUD_PRINTNOTIFY, "Corner!\n");

       pBot->f_dont_avoid_wall_time = gpGlobals->time + 1.0;
	   return;
   }

   // then check if he can't move forward...
   if (pBot->eye[(eye_width+1)/2].distance < 70) // something is blocking on eye height
   {
	   TraceResult tr;
	   Vector v_src, v_end;
	   edict_t *pEdict = pBot->pEdict;

	   // check if the bot can jump when he's not flying and the bot is not in water
	   if ((pEdict->v.gravity > 0.1) && (pEdict->v.waterlevel != 3) &&
		   (!(pEdict->v.flags & FL_ONGROUND)))
	   {
		   UTIL_MakeVectors(pEdict->v.v_angle);

		   v_src = pEdict->v.origin + Vector(0,0,200);
		   v_end = v_src + gpGlobals->v_forward * 40;

		   UTIL_TraceHull(v_src, v_end, ignore_monsters, human_hull, 
					  pEdict->v.pContainingEntity, &tr);

	       if (tr.flFraction >= 1.0)
		   {
			   pEdict->v.button |= IN_JUMP;
			   return;
		   }
/* Disabled, maybe i work on it later
		   else // Otherwise try to walljump on it
		   {
			   MakeTask(pBot, TaskWallJump);
			   pEdict->v.button |= IN_JUMP;
			   return;
		   }
*/
	   }

	   BotTurnAtWall(pBot, &pBot->eye[(eye_width+1)/2].vecPlaneNormal);

	   if (debug_mode)
		   ClientPrint( listenserver_edict, HUD_PRINTNOTIFY, "Front-eye is blocked!\n");

       pBot->f_dont_avoid_wall_time = gpGlobals->time + 1.0;
	   pBot->CheckKameTorpTime += 1.5;
	   return;
   }

   return;
}

void CheckSkyBox(bot_t *pBot)
{
   edict_t *pEdict = pBot->pEdict;

   Vector v_src;
   Vector vecEnd;
   referential_t referential;

   if (pBot->f_dont_avoid_wall_time > gpGlobals->time)
	   return;

   v_src = WrapAngles(pEdict->v.v_angle); // restore bot's current v_angle
   referential = ReferentialOfAngles (v_src); 
    
   vecEnd = pEdict->v.origin + pEdict->v.view_ofs + (referential.v_forward * 400);

   if (UTIL_PointContents(vecEnd) == CONTENTS_SKY)
   {
       pBot->AimVec = WrapAngles(v_src);
       pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y+180);
	   pBot->BodyVec = pBot->AimVec;
       
	   pBot->f_dont_avoid_wall_time = gpGlobals->time + 1.0;

	   if (debug_mode)
		   ClientPrint( listenserver_edict, HUD_PRINTNOTIFY, "Sky box in front!\n");

	   pBot->CheckKameTorpTime += 1.5;
	   return;
   }

   return;
}

void BotCheckUpDown(bot_t *pBot)
{
	if (pBot->pEdict->v.gravity > 0.1)
	{
		// Loop up so the bot will walk on slopes aswell(otherwise the bot thinks the slope is a
		// wall
		pBot->AimVec.x = 40.0;
		return;
	}

	bool direction_up = false;
	bool direction_down = false;

	pBot->CheckUpDownTime = gpGlobals->time + 3.0;

	direction_up = CheckForCollide(pBot->pEdict, dir_upforward, 100.0);
	direction_down = CheckForCollide(pBot->pEdict, dir_downforward, 100.0);

	if ((direction_up) && (!direction_down))
	{
        pBot->AimVec.x = RANDOM_FLOAT(-25.0, -35.0);  // look downwards
	}
	else if ((!direction_up) && (direction_down))
	{
        pBot->AimVec.x = RANDOM_FLOAT(25.0, 35.0);  // look upwards
	}
    else if ((direction_up) && (direction_down))
	{
		pBot->AimVec.x = 0; // look straight
	}
	else
	{
		int i = RANDOM_LONG(1, 3);
		if (i == 1)
            pBot->AimVec.x = RANDOM_FLOAT(-25.0, -35.0);  // look downwards
		else if (i == 2)
            pBot->AimVec.x = RANDOM_FLOAT(25.0, 35.0);  // look upwards
		else
            pBot->AimVec.x = 0;  // look straight
	}
    return;
}

void BotCombatMovement(bot_t *pBot)
{
	if (!pBot->pBotEnemy)
		return;

	if ((pBot->f_max_speed == 0) || (BotShouldMove == false))
		return;

	float dist = UTIL_Distance(pBot->pEdict->v.origin,pBot->pBotEnemy->v.origin);

	if ((pBot->bot_skill > 2) && (!FInViewCone(&pBot->pBotEnemy->v.origin,pBot->pEdict)))
	{
		pBot->f_move_speed = 0.0; 
		pBot->CombatNavDir = 0;
		return;
	}

	edict_t *pEdict = pBot->pEdict;

	Vector AimVec, v_src, v_dest;
	float TraceDist[3][5];
	float nearestdistance = 0;
	float distance = 0;
	int i, j;
	float x=0,y=0;
	TraceResult tr;
	referential_t referential;
	int ind_i = 0, ind_j = 0;
	
	if (pBot->CombatNavDelay < gpGlobals->time)
	{
		bool go_backwards = (dist < RANDOM_FLOAT(1300.0, 1600.0));

		for (i=0;i<3;i++)
		{ 
			switch (i)
			{
			case 0:
				x=0;
				break;
			case 1:
				x=-30;
				break;
			case 2:
				x=30;
				break;
			default:
				break;
			}

			for (j=0;j<5;j++)
			{
				switch (j)
				{
				case 0:
					y=-90;
					break;
				case 1:
					y=-45;
					break;
				case 2:
					y=0;
					break;
				case 3:
					y=45;
					break;
				case 4:
					y=90;
					break;
				default:
					break;
				}

		        v_src = WrapAngles(pEdict->v.v_angle); // restore bot's current v_angle
			    v_src.y = UTIL_WrapAngle (v_src.y + y);
				v_src.x = UTIL_WrapAngle (x);

				referential = ReferentialOfAngles (v_src);

				v_dest = pEdict->v.origin + pEdict->v.view_ofs;

				if (go_backwards)
					v_dest = v_dest - referential.v_forward * 10000;
				else
					v_dest = v_dest + referential.v_forward * 10000;

			    // trace line slightly under eyes level
		        UTIL_TraceHull (pEdict->v.origin + pEdict->v.view_ofs,v_dest,
			                    dont_ignore_monsters, human_hull, pEdict, &tr);

				TraceDist[i][j] = (pEdict->v.origin - tr.vecEndPos).Length();
				distance = (pEdict->v.origin - tr.vecEndPos).Length();
				if (distance > nearestdistance)
				{
					nearestdistance = distance;
					AimVec = tr.vecEndPos;
					ind_i = i;
					ind_j =	j;
				}
			}
		}

		pBot->CombatNavDir = 0;
		pBot->CombatNavDelay = gpGlobals->time + RANDOM_FLOAT(0.8, 1.2);

		if (ind_i == 1)
			pBot->CombatNavDir |= dir_up;
		else if (ind_i == 2)
			pBot->CombatNavDir |= dir_down;

		switch (ind_j)
		{
		case 0:
			pBot->CombatNavDir |= dir_left;
			break;
		case 1:
			pBot->CombatNavDir |= dir_left;

			if (go_backwards)
				pBot->CombatNavDir |= dir_back;
			else
				pBot->CombatNavDir |= dir_forward;

			break;
		case 2:
			if (go_backwards)
				pBot->CombatNavDir |= dir_back;
			else
				pBot->CombatNavDir |= dir_forward;

			break;
		case 3:
			pBot->CombatNavDir |= dir_right;

			if (go_backwards)
				pBot->CombatNavDir |= dir_back;
			else
				pBot->CombatNavDir |= dir_forward;

			break;
		case 4:
			pBot->CombatNavDir |= dir_right;
			break;
		}
	}

	pBot->f_strafe_speed = 0.0;
	pBot->f_updown_speed = 0.0;
	pBot->f_move_speed = 0.0;

	if (pBot->CombatNavDir & dir_forward)
	{
		pBot->f_move_speed = pBot->f_max_speed;
	}
	if (pBot->CombatNavDir & dir_back)
	{
		pBot->f_move_speed = -pBot->f_max_speed;
	}
	if (pBot->CombatNavDir & dir_left)
	{
		pBot->f_strafe_speed = -pBot->f_max_speed;
	}
	if (pBot->CombatNavDir & dir_right)
	{
		pBot->f_strafe_speed = pBot->f_max_speed;
	}
	if (pBot->CombatNavDir & dir_up)
	{
		pBot->f_updown_speed = pBot->f_max_speed/2.0;
	}
	if (pBot->CombatNavDir & dir_down)
	{
		pBot->f_updown_speed = -pBot->f_max_speed/2.0;
	}

	CheckBotStrafe(pBot);

	return;
}

void CheckBotStrafe(bot_t *pBot)
{
	if (pBot->f_max_speed == 0.0)
		return;

	if (pBot->StrafeDir == 1)
		pBot->f_strafe_speed = -pBot->f_max_speed;
	else if (pBot->StrafeDir == 2)
		pBot->f_strafe_speed = pBot->f_max_speed;

	if (pBot->f_strafe_time > gpGlobals->time)
		return;

	pBot->StrafeDir = 0;

	pBot->f_strafe_time = gpGlobals->time + 0.8;

	edict_t *pEdict = pBot->pEdict;

	bool wall_left = false;
    bool wall_right = false;

	wall_left = CheckForCollide(pBot->pEdict, dir_left, 70.0);
	wall_right = CheckForCollide(pBot->pEdict, dir_right, 70.0);

	if ((wall_left) && (!wall_right))
	{
            // Strafe right if there is a wall on the left side but not on the right side.
		pBot->StrafeDir = 2;
		pBot->f_strafe_time = gpGlobals->time + RANDOM_FLOAT(0.3, 0.7);
		return;
	}
	else if ((!wall_left) && (wall_right))
	{
            // Strafe left if there is a wall on the right side but not on the left side.
		pBot->StrafeDir = 1;
		pBot->f_strafe_time = gpGlobals->time + RANDOM_FLOAT(0.3, 0.7);
		return;
	}

	if (!IsTeamPlay())
	      return;

	edict_t *pNearestPlayer = NULL;
	edict_t *pPlayer = NULL;
	edict_t *pNearestDBall = NULL;
    edict_t *pent = NULL;

	float dist, nearestdistance = 300.0;
	Vector vecEnd;

	// Only check for DBalls when cptdb is on...
	if (CVAR_GET_FLOAT("mp_gamemode") == 2.0)
	{
    	while ((pent = UTIL_FindEntityByClassname( pent, "dragonball")) != NULL)
		{
			if (IsNull(pent))
				continue;

			dist = UTIL_Distance(pEdict->v.origin,pent->v.origin);

			if (dist > 300.0)
				continue;

			vecEnd = pent->v.origin;

			if (!FInViewCone( &vecEnd, pEdict ))
				continue;

			if (!FVisible(vecEnd,pEdict))
				continue;

			if (dist < nearestdistance)
			{
				nearestdistance = dist;
				pNearestDBall = pent;
			}
		}
	}

	if (pNearestDBall)
	{
		Vector v_src = pEdict->v.origin;
		Vector v_dbsrc = pNearestDBall->v.origin;
		Vector v_left;
		Vector v_right;

		float LeftDistToDB = 0.0;
		float RightDistToDB = 0.0;

		UTIL_MakeVectors(pEdict->v.angles);

		// should we go left or right ?
		v_left = v_src - gpGlobals->v_right * 100.0;
		v_right = v_src + gpGlobals->v_right * 100.0;

		LeftDistToDB = UTIL_Distance(v_dbsrc, v_left);
		RightDistToDB = UTIL_Distance(v_dbsrc, v_right);

		if (LeftDistToDB < RightDistToDB) // DB is on the left side
			pBot->StrafeDir = 2; // Strafe right
		else if (LeftDistToDB > RightDistToDB) // DB is on the right side
			pBot->StrafeDir = 1; // Strafe left
		else // Equal distance...
		{
			// choose a random dir
			if (RANDOM_LONG(0, 1))
				pBot->StrafeDir = 1; // Strafe left
			else
				pBot->StrafeDir = 2; // Strafe right
		}
	}
		
	if (!pBot->MadePlayerList)
		MakePlayerList(pBot);

	nearestdistance = 400.0;
	if (pBot->PlayerCount > 0)
	{
		for (int i=0;i<pBot->PlayerCount;i++)
		{
			pPlayer = pBot->PlayerList[i];

			int player_team = UTIL_GetTeam(pPlayer);
		    int bot_team = UTIL_GetTeam(pEdict);

			if (bot_team != player_team)
				continue; // only avoid team mates

			dist = UTIL_Distance(pEdict->v.origin, pPlayer->v.origin);
			if (dist > 400.0)
				continue; // only avoid close peeps

			Vector v_end = pPlayer->v.origin;

			if (!FInViewCone( &v_end, pEdict ))
				continue; // don't avoid people who aren't in view cone

			if ((EntityHeadsToPlayer(pEdict, pPlayer) == false) &&
			    (pPlayer->v.velocity.Length() > 10.0))
				continue; // don't bother about people not moving to us

			if (dist < nearestdistance)
			{
				nearestdistance = dist;
				pNearestPlayer = pPlayer;
			}
		}
	}

	if (pNearestPlayer)
	{
		vecEnd = pEdict->v.origin;

		if (EntityHeadsToPlayer(pEdict, pNearestPlayer))
		{
			Vector v_src = pEdict->v.origin;
			Vector v_predict = PredictEntityPos(pNearestPlayer, 1.0);
			Vector v_left;
			Vector v_right;

			float LeftDistToPlayer = 0.0;
			float RightDistToPlayer = 0.0;

			UTIL_MakeVectors(pEdict->v.angles);

			v_left = v_src - gpGlobals->v_forward * 100.0;
			v_right = v_src + gpGlobals->v_forward * 100.0;

			LeftDistToPlayer = UTIL_Distance(v_left, v_predict);
			RightDistToPlayer = UTIL_Distance(v_right, v_predict);

			// Is the player in 1.0 secs more closer to the left or closer to the right ?
			if (LeftDistToPlayer < RightDistToPlayer) // player moves more to the left side
				pBot->StrafeDir = 2; // Strafe right
			else if (LeftDistToPlayer > RightDistToPlayer) // player moves more to the right side
				pBot->StrafeDir = 1; // Strafe left
			else
			{
				// choose a random dir
				if (RANDOM_LONG(0, 1))
					pBot->StrafeDir = 1; // Strafe left
				else
					pBot->StrafeDir = 2; // Strafe right
			}		
		}
		else
		{
			// choose a random dir
			if (RANDOM_LONG(0, 1))
				pBot->StrafeDir = 1; // Strafe left
			else
				pBot->StrafeDir = 2; // Strafe right
		}
	}

	if (pBot->StrafeDir)
		pBot->f_strafe_time = gpGlobals->time + RANDOM_FLOAT(0.3, 0.7);
}

// Fires 50(ouch) tracelines to determine what is the nearest pos of a player
Vector GetNearestCollision(edict_t *pEdict, float Range)
{
	Vector v_nearest = g_vecZero;
	Vector v_src, v_dest, v_dest2;
	referential_t referential;
	TraceResult tr, tr2;
	int i, j;
	float nearestdistance = 9999.9;
	float distance, distance2, dist, x, y;
	x = y = 0.0;

	for (i=0;i<5;i++)
	{ 
		switch (i)
		{
		case 0:
			x=0.0;
			break;
		case 1:
			x=-40.0;
			break;
		case 2:
			x=40.0;
			break;
		case 3:
			x=-89.0;
			break;
		case 4:
			x=89.0;
			break;
		default:
			break;
		}

		for (j=0;j<5;j++)
		{
			switch (j)
			{
			case 0:
				y=-90.0;
				break;
			case 1:
				y=-45.0;
				break;
			case 2:
				y=0.0;
				break;
			case 3:
				y=45.0;
				break;
			case 4:
				y=90.0;
				break;
			default:
				break;
			}

			v_src = WrapAngles(pEdict->v.angles);
			v_src.y = UTIL_WrapAngle (v_src.y + y);
			v_src.x = UTIL_WrapAngle (x);

			referential = ReferentialOfAngles (v_src);

			v_dest = pEdict->v.origin + referential.v_forward * Range;

			v_dest2 = pEdict->v.origin - referential.v_forward * Range;

	        UTIL_TraceHull (pEdict->v.origin, v_dest,
		                    ignore_monsters, human_hull, pEdict, &tr);

	        UTIL_TraceHull (pEdict->v.origin, v_dest2,
		                    ignore_monsters, human_hull, pEdict, &tr2);

			distance = (tr.vecEndPos - pEdict->v.origin).Length();
			distance2 = (tr2.vecEndPos - pEdict->v.origin).Length();

			if ((distance < distance2) && (tr.flFraction < 1.0f))
			{
				dist = distance;
				v_dest = tr.vecEndPos;
			}
			else if ((distance2 <= distance) && (tr2.flFraction < 1.0f))
			{
				dist = distance2;
				v_dest = tr2.vecEndPos;
			}
			else
				continue;

			if (dist < nearestdistance)
			{
				nearestdistance = dist;
				v_nearest = v_dest;
			}
		}
	}

	return v_nearest;
}

// Fires 50(ouch) tracelines to determine what the farthest pos of a player is
Vector GetFarthestCollision(edict_t *pEdict, float Range)
{
	Vector v_farthest = g_vecZero;
	Vector v_src, v_dest, v_dest2;
	referential_t referential;
	TraceResult tr, tr2;
	int i, j;
	float farthestdistance = 0.0;
	float distance, distance2, dist, x, y;
	x = y = 0.0;

	for (i=0;i<5;i++)
	{ 
		switch (i)
		{
		case 0:
			x=0.0;
			break;
		case 1:
			x=-40.0;
			break;
		case 2:
			x=40.0;
			break;
		case 3:
			x=-89.0;
			break;
		case 4:
			x=89.0;
			break;
		default:
			break;
		}

		for (j=0;j<5;j++)
		{
			switch (j)
			{
			case 0:
				y=-90.0;
				break;
			case 1:
				y=-45.0;
				break;
			case 2:
				y=0.0;
				break;
			case 3:
				y=45.0;
				break;
			case 4:
				y=90.0;
				break;
			default:
				break;
			}

			v_src = WrapAngles(pEdict->v.angles);
			v_src.y = UTIL_WrapAngle (v_src.y + y);
			v_src.x = UTIL_WrapAngle (x);

			referential = ReferentialOfAngles (v_src);

			v_dest = pEdict->v.origin + referential.v_forward * Range;

			v_dest2 = pEdict->v.origin - referential.v_forward * Range;

	        UTIL_TraceHull (pEdict->v.origin, v_dest,
		                    ignore_monsters, human_hull, pEdict, &tr);

	        UTIL_TraceHull (pEdict->v.origin, v_dest2,
		                    ignore_monsters, human_hull, pEdict, &tr2);

			distance = (tr.vecEndPos - pEdict->v.origin).Length();
			distance2 = (tr2.vecEndPos - pEdict->v.origin).Length();

			if (distance > distance2)
			{
				dist = distance;
				v_dest = tr.vecEndPos;
			}
			else
			{
				dist = distance2;
				v_dest = tr2.vecEndPos;
			}

			if (dist > farthestdistance)
			{
				farthestdistance = dist;
				v_farthest = v_dest;
			}
		}
	}

	return v_farthest;
}

void ResetMoveSpeed(bot_t *pBot)
{
	pBot->f_move_speed = pBot->f_strafe_speed = pBot->f_updown_speed = 0.0f;
	pBot->pEdict->v.button &= ~(IN_FORWARD | IN_BACK | IN_MOVERIGHT | IN_MOVELEFT);
}

void SetMoveDir(bot_t *pBot, int MoveDir)
{
	edict_t *pEdict = pBot->pEdict;

	if (MoveDir & dir_left)
	{
		pBot->f_strafe_speed = -pBot->f_max_speed;
		pEdict->v.button |= IN_MOVELEFT;
	}
	if (MoveDir & dir_right)
	{
		pBot->f_strafe_speed = pBot->f_max_speed;
		pEdict->v.button |= IN_MOVERIGHT;
	}
	if (MoveDir & dir_forward)
	{
		pBot->f_move_speed = pBot->f_max_speed;
		pEdict->v.button |= IN_FORWARD;
	}
	if (MoveDir & dir_back)
	{
		pBot->f_move_speed = -pBot->f_max_speed;
		pEdict->v.button |= IN_BACK;
	}
	if (MoveDir & dir_up)
	{
		pBot->f_updown_speed = pBot->f_max_speed;
		pEdict->v.button |= IN_JUMP;
	}
	if (MoveDir & dir_down)
	{
		pBot->f_updown_speed = -pBot->f_max_speed;
		pEdict->v.button |= IN_DUCK;
	}
}

bool GoToVec(bot_t *pBot, Vector v_dest)
{
	edict_t *pEdict = pBot->pEdict;
	Vector v_src = pEdict->v.origin;
	Vector v_AimDest = WrapAngles(UTIL_VecToAngles(v_dest - v_src));
	Vector v_start;
	Vector v_end;
	Vector v_aim;
	float DistToTrace = UTIL_Distance(v_src, v_dest) + 250.0f;
	TraceResult tr1, tr2;
	float BestFraction = 0.0f;

	UTIL_MakeVectors(v_AimDest);

	UTIL_TraceHull(v_src, v_dest, ignore_monsters, human_hull, pEdict, &tr1);

	if (tr1.flFraction >= 1.0f)
	{
		pBot->AimVec = v_AimDest;
		return true;
	}

	float x, y;

	for (x=-45;x<=45;x+=5)
	{
		for (y=-45;y<=45;y+=5)
		{
			v_start = v_AimDest;
			v_start.x = UTIL_WrapAngle(v_start.x + x);
			v_start.y = UTIL_WrapAngle(v_start.y + y);
			v_end = v_start + gpGlobals->v_forward * (DistToTrace + ((abs(x) / 45) * 10) + ((abs(y) / 45) * 10));

			UTIL_TraceHull(v_src, v_end, ignore_monsters, human_hull, pEdict, &tr2);

			if ((tr2.flFraction > tr1.flFraction) && (tr2.flFraction > BestFraction))
			{
				v_aim = tr2.vecEndPos;
				BestFraction = tr2.flFraction;
			}
		}
	}

	if (BestFraction > 0.0f)
	{
		pBot->AimVec = WrapAngles(UTIL_VecToAngles(v_aim - v_src));
		return true;
	}
	return false;
}