#include "general_header.h"

BotPersonality_t BotPersonalities[9];
short DefaultPersonality = -1;

// Make random personalities for bots or read them out of the file
// 'botpersonality.cfg'
void MakePersonalities()
{
	char PersoFileName[256] = "";
	FILE *PersoFile = NULL;
	int CurrentPersonalityNr = 0;

	memset(BotPersonalities,0,sizeof(BotPersonalities));

	UTIL_BuildFileName(PersoFileName, "bot_personality.cfg", NULL);

	PersoFile = fopen(PersoFileName, "r");
	(*g_engfuncs.pfnServerPrint) ("Reading bot_personalities file... ");

	// make random personalities, in case the file doesnt exist or 
	// has missing settings.
	MakeRandomPersonalities();

	if (PersoFile == NULL) // file doesn't exist
	{
		(*g_engfuncs.pfnServerPrint) ("file not found, random settings will be used\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	static char server_cmd[80];
	char *cmd, *arg1, *arg2, *arg3, *arg4;
	int value = 0;
	
	while (PersoFile)
	{    
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(PersoFile);

		// skip any leading blanks
		while (ch == ' ')
			ch = fgetc(PersoFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
		      ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(PersoFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') &&
		             (ch == ' '))      
         		ch = fgetc(PersoFile);

		      cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
		      ch = fgetc(PersoFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
		      fclose(PersoFile);
			PersoFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		// copy the command line to a server command buffer...
		strcpy(server_cmd, cmd_line);
		strcat(server_cmd, "\n");

		cmd_index = 0;
		cmd = cmd_line;
		arg1 = arg2 = arg3 = arg4 = NULL;

		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		      cmd_index++;

		if (cmd_line[cmd_index] == ' ')
		{
		      cmd_line[cmd_index++] = 0;
		      arg1 = &cmd_line[cmd_index];

		      // skip to blank or end of string...
		      while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		         cmd_index++;

		      if (cmd_line[cmd_index] == ' ')
			  {
		         cmd_line[cmd_index++] = 0;
		         arg2 = &cmd_line[cmd_index];

		         // skip to blank or end of string...
		         while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		            cmd_index++;

		         if (cmd_line[cmd_index] == ' ')
		         {
		            cmd_line[cmd_index++] = 0;
		            arg3 = &cmd_line[cmd_index];

            		// skip to blank or end of string...
		            while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
            		   cmd_index++;

		            if (cmd_line[cmd_index] == ' ')
            		{
		               cmd_line[cmd_index++] = 0;
		               arg4 = &cmd_line[cmd_index];
            		}
		         }
		      }
		}

		if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
		    continue;  // skip if comment or blank line

		if (strcmp(cmd, "[BOT1]") == 0)
			CurrentPersonalityNr = 0; // bot personality 1
		else if (strcmp(cmd, "[BOT2]") == 0)
			CurrentPersonalityNr = 1; // bot personality 2
		else if (strcmp(cmd, "[BOT3]") == 0)
			CurrentPersonalityNr = 2; // bot personality 3
		else if (strcmp(cmd, "[BOT4]") == 0)
			CurrentPersonalityNr = 3; // bot personality 4
		else if (strcmp(cmd, "[BOT5]") == 0)
			CurrentPersonalityNr = 4; // bot personality 5
		else if (strcmp(cmd, "[BOT6]") == 0)
			CurrentPersonalityNr = 5; // bot personality 6
		else if (strcmp(cmd, "[BOT7]") == 0)
			CurrentPersonalityNr = 6; // bot personality 7
		else if (strcmp(cmd, "[BOT8]") == 0)
			CurrentPersonalityNr = 7; // bot personality 8
		else if (strcmp(cmd, "[BOT9]") == 0)
			CurrentPersonalityNr = 8; // bot personality 9

		if ((arg1 == NULL) || (*arg1 == 0))
			continue;

		value = atoi(arg1);

		if (strcmp(cmd, "default_personality") == 0)
		{
			if ((value == -1) || ((value > 0) && (value < 10)))
				DefaultPersonality = value;
		}
		else if (strcmp(cmd, "melee_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].melee_percent = value;
		}
		else if (strcmp(cmd, "kiblast_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].kiblast_percent = value;
		}
		else if (strcmp(cmd, "lightbeam_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].lightbeam_percent = value;
		}
		else if (strcmp(cmd, "mediumbeam_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))			
				BotPersonalities[CurrentPersonalityNr].mediumbeam_percent = value;
		}
		else if (strcmp(cmd, "heavybeam_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].heavybeam_percent = value;
		}
		else if (strcmp(cmd, "disc_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))				
				BotPersonalities[CurrentPersonalityNr].disc_percent = value;
		}
		else if (strcmp(cmd, "laser_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].laser_percent = value;
		}
		else if (strcmp(cmd, "heavyball_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].heavyprojectile_percent = value;
		}
		else if (strcmp(cmd, "kametorp_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].kametorp_percent = value;
		}
		else if (strcmp(cmd, "solarflare_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].solarflare_percent = value;
		}

		else if (strcmp(cmd, "meleecombo_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].meleecombo_percent = value;
		}
		else if (strcmp(cmd, "meleekick_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].meleekick_percent = value;
		}

		else if (strcmp(cmd, "chat_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_percent = value;
		}
		else if (strcmp(cmd, "taunt_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].taunt_percent = value;
		}
		else if (strcmp(cmd, "whine_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].whine_percent = value;
		}
		else if (strcmp(cmd, "chat_tag_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_tag_percent = value;
		}
		else if (strcmp(cmd, "chat_drop_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_drop_percent = value;
		}
		else if (strcmp(cmd, "chat_swap_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_swap_percent = value;
		}
		else if (strcmp(cmd, "chat_lower_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_lower_percent = value;
		}

		else if (strcmp(cmd, "teleport_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].teleport_percent = value;
		}
		else if (strcmp(cmd, "swoop_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].swoop_percent = value;
		}
		else if (strcmp(cmd, "beamexplode_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].beamexplode_percent = value;
		}
		else if (strcmp(cmd, "fly_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].fly_percent = value;
		}
		else if (strcmp(cmd, "stopfly_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].stopfly_percent = value;
		}
		else if (strcmp(cmd, "jump_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].jump_percent = value;
		}
		else if (strcmp(cmd, "block_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].block_percent = value;
		}

	    else if (FStrEq(cmd, "aggression_level"))
		{
			if (FStrEq(arg1,"defensive"))
				BotPersonalities[CurrentPersonalityNr].aggression_level = Defensive;
			else if (FStrEq(arg1,"normal"))
				BotPersonalities[CurrentPersonalityNr].aggression_level = Normal;
			else if (FStrEq(arg1,"aggressive"))
				BotPersonalities[CurrentPersonalityNr].aggression_level = Aggressive;
		}
		else if (strcmp(cmd, "transkiller") == 0)
		{
			if ((value == 0) || (value == 1))
				BotPersonalities[CurrentPersonalityNr].transkiller = (value == 1) ? true : false;
		}
	}
	(*g_engfuncs.pfnServerPrint) ("done\n");
}

// make random personalities
void MakeRandomPersonalities()
{
	for (int count=0;count<9;count++)
	{
		BotPersonalities[count].melee_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].kiblast_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].lightbeam_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].mediumbeam_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].heavybeam_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].disc_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].laser_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].heavyprojectile_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].kametorp_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].solarflare_percent = RANDOM_LONG(0, 100);

		BotPersonalities[count].meleecombo_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].meleekick_percent = RANDOM_LONG(0, 100);

		BotPersonalities[count].chat_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].taunt_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].whine_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_tag_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_lower_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_drop_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_swap_percent = RANDOM_LONG(0, 100);

		BotPersonalities[count].teleport_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].swoop_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].beamexplode_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].fly_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].stopfly_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].jump_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].block_percent = RANDOM_LONG(0, 100);

		switch (RANDOM_LONG(0, 2))
		{
		case 0:
			BotPersonalities[count].aggression_level = Defensive;
			break;
		case 1:
			BotPersonalities[count].aggression_level = Normal;
			break;
		case 2:
			BotPersonalities[count].aggression_level = Aggressive;
			break;
		}

		if (RANDOM_LONG(0, 1))
			BotPersonalities[count].transkiller = true;
		else
			BotPersonalities[count].transkiller = false;
	}
}

#ifdef classstuff
// Make random personalities for bots or read them out of the file
// 'botpersonality.cfg'
void CBotManager::CreateBotPersonalities()
{
	char PersoFileName[256] = "";
	FILE *PersoFile = NULL;
	int CurrentPersonalityNr = -1;

	memset(BotPersonalities,0,sizeof(BotPersonalities));

	UTIL_BuildFileName(PersoFileName, "bot_personality.cfg", NULL);

	PersoFile = fopen(PersoFileName, "r");
	(*g_engfuncs.pfnServerPrint) ("Reading bot_personalities file... ");

	// make random personalities, in case the file doesnt exist or 
	// has missing settings.
	MakeRandomPersonalities();

	if (PersoFile == NULL) // file doesn't exist
	{
		(*g_engfuncs.pfnServerPrint) ("file not found, random settings will be used\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	static char server_cmd[80];
	char *cmd, *arg1, *arg2, *arg3, *arg4;
	int value = 0;
	
	while (PersoFile)
	{    
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(PersoFile);

		// skip any leading blanks
		while (ch == ' ')
			ch = fgetc(PersoFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
		      ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(PersoFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') &&
		             (ch == ' '))      
         		ch = fgetc(PersoFile);

		      cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
		      ch = fgetc(PersoFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
		      fclose(PersoFile);
			PersoFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		// copy the command line to a server command buffer...
		strcpy(server_cmd, cmd_line);
		strcat(server_cmd, "\n");

		cmd_index = 0;
		cmd = cmd_line;
		arg1 = arg2 = arg3 = arg4 = NULL;

		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		      cmd_index++;

		if (cmd_line[cmd_index] == ' ')
		{
		      cmd_line[cmd_index++] = 0;
		      arg1 = &cmd_line[cmd_index];

		      // skip to blank or end of string...
		      while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		         cmd_index++;

		      if (cmd_line[cmd_index] == ' ')
			  {
		         cmd_line[cmd_index++] = 0;
		         arg2 = &cmd_line[cmd_index];

		         // skip to blank or end of string...
		         while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
		            cmd_index++;

		         if (cmd_line[cmd_index] == ' ')
		         {
		            cmd_line[cmd_index++] = 0;
		            arg3 = &cmd_line[cmd_index];

            		// skip to blank or end of string...
		            while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
            		   cmd_index++;

		            if (cmd_line[cmd_index] == ' ')
            		{
		               cmd_line[cmd_index++] = 0;
		               arg4 = &cmd_line[cmd_index];
            		}
		         }
		      }
		}

		if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
		    continue;  // skip if comment or blank line

		if (strcmp(cmd, "[BOT1]") == 0)
			CurrentPersonalityNr = 0; // bot personality 1
		else if (strcmp(cmd, "[BOT2]") == 0)
			CurrentPersonalityNr = 1; // bot personality 2
		else if (strcmp(cmd, "[BOT3]") == 0)
			CurrentPersonalityNr = 2; // bot personality 3
		else if (strcmp(cmd, "[BOT4]") == 0)
			CurrentPersonalityNr = 3; // bot personality 4
		else if (strcmp(cmd, "[BOT5]") == 0)
			CurrentPersonalityNr = 4; // bot personality 5
		else if (strcmp(cmd, "[BOT6]") == 0)
			CurrentPersonalityNr = 5; // bot personality 6
		else if (strcmp(cmd, "[BOT7]") == 0)
			CurrentPersonalityNr = 6; // bot personality 7
		else if (strcmp(cmd, "[BOT8]") == 0)
			CurrentPersonalityNr = 7; // bot personality 8
		else if (strcmp(cmd, "[BOT9]") == 0)
			CurrentPersonalityNr = 8; // bot personality 9

		if ((arg1 == NULL) || (*arg1 == 0))
			continue;

		if (CurrentPersonalityNr == -1)
			continue;

		value = atoi(arg1);

		if (strcmp(cmd, "default_personality") == 0)
		{
			if ((value == -1) || ((value > 0) && (value <= 10)))
				DefaultPersonality = value;
		}
		else if (strcmp(cmd, "melee_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].melee_percent = value;
		}
		else if (strcmp(cmd, "kiblast_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].kiblast_percent = value;
		}
		else if (strcmp(cmd, "lightbeam_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].lightbeam_percent = value;
		}
		else if (strcmp(cmd, "mediumbeam_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))			
				BotPersonalities[CurrentPersonalityNr].mediumbeam_percent = value;
		}
		else if (strcmp(cmd, "heavybeam_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].heavybeam_percent = value;
		}
		else if (strcmp(cmd, "disc_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))				
				BotPersonalities[CurrentPersonalityNr].disc_percent = value;
		}
		else if (strcmp(cmd, "laser_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].laser_percent = value;
		}
		else if (strcmp(cmd, "heavyball_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].heavyprojectile_percent = value;
		}
		else if (strcmp(cmd, "kametorp_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].kametorp_percent = value;
		}
		else if (strcmp(cmd, "solarflare_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].solarflare_percent = value;
		}

		else if (strcmp(cmd, "meleecombo_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].meleecombo_percent = value;
		}
		else if (strcmp(cmd, "meleekick_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].meleekick_percent = value;
		}

		else if (strcmp(cmd, "chat_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_percent = value;
		}
		else if (strcmp(cmd, "taunt_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].taunt_percent = value;
		}
		else if (strcmp(cmd, "whine_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].whine_percent = value;
		}
		else if (strcmp(cmd, "chat_tag_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_tag_percent = value;
		}
		else if (strcmp(cmd, "chat_drop_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_drop_percent = value;
		}
		else if (strcmp(cmd, "chat_swap_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_swap_percent = value;
		}
		else if (strcmp(cmd, "chat_lower_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].chat_lower_percent = value;
		}

		else if (strcmp(cmd, "teleport_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))		
				BotPersonalities[CurrentPersonalityNr].teleport_percent = value;
		}
		else if (strcmp(cmd, "swoop_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].swoop_percent = value;
		}
		else if (strcmp(cmd, "beamexplode_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].beamexplode_percent = value;
		}
		else if (strcmp(cmd, "fly_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].fly_percent = value;
		}
		else if (strcmp(cmd, "stopfly_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].stopfly_percent = value;
		}
		else if (strcmp(cmd, "jump_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].jump_percent = value;
		}
		else if (strcmp(cmd, "block_percent") == 0)
		{
			if ((value <= 100) && (value >= 0))
				BotPersonalities[CurrentPersonalityNr].block_percent = value;
		}

	    else if (FStrEq(cmd, "aggression_level"))
		{
			if (FStrEq(arg1,"defensive"))
				BotPersonalities[CurrentPersonalityNr].aggression_level = Defensive;
			else if (FStrEq(arg1,"normal"))
				BotPersonalities[CurrentPersonalityNr].aggression_level = Normal;
			else if (FStrEq(arg1,"aggressive"))
				BotPersonalities[CurrentPersonalityNr].aggression_level = Aggressive;
		}
		else if (strcmp(cmd, "transkiller") == 0)
		{
			if ((value == 0) || (value == 1))
				BotPersonalities[CurrentPersonalityNr].transkiller = (value == 1) ? true : false;
		}
	}
	(*g_engfuncs.pfnServerPrint) ("done\n");
}

// make random personalities
void CBotManager::MakeRandomPersonalities()
{
	for (int count=0;count<9;count++)
	{
		BotPersonalities[count].melee_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].kiblast_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].lightbeam_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].mediumbeam_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].heavybeam_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].disc_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].laser_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].heavyprojectile_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].kametorp_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].solarflare_percent = RANDOM_LONG(0, 100);

		BotPersonalities[count].meleecombo_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].meleekick_percent = RANDOM_LONG(0, 100);

		BotPersonalities[count].chat_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].taunt_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].whine_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_tag_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_lower_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_drop_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].chat_swap_percent = RANDOM_LONG(0, 100);

		BotPersonalities[count].teleport_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].swoop_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].beamexplode_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].fly_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].stopfly_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].jump_percent = RANDOM_LONG(0, 100);
		BotPersonalities[count].block_percent = RANDOM_LONG(0, 100);

		switch (RANDOM_LONG(0, 2))
		{
		case 0:
			BotPersonalities[count].aggression_level = Defensive;
			break;
		case 1:
			BotPersonalities[count].aggression_level = Normal;
			break;
		case 2:
			BotPersonalities[count].aggression_level = Aggressive;
			break;
		}

		if (RANDOM_LONG(0, 1))
			BotPersonalities[count].transkiller = true;
		else
			BotPersonalities[count].transkiller = false;
	}
}

#endif