#ifndef bot_personality_h
#define bot_personality_h

#include "bot.h"

struct BotPersonality_t
{
	// weapon use percents
	short int melee_percent; // used for melee and sword
	short int kiblast_percent; // used for kiblast and renzoku
	short int lightbeam_percent; // used for genericbeam and burning attack
    short int mediumbeam_percent; // used for masenko and powerbeam
	short int heavybeam_percent; // used for kame,gallit gun,mouthblast etc
	short int disc_percent; // used for discs
	short int laser_percent; // used for eye-laser and fingerlaser
	short int heavyprojectile_percent; // used for bb,sb and finishing buster
	short int kametorp_percent; // used for kame torpedo's
	short int solarflare_percent; // percent that a bot will blind his enemy when in danger

	// melee related percents
	short int meleecombo_percent; // percent that a bot will perform a combo instead of a throw
	short int meleekick_percent; // percent that a bot will use secondary fire in a swoop to 
                                 // kick enemys

	// chat percents
	short int chat_percent; // percent of time to chat
    short int taunt_percent; // percent of time to taunt after kill
    short int whine_percent; // percent of time to whine after death
    short int chat_tag_percent; // percent of the time to drop clan tag
    short int chat_drop_percent; // percent of the time to drop characters
    short int chat_swap_percent; // percent of the time to swap characters
    short int chat_lower_percent; // percent of the time to lowercase chat

	// other percent(s)
	short int teleport_percent; // percent that the bot will teleport
	short int swoop_percent; // percent that a bot will swoop away to avoid danger
	short int beamexplode_percent; // percent that a bot will let a beam explode in 
								   // their enemy's face
	short int fly_percent; // how much will a bot fly ?
	short int stopfly_percent; // how much will a bot stop with flying(for a while) to avoid danger ?
	short int jump_percent; // percent that a bot will avoid danger by jumping when on the ground
	short int block_percent; // percent that a bot will avoid danger by blocking

	AggressionLevel_e aggression_level; // defensive, normal or aggressive

	bool transkiller; // does the bot still attack his enemy when he ascends ?
};

void MakePersonalities(void);
void MakeRandomPersonalities(void);

#endif // bot_personality.h