#include "general_header.h"

extern ClientInfo_t ClientInfo[32];
extern edict_t *listenserver_edict;
extern bool BotDontSearchEnemy;
extern bool b_botdontshoot;
extern SBotSettings_t SBotSettings[3];
extern BotPersonality_t BotPersonalities[9];

#ifdef _DEBUG
extern unsigned long MeleeCalls;
#endif

//////////////////////////////////////////////////////////////////
// Danger reaction code of bot tasks BEGIN
//////////////////////////////////////////////////////////////////

bool CPowerUpTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	short MinKiLevel = 990;

	if (pDangerInfo->DangerValue <= DANGER_MEDIUM_MAX_VAL)
		MinKiLevel = 100; // hurry up
	else
		MinKiLevel = 20;

	if (pBot->bot_ki >= MinKiLevel)
	{
		TaskState = done;
		return true;
	}

	return false;
}

bool CTeleportTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if (pDangerInfo->DangerValue >= DANGER_HEAVY_MIN_VAL)
		pBot->teleport_delay = 0.0;
	else if (pDangerInfo->DangerValue >= DANGER_HARD_MIN_VAL)
	{
		if ((pBot->teleport_delay - gpGlobals->time) > 0.1)
			pBot->teleport_delay = gpGlobals->time + 0.1;
	}

	return false;
}

bool CAscendTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if (pBot->DangerType == DangerEnemy)
		return false;

	if (pDangerInfo->DangerValue <= DANGER_MEDIUM_MIN_VAL)
		return false;

	if (pBot->DangerType == DangerHit)
	{
		float DangerousDamage = pBot->DamageTaken * 2.0f;

		if (pBot->AggressionLevel == Defensive)
			DangerousDamage *= 1.25f;
		else if (pBot->AggressionLevel == Aggressive)
			DangerousDamage *= 0.75f;

		if (pEdict->v.health < DangerousDamage)
			return false;
	}

	float MaxTimeLeftToStop = 2.0;

	if (pBot->AggressionLevel == Defensive)
		MaxTimeLeftToStop *= 1.25;
	else if (pBot->AggressionLevel == Aggressive)
		MaxTimeLeftToStop *= 0.75;

	if ((pBot->AscendTime - gpGlobals->time) > MaxTimeLeftToStop)
	{
		FakeClientCommand(pEdict,"descend",NULL,NULL);
		// Don't check for ascending for a while
		pBot->LastAscendCheck = gpGlobals->time + RANDOM_FLOAT(10.0f, 25.0f);
		return true;
	}

	return false;
}

bool CChargeAttackTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if (pDangerInfo->DangerValue >= DANGER_MEDIUM_MIN_VAL)
	{
		if (RANDOM_LONG(1, 100) <= pBot->TeleportPercent)
		{
			bool GoTeleport = false;

			if (pBot->ChargeBeamVal > 0)
			{
				if (pEdict->v.playerclass == 2)
				{
					char model[32] = "";
					UTIL_GetModel(pEdict, model);
					if (FStrEq(model, "ssjgoku"))
						GoTeleport = true;
				}
			}
			else
				GoTeleport = true;

			if (GoTeleport)
			{
				FakeClientCommand(pEdict, "teleport", NULL, NULL);
				return false;
			}
		}
		
		if (BotShouldFallDown(pBot))
		{
			if (pEdict->v.gravity < 0.1)
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);

			pBot->ShouldFly = false;
			pBot->CheckFlyDelay = gpGlobals->time + RANDOM_FLOAT(0.8, 1.2);
			return false;
		}
		
		if (pBot->ChargeBeamVal >= 33)
		{
			if ((AttackIsBeamJumpable(pBot->charging_weapon_id, (pBot->f_secondary_charging > 0.0))) &&
				(pDangerInfo->DangerValue < DANGER_HARD_MIN_VAL) && (BotCanBeamJump(pBot, false)))
			{
				pBot->TaskAfterTask = TaskBeamJump;
				TaskState = done;
				pEdict->v.button |= IN_ATTACK; // Otherwise the beam will be released
				return false;
			}

			bool AttackHeadsToBot = false;

			if ((pBot->pBotEnemy) && (pBot->DangerType == DangerAttack))
			{
//				edict_t *pEnemyAttack = GetAttackFromPlayer(pBot->pBotEnemy);

				edict_t *pEnemyAttack = pAttackManager->SearchLastAttack(pBot->pBotEnemy);

				if (pEnemyAttack)
				{
					if (EntityHeadsToPlayer(pEdict, pEnemyAttack))
					{
						AttackHeadsToBot = true;
						// stop charging...

						// set next time to shoot
						pBot->f_shoot_time = AddShootDelay(pBot);

						if (RANDOM_LONG(1, 100) <= 
							BotPersonalities[pBot->Personality].beamexplode_percent)
							pBot->LetBeamExplode = true;
						else
							pBot->LetBeamExplode = false;

						pBot->TaskAfterTask = TaskControlBeam;
						TaskState = done;

						// Aim at the attack
						pBot->AimVec = WrapAngles(UTIL_VecToAngles(pEnemyAttack->v.origin - pEdict->v.origin));
					}
				}
			}
			
			if ((AttackHeadsToBot) || (pDangerInfo->DangerValue < DANGER_HARD_MIN_VAL))
				return false;

			// Charging attack is a beam?
			if (AttackIsBeam(pBot->charging_weapon_id, (pBot->f_secondary_charging > 0.0)))
			{
				// Switch to melee or sword, otherwise the attack will be releashed
				if (pEdict->v.playerclass == 7)
					UTIL_SelectItem(pEdict, "weapon_sword");
				else
					UTIL_SelectItem(pEdict, "weapon_melee");
			}
		}
		return true;
	}
	return false;
}

bool CShootNonChargebleTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if (pDangerInfo->DangerValue >= DANGER_MEDIUM_MIN_VAL)
	{
		if (RANDOM_LONG(1, 100) <= pBot->TeleportPercent)
		{
			FakeClientCommand(pEdict, "teleport", NULL, NULL);
			return false;
		}
		
		if ((pDangerInfo->DangerValue <= DANGER_MEDIUM_MAX_VAL) && (BotShouldFallDown(pBot)))
		{
			if (pEdict->v.gravity < 0.1)
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);

			pBot->ShouldFly = false;
			pBot->CheckFlyDelay = gpGlobals->time + RANDOM_FLOAT(0.8, 1.2);
			return false;
		}
		
		return true;
	}
	return false;
}

bool CShootScatterShotsTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if (pDangerInfo->DangerValue >= DANGER_MEDIUM_MIN_VAL)
	{
		if (RANDOM_LONG(1, 100) <= pBot->TeleportPercent)
		{
			FakeClientCommand(pEdict, "teleport", NULL, NULL);
			return false;
		}
		
		if ((pDangerInfo->DangerValue <= DANGER_MEDIUM_MAX_VAL) && (BotShouldFallDown(pBot)))
		{
			if (pEdict->v.gravity < 0.1)
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);

			pBot->ShouldFly = false;
			pBot->CheckFlyDelay = gpGlobals->time + RANDOM_FLOAT(0.8, 1.2);
			return false;
		}
		
		return true;
	}
	return false;
}

bool CControlBeamTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if (pDangerInfo->DangerValue < DANGER_MEDIUM_MIN_VAL)
		return false;

	edict_t *pAttack = pAttackManager->SearchLastAttack(pEdict);
	if (!pAttack) // Shouldn't happen
	{
		pEdict->v.button |= IN_ATTACK2;
		return true;
	}

	Vector v_src = pEdict->v.origin; 
	Vector v_attack = pAttack->v.origin;
	float BotToAttackDist = UTIL_Distance(v_src, v_attack);
	float MinExplodeAttackDist = (pAttack->v.dmg * 11.0f);

	if ((pBot->pBotEnemy) && (pBot->DangerType == DangerAttack))
	{
		edict_t *pEnemyAttack = pAttackManager->SearchLastAttack(pBot->pBotEnemy);
		if (pEnemyAttack)
		{
			if (AttacksWillCollide(pAttack, pEnemyAttack))
			{

				pBot->AimVec = WrapAngles(UTIL_VecToAngles(pEnemyAttack->v.origin - pEdict->v.origin));
				BotShouldAimAtAttack = true;
				return false;
			}
		}
	}

	if (pDangerInfo->DangerValue < DANGER_HEAVY_MIN_VAL)
	{
		if (BotCanBeamJump(pBot, true))
		{
			pBot->TaskAfterTask = TaskBeamJump;
			TaskState = done;
			return false;
		}
		else if ((BotToAttackDist > MinExplodeAttackDist) &&
			     (pDangerInfo->DangerValue >= DANGER_HARD_MIN_VAL))
		{
			pEdict->v.button |= IN_ATTACK2;
			return true;
		}
	}
	else
	{
		pEdict->v.button |= IN_ATTACK2;
		return true;
	}

	return false;
}

bool CRecoverHPTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	int MinHealth = 140;

	if (pDangerInfo->DangerValue < DANGER_MEDIUM_MIN_VAL)
		MinHealth = 120;
	else if (pDangerInfo->DangerValue <= DANGER_MEDIUM_MAX_VAL)
		MinHealth = 30;
	else
		MinHealth = 0;

	MinHealth -= (100-((pBot->bot_ki/1000)*100));

	if (pEdict->v.health >= MinHealth)
		return true;

	return false;
}

bool CWallJumpTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if ((pDangerInfo->DangerValue >= DANGER_HEAVY_MIN_VAL) && (pBot->DangerType != DangerEnemy) &&
		(pBot->DangerType != DangerCurrentEnemy))
	{
		if ((pBot->pBotClient->WallJumps) || (pBot->pBotClient->ChargesWallJump))
		{
			if (pBot->pBotClient->WallJumps)
			{
				if (RANDOM_LONG(1, 100) <= pBot->TeleportPercent)
				{
					FakeClientCommand(pEdict, "teleport", NULL, NULL);
					return false;
				}
			}
			else
				if (StartChargingTime > (gpGlobals->time - 0.25f))
					return false;

			return true;
		}
	}
	return false;
}

bool CKameTorpTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if ((pDangerInfo->DangerValue >= DANGER_HARD_MIN_VAL) &&
		(pDangerInfo->DangerValue <= DANGER_HARD_MAX_VAL))
		
	{
		pEdict->v.button |= IN_ATTACK2;
		return false;
	}

	if (pDangerInfo->DangerValue < DANGER_MEDIUM_MIN_VAL)
		DesiredTorpCount = 3;
	else if (pDangerInfo->DangerValue <= DANGER_MEDIUM_MAX_VAL)
		DesiredTorpCount = 1;
	else
	{
		pEdict->v.button |= IN_ATTACK2;
		return true;
	}

	return false;
}

bool CBeamJumpTask::ReactOnDanger(SDangerInfo *pDangerInfo)
{
	if ((pDangerInfo->DangerValue >= DANGER_HEAVY_MIN_VAL) &&
		(pBot->pBotClient->BeamJumps == false))
	{
#ifdef _DEBUG
		lcout << "Beamjump danger\n";
#endif
		if (pBot->pBotClient->ChargeBeamVal)
		{
			// Switch to another attack so the beam won't be released
			if (pEdict->v.playerclass == 7)
				UTIL_SelectItem(pEdict, "weapon_sword");
			else
				UTIL_SelectItem(pEdict, "weapon_melee");
		}
		else
			pEdict->v.button |= IN_ATTACK2;

		return true;
	}
	
	return false;
};
//////////////////////////////////////////////////////////////////
// Danger reaction code of bot tasks END
//////////////////////////////////////////////////////////////////

char *ChargeLightBeamSounds[] = 
{
	"weapons/basicbeam_charge.wav", 
	"weapons/burning_charge.wav",

	//terminator
	0
};
	
char *ChargeMediumBeamSounds[] = 
{
	"piccolo/masenko.wav",
	"gohan/powerbeam.wav",

	//terminator
	0
};

char *ChargeBigBeamSounds[] =
{
	"cell/gallitgun.wav", 
	"cell2/gallitgun.wav", 
	"vegeta/gallitgun.wav", 
	"cell/kamehame.wav", 
	"celll2/kamehame.wav", 
	"gohan/kamehame.wav", 
	"goku/kamehame.wav",

	//terminator
	0
};

char *ChargeNonBeamSounds[] =
{
	"weapons/sbc_charge.wav",
	"weapons/deathball_charge.wav",
    "goku/spiritbomb_charge.wav",
	"goku/spiritbomb2_charge.wav",
	"vegeta/bigbang_charge.wav",

	//terminator
	0
};

char *LaserSounds[] =
{
	"weapons/fingerlaser.wav",
	"weapons/candyattack.wav",
	"weapons/eyebeam_fire.wav",

	//terminator
	0
};

bool DangerousPlForBot(bot_t *pBot, long EnemyPl)
{
	long DangerousPl = EnemyPl;

	if (pBot->AggressionLevel == Defensive) // its really soon dangerous
		DangerousPl -= RANDOM_LONG(100000, 250000);
	else if (pBot->AggressionLevel == Normal)
		DangerousPl -= RANDOM_LONG(550000, 1000000);
	else if (pBot->AggressionLevel == Aggressive)
		DangerousPl -= RANDOM_LONG(750000, 1250000);

	return (pBot->PL < DangerousPl);
}

SoundType_e ClassifySound(char *AttackName)
{
	if (!AttackName)
		return NoInterestingSound;

	short count = 0;

	while (LaserSounds[count] != 0)
	{
		if (FStrEq(AttackName, LaserSounds[count]))
			return LaserSound;

		count++;
	}

	return NoInterestingSound;
/*
	while (ChargeLightBeamSounds[count])
	{
		if (FStrEq(AttackName, ChargeLightBeamSounds[count]))
			return ChargingLightBeam;

		count++;
	}

	count = 0;
	while (ChargeMediumBeamSounds[count])
	{
		if (FStrEq(AttackName, ChargeMediumBeamSounds[count]))
			return ChargingMediumBeam;

		count++;
	}

	count = 0;
	while (ChargeBigBeamSounds[count])
	{
		if (FStrEq(AttackName, ChargeBigBeamSounds[count]))
			return ChargingBigBeam;

		count++;
	}

	count = 0;
	while (ChargeNonBeamSounds[count])
	{
		if (FStrEq(AttackName, ChargeNonBeamSounds[count]))
			return ChargingNonBeam;

		count++;
	}

	count = 0;*/
}

EAttackType ClassifyAttack(const char *szAttackName)
{
	if ((FStrEq(szAttackName,"kiblast")) || (FStrEq(szAttackName,"scattershot")) ||
		(FStrEq(szAttackName,"renzoku")))
		return AttackKiblast;

	if ((FStrEq(szAttackName,"blueattack")) || (FStrEq(szAttackName,"burningattack")) ||
	    (FStrEq(szAttackName,"greenattack")) || (FStrEq(szAttackName,"purpleattack")) ||
		(FStrEq(szAttackName,"yellowattack")))
		return AttackLightBeam;

	if ((FStrEq(szAttackName,"masenko")) || (FStrEq(szAttackName,"powerbeam")))
		return AttackMediumBeam;
 
	if ((FStrEq(szAttackName,"kamehameha")) || (FStrEq(szAttackName,"gallitgun")) ||
		(FStrEq(szAttackName,"mouthblast")) || (FStrEq(szAttackName,"finalflash")))
		return AttackHeavyBeam;

	if ((FStrEq(szAttackName,"bigbang")) || (FStrEq(szAttackName,"finishingbuster")) ||
		(FStrEq(szAttackName,"Spirit Bomb")) || (FStrEq(szAttackName,"Special Beam Cannon")) ||
		(FStrEq(szAttackName,"Death Ball")) || (FStrEq(szAttackName,"shieldattack")) ||
		(FStrEq(szAttackName,"Kame Torpedo")) || (FStrEq(szAttackName,"Scattering Beam")))
		return AttackHeavyProjectile;

	if ((FStrEq(szAttackName,"Destructo Disc")) || (FStrEq(szAttackName,"Frieza Disc")))
		return AttackDisc;
				
	if (FStrEq(szAttackName,"rock"))
		return AttackTelekinesis;

	return AttackNone;
}

// Gives the time before entity2 reaches entity1, delay will be added when entity2 does not head
// straight forward
float TimeEntityReachesEntity(edict_t *pEntity1, edict_t *pEntity2)
{
	Vector v_src1 = pEntity1->v.origin;
	Vector v_src2 = pEntity2->v.origin;
	Vector v_predict = PredictEntityPos(pEntity2, 1.0);
	Vector v_straight;

	UTIL_MakeVectors(pEntity1->v.angles);
	v_straight = v_src1 + gpGlobals->v_forward * pEntity2->v.velocity.Length();

	float DistEnt1ToEnt2 = UTIL_Distance(v_src1, v_src2);
	float PredictDist = UTIL_Distance(v_src1, v_predict);
	float StraightDist = UTIL_Distance(v_src1, v_straight); 
	float NormalTime = (DistEnt1ToEnt2 / pEntity2->v.velocity.Length());

	return NormalTime + ((PredictDist - StraightDist)/10.0);
}

void SenseSurroundingAttacks(bot_t *pBot, SDangerInfo &DangerInfo)
{
	// Declare some shortcuts...
	edict_t *pEdict = pBot->pEdict;
	edict_t *pAttack;
	Vector v_end;

	float flDist;
	ClientInfo_t *pClient;
	EAttackType AttackType;

	short HeadPercent;

	short AttackVal;
	short HighestAttackVal = 0;
	
	float TeleVal, SwoopVal, BlockVal, JumpVal, FallDownVal;

	byte DangerHeadPercent = MIN_DANGER_HEAD_PERCENT;

	if (pBot->AggressionLevel == Defensive)
		DangerHeadPercent *= 0.85f;
	else if (pBot->AggressionLevel == Aggressive)
		DangerHeadPercent *= 1.2;

	CAttackManager::TAttackListNode *pNode = NULL;
	bool CheckOnlyFOV = (pBot->bot_skill > 0);

	while ((pNode = pAttackManager->GetNextHostileAttack(pNode, pEdict, CheckOnlyFOV)) != NULL)
	{
		pAttack = pNode->Entry->pAttack; // Shortcut

		if ((IsTeamPlay()) && (IsNull(pAttack->v.owner) == false))
		{
			if (pAttack->v.owner->v.team == pEdict->v.team)
			{
				continue;
			}
		}

		if (pAttack->v.velocity.Length() < 10.0f)
			continue; // Attack is not scary

		HeadPercent = UTIL_GetHeadingPercentage(pEdict, pAttack);

		if (HeadPercent < DangerHeadPercent)
			continue;

		v_end = pAttack->v.origin;
		flDist = UTIL_Distance(pEdict->v.origin, v_end);

		if (flDist > 2000.0f)
			continue;

		if ((flDist > 250.0f) && (!FInViewCone(&v_end, pEdict)))
			continue;

		// Can the bot 'see' the attack?
		if (FVisible(pAttack->v.origin, pEdict) == false)
			continue; // Nope

		// hmm okay we found an attack wich might be hostile... now determine how hostile it is

		// Reset all temp vars
		AttackVal = 0;
		TeleVal = pBot->TeleportPercent;
		SwoopVal = pBot->SwoopPercent;
		BlockVal = BotPersonalities[pBot->Personality].block_percent;
		JumpVal = BotPersonalities[pBot->Personality].jump_percent;
		FallDownVal = BotPersonalities[pBot->Personality].stopfly_percent;

		// First look how close this attack is
		if (flDist < 150.0f) // Argh
		{
			AttackVal += 160;
			TeleVal *= 1.7f;
			SwoopVal *= 0.01f;
			BlockVal *= 1.5f;
			JumpVal *= 0.01f;
			FallDownVal *= 0.01f;
		}
		else if (flDist < 350.0f)
		{
			AttackVal += 145;
			TeleVal *= 1.5f;
			SwoopVal *= 0.02f;
			BlockVal *= 1.15f;
			JumpVal *= 0.1f;
			FallDownVal *= 0.1f;
		}
		else if (flDist < 500.0f)
		{
			AttackVal += 125;
			TeleVal *= 1.25f;
			SwoopVal *= 0.15f;
			JumpVal *= 0.3f;
			FallDownVal *= 0.15f;
		}
		else if (flDist < 750.0f)
		{
			AttackVal += 100;
			TeleVal *= 1.1f;
			SwoopVal *= 0.30f;
			BlockVal *= 0.95f;
			JumpVal *= 0.55f;
			FallDownVal *= 0.2f;
		}
		else if (flDist < 875.0f)
		{
			AttackVal += 85;
			SwoopVal *= 0.5f;
			BlockVal *= 0.95f;
			JumpVal *= 0.7f;
			FallDownVal *= 0.4f;
		}
		else if (flDist < 1000.0f)
		{
			AttackVal += 75;
			SwoopVal *= 0.85f;
			BlockVal *= 0.9f;
			FallDownVal *= 0.75f;
		}
		else if (flDist < 1250.0f)
		{
			AttackVal += 60;
			BlockVal *= 0.8f;
			JumpVal *= 0.85f;
		}
		else if (flDist < 2000.0f)
		{
			AttackVal += 25;
			TeleVal *= 0.95f;
			SwoopVal *= 1.05f;
			BlockVal *= 0.3f;
			JumpVal *= 0.5f;
			FallDownVal *= 1.05f;
		}

		// Now determine how much stronger the owner of this attack is
		pClient = UTIL_GetClientPointer(pAttack->v.owner);
		if (pClient)
		{
			// Determine the pl difference between the owner and the bot
			long PlDiff = pClient->PL - pBot->PL;

			if (PlDiff > 5000000)
			{
				AttackVal += 75;
				TeleVal *= 1.75f;
				BlockVal *= 0.01f;
				JumpVal *= 0.9f;
				FallDownVal *= 0.9f;
			}
			else if (PlDiff > 3000000)
			{
				AttackVal += 65;
				TeleVal *= 1.55f;
				BlockVal *= 0.01f;
				JumpVal *= 0.95f;
				FallDownVal *= 0.95f;
			}
			else if (PlDiff > 2500000)
			{
				AttackVal += 55;
				TeleVal *= 1.2f;
				BlockVal *= 0.01f;
			}
			else if (PlDiff > 1750000)
			{
				AttackVal += 35;
				BlockVal *= 0.1f;
			}
			else if (PlDiff > 1250000)
			{
				AttackVal += 20;
				BlockVal *= 0.45f;
			}
			else if (PlDiff > 800000)
			{
				AttackVal += 10;
				BlockVal *= 0.75f;
			}
		}
		
		// Now determine how much damage this attack has
		if (pAttack->v.dmg > 125.0f)
		{
			AttackVal += 40;
			TeleVal *= 1.75f;
			SwoopVal *= 0.9f;
			BlockVal *= 0.25f;
			JumpVal *= 0.9f;
			FallDownVal *= 0.9f;
		}
		else if (pAttack->v.dmg > 85.0f)
		{
			AttackVal += 25;
			TeleVal *= 1.45f;
			BlockVal *= 0.5f;
		}
		else if (pAttack->v.dmg > 65.0f)
		{
			AttackVal += 10;
			TeleVal *= 1.2f;
			BlockVal *= 0.8f;
		}
		else if (pAttack->v.dmg > 40.0f)
		{
			AttackVal += 4;
		}

		if (pAttack->v.dmg > pEdict->v.health)
		{
			AttackVal += 60;
			TeleVal *= 1.45f;
			BlockVal *= 0.5f;
		}


		// Okay, now how much health has this bot?
		if (pEdict->v.health < 10)
		{
			AttackVal += 45;
			TeleVal *= 1.55f;
			SwoopVal *= 0.9f;
			BlockVal *= 0.01f;
			JumpVal *= 0.8f;
			FallDownVal *= 0.75f;
		}
		else if (pEdict->v.health < 25)
		{
			AttackVal += 25;
			TeleVal *= 1.25f;
			SwoopVal *= 0.95f;
			BlockVal *= 0.05f;
			JumpVal *= 0.95f;
			FallDownVal *= 0.9f;
		}
		else if (pEdict->v.health < 35)
		{
			AttackVal += 10;
			BlockVal *= 0.05f;
		}

		// Now see how 'much' this attack heads to the bot
		if (HeadPercent < 90)
			AttackVal -= 35;
		else if (HeadPercent < 95)
			AttackVal -= 12;

		// What is this for attack type?
		AttackType = ClassifyAttack(STRING(pAttack->v.classname));

		if (AttackType == AttackKiblast)
		{
			AttackVal -= 70;
			TeleVal *= 0.35f;
			SwoopVal *= 0.35f;
			BlockVal *= 1.75f;
			JumpVal *= 0.80f;
		}
		else if (AttackType == AttackLightBeam)
		{
			AttackVal -= 50;
			TeleVal *= 0.85f;
			SwoopVal *= 0.85f;
			BlockVal *= 1.25f;
			JumpVal *= 0.85f;
			FallDownVal *= 0.85f;
		}
		else if (AttackType == AttackMediumBeam)
		{
			AttackVal -= 35;
			SwoopVal *= 0.95f;
			BlockVal *= 0.95f;
		}
		else if (AttackType == AttackHeavyBeam)
		{
			TeleVal *= 1.1f;
			SwoopVal *= 1.1f;
			BlockVal *= 0.75f;
		}
		else if (AttackType == AttackHeavyProjectile)
		{
			TeleVal *= 1.1f;
			SwoopVal *= 1.15f;
			BlockVal *= 0.65f;
		}
		else if (AttackType == AttackDisc)
		{
			AttackVal += 5;
			TeleVal *= 1.25f;
			SwoopVal *= 0.85f;
			BlockVal = 0.0f;
			JumpVal *= 0.95f;
			FallDownVal *= 0.95f;
		}
		else if (AttackType == AttackTelekinesis)
		{
			TeleVal *= 1.25f;
			BlockVal = 0.0f;
		}

		if (pBot->AggressionLevel == Aggressive)
			AttackVal *= 0.85f;
		else if (pBot->AggressionLevel == Defensive)
			AttackVal *= 1.25f;

		// Yay done determinging how hostile the attack is....

		// Well was it hostile?
		if (AttackVal < DANGER_LIGHT_MIN_VAL)
			continue; // Nope :-)

		if (AttackVal > HighestAttackVal)
		{
			HighestAttackVal = AttackVal;
			DangerInfo.TeleVal = TeleVal;
			DangerInfo.SwoopVal = SwoopVal;
			DangerInfo.BlockVal = BlockVal;
			DangerInfo.JumpVal = JumpVal;
			DangerInfo.StopFlyVal = FallDownVal;
			DangerInfo.pMostDangerousEnt = pAttack;
		}
		DangerInfo.DangerValue += AttackVal;
	}

	if (DangerInfo.DangerValue > DANGER_HEAVY_MIN_VAL) // If it is this high, then there are multiple dangerous attacks...
	{
//		DangerInfo.DangerValue += 75;
		DangerInfo.TeleVal *= 1.75f;
		DangerInfo.SwoopVal *= 1.55f;
		DangerInfo.BlockVal *= 0.01f;
		DangerInfo.JumpVal *= 0.5f;
		DangerInfo.StopFlyVal *= 0.5f;
	}
	else if (DangerInfo.DangerValue > 200)
	{
//		DangerInfo.DangerValue += 55;
		DangerInfo.TeleVal *= 1.5f;
		DangerInfo.SwoopVal *= 1.25f;
		DangerInfo.BlockVal *= 0.25f;
		DangerInfo.JumpVal *= 0.75f;
		DangerInfo.StopFlyVal *= 0.75f;
	}
	else if (DangerInfo.DangerValue > 175)
	{
//		DangerInfo.DangerValue += 25;
		DangerInfo.TeleVal *= 1.25f;
		DangerInfo.SwoopVal *= 1.1f;
		DangerInfo.BlockVal *= 0.35f;
		DangerInfo.JumpVal *= 0.9f;
		DangerInfo.StopFlyVal *= 0.9f;
	}
	else if (DangerInfo.DangerValue > 150)
	{
//		DangerInfo.DangerValue += 10;
		DangerInfo.TeleVal *= 1.02f;
		DangerInfo.SwoopVal *= 1.02f;
		DangerInfo.BlockVal *= 0.75f;
	}

	DangerInfo.MayUseSolar = DangerInfo.MayUseMelee = false;
	DangerInfo.MayUseSBotLaser = true;
}

void SenseSurroundingPlayers(bot_t *pBot, SDangerInfo &DangerInfo)
{
	// Declare some shortcuts...
	edict_t *pEdict = pBot->pEdict;
	edict_t *pPlayer;
	Vector v_src = pEdict->v.origin;
	Vector v_end;

	float flDist;
	ClientInfo_t *pClient;
	short HeadPercent;
	bool JustMadeASound;
	bool InViewCone;

	short EnemyVal;
	short HighestEnemyVal = 0;
	float TeleVal, SwoopVal, BlockVal, JumpVal, FallDownVal;

	if (!pBot->MadePlayerList)
		MakePlayerList(pBot);

	if (pBot->PlayerCount == 0)
		return;

	byte DangerHeadPercent = MIN_DANGER_HEAD_PERCENT;

	if (pBot->AggressionLevel == Defensive)
		DangerHeadPercent *= 0.85f;
	else if (pBot->AggressionLevel == Aggressive)
		DangerHeadPercent *= 1.2;

	for (byte b=0;b<pBot->PlayerCount;b++)
	{
		pPlayer = pBot->PlayerList[b];

		if ((IsTeamPlay()) && (pPlayer->v.team == pEdict->v.team))
			continue;

		v_end = pPlayer->v.origin;
		flDist = UTIL_Distance(pEdict->v.origin, v_end);

		if (flDist > 2000.0f)
			continue;

		HeadPercent = UTIL_GetHeadingPercentage(pEdict, pPlayer);
//		rcout << "HeadPercent: " << HeadPercent << "\n";

		pClient = UTIL_GetClientPointer(pPlayer);
		if (!pClient) // Shouldn't happen
		{
#ifdef _DEBUG
			lcout << "Couldn't get client pointer in SenseSurroundingPlayers()!\n";
#endif
			continue;
		}

		JustMadeASound = ((pClient->LastSoundTime > (gpGlobals->time - 1.0)) &&
						  (pClient->SoundName[0] != 0) && (flDist < 3000.0f));

		InViewCone = (FInViewCone(&v_end, pEdict));

		if ((!InViewCone) && (!JustMadeASound))
			continue;

		// Is this enemy 'busy'?(ie charging a combo, powerstruggling)
		if ((pClient->Ascends) || (pClient->IsInMeleeMode) || (pClient->MeleeStruggles) ||
			(pClient->IsStuckAgainstWall) || (pClient->LaysOnGround) || (pClient->FlysAfterHit) ||
			(pClient->IsAutoPunching) || (pClient->GetAutoPunched) || (pClient->Powerstruggles))
			continue; // Player can't attack the bot so isn't hostile


		// hmm okay we found a player wich might be hostile... now determine how hostile he/she is

		// Reset all temp vars
		EnemyVal = 0;
		TeleVal = pBot->TeleportPercent;
		SwoopVal = pBot->SwoopPercent;
		BlockVal = BotPersonalities[pBot->Personality].block_percent;
		JumpVal = BotPersonalities[pBot->Personality].jump_percent;
		FallDownVal = BotPersonalities[pBot->Personality].stopfly_percent;

		// Does this player swoop?(handle the danger stuff different)
		if (pClient->Swoops)
		{
			if (HeadPercent < DangerHeadPercent)
				continue;

			// First look how close this attack is
			if (flDist < 150.0f) // Argh
			{
				EnemyVal += 160;
				TeleVal *= 1.7f;
				SwoopVal *= 0.01f;
				BlockVal *= 1.1f;
				JumpVal *= 0.01f;
				FallDownVal *= 0.01f;
			}
			else if (flDist < 350.0f)
			{
				EnemyVal += 130;
				TeleVal *= 1.3f;
				SwoopVal *= 0.1f;
				BlockVal *= 0.75f;
				JumpVal *= 0.1f;
				FallDownVal *= 0.1f;
			}
			else if (flDist < 500.0f)
			{
				EnemyVal += 100;
				TeleVal *= 1.25f;
				SwoopVal *= 0.25f;
				BlockVal *= 0.3f;
				JumpVal *= 0.25f;
				FallDownVal *= 0.25f;
			}
			else if (flDist < 750.0f)
			{
				EnemyVal += 100;
				TeleVal *= 1.05f;
				SwoopVal *= 0.40f;
				BlockVal *= 0.1f;
				JumpVal *= 0.45f;
				FallDownVal *= 0.45f;
			}
			else if (flDist < 875.0f)
			{
				EnemyVal += 85;
				SwoopVal *= 0.5f;
				BlockVal *= 0.07f;
				JumpVal *= 0.6f;
				FallDownVal *= 0.6f;
			}
			else if (flDist < 1000.0f)
			{
				EnemyVal += 65;
				SwoopVal *= 0.85f;
				BlockVal *= 0.05f;
			}
			else if (flDist < 1250.0f)
			{
				EnemyVal += 35;
				TeleVal *= 0.9f;
				BlockVal *= 0.03f;
			}
			else if (flDist < 2000.0f)
			{
				EnemyVal += 15;
				TeleVal *= 0.75f;
				BlockVal *= 0.01f;
				JumpVal *= 0.5f;
				FallDownVal *= 0.5f;
			}

			// Now determine how much stronger the player is

			// Determine the pl difference between the owner and the bot
			long PlDiff = pClient->PL - pBot->PL;

			if (PlDiff > 3000000)
			{
				EnemyVal += 45;
				TeleVal *= 1.55f;
				BlockVal *= 0.01f;
				JumpVal *= 0.9f;
				FallDownVal *= 0.9f;
			}
			else if (PlDiff > 2500000)
			{
				EnemyVal += 30;
				TeleVal *= 1.45f;
				BlockVal *= 0.01f;
				JumpVal *= 0.95f;
				FallDownVal *= 0.95f;
			}
			else if (PlDiff > 1500000)
			{
				EnemyVal += 20;
				TeleVal *= 1.2f;
				BlockVal *= 0.02f;
			}
			else if (PlDiff > 800000)
			{
				EnemyVal += 10;
				BlockVal *= 0.2f;
			}
				
			// Okay, now how much health has the bot?
			if (pEdict->v.health < 10)
			{
				EnemyVal += 25;
				TeleVal *= 1.25f;
				SwoopVal *= 0.95f;
				BlockVal *= 0.01f;
				JumpVal *= 0.9f;
				FallDownVal *= 0.9f;
			}
			else if (pEdict->v.health < 25)
			{
				EnemyVal += 15;
				TeleVal *= 1.1f;
				BlockVal *= 0.05f;
			}
			else if (pEdict->v.health < 35)
			{
				EnemyVal += 10;
				BlockVal *= 0.15f;
			}

			// Now see how 'much' this player heads to the bot
			if (HeadPercent < 90)
				EnemyVal -= 12;
			else if (HeadPercent < 95)
				EnemyVal -= 5;
		}
		else if (FInViewCone(&v_src, pPlayer))
		{
			// First look how close this attack is
			if (flDist < 50.0f)
			{
				EnemyVal += 150;
				TeleVal *= 1.7f;
				SwoopVal *= 0.01f;
				BlockVal *= 0.1f;
				JumpVal *= 0.01f;
				FallDownVal *= 0.01f;
			}
			else if (flDist < 120.0f)
			{
				EnemyVal += 120;
				TeleVal *= 1.3f;
				SwoopVal *= 0.1f;
				BlockVal *= 0.01f;
				JumpVal *= 0.25f;
				FallDownVal *= 0.25f;
			}
			else if (flDist < 175.0f)
			{
				EnemyVal += 80;
				TeleVal *= 1.05f;
				SwoopVal *= 0.35f;
				BlockVal *= 0.01f;
				JumpVal *= 0.85f;
				FallDownVal *= 0.85f;
			}
			else if (flDist < 250.0f)
			{
				EnemyVal += 60;
				TeleVal *= 0.9f;
				SwoopVal *= 0.85f;
				BlockVal *= 0.01f;
			}
			else
				continue; // To far away

			// Now determine how much stronger the player is

			// Determine the pl difference between the owner and the bot
			long PlDiff = pClient->PL - pBot->PL;

			if (PlDiff > 3000000)
			{
				EnemyVal += 35;
				TeleVal *= 1.55f;
				BlockVal *= 0.01f;
				JumpVal *= 0.9f;
				FallDownVal *= 0.9f;
			}
			else if (PlDiff > 2500000)
			{
				EnemyVal += 25;
				TeleVal *= 1.45f;
				BlockVal *= 0.01f;
				JumpVal *= 0.95f;
				FallDownVal *= 0.95f;
			}
			else if (PlDiff > 1500000)
			{
				EnemyVal += 15;
				TeleVal *= 1.2f;
				BlockVal *= 0.02f;
			}
				
			// Okay, now how much health has the bot?
			if (pEdict->v.health < 10)
			{
				EnemyVal += 30;
				TeleVal *= 1.25f;
				SwoopVal *= 0.95f;
				BlockVal *= 0.01f;
				JumpVal *= 0.9f;
				FallDownVal *= 0.9f;
			}
			else if (pEdict->v.health < 25)
			{
				EnemyVal += 20;
				TeleVal *= 1.1f;
				BlockVal *= 0.05f;
			}
			else if (pEdict->v.health < 35)
			{
				EnemyVal += 10;
				BlockVal *= 0.15f;
			}

			// Now see how 'much' this player heads to the bot
			if (HeadPercent < 90)
				EnemyVal -= 25;
			else if (HeadPercent < 95)
				EnemyVal -= 10;
		}

		if (pBot->AggressionLevel == Aggressive)
			EnemyVal *= 0.85f;
		else if (pBot->AggressionLevel == Defensive)
			EnemyVal *= 1.25f;

		// Yay done determinging how hostile the player is....

		// Well was he/she hostile?
		if (EnemyVal < DANGER_LIGHT_MIN_VAL)
			continue; // Nope :-)

		if (EnemyVal > HighestEnemyVal)
		{
			HighestEnemyVal = EnemyVal;
			DangerInfo.TeleVal = TeleVal;
			DangerInfo.SwoopVal = SwoopVal;
			DangerInfo.BlockVal = BlockVal;
			DangerInfo.JumpVal = JumpVal;
			DangerInfo.StopFlyVal = FallDownVal;
			DangerInfo.pMostDangerousEnt = pPlayer;
		}
		DangerInfo.DangerValue += EnemyVal;
	}
	
	if (DangerInfo.DangerValue > DANGER_HEAVY_MIN_VAL) // If it is this high, then there are multiple dangerous players...
	{
//		DangerInfo.DangerValue += 75;
		DangerInfo.TeleVal *= 1.75f;
		DangerInfo.SwoopVal *= 1.55f;
		DangerInfo.BlockVal *= 0.01f;
		DangerInfo.JumpVal *= 0.5f;
		DangerInfo.StopFlyVal *= 0.5f;
	}
	else if (DangerInfo.DangerValue > 200)
	{
//		DangerInfo.DangerValue += 55;
		DangerInfo.TeleVal *= 1.5f;
		DangerInfo.SwoopVal *= 1.25f;
		DangerInfo.BlockVal *= 0.07f;
		DangerInfo.JumpVal *= 0.75f;
		DangerInfo.StopFlyVal *= 0.75f;
	}
	else if (DangerInfo.DangerValue > 175)
	{
//		DangerInfo.DangerValue += 25;
		DangerInfo.TeleVal *= 1.25f;
		DangerInfo.SwoopVal *= 1.1f;
		DangerInfo.BlockVal *= 0.15f;
		DangerInfo.JumpVal *= 0.9f;
		DangerInfo.StopFlyVal *= 0.9f;
	}
	else if (DangerInfo.DangerValue > 150)
	{
//		DangerInfo.DangerValue += 10;
		DangerInfo.TeleVal *= 1.02f;
		DangerInfo.SwoopVal *= 1.02f;
		DangerInfo.BlockVal *= 0.15f;
	}

	DangerInfo.MayUseSolar = DangerInfo.MayUseSBotLaser = DangerInfo.MayUseMelee = false;

	if (DangerInfo.pMostDangerousEnt)
	{
		flDist = UTIL_Distance(pEdict->v.origin, DangerInfo.pMostDangerousEnt->v.origin);
		DangerInfo.MayUseSolar = (flDist < 250.0f);
		DangerInfo.MayUseSBotLaser = (flDist > 350.0f);
		DangerInfo.MayUseMelee = (flDist < 1500.0f);
	}
}

void SenseSurroundingSounds(bot_t *pBot, SDangerInfo &DangerInfo)
{
	edict_t *pEdict = pBot->pEdict;
	edict_t *pPlayer;
	edict_t *pMostDangerousPlayer = NULL;
	Vector v_src = pEdict->v.origin;

	if (!pBot->MadePlayerList)
		MakePlayerList(pBot);

	float NearestDist = 9999.9;

	if (pBot->PlayerCount > 0)
	{
		ClientInfo_t *pClient;
		int SoundMakerVal;
		int BestSoundMakerVal = 0;
		float flDist = 0.0;
		TraceResult tr;

		for(int i=0;i<pBot->PlayerCount;i++)
		{
			SoundMakerVal = 1;

			pPlayer = pBot->PlayerList[i];

			// Skip team mates if team play is enabled
			if ((IsTeamPlay()) && (pPlayer->v.team == pEdict->v.team))
				continue;
			
			flDist = UTIL_Distance(pEdict->v.origin, pPlayer->v.origin);

			if (flDist > 3000.0)
				continue;

			Vector vecEnemy = pPlayer->v.origin;

			// since a scouter is 2d, calculate the distance in 2d :)
			Vector v_dist = vecEnemy - GetGunPosition(pBot->pEdict);
			v_dist.z = 0;
			float distance = v_dist.Length();

			bool OnScouter = ((distance <= 2300.0) || (pBot->SBotType > 0));
			bool InViewCone = (FInViewCone(&vecEnemy, pBot->pEdict));

			if ((!InViewCone) && (!OnScouter))
				continue;

			// Only check if player is facing the bot...
			UTIL_TraceLine(pPlayer->v.origin, pEdict->v.origin, dont_ignore_monsters, pPlayer, &tr);
			if (tr.pHit != pEdict)
				continue;
			
			pClient = UTIL_GetClientPointer(pPlayer);
			if (!pClient) // Shouldn't happen
			{
#ifdef _DEBUG
				lcout << "Couldn't get client pointer in SenseSurroundingSounds()!\n";
#endif
				continue;
			}

			if (pClient->LastSoundTime > gpGlobals->time)
			{
				SoundType_e SoundType = ClassifySound(pClient->SoundName);

				// Only avoid laser sounds
				if (SoundType == LaserSound)
				{
					// don't react on a candy beam when the distance is to high...
					if ((FStrEq(pClient->SoundName,"weapons/candyattack.wav")) &&
						(flDist > 300.0))
						continue;

					if (NearestDist > flDist)
					{
						NearestDist = flDist;
						SoundMakerVal++;
					}

					if (SoundMakerVal > BestSoundMakerVal)
					{
						BestSoundMakerVal = SoundMakerVal;
						pMostDangerousPlayer = pPlayer;
						break; // For now just break
					}
				}
			}
		}
	}

	if (pMostDangerousPlayer)
	{
		DangerInfo.DangerValue = 175;

		if (pBot->AggressionLevel == Aggressive)
			DangerInfo.DangerValue *= 0.85f;
		else if (pBot->AggressionLevel == Defensive)
			DangerInfo.DangerValue *= 1.25f;

		DangerInfo.TeleVal = static_cast<float>(pBot->TeleportPercent) * 1.75f;
		DangerInfo.SwoopVal = static_cast<float>(pBot->SwoopPercent) * 0.2f;
		DangerInfo.BlockVal = 0.01f;
		DangerInfo.JumpVal = static_cast<float>(BotPersonalities[pBot->Personality].jump_percent) * 0.3f;
		DangerInfo.StopFlyVal = static_cast<float>(BotPersonalities[pBot->Personality].stopfly_percent) * 0.3f;
		DangerInfo.pMostDangerousEnt = pMostDangerousPlayer;
		DangerInfo.MayUseSolar = DangerInfo.MayUseSBotLaser = DangerInfo.MayUseMelee = false;
	}
}

void SenseHit(bot_t *pBot, SDangerInfo &DangerInfo)
{
	if (pBot->LastHitTime > (gpGlobals->time - 0.5f))
	{
		DangerInfo.DangerValue = 175;

		if (pBot->AggressionLevel == Aggressive)
			DangerInfo.DangerValue *= 0.85f;
		else if (pBot->AggressionLevel == Defensive)
			DangerInfo.DangerValue *= 1.25f;

		DangerInfo.TeleVal = static_cast<float>(pBot->TeleportPercent) * 1.75f;
		DangerInfo.SwoopVal = static_cast<float>(pBot->SwoopPercent) * 0.2f;
		DangerInfo.BlockVal = 0.01f;
		DangerInfo.JumpVal = static_cast<float>(BotPersonalities[pBot->Personality].jump_percent) * 0.3f;
		DangerInfo.StopFlyVal = static_cast<float>(BotPersonalities[pBot->Personality].stopfly_percent) * 0.3f;

		edict_t *pEdict = pBot->pEdict; // Shortcut

		if (IsNull(pEdict->v.dmg_inflictor) == false)
		{
			if (pEdict->v.dmg_inflictor->v.flags & FL_CLIENT) // Bot hurt by a player?
				DangerInfo.pMostDangerousEnt = pEdict->v.dmg_inflictor;
			else if ((IsNull(pEdict->v.dmg_inflictor->v.owner) == false) &&
					 (pEdict->v.dmg_inflictor->v.owner->v.flags & FL_CLIENT))
				DangerInfo.pMostDangerousEnt = pEdict->v.dmg_inflictor->v.owner;
		}

		DangerInfo.MayUseSolar = DangerInfo.MayUseSBotLaser = DangerInfo.MayUseMelee = false;
		pBot->LastHitTime = 0.0f;
	}
}

// global bot sensing
void BotSenseNew(bot_t *pBot)
{
	edict_t *pEdict = pBot->pEdict;
	SDangerInfo AttacksDangerInfo, PlayersDangerInfo, SoundsDangerInfo, HitDangerInfo;
	SDangerInfo *pReactOnDangerInfo = NULL;

	int SenseChecks = 0;
	bool CheckEverything = false;

	if (pBot->CurrentBotTask)
		SenseChecks = pBot->CurrentBotTask->GetBotSenseChecks();
	else
		CheckEverything = true;

	// Reset danger vars
	pBot->DangerLevel = pBot->DangerType = 0;

	if ((SenseChecks == 0) && (!CheckEverything))
	{
		// Don't sense when the bot don't want to O_o
		return;
	}

	if ((SenseChecks & CheckAttacks) || (CheckEverything))
		SenseSurroundingAttacks(pBot, AttacksDangerInfo);

	if ((SenseChecks & CheckSurroundingPlayers) || (CheckEverything))
		SenseSurroundingPlayers(pBot, PlayersDangerInfo);

	if ((SenseChecks & CheckSounds) || (CheckEverything))
		SenseSurroundingSounds(pBot, SoundsDangerInfo);

	if ((SenseChecks & CheckAttacks) || (CheckEverything))
		SenseHit(pBot, HitDangerInfo);

	// Check where the bot should react on

	if (AttacksDangerInfo.DangerValue)
	{
		pReactOnDangerInfo = &AttacksDangerInfo;
		pBot->DangerType = DangerAttack;
	}
	
	if (PlayersDangerInfo.DangerValue)
	{
		if ((!pReactOnDangerInfo) ||
			(PlayersDangerInfo.DangerValue > pReactOnDangerInfo->DangerValue))
		{
			pReactOnDangerInfo = &PlayersDangerInfo;

			if ((pBot->pBotEnemy == pReactOnDangerInfo->pMostDangerousEnt) ||
			    (EnemyIsInList(pBot, pReactOnDangerInfo->pMostDangerousEnt)))
				pBot->DangerType = DangerCurrentEnemy;
			else
				pBot->DangerType = DangerEnemy;
		}
	}

	if (SoundsDangerInfo.DangerValue)
	{
		if ((!pReactOnDangerInfo) ||
			(SoundsDangerInfo.DangerValue > pReactOnDangerInfo->DangerValue))
		{
			pReactOnDangerInfo = &SoundsDangerInfo;
			pBot->DangerType = DangerSound;
		}
	}

	if (HitDangerInfo.DangerValue)
	{
		if ((!pReactOnDangerInfo) ||
			(HitDangerInfo.DangerValue > pReactOnDangerInfo->DangerValue))
		{
			pReactOnDangerInfo = &HitDangerInfo;
			pBot->DangerType = DangerHit;
		}
	}

	bool ReactOnDanger = false;

	if (pReactOnDangerInfo)
	{
#ifdef _DEBUG
		char sz[45] = "";
		sprintf(sz, "DangerLevel: %d\n", pReactOnDangerInfo->DangerValue);
		UTIL_Printf(sz, HUD_PRINTCENTER);
#endif
		pBot->DangerLevel = pReactOnDangerInfo->DangerValue;

		if (pBot->CurrentBotTask)
		{
			ReactOnDanger = (pBot->CurrentBotTask->ReactOnDanger(pReactOnDangerInfo));
		}
		else
			ReactOnDanger = true;
	}

	// React on danger?
	if (ReactOnDanger)
	{
		// Bot is low on ki?
		if (pBot->bot_ki < 300)
		{
			float KiFactor = 0.0f;
			if (pBot->bot_ki) // We don't want a zero devide...
				KiFactor = float((pBot->bot_ki / 1000.0f));

			// Teleport eats ki. So less chance for that.
			pReactOnDangerInfo->TeleVal *= KiFactor;
			// But stopping with fly gives you ki instead :-)
			pReactOnDangerInfo->StopFlyVal *= (2.0f - KiFactor);
		}

		// damn :( now lets see how we are going to do that...

		bool BotCanShoot = ((pBot->pBotWeaponList) && (pBot->pBotWeaponList->Empty() == false) &&
							(b_botdontshoot == false) && (BotDontSearchEnemy == false));

		// First check if the bot should melee to handle the danger(mainly counter attacking)
		if ((pReactOnDangerInfo->MayUseMelee) && (pReactOnDangerInfo->pMostDangerousEnt) &&
			(BotCanShoot) && (EnemyIsInMeleeRange(pBot, pReactOnDangerInfo->pMostDangerousEnt)))
		{
			edict_t *pEnemy = pReactOnDangerInfo->pMostDangerousEnt; // Shortcut
			short MeleePercent = pBot->MeleePercent;
			float flDist = UTIL_Distance(pEdict->v.origin, pEnemy->v.origin);

			if (pBot->AggressionLevel == Aggressive)
				MeleePercent *= 1.25f;
			else if (pBot->AggressionLevel == Defensive)
				MeleePercent *= 0.8f;

			if (PlayerSwoops(pEnemy) == false)
			{
				if (RANDOM_LONG(1, 100) <= MeleePercent)
				{
					if (flDist < 175.0)
					{
						pBot->pBotEnemy = pEnemy;
						MakeTask(pBot, TaskKickEnemy);
#ifdef _DEBUG
						lcout << "Kick enemy!\n";
						MeleeCalls++;
#endif
						return;
					}
					else if ((pBot->bot_ki > 400) && (flDist < 350.0) && (pBot->bot_skill < 3))
					{
						pBot->pBotEnemy = pEnemy;

						if (RANDOM_LONG(1, 100) <= pBot->TeleportPercent)
						{
							MakeCombo(pBot, telekick);
#ifdef _DEBUG
							lcout << "Tele kick!\n";
							MeleeCalls++;
#endif
						}
						else if (flDist > 225.0f)
						{
							MakeCombo(pBot, startforwardswoop);
#ifdef _DEBUG
							lcout << "Swoop @ danger(2)....\n";
							MeleeCalls++;
#endif
						}
						return;
					}
				}
			}
			else
			{
				if (RANDOM_LONG(1, 100) <= MeleePercent)
				{
					if ((flDist > 150.0f) && (flDist < 850.0f) && (pBot->bot_skill <= 1) &&
						(pBot->bot_ki > 400) && (RANDOM_LONG(1, 100) <= pBot->TeleportPercent))
					{
						if (MakeTeleMelee(pBot, flDist))
						{
							pBot->pBotEnemy = pEnemy;
#ifdef _DEBUG
							lcout << "Made tele swoop....\n";
							MeleeCalls++;
#endif
							return;
						}
					}
					if ((flDist > 500.0f) && (pBot->f_shoot_time <= gpGlobals->time) &&
						(RANDOM_LONG(1, 100) <= 65))
					{
						pBot->pBotEnemy = pEnemy;
						MakeCombo(pBot, startforwardswoop);
#ifdef _DEBUG
						lcout << "Swoop @ danger....\n";
						MeleeCalls++;
#endif
						return;
					}
				}
			}
		}

		if (pEdict->v.waterlevel == 3)
		{
			// If the bot is underwater don't try to jump or release fly
			pReactOnDangerInfo->JumpVal = pReactOnDangerInfo->StopFlyVal = 0.0;
		}

		if (!(pEdict->v.flags & FL_ONGROUND))
			pReactOnDangerInfo->JumpVal = 0.0;
		else
			pReactOnDangerInfo->StopFlyVal = 0.0f;

		if (pReactOnDangerInfo->StopFlyVal > 0.0)
		{
			if (CheckForCollide(pEdict, dir_down, MIN_DIST_TO_FALL_DOWN))
				pReactOnDangerInfo->StopFlyVal = 0.0;
		}

		bool BotMayUseSolarFlare = false;
		bool UseSolar = false;

		if (pReactOnDangerInfo->pMostDangerousEnt)
		{
			float EnemyDist = UTIL_Distance(pEdict->v.origin, pReactOnDangerInfo->pMostDangerousEnt->v.origin);
			BotMayUseSolarFlare = ((pReactOnDangerInfo->MayUseSolar) && (pBot->bot_ki > 600) &&
								   (BotCanShoot) && (EnemyDist < 250.0) &&
								   (bot_has_weapon(ESF_WEAPON_SOLARFLARE, pBot)) &&  
								   (PlayerIsBlinded(pBot->pBotEnemy) == false) &&
								   (RANDOM_LONG(1, 100) <= 
								   BotPersonalities[pBot->Personality].solarflare_percent));
		}

		TMultiChoice<EReactOnDangerType> AvoidChoice;

		AvoidChoice.Insert(ReactWithTeleport, pReactOnDangerInfo->TeleVal);
		AvoidChoice.Insert(ReactWithSwoop, pReactOnDangerInfo->SwoopVal);
		AvoidChoice.Insert(ReactWithBlock, pReactOnDangerInfo->BlockVal);
		AvoidChoice.Insert(ReactWithJump, pReactOnDangerInfo->JumpVal);
		AvoidChoice.Insert(ReactWithStopFly, pReactOnDangerInfo->StopFlyVal);

		if ((pReactOnDangerInfo->MayUseSBotLaser) && (pReactOnDangerInfo->pMostDangerousEnt) &&
			(pBot->SBotType > 0) && (pBot->bot_ki > 200) && (pBot->f_max_speed > 0.0f) &&
			(BotCanShoot))
		{
			// yay im a superbot, i can cheat :D
			AvoidChoice.Insert(ReactWithSBotLaser, SBotSettings[pBot->SBotType-1].laser_percent);
		}

		EReactOnDangerType Choice = ReactNone;
		AvoidChoice.GetSelection(Choice);

		if (Choice == ReactWithTeleport)
		{
			if (BotMayUseSolarFlare)
			{
				UseSolar = true;
				FakeClientCommand(pEdict, "teleport", NULL, NULL);
			}
			else if ((RANDOM_LONG(1, 100) <= pBot->TeleportPercent) && 
				     (pReactOnDangerInfo->DangerValue >= 300))
			{
#ifdef _DEBUG
				lcout << "Multi teleport\n";
#endif
				MakeCombo(pBot, MultipleTeleport);
			}
			else
				MakeTask(pBot, TaskTeleport);

			if (pReactOnDangerInfo->DangerValue >= DANGER_HEAVY_MIN_VAL)
				pBot->teleport_delay = 0.0; // do it as fast as possible
		}
		else if (Choice == ReactWithSwoop)
		{
			MakeTask(pBot, TaskSwoopAway);
		}
		else if (Choice == ReactWithBlock)
		{
			MakeTask(pBot, TaskBlock);
		}
		else if (Choice == ReactWithJump)
		{
			MakeTask(pBot, TaskNormalJump);

			int RandNr = RANDOM_LONG(1, 3);

			if (RandNr == 0)
				pBot->JumpDir = dir_left;
			else if (RandNr == 1)
				pBot->JumpDir = dir_right;
			
			if (RANDOM_LONG(0, 1))
				pBot->JumpDir |= dir_back;
		}
		else if (Choice == ReactWithStopFly)
		{
			pBot->ShouldFly = false;
			if (pEdict->v.gravity < 0.1)
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);

			pBot->CheckFlyDelay = gpGlobals->time + RANDOM_FLOAT(1.0, 1.4);

			if (BotMayUseSolarFlare)
				UseSolar = true;
		}
		else if (Choice == ReactWithSBotLaser)
		{
			MakeTask(pBot, TaskKeepDangerAway);
		}

		if (UseSolar)
		{
			if (pBot->current_weapon.iId != ESF_WEAPON_SOLARFLARE)
				UTIL_SelectItem(pEdict, "weapon_solarflare");
			pEdict->v.button |= IN_ATTACK;
		}
	}
}

void BotSense(bot_t *pBot)
{
#ifdef LOGBOTINFO
	clog << "BotSense() Start\n";
#endif

	edict_t *pEdict = pBot->pEdict;
	edict_t *pEnemy = NULL;
	ClientInfo_t *pClient;

	int SenseChecks = 0;
	bool CheckEverything = false;

	if (pBot->CurrentBotTask)
	{
		SenseChecks = pBot->CurrentBotTask->GetBotSenseChecks();
	}
	else
		CheckEverything = true;

	if ((SenseChecks == 0) && (!CheckEverything))
	{
		// Don't sense when don't want to O_o
		pBot->DangerLevel = pBot->DangerType = 0;
		return;
	}

	short NumberSurroundingAttacks = 0;

	bool ReactOnDanger = false;

	float TelePercent = float(pBot->TeleportPercent);
	float SwoopPercent = float(pBot->SwoopPercent);
	float JumpPercent = float(BotPersonalities[pBot->Personality].jump_percent);
	float StopFlyPercent = float(BotPersonalities[pBot->Personality].stopfly_percent);
	float BlockPercent = float(BotPersonalities[pBot->Personality].block_percent);

	float UsedTelePercent = TelePercent;
	float UsedSwoopPercent = SwoopPercent;
	float UsedBlockPercent = BlockPercent;
	float UsedJumpPercent = JumpPercent;
	float UsedStopFlyPercent = StopFlyPercent;

	short HighestDangerLevel = 0;
	int DangerType = 0;

	short DangerLevel = 0;

	SoundType_e BestSoundType = NoInterestingSound;

	edict_t *pMostDangerousPlayer = NULL;

	float NearestDangerDist = 9999.9;

	if ((SenseChecks & CheckAttacks) || (CheckEverything)) 
	{
/*
		NumberSurroundingAttacks = 
					GetSurroundingHostileAttacks(pEdict, 2000.0,
												(pBot->bot_skill > 1 ? true : false));

		edict_t *NearestAttack = GetNearestHostileAttack(pEdict, 2000.0, 
														(pBot->bot_skill > 1 ? true : false));
*/
		NumberSurroundingAttacks = pAttackManager->CountHostileAttacks(pEdict, 2000.0,
															(pBot->bot_skill > 1 ? true : false));

		edict_t *NearestAttack = pAttackManager->GetNearestHostileAttack(pEdict, 2000.0, 
														(pBot->bot_skill > 1 ? true : false));

		float AttackDist = 9999.9;

		if (NearestAttack)
			AttackDist = UTIL_Distance(pEdict->v.origin, NearestAttack->v.origin);

		if (NumberSurroundingAttacks > 1) // uh oh
		{
			DangerLevel = danger_heavy;
			ReactOnDanger = true;

			TelePercent *= 1.5; // teleporting would be fine now :)

			if (AttackDist < 300.0)
			{
				SwoopPercent = 0.0;
				JumpPercent = 0.0;
				StopFlyPercent = 0.0;
			}
			else if (AttackDist < 600.0)
			{
				SwoopPercent *= 0.2;
				JumpPercent = 0.0;
				StopFlyPercent = 0.0;
			}
			else if (AttackDist < 800.0)
			{
				SwoopPercent *= 0.6;
				JumpPercent *= 0.2;
				StopFlyPercent *= 0.2;
			}
		}
		else if (NearestAttack)
		{
			ReactOnDanger = true;

			BlockPercent *= 1.1;
			if (AttackDist < 300.0)
			{
				DangerLevel = danger_heavy;
				BlockPercent *= 1.2;
				SwoopPercent = 0.0;
				JumpPercent = 0.0;
				StopFlyPercent = 0.0;
			}
			else if (AttackDist < 600.0)
			{
				DangerLevel = danger_heavy;
				BlockPercent *= 1.1;
				SwoopPercent *= 0.2;
				JumpPercent *= 0.2;
				StopFlyPercent *= 0.2;
			}
			else if (AttackDist < 800.0)
			{
				DangerLevel = danger_heavy;
				SwoopPercent *= 0.6;
				JumpPercent *= 0.6;
				StopFlyPercent *= 0.6;
			}
			else if (AttackDist < 1000.0)
			{
				DangerLevel = danger_hard;
				// skilled enough to look on the scouter to determine enemies pl?
				if ((pBot->bot_skill < 3) && (!IsNull(NearestAttack->v.owner)))
				{
					long AttackOwnerPl = GetPlayerPl(NearestAttack->v.owner);

					if (DangerousPlForBot(pBot, AttackOwnerPl))
						BlockPercent *= 0.5; // we don't want to loose a blockstruggle
				}
			}
			else
			{
				if (pBot->AggressionLevel == Defensive)
					DangerLevel = danger_hard;
				else
					DangerLevel = danger_medium;

				BlockPercent *= 0.5; // don't block much with large distances
			}

			if (IsNonBeamAttack(NearestAttack))
			{
				BlockPercent *= 0.6;
			}
			else if (IsKiBall(NearestAttack))
			{
				BlockPercent *= 1.7;
				SwoopPercent *= 0.7;
				TelePercent *= 0.7;
			}
			else if (IsOtherAttack(NearestAttack))// discs...
			{
				BlockPercent = 0.0; // don't block unblockable attacks
			}

		}

		if (DangerLevel > 0)
		{
			if (DangerLevel > HighestDangerLevel)
			{
				NearestDangerDist = AttackDist;

				HighestDangerLevel = DangerLevel;
				DangerType = DangerAttack;
				UsedTelePercent = TelePercent;
				UsedSwoopPercent = SwoopPercent;
				UsedBlockPercent = BlockPercent;
				UsedJumpPercent = JumpPercent;
				UsedStopFlyPercent = StopFlyPercent;
			}
		}
	}

	// Reset temp-Percents and temp DangerLevel
	DangerLevel = 0;
	TelePercent = float(pBot->TeleportPercent);
	SwoopPercent = float(pBot->SwoopPercent);
	JumpPercent = float(BotPersonalities[pBot->Personality].jump_percent);
	StopFlyPercent = float(BotPersonalities[pBot->Personality].stopfly_percent);
	BlockPercent = float(BotPersonalities[pBot->Personality].block_percent);

	if ((SenseChecks & CheckSounds) || (CheckEverything))
	{
		if (!pBot->MadePlayerList)
			MakePlayerList(pBot);

		float NearestDist = 9999.9;

		if (pBot->PlayerCount > 0)
		{
			int ClInd = -1;
			int SoundMakerVal;

			int BestSoundMakerVal = 0;
			edict_t *pBestSoundMaker = NULL;

			float EnemyDist = 0.0;

			for(int i=0;i<pBot->PlayerCount;i++)
			{
				SoundMakerVal = 1;

				pEnemy = pBot->PlayerList[i];
				EnemyDist = UTIL_Distance(pEdict->v.origin, pEnemy->v.origin);

				if (EnemyDist > 3000.0)
					continue;

				// is team play enabled?
				if (IsTeamPlay())
				{
					int player_team = UTIL_GetTeam(pEnemy);
					int bot_team = UTIL_GetTeam(pEdict);

					// don't target your teammates...
					if (bot_team == player_team)
						continue;
				}

				Vector vecEnemy = pEnemy->v.origin;

				// since a scouter is 2d, calculate the distance in 2d :)
				Vector v_dist = vecEnemy - GetGunPosition(pBot->pEdict);
				v_dist.z = 0;
				float distance = v_dist.Length();

				bool OnScouter = ((distance <= 2300.0) || (pBot->SBotType > 0));
				bool InViewCone = (FInViewCone(&vecEnemy, pBot->pEdict));

				if ((!InViewCone) && (!OnScouter))
					continue;

				ClInd = UTIL_GetClientIndex(pEnemy);

				if (ClInd > -1)
				{
					if (ClientInfo[ClInd].LastSoundTime > gpGlobals->time)
					{
						SoundType_e SoundType = ClassifySound(ClientInfo[ClInd].SoundName);

						// Only avoid laser sounds
						if (SoundType == LaserSound)
						{
							// don't react on a candy beam when the distance is to high...
							if ((FStrEq(ClientInfo[ClInd].SoundName,"weapons/candyattack.wav")) &&
								(EnemyDist > 300.0))
								continue;

							if (NearestDist > EnemyDist)
							{
								NearestDist = EnemyDist;
								SoundMakerVal++;
							}

							if (SoundMakerVal > BestSoundMakerVal)
							{
								BestSoundMakerVal = SoundMakerVal;
								BestSoundType = SoundType;
								pBestSoundMaker = pEnemy;
							}
						}
					}
				}
			}

			if (BestSoundMakerVal > 0)
			{
				if (BestSoundType == LaserSound)
				{
//					if (pBestSoundMaker == pBot->pBotEnemy)
//						DangerTypes = DangerCurrentEnemy;


					ReactOnDanger = true;

					BlockPercent = 0.0;
					SwoopPercent *= 0.15;
					JumpPercent *= 0.15;
					StopFlyPercent *= 0.5;
					TelePercent *= 1.1;

					DangerLevel = danger_heavy;

					NearestDangerDist = NearestDist;
				}
			}
		}

		if (DangerLevel > 0)
		{
			if (DangerLevel > HighestDangerLevel)
			{
				HighestDangerLevel = DangerLevel;
				DangerType = DangerSound;
				UsedTelePercent = TelePercent;
				UsedSwoopPercent = SwoopPercent;
				UsedBlockPercent = BlockPercent;
				UsedJumpPercent = JumpPercent;
				UsedStopFlyPercent = StopFlyPercent;
			}
		}
	}

	// Reset temp-Percents and temp DangerLevel
	DangerLevel = 0;
	TelePercent = float(pBot->TeleportPercent);
	SwoopPercent = float(pBot->SwoopPercent);
	JumpPercent = float(BotPersonalities[pBot->Personality].jump_percent);
	StopFlyPercent = float(BotPersonalities[pBot->Personality].stopfly_percent);
	BlockPercent = float(BotPersonalities[pBot->Personality].block_percent);

	
	if ((SenseChecks & CheckSurroundingPlayers) || (CheckEverything))
	{
		if (!pBot->MadePlayerList)
			MakePlayerList(pBot);

		if (pBot->PlayerCount)
		{
			short SurroundingEnemysCount = 0;
			short EnemyVal;
			short BestEnemyVal = 0;

			float EnemyDist = 0.0;
			float NearestDist = 9999.9;

			Vector v_src = pEdict->v.origin;

			for (int i=0;i<pBot->PlayerCount;i++)
			{
				EnemyVal = 0;

				pEnemy = pBot->PlayerList[i];

				EnemyDist = UTIL_Distance(v_src, pEnemy->v.origin);

				if (EnemyDist > 2000.0)
					continue;

   				// is team play enabled?
				if (IsTeamPlay())
				{
					int player_team = UTIL_GetTeam(pEnemy);
					int bot_team = UTIL_GetTeam(pEdict);

					// don't target your teammates...
					if (bot_team == player_team)
						continue;
				}	

				Vector vecEnemy = pEnemy->v.origin;

				Vector v_dist = vecEnemy - GetGunPosition(pBot->pEdict);
				v_dist.z = 0;
				float distance = v_dist.Length();

				bool OnScouter = ((distance <= 2300.0) || (pBot->SBotType > 0));
				bool InViewCone = (FInViewCone(&vecEnemy, pBot->pEdict));

				if ((!InViewCone) && (!OnScouter))
					continue;

				pClient = UTIL_GetClientPointer(pEnemy);
				if (pClient)
				{
					if (pClient->Ascends)
						continue;

					if (pClient->IsInMeleeMode)
						continue;

					if (pClient->MeleeStruggles)
						continue;

					if (pClient->IsStuckAgainstWall)
						continue;

					if (pClient->LaysOnGround)
						continue;

					if (pClient->FlysAfterHit)
						continue;

					if (pClient->IsAutoPunching)
						continue;

					if (pClient->GetAutoPunched)
						continue;

					if (pClient->Powerstruggles)
						continue;
				}

				SurroundingEnemysCount++;

				bool BotIsInViewCone = (FInViewCone(&v_src, pEnemy));

				if (InViewCone)
					EnemyVal++;

				if ((BotIsInViewCone) || (EntityHeadsToPlayer(pEdict, pEnemy)))
					EnemyVal++;

				if (EnemyDist < NearestDist)
				{
					NearestDist = EnemyDist;
					EnemyVal++;
				}

				if (EnemyVal > BestEnemyVal)
				{
					BestEnemyVal = EnemyVal;
					pMostDangerousPlayer = pEnemy;
				}
			}

			if ((BestEnemyVal > 0) && (pMostDangerousPlayer))
			{
				float EnemyDist = UTIL_Distance(v_src, pMostDangerousPlayer->v.origin);

				bool EnemyIsInViewCone = EntIsInFieldOfView(pMostDangerousPlayer, pEdict);
				bool EnemyHeadsToPlayer = EntityHeadsToPlayer(pEdict, pMostDangerousPlayer);

				if ((EnemyHeadsToPlayer) || (EnemyIsInViewCone))
				{
					// Whats the enemy doing ?
					if (PlayerSwoops(pMostDangerousPlayer))
					{
						// its almost never handy to block when someone swoops at you...
						if (EnemyDist > 200.0)
							BlockPercent = 0.0; // Not if the enemy isn't close anyway
						else
							BlockPercent *= RANDOM_FLOAT(0.0, 0.3);

						if (EnemyDist < 150.0)
						{
							TelePercent *= 1.7; // teleport please !
							SwoopPercent = 0.0;
							JumpPercent = 0.0;
							StopFlyPercent = 0.0;
							DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 350.0)
						{
							TelePercent *= 1.3;
							SwoopPercent *= 0.1;
							JumpPercent *= 0.1;
							StopFlyPercent *= 0.1;
	
							if (pBot->AggressionLevel != Defensive)
								DangerLevel = danger_hard;
							else
								DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 550.0)
						{
							TelePercent *= 1.1;
							SwoopPercent *= 0.20;
							JumpPercent *= 0.35;
							StopFlyPercent *= 0.35;

							if (pBot->AggressionLevel != Defensive)
								DangerLevel = danger_medium;
							else
								DangerLevel = danger_hard;
						}
						else if (EnemyDist < 750.0)
						{
							SwoopPercent *= 0.5;
							JumpPercent *= 0.5;
							StopFlyPercent *= 0.5;

							if (pBot->AggressionLevel != Defensive)
								DangerLevel = danger_medium;
							else
								DangerLevel = danger_hard;
						}
						else if (EnemyDist < 1000.0)
						{
							SwoopPercent *= 0.9;
							JumpPercent *= 0.8;

							if (pBot->AggressionLevel != Defensive)
								DangerLevel = danger_light;
							else
								DangerLevel = danger_medium;
						}
					}
/*
					else if (PlayerChargesAttack(pMostDangerousPlayer))
					{
						int ClInd = UTIL_GetClientIndex(pMostDangerousPlayer);

						if (ClInd > -1)
						{
							short Offset = (pBot->bot_skill + 1) * 10;
							short PredictedChargeVal = ClientInfo[ClInd].ChargeBeamVal +
													   RANDOM_LONG(-Offset,Offset);

							if (pBot->AggressionLevel == Defensive)
								PredictedChargeVal += RANDOM_LONG(30, 70);

							if (PredictedChargeVal < 20)
							{
								DangerLevel = danger_light;
							}
							else if (PredictedChargeVal < 50)
							{
								DangerLevel = danger_medium;
							}
							else
							{
								DangerLevel = danger_hard;
							}
						}
					}
*/
					else if ((pBot->AggressionLevel != Aggressive) && (EnemyHeadsToPlayer))
					{
						BlockPercent = 0.0;

						if (EnemyDist < 100.0)
						{
							TelePercent *= 1.5;
							SwoopPercent *= 0.2;
							JumpPercent *= 0.2;
							StopFlyPercent *= 0.5;
							DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 210.0)
						{
							TelePercent *= 1.1;
							SwoopPercent *= 0.5;
							JumpPercent *= 0.6;
							StopFlyPercent *= 0.5;

							if (pBot->AggressionLevel == Defensive)
								DangerLevel = danger_heavy;
							else
								DangerLevel = danger_hard;
						}
						else if (EnemyDist < 280.0)
						{
							SwoopPercent *= 0.8;
							JumpPercent *= 0.7;
							StopFlyPercent *= 0.8;

							if (pBot->AggressionLevel == Defensive)
								DangerLevel = danger_hard;
							else
								DangerLevel = danger_medium;
						}
						else if (EnemyDist < 330.0)
						{
							TelePercent *= 0.9;
							if (pBot->AggressionLevel == Defensive)
								DangerLevel = danger_medium;
							else
								DangerLevel = danger_light;
						}
					}
					else if (EnemyIsInViewCone)
					{
						if (EnemyDist < 50.0)
						{
							DangerLevel = danger_hard;
							SwoopPercent *= 0.8;
						}
						else if (EnemyDist < 150.0)
						{
							DangerLevel = danger_medium;
						}
						else if (EnemyDist < 220.0)
						{
							DangerLevel = danger_light;
						}	
					}
				}

				if (DangerLevel > 0)
				{
					if (DangerLevel > HighestDangerLevel)
					{
						NearestDangerDist = EnemyDist;

						if (pMostDangerousPlayer == pBot->pBotEnemy)
							DangerType = DangerCurrentEnemy;
						else
							DangerType = DangerEnemy;

						HighestDangerLevel = DangerLevel;
						DangerType = DangerEnemy;
						UsedTelePercent = TelePercent;
						UsedSwoopPercent = SwoopPercent;
						UsedBlockPercent = BlockPercent;
						UsedJumpPercent = JumpPercent;
						UsedStopFlyPercent = StopFlyPercent;
					}
				}

				// Reset temp-Percents and temp DangerLevel
				DangerLevel = 0;
				TelePercent = float(pBot->TeleportPercent);
				SwoopPercent = float(pBot->SwoopPercent);
				JumpPercent = float(BotPersonalities[pBot->Personality].jump_percent);
				StopFlyPercent = float(BotPersonalities[pBot->Personality].stopfly_percent);
				BlockPercent = float(BotPersonalities[pBot->Personality].block_percent);

				if (SurroundingEnemysCount > 1)
				{
					short MinEnemysForRealDanger = 0;

					BlockPercent = 0.0;

					if (pBot->AggressionLevel == Aggressive)
					{
						MinEnemysForRealDanger = 4;
					}
					else if (pBot->AggressionLevel == Normal)
					{
						MinEnemysForRealDanger = RANDOM_LONG(2, 3);
					}
					else if (pBot->AggressionLevel == Defensive)
					{
						MinEnemysForRealDanger = 2;
					}

					if (SurroundingEnemysCount >= MinEnemysForRealDanger)
					{
						if (EnemyDist < 400.0) // HELP
						{
							TelePercent *= 1.7;
							SwoopPercent *= 0.6;
							JumpPercent = 0.0;
							StopFlyPercent = 0.3;
							DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 700.0)
						{
							TelePercent *= 1.3;
							SwoopPercent *= 0.8;
							JumpPercent = 0.0;
							StopFlyPercent *= 0.4;
							DangerLevel = danger_heavy;
						}
						else
							JumpPercent *= 0.2;
					}
				}

				if (DangerLevel > 0)
				{
					if (DangerLevel > HighestDangerLevel)
					{
						NearestDangerDist = EnemyDist;

						HighestDangerLevel = DangerLevel;

						if (pMostDangerousPlayer == pBot->pBotEnemy)
							DangerType = DangerCurrentEnemy;
						else
							DangerType = DangerEnemy;

						UsedTelePercent = TelePercent;
						UsedSwoopPercent = SwoopPercent;
						UsedBlockPercent = BlockPercent;
						UsedJumpPercent = JumpPercent;
						UsedStopFlyPercent = StopFlyPercent;
					}
				}
			}
		}
	}

	// Reset temp-Percents and temp DangerLevel
	DangerLevel = 0;
	TelePercent = float(pBot->TeleportPercent);
	SwoopPercent = float(pBot->SwoopPercent);
	JumpPercent = float(BotPersonalities[pBot->Personality].jump_percent);
	StopFlyPercent = float(BotPersonalities[pBot->Personality].stopfly_percent);
	BlockPercent = float(BotPersonalities[pBot->Personality].block_percent);

	if ((SenseChecks & CheckHit) || (CheckEverything))
	{
		// Did the bot just got hit by something ?
		if (pBot->LastHitTime > (gpGlobals->time - 1.0))
		{
			DangerType = DangerHit;
			HighestDangerLevel = danger_heavy;
			UsedTelePercent = TelePercent * 1.3;
			UsedSwoopPercent = SwoopPercent;
			UsedBlockPercent = 0.0;
			UsedJumpPercent = JumpPercent * 0.3;
			UsedStopFlyPercent = StopFlyPercent * 0.3;

			// reset it otherwise the bot might react more then once on it
			pBot->LastHitTime = 0.0;
		}
	}

	// Done checking

	// Save results
	pBot->DangerLevel = HighestDangerLevel;
	pBot->DangerType = DangerType;

	bool AvoidDanger = false;
	if (HighestDangerLevel >= danger_light)
	{
		if (pBot->CurrentBotTask)
		{
			if (pBot->CurrentBotTask->KillTaskOnDanger(HighestDangerLevel) == true)
				AvoidDanger = true;
		}
		else
			AvoidDanger = true;
	}


	// Avoid danger ?
	if (AvoidDanger)
	{
		bool BotCanShoot = ((pBot->pBotWeaponList) && (pBot->pBotWeaponList->Empty() == false) &&
							(b_botdontshoot == false) && (BotDontSearchEnemy == false));

		if ((pMostDangerousPlayer) &&
			((DangerType == DangerCurrentEnemy) || (EnemyIsInList(pBot, pMostDangerousPlayer))) &&
			(HighestDangerLevel > danger_light) && (BotCanShoot))
		{
			float EnemyDist = UTIL_Distance(pEdict->v.origin, pMostDangerousPlayer->v.origin);

			if (PlayerSwoops(pMostDangerousPlayer) == false)
			{
				if (RANDOM_LONG(1, 100) <= pBot->MeleePercent)
				{
					if (EnemyDist < 175.0)
					{
						pBot->pBotEnemy = pMostDangerousPlayer;
						MakeTask(pBot, TaskKickEnemy);
#ifdef _DEBUG
						lcout << "Kick enemy!\n";
						MeleeCalls++;
#endif
						return;
					}
					else if ((EnemyDist < 350.0) && (pBot->bot_skill < 3) &&
						     (RANDOM_LONG(1, 100) <= pBot->TeleportPercent))
					{
						pBot->pBotEnemy = pMostDangerousPlayer;
						MakeCombo(pBot, telekick);
#ifdef _DEBUG
						lcout << "Tele kick!\n";
						MeleeCalls++;
#endif
						return;
					}
				}
			}
			else
			{
				if (RANDOM_LONG(1, 100) <= pBot->MeleePercent)
				{
					if ((EnemyDist > 150.0f) && (EnemyDist < 650.0f) && (pBot->bot_skill == 0) &&
						(RANDOM_LONG(1, 100) <= pBot->TeleportPercent))
					{
						if (MakeTeleMelee(pBot, EnemyDist))
						{
							pBot->pBotEnemy = pMostDangerousPlayer;
#ifdef _DEBUG
							lcout << "Made tele swoop....\n";
							MeleeCalls++;
#endif
							return;
						}
					}
					if ((EnemyDist > 500.0f) && (RANDOM_LONG(1, 100) <= 65))
					{
						pBot->pBotEnemy = pMostDangerousPlayer;
						MakeCombo(pBot, startforwardswoop);
#ifdef _DEBUG
						MeleeCalls++;
#endif
						return;
					}
				}
			}
		}

		// damn :( now lets see how we are going to do that...

		if (pEdict->v.waterlevel == 3)
		{
			// If the bot is underwater don't try to jump or release fly
			UsedJumpPercent = UsedStopFlyPercent = 0.0;
		}

		if (!(pEdict->v.flags & FL_ONGROUND))
			UsedJumpPercent = 0.0;
		else
			UsedStopFlyPercent = 0.0f;

		if (UsedStopFlyPercent > 0.0)
		{
			if (CheckForCollide(pEdict, dir_down, MIN_DIST_TO_FALL_DOWN))
				UsedStopFlyPercent = 0.0;
		}

		bool BotMayUseSolarFlare = false;
		bool UseSolar = false;

		if (DangerType == DangerCurrentEnemy)
		{
			float EnemyDist = UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin);
			BotMayUseSolarFlare = ((bot_has_weapon(ESF_WEAPON_SOLARFLARE, pBot)) && 
							       (pBot->bot_ki > 600) && 
								   (PlayerIsBlinded(pBot->pBotEnemy) == false) &&
								   (EnemyDist < 250.0) && (BotCanShoot) &&
								   (RANDOM_LONG(1, 100) <= 
								   BotPersonalities[pBot->Personality].solarflare_percent));
		}

		TMultiChoice<short> AvoidChoice;

		short GoTeleport = 1;
		short GoSwoop = 2;
		short GoBlock = 3;
		short GoJump = 4;
		short GoStopFlying = 5;
		short GoLasering = 6;

		AvoidChoice.Insert(GoTeleport, UsedTelePercent);
		AvoidChoice.Insert(GoSwoop, UsedSwoopPercent);
		AvoidChoice.Insert(GoBlock, UsedBlockPercent);
		AvoidChoice.Insert(GoJump, UsedJumpPercent);
		AvoidChoice.Insert(GoStopFlying, UsedStopFlyPercent);

		if ((pBot->SBotType > 0) && (pBot->bot_ki > 200) && (pBot->f_max_speed > 0.0f) &&
			(HighestDangerLevel >= danger_medium) && (BotCanShoot))
		{
			// yay im a superbot, i can cheat :D
			float MostDangerousEnemyDist = 9999.0;

			if (((DangerType == DangerCurrentEnemy) || (DangerType == DangerCurrentEnemy)) &&
				(pMostDangerousPlayer))
				MostDangerousEnemyDist = UTIL_Distance(pEdict->v.origin,
													   pMostDangerousPlayer->v.origin);

			if (MostDangerousEnemyDist >= 350.0)
			{
				short LaserPercent = SBotSettings[pBot->SBotType-1].laser_percent;

				if (DangerType == DangerEnemy)
					LaserPercent *= 0.75;

				if ((DangerType == DangerSound) || (DangerType == DangerHit))
					LaserPercent = 0;

				AvoidChoice.Insert(GoLasering, LaserPercent);
			}
		}

		short Choice = 0;
		AvoidChoice.GetSelection(Choice);

		if (Choice == GoTeleport)
		{
			if (BotMayUseSolarFlare)
			{
				UseSolar = true;
				FakeClientCommand(pEdict, "teleport", NULL, NULL);
			}
			else if ((RANDOM_LONG(1, 100) <= pBot->TeleportPercent) && 
					 (HighestDangerLevel == danger_heavy))
				MakeCombo(pBot, teletwice);
			else
				MakeTask(pBot, TaskTeleport);

			if (HighestDangerLevel == danger_heavy)
				pBot->teleport_delay = 0.0; // do it as fast as possible
		}
		else if (Choice == GoSwoop)
		{
			MakeTask(pBot, TaskSwoopAway);
		}
		else if (Choice == GoBlock)
		{
			MakeTask(pBot, TaskBlock);
		}
		else if (Choice == GoJump)
		{
			MakeTask(pBot, TaskNormalJump);

			int RandNr = RANDOM_LONG(1, 3);

			if (RandNr == 0)
				pBot->JumpDir = dir_left;
			else if (RandNr == 1)
				pBot->JumpDir = dir_right;
			
			if (RANDOM_LONG(0, 1))
				pBot->JumpDir |= dir_back;
		}
		else if (Choice == GoStopFlying)
		{
			pBot->ShouldFly = false;
			if (pEdict->v.gravity < 0.1)
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);

			pBot->CheckFlyDelay = gpGlobals->time + RANDOM_FLOAT(1.0, 1.4);

			if (BotMayUseSolarFlare)
				UseSolar = true;
		}
		else if (Choice == GoLasering)
		{
			MakeTask(pBot, TaskKeepDangerAway);
		}

		if (UseSolar)
		{
			if (pBot->current_weapon.iId != ESF_WEAPON_SOLARFLARE)
				UTIL_SelectItem(pEdict, "weapon_solarflare");
			pEdict->v.button |= IN_ATTACK;
		}

/*
		char DTypes[125] = "";

		if (DangerTypes & DangerAttack)
			strcat(DTypes, "DangerAttack ");
		if (DangerTypes & DangerSound)
			strcat(DTypes, "DangerSound ");
		if (DangerTypes & DangerEnemy)
			strcat(DTypes, "DangerEnemy ");
		if (DangerTypes & DangerHit)
			strcat(DTypes, "DangerHit ");
		if (DangerTypes & DangerCurrentEnemy)
			strcat(DTypes, "DangerCurrentEnemy");

		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "\n\n Bot sense results:\n\n"
					"UsedTeleportPercent: %f\n"
					"UsedSwoopPercent: %f\n"
					"UsedJumpPercent: %f\n"
					"UsedBlockPercent: %f\n"
					"UsedStopFlyPercent: %f\n"
					"AvoidChoice: %s\n"
					"DangerDist: %f\n"
					"DangerTypes: %s\n"
					"DangerLevel: %d\n",
					UsedTelePercent, UsedSwoopPercent, UsedJumpPercent, UsedBlockPercent,
					UsedStopFlyPercent, s, NearestDangerDist, DTypes, HighestDangerLevel);
		fclose(fp);*/
	}
#ifdef LOGBOTINFO
	clog << "BotSense() End\n";
#endif

}

#ifdef classstuff

bool CBot::DangerousPlForBot(long EnemyPl)
{
	long DangerousPl = EnemyPl;

	if (m_pPersonality->aggression_level == Defensive) // its really soon dangerous
		DangerousPl -= RANDOM_LONG(100000, 250000);
	else if (m_pPersonality->aggression_level == Normal)
		DangerousPl -= RANDOM_LONG(550000, 1000000);
	else if (m_pPersonality->aggression_level == Aggressive)
		DangerousPl -= RANDOM_LONG(750000, 1250000);

	return (GetPl() < DangerousPl);
}

// global bot sensing
void CBot::BotSense()
{
#ifdef LOGBOTINFO
	clog << "BotSense() Start\n";
#endif

	if (BotDontSearchEnemy)
		return;

	CClient *pEnemy = NULL;

	int SenseChecks = 0;
	bool CheckEverything = false;

	if (m_pCurrentBotTask)
	{
		SenseChecks = m_pCurrentBotTask->GetBotSenseChecks();
	}
	else
		CheckEverything = true;

	if ((SenseChecks == 0) && (!CheckEverything))
	{
		// Don't sense when don't want to O_o
		m_bDangerLevel = m_iDangerTypes = 0;
		return;
	}

	short NumberSurroundingAttacks = 0;

	bool ReactOnDanger = false;

	float TelePercent = float(m_pPersonality->teleport_percent);
	float SwoopPercent = float(m_pPersonality->swoop_percent);
	float JumpPercent = float(m_pPersonality->jump_percent);
	float StopFlyPercent = float(m_pPersonality->stopfly_percent);
	float BlockPercent = float(m_pPersonality->block_percent);

	float UsedTelePercent = TelePercent;
	float UsedSwoopPercent = SwoopPercent;
	float UsedBlockPercent = BlockPercent;
	float UsedJumpPercent = JumpPercent;
	float UsedStopFlyPercent = StopFlyPercent;

	short HighestDangerLevel = 0;
	int DangerTypes = 0;

	short DangerLevel = 0;

	SoundType_e BestSoundType = NoInterestingSound;

	CClient *pMostDangerousPlayer = NULL;

	float NearestDangerDist = 9999.9;

	if ((SenseChecks & CheckAttacks) || (CheckEverything)) 
	{
		NumberSurroundingAttacks = 
					GetSurroundingHostileAttacks(pEdict, 2000.0,
												(m_bBotSkill > 1 ? true : false));

		edict_t *NearestAttack = GetNearestHostileAttack(pEdict, 2000.0, 
														(m_bBotSkill > 1 ? true : false));

		float AttackDist = 9999.9;

		if (NearestAttack)
			AttackDist = UTIL_Distance(pEdict->v.origin, NearestAttack->v.origin);

		if (NumberSurroundingAttacks > 1) // uh oh
		{
			DangerTypes = DangerAttack;
			DangerLevel = danger_heavy;
			ReactOnDanger = true;

			TelePercent *= 1.5; // teleporting would be fine now :)

			if (AttackDist < 300.0)
			{
				SwoopPercent = 0.0;
				JumpPercent = 0.0;
				StopFlyPercent = 0.0;
			}
			else if (AttackDist < 600.0)
			{
				SwoopPercent *= 0.2;
				JumpPercent = 0.0;
				StopFlyPercent = 0.0;
			}
			else if (AttackDist < 800.0)
			{
				SwoopPercent *= 0.6;
				JumpPercent *= 0.2;
				StopFlyPercent *= 0.2;
			}
		}
		else if (NearestAttack)
		{
			DangerTypes = DangerAttack;

			ReactOnDanger = true;

			BlockPercent *= 1.1;
			if (AttackDist < 300.0)
			{
				DangerLevel = danger_heavy;
				BlockPercent *= 1.2;
				SwoopPercent = 0.0;
				JumpPercent = 0.0;
				StopFlyPercent = 0.0;
			}
			else if (AttackDist < 600.0)
			{
				DangerLevel = danger_heavy;
				BlockPercent *= 1.1;
				SwoopPercent *= 0.2;
				JumpPercent *= 0.2;
				StopFlyPercent *= 0.2;
			}
			else if (AttackDist < 800.0)
			{
				DangerLevel = danger_heavy;
				SwoopPercent *= 0.6;
				JumpPercent *= 0.6;
				StopFlyPercent *= 0.6;
			}
			else if (AttackDist < 1000.0)
			{
				DangerLevel = danger_hard;
				// skilled enough to look on the scouter to determine enemys pl?
				if ((m_bBotSkill < 3) && (!IsNull(NearestAttack->v.owner)))
				{
					long AttackOwnerPl = GetPlayerPl(NearestAttack->v.owner);

					if (DangerousPlForBot(AttackOwnerPl))
						BlockPercent *= 0.5; // we don't want to loose a blockstruggle
				}
			}
			else
			{
				if (m_pPersonality->aggression_level == Defensive)
					DangerLevel = danger_hard;
				else
					DangerLevel = danger_medium;

				BlockPercent *= 0.5; // don't block much with large distances
			}

			if (IsNonBeamAttack(NearestAttack))
			{
				BlockPercent *= 0.6;
			}
			else if (IsKiBall(NearestAttack))
			{
				BlockPercent *= 1.7;
				SwoopPercent *= 0.7;
				TelePercent *= 0.7;
			}
			else if (IsOtherAttack(NearestAttack))// discs...
			{
				BlockPercent = 0.0; // don't block unblockable attacks
			}

		}

		if (DangerLevel > 0)
		{
			if (DangerLevel > HighestDangerLevel)
			{
				NearestDangerDist = AttackDist;

				HighestDangerLevel = DangerLevel;
				UsedTelePercent = TelePercent;
				UsedSwoopPercent = SwoopPercent;
				UsedBlockPercent = BlockPercent;
				UsedJumpPercent = JumpPercent;
				UsedStopFlyPercent = StopFlyPercent;
			}
		}
	}

	// Reset temp-Percents and temp DangerLevel
	DangerLevel = 0;
	TelePercent = float(m_pPersonality->teleport_percent);
	SwoopPercent = float(m_pPersonality->swoop_percent);
	JumpPercent = float(m_pPersonality->jump_percent);
	StopFlyPercent = float(m_pPersonality->stopfly_percent);
	BlockPercent = float(m_pPersonality->block_percent);

	if ((SenseChecks & CheckSounds) || (CheckEverything))
	{
		if (m_bMadePlayerList)
			MakePlayerList();

		float NearestDist = 9999.9;

		if (m_bPlayerCount > 0)
		{
			int ClInd = -1;
			int SoundMakerVal;

			int BestSoundMakerVal = 0;

			float EnemyDist = 0.0;

			for(int i=0;i<m_bPlayerCount;i++)
			{
				SoundMakerVal = 1;

				pEnemy = m_pPlayerList[i];
				EnemyDist = UTIL_Distance(pEdict->v.origin, pEnemy->GetOrigin());

				if (EnemyDist > 3000.0)
					continue;

				// is team play enabled?
				if (IsTeamPlay())
				{
					// don't target your teammates...
					if (GetTeam() == pEnemy->GetTeam())
						continue;
				}

				Vector vecEnemy = pEnemy->GetOrigin();

				// since a scouter is 2d, calculate the distance in 2d :)
				Vector v_dist = vecEnemy - GetGunPosition();
				v_dist.z = 0;
				float distance = v_dist.Length();

				bool OnScouter = ((distance <= 2300.0) || (IsSuperBot()));
				bool InViewCone = (FInViewCone(&vecEnemy));

				if ((!InViewCone) && (!OnScouter))
					continue;

				if (pEnemy->MadeASound())
				{
					SoundType_e SoundType = ClassifySound(ClientInfo[ClInd].SoundName);

					// Only avoid laser sounds
					if (SoundType == LaserSound)
					{
						// don't react on a candy beam when the distance is to high...
						if ((FStrEq(ClientInfo[ClInd].SoundName,"weapons/candyattack.wav")) &&
							(EnemyDist > 300.0))
							continue;

						if (NearestDist > EnemyDist)
						{
							NearestDist = EnemyDist;
							SoundMakerVal++;
						}

						if (SoundMakerVal > BestSoundMakerVal)
						{
							BestSoundMakerVal = SoundMakerVal;
							BestSoundType = SoundType;
						}
					}
				}
			}

			if (BestSoundMakerVal > 0)
			{
				if (BestSoundType == LaserSound)
				{
					DangerTypes = DangerSound;
//					if (pBestSoundMaker == pBot->pBotEnemy)
//						DangerTypes = DangerCurrentEnemy;


					ReactOnDanger = true;

					BlockPercent = 0.0;
					SwoopPercent *= 0.15;
					JumpPercent *= 0.15;
					StopFlyPercent *= 0.5;
					TelePercent *= 1.1;

					DangerLevel = danger_heavy;

					NearestDangerDist = NearestDist;
				}
			}
		}

		if (DangerLevel > 0)
		{
			if (DangerLevel > HighestDangerLevel)
			{
				HighestDangerLevel = DangerLevel;
				UsedTelePercent = TelePercent;
				UsedSwoopPercent = SwoopPercent;
				UsedBlockPercent = BlockPercent;
				UsedJumpPercent = JumpPercent;
				UsedStopFlyPercent = StopFlyPercent;
			}
		}
	}

	// Reset temp-Percents and temp DangerLevel
	DangerLevel = 0;
	TelePercent = float(m_pPersonality->teleport_percent);
	SwoopPercent = float(m_pPersonality->swoop_percent);
	JumpPercent = float(m_pPersonality->jump_percent);
	StopFlyPercent = float(m_pPersonality->stopfly_percent);
	BlockPercent = float(m_pPersonality->block_percent);

	
	if ((SenseChecks & CheckSurroundingPlayers) || (CheckEverything))
	{
		if (!m_bMadePlayerList)
			MakePlayerList();

		if (m_bPlayerCount)
		{
			short SurroundingEnemysCount = 0;
			short EnemyVal;
			short BestEnemyVal = 0;

			float EnemyDist = 0.0;
			float NearestDist = 9999.9;

			Vector v_src = GetOrigin();

			for (int i=0;i<m_bPlayerCount;i++)
			{
				EnemyVal = 0;

				pEnemy = m_pPlayerList[i];

				EnemyDist = UTIL_Distance(v_src, pEnemy->GetOrigin());

				if (EnemyDist > 2000.0)
					continue;

   				// is team play enabled?
				if (IsTeamPlay())
				{
					// don't target your teammates...
					if (GetTeam() == pEnemy->GetTeam())
						continue;
				}	

				Vector vecEnemy = pEnemy->GetOrigin();

				Vector v_dist = vecEnemy - GetGunPosition();
				v_dist.z = 0;
				float distance = v_dist.Length();

				bool OnScouter = ((distance <= 2300.0) || (IsSuperBot()));
				bool InViewCone = (FInViewCone(&vecEnemy));

				if ((!InViewCone) && (!OnScouter))
					continue;

				if (pEnemy->Ascends())
					continue;

				if (pEnemy->IsInMeleeMode())
					continue;

				if (pEnemy->MeleeStruggles())
					continue;

				if (pEnemy->IsStuckAgainstWall())
					continue;

				if (pEnemy->LaysOnGround())
					continue;

				if (pEnemy->FlysAfterHit())
					continue;

				if (pEnemy->IsAutoPunching())
					continue;

				if (pEnemy->GetAutoPunched())
					continue;

				if (pEnemy->Powerstruggles())
					continue;

				SurroundingEnemysCount++;

				bool BotIsInViewCone = pEnemy->FInViewCone(&v_src);

				if (InViewCone)
					EnemyVal++;

				if ((BotIsInViewCone) || (EntityHeadsToPlayer(pEdict, pEnemy->pEdict)))
					EnemyVal++;

				if (EnemyDist < NearestDist)
				{
					NearestDist = EnemyDist;
					EnemyVal++;
				}

				if (EnemyVal > BestEnemyVal)
				{
					BestEnemyVal = EnemyVal;
					pMostDangerousPlayer = pEnemy;
				}
			}

			if ((BestEnemyVal > 0) && (pMostDangerousPlayer))
			{
				DangerTypes = DangerEnemy;

				if (pMostDangerousPlayer == m_pBotEnemy)
					DangerTypes = DangerCurrentEnemy;
				
				float EnemyDist = UTIL_Distance(v_src, pMostDangerousPlayer->GetOrigin());

				if (EntityHeadsToPlayer(pEdict, pMostDangerousPlayer->pEdict))
				{
					// Whats the enemy doing ?
					if (pMostDangerousPlayer->Swoops())
					{
						// its almost never handy to block when someone swoops at you...
						if (EnemyDist > 200.0)
							BlockPercent = 0.0; // Not if the enemy isn't close anyway
						else
							BlockPercent *= RANDOM_FLOAT(0.0, 0.3);

						if (EnemyDist < 150.0)
						{
							TelePercent *= 1.7; // teleport please !
							SwoopPercent = 0.0;
							JumpPercent = 0.0;
							StopFlyPercent = 0.0;
							DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 350.0)
						{
							TelePercent *= 1.3;
							SwoopPercent *= 0.1;
							JumpPercent *= 0.1;
							StopFlyPercent *= 0.1;
	
							if (m_pPersonality->aggression_level != Defensive)
								DangerLevel = danger_hard;
							else
								DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 550.0)
						{
							TelePercent *= 1.1;
							SwoopPercent *= 0.20;
							JumpPercent *= 0.35;
							StopFlyPercent *= 0.35;

							if (m_pPersonality->aggression_level != Defensive)
								DangerLevel = danger_medium;
							else
								DangerLevel = danger_hard;
						}
						else if (EnemyDist < 750.0)
						{
							SwoopPercent *= 0.5;
							JumpPercent *= 0.5;
							StopFlyPercent *= 0.5;

							if (m_pPersonality->aggression_level != Defensive)
								DangerLevel = danger_medium;
							else
								DangerLevel = danger_hard;
						}
						else if (EnemyDist < 1000.0)
						{
							SwoopPercent *= 0.9;
							JumpPercent *= 0.8;

							if (m_pPersonality->aggression_level != Defensive)
								DangerLevel = danger_light;
							else
								DangerLevel = danger_medium;
						}
					}
/*
					else if (PlayerChargesAttack(pMostDangerousPlayer))
					{
						int ClInd = UTIL_GetClientIndex(pMostDangerousPlayer);

						if (ClInd > -1)
						{
							short Offset = (m_bBotSkill + 1) * 10;
							short PredictedChargeVal = ClientInfo[ClInd].ChargeBeamVal +
													   RANDOM_LONG(-Offset,Offset);

							if (m_pPersonality->aggression_level == Defensive)
								PredictedChargeVal += RANDOM_LONG(30, 70);

							if (PredictedChargeVal < 20)
							{
								DangerLevel = danger_light;
							}
							else if (PredictedChargeVal < 50)
							{
								DangerLevel = danger_medium;
							}
							else
							{
								DangerLevel = danger_hard;
							}
						}
					}
*/
					else if ((m_pPersonality->aggression_level != Aggressive) &&
							 (EntityHeadsToPlayer(pEdict, pMostDangerousPlayer->pEdict)))
					{
						BlockPercent = 0.0;

						if (EnemyDist < 100.0)
						{
							TelePercent *= 1.5;
							SwoopPercent *= 0.2;
							JumpPercent *= 0.2;
							StopFlyPercent *= 0.5;
							DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 210.0)
						{
							TelePercent *= 1.1;
							SwoopPercent *= 0.5;
							JumpPercent *= 0.6;
							StopFlyPercent *= 0.5;

							if (m_pPersonality->aggression_level == Defensive)
								DangerLevel = danger_heavy;
							else
								DangerLevel = danger_hard;
						}
						else if (EnemyDist < 280.0)
						{
							SwoopPercent *= 0.8;
							JumpPercent *= 0.7;
							StopFlyPercent *= 0.8;

							if (m_pPersonality->aggression_level == Defensive)
								DangerLevel = danger_hard;
							else
								DangerLevel = danger_medium;
						}
						else if (EnemyDist < 330.0)
						{
							TelePercent *= 0.9;
							if (m_pPersonality->aggression_level == Defensive)
								DangerLevel = danger_medium;
							else
								DangerLevel = danger_light;
						}
					}
					else if (EntIsInFieldOfView(pMostDangerousPlayer->pEdict, pEdict))
					{
						if (EnemyDist < 50.0)
						{
							DangerLevel = danger_hard;
							SwoopPercent *= 0.8;
						}
						else if (EnemyDist < 150.0)
						{
							DangerLevel = danger_medium;
						}
						else if (EnemyDist < 220.0)
						{
							DangerLevel = danger_light;
						}	
					}
				}

				if (DangerLevel > 0)
				{
					if (DangerLevel > HighestDangerLevel)
					{
						NearestDangerDist = EnemyDist;

						HighestDangerLevel = DangerLevel;
						UsedTelePercent = TelePercent;
						UsedSwoopPercent = SwoopPercent;
						UsedBlockPercent = BlockPercent;
						UsedJumpPercent = JumpPercent;
						UsedStopFlyPercent = StopFlyPercent;
					}
				}

				// Reset temp-Percents and temp DangerLevel
				DangerLevel = 0;
				TelePercent = float(m_pPersonality->teleport_percent);
				SwoopPercent = float(m_pPersonality->swoop_percent);
				JumpPercent = float(m_pPersonality->jump_percent);
				StopFlyPercent = float(m_pPersonality->stopfly_percent);
				BlockPercent = float(m_pPersonality->block_percent);

				if (SurroundingEnemysCount > 1)
				{
					short MinEnemysForRealDanger = 0;

					BlockPercent = 0.0;

					if (m_pPersonality->aggression_level == Aggressive)
					{
						MinEnemysForRealDanger = 4;
					}
					else if (m_pPersonality->aggression_level == Normal)
					{
						MinEnemysForRealDanger = RANDOM_LONG(2, 3);
					}
					else if (m_pPersonality->aggression_level == Defensive)
					{
						MinEnemysForRealDanger = 2;
					}

					if (SurroundingEnemysCount >= MinEnemysForRealDanger)
					{
						if (EnemyDist < 400.0) // HELP
						{
							TelePercent *= 1.7;
							SwoopPercent *= 0.6;
							JumpPercent = 0.0;
							StopFlyPercent = 0.3;
							DangerLevel = danger_heavy;
						}
						else if (EnemyDist < 700.0)
						{
							TelePercent *= 1.3;
							SwoopPercent *= 0.8;
							JumpPercent = 0.0;
							StopFlyPercent *= 0.4;
							DangerLevel = danger_heavy;
						}
						else
							JumpPercent *= 0.2;
					}
				}

				if (DangerLevel > 0)
				{
					if (DangerLevel > HighestDangerLevel)
					{
						NearestDangerDist = EnemyDist;

						HighestDangerLevel = DangerLevel;
						UsedTelePercent = TelePercent;
						UsedSwoopPercent = SwoopPercent;
						UsedBlockPercent = BlockPercent;
						UsedJumpPercent = JumpPercent;
						UsedStopFlyPercent = StopFlyPercent;
					}
				}
			}
		}
	}

	// Reset temp-Percents and temp DangerLevel
	DangerLevel = 0;
	TelePercent = float(m_pPersonality->teleport_percent);
	SwoopPercent = float(m_pPersonality->swoop_percent);
	JumpPercent = float(m_pPersonality->jump_percent);
	StopFlyPercent = float(m_pPersonality->stopfly_percent);
	BlockPercent = float(m_pPersonality->block_percent);

	if ((SenseChecks & CheckHit) || (CheckEverything))
	{
		// Did the bot just got hit by something ?
		if (m_fLastHitTime > (gpGlobals->time - 1.0))
		{
			DangerTypes = DangerHit;
			HighestDangerLevel = danger_heavy;
			UsedTelePercent = TelePercent * 1.3;
			UsedSwoopPercent = SwoopPercent;
			UsedBlockPercent = 0.0;
			UsedJumpPercent = JumpPercent * 0.3;
			UsedStopFlyPercent = float(m_pPersonality->stopfly_percent) * 0.3;

			// reset it otherwise the bot might react more then once on it
			m_fLastHitTime = 0.0;
		}
	}

	// Done checking

	// Save results
	m_bDangerLevel = HighestDangerLevel;
	m_iDangerTypes = DangerTypes;

	bool AvoidDanger = false;
	if (HighestDangerLevel >= danger_light)
	{
		if (m_pCurrentBotTask)
		{
			if (m_pCurrentBotTask->KillTaskOnDanger(HighestDangerLevel) == true)
				AvoidDanger = true;
		}
		else
			AvoidDanger = true;
	}


	// Avoid danger ?
	if (AvoidDanger)
	{
		if ((DangerTypes == DangerCurrentEnemy) && (HighestDangerLevel > danger_light) &&
			(HighestDangerLevel < danger_heavy) && (b_botdontshoot == false) && 
			(BotDontSearchEnemys == false))
		{
			float EnemyDist = UTIL_Distance(GetOrigin(), pMostDangerousPlayer->GetOrigin());

			if (pMostDangerousPlayer->Swoops() == false)
			{
				if (RANDOM_LONG(1, 100) <= m_pPersonality->melee_percent)
				{
					if (EnemyDist < 250.0)
					{
						MakeTask(TaskKickEnemy);
#ifdef _DEBUG
						MeleeCalls++;
#endif
						return;
					}
					else if ((EnemyDist < 350.0) && 
							 (RANDOM_LONG(1, 100) <= m_pPersonality->teleport_percent))
					{
						MakeCombo(telekick);
#ifdef _DEBUG
						MeleeCalls++;
#endif
						return;
					}
				}
			}
			else if (EnemyDist > 500.0)
			{
				short MeleePercent = m_pPersonality->melee_percent;

				switch (m_pPersonality->aggression_level)
				{
				case Defensive:
					MeleePercent *= 0.8;
					break;
				case Aggressive:
					MeleePercent *= 1.2;
					break;
				}

				if (EnemyDist <= 550.0)
					MeleePercent *= 0.50;
				else if (EnemyDist < 650.0)
					MeleePercent *= 0.85;

				if (RANDOM_LONG(1, 100) <= MeleePercent)
				{
					MakeCombo(startforwardswoop);
#ifdef _DEBUG
					MeleeCalls++;
#endif
					return;
				}
			}
		}

		// damn :( now lets see how we are going to do that...

		if (pEdict->v.waterlevel == 3)
		{
			// If the bot is underwater don't try to jump or release fly
			UsedJumpPercent = UsedStopFlyPercent = 0.0;
		}

		if (!(pEdict->v.flags & FL_ONGROUND))
			UsedJumpPercent = 0.0;

		if (pEdict->v.gravity < 0.1)
			UsedJumpPercent = 0.0;

		if (UsedStopFlyPercent > 0.0)
		{
			if (CheckForCollide(pEdict, dir_down, MIN_DIST_TO_FALL_DOWN))
				UsedStopFlyPercent = 0.0;
		}

		bool BotMayUseSolarFlare = false;
		bool UseSolar = false;

		if (DangerTypes == DangerCurrentEnemy)
		{
			float EnemyDist = UTIL_Distance(pEdict->v.origin, m_pBotEnemy->GetOrigin());
			BotMayUseSolarFlare = ((BotHasWeapon(ESF_WEAPON_SOLARFLARE)) && 
							       (GetKi() > 600) && (m_pBotEnemy->IsBlinded() == false) &&
								   (EnemyDist < 250.0) &&
								   (RANDOM_LONG(1, 100) <= m_pPersonality->solarflare_percent));
		}

		TMultiChoice<short> AvoidChoice;

		short GoTeleport = 1;
		short GoSwoop = 2;
		short GoBlock = 3;
		short GoJump = 4;
		short GoStopFlying = 5;
		short GoLasering = 6;

		AvoidChoice.Insert(GoTeleport, UsedTelePercent);
		AvoidChoice.Insert(GoSwoop, UsedSwoopPercent);
		AvoidChoice.Insert(GoBlock, UsedBlockPercent);
		AvoidChoice.Insert(GoJump, UsedJumpPercent);
		AvoidChoice.Insert(GoStopFlying, UsedStopFlyPercent);

		if ((IsSuperBot()) && (GetKi() > 200) &&
			(HighestDangerLevel >= danger_medium))
		{
			// yay im a superbot, i can cheat :D
			float MostDangerousEnemyDist = 9999.0;

			if (pMostDangerousPlayer)
				MostDangerousEnemyDist = UTIL_Distance(pEdict->v.origin,
													   pMostDangerousPlayer->GetOrigin());

			if (MostDangerousEnemyDist >= 350.0)
			{
				short LaserPercent = SBotSettings[m_sSBotType-1].laser_percent;

				if (DangerTypes & DangerEnemy)
					LaserPercent *= 0.75;

				if ((DangerTypes & DangerSound) || (DangerTypes & DangerHit))
					LaserPercent = 0;

				AvoidChoice.Insert(GoLasering, LaserPercent);
			}
		}

		int Choice = AvoidChoice.GetSelection();

		if (Choice == GoTeleport)
		{
			if (BotMayUseSolarFlare)
			{
				UseSolar = true;
				FakeClientCommand(pEdict, "teleport", NULL, NULL);
			}
			else if (((RANDOM_LONG(1, 100) <= m_pPersonality->teleport_percent) && 
					 (HighestDangerLevel == danger_heavy)) || (danger_level == danger_very_heavy))
				MakeCombo(teletwice);
			else
				MakeTask(TaskTeleport);

			if (HighestDangerLevel == danger_heavy)
				m_fTeleportDelay = 0.0; // do it as fast as possible
		}
		else if (Choice == GoSwoop)
		{
			MakeTask(TaskSwoopAway);
		}
		else if (Choice == GoBlock)
		{
			MakeTask(TaskBlock);
		}
		else if (Choice == GoJump)
		{
			MakeTask(TaskNormalJump);

			int RandNr = RANDOM_LONG(1, 3);

			if (RandNr == 0)
				m_sJumpDir = dir_left;
			else if (RandNr == 1)
				m_sJumpDir = dir_right;
			
			if (RANDOM_LONG(0, 1))
				m_sJumpDir |= dir_back;
		}
		else if (Choice == GoStopFlying)
		{
			m_bShouldFly = false;
			if (pEdict->v.gravity < 0.1)
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);

			m_fCheckFlyDelay = gpGlobals->time + RANDOM_FLOAT(1.0, 1.4);

			if (BotMayUseSolarFlare)
				UseSolar = true;
		}
		else if (Choice == GoLasering)
		{
			MakeTask(TaskKeepDangerAway);
		}

		if (UseSolar)
		{
			if (m_CurrentWeapon.iId != ESF_WEAPON_SOLARFLARE)
				UTIL_SelectItem(pEdict, "weapon_solarflare");
			pEdict->v.button |= IN_ATTACK;
		}

/*
		char DTypes[125] = "";

		if (DangerTypes & DangerAttack)
			strcat(DTypes, "DangerAttack ");
		if (DangerTypes & DangerSound)
			strcat(DTypes, "DangerSound ");
		if (DangerTypes & DangerEnemy)
			strcat(DTypes, "DangerEnemy ");
		if (DangerTypes & DangerHit)
			strcat(DTypes, "DangerHit ");
		if (DangerTypes & DangerCurrentEnemy)
			strcat(DTypes, "DangerCurrentEnemy");

		FILE *fp = fopen("bot.txt", "a");
		fprintf(fp, "\n\n Bot sense results:\n\n"
					"UsedTeleportPercent: %f\n"
					"UsedSwoopPercent: %f\n"
					"UsedJumpPercent: %f\n"
					"UsedBlockPercent: %f\n"
					"UsedStopFlyPercent: %f\n"
					"AvoidChoice: %s\n"
					"DangerDist: %f\n"
					"DangerTypes: %s\n"
					"DangerLevel: %d\n",
					UsedTelePercent, UsedSwoopPercent, UsedJumpPercent, UsedBlockPercent,
					UsedStopFlyPercent, s, NearestDangerDist, DTypes, HighestDangerLevel);
		fclose(fp);*/
	}
#ifdef LOGBOTINFO
	clog << "BotSense() End\n";
#endif

}

#endif