#include "extdll.h"
#include "util.h"
#include "cbase.h"

#include "bot.h"
#include "bot_func.h"
#include "waypoint.h"
#include "bot_weapons.h"
#include "combo.h"
#include "bot_action.h"
#include "client.h"

#include <sys/types.h>
#include <sys/stat.h>

extern bot_t bots[32];
extern ClientInfo_t ClientInfo[32];

extern bool b_observer_mode;
extern bool isesfteamplay;
extern bool b_botdontshoot;
extern bool BotDontSearchEnemy;
extern edict_t *listenserver_edict;
extern int bot_melee_percent;
extern int bot_teleport_percent;

char *ChargeLightBeamSounds[ChargeSoundLightNumber] = {
	"weapons/basicbeam_charge.wav", "weapons/burning_charge.wav"};
	
char *ChargeMediumBeamSounds[ChargeSoundMediumNumber] = {
	"weapons/mase_charge.wav", "weapons/powerbeam.wav"};

char *ChargeHeavyBeamSounds[ChargeSoundHeavyNumber] = {
	"weapons/kame_charge.wav", "cell/gallitgun.wav", "cell2/gallitgun.wav", 
	"vegeta/gallitgun.wav", "cell/kamehame.wav", "celll2/kamehame.wav", 
	"gohan/kamehame.wav", "goku/kamehame.wav"};

char *ChargeNonBeamSounds[ChargeSoundNonBeam] = {
	"weapons/sbc_charge.wav", "weapons/deathball_charge.wav","weapons/shieldha.wav",
    "goku/spiritbomb_charge.wav", "goku/spiritbomb2_charge.wav"};

char *KiBallShots[KiBallNumber] = {
    "weapons/kiblast.wav", "weapons/kiblast2.wav"};

char *ReleaseFireMostBlockSounds[ReleaseMostBlockNumber] = {
	"weapons/basicbeam_fire.wav", "weapons/beamfire.wav",
	"weapons/beamhead.wav", "weapons/burning_fire.wav"};

char *ReleaseFireHalfBlockSounds[ReleaseHalfBlockNumber] = {	
	"weapons/kamehameha_fire.wav", "cell/gallitgunfire.wav", 
	"cell2/gallitgunfire.wav", "cell/ha.wav", "cell2/ha.wav", "gohan/powerbeamha.wav", 
	"gohan/ha.wav", "goku/ha.wav", "krillin/ha.wav", "piccolo/ha.wav",
	"piccolo/specialbeamcannon.wav", "vegeta/finalflash.wav", "vegeta/gallitgunfire.wav"};

char *ReleaseFireNeverBlockSounds[ReleaseNeverBlockNumber] = {
	"weapons/buster_fire.wav", "weapons/bigbang_fire.wav", "weapons/deathball_fire.wav", 
    "weapons/sbc_fire.wav", "weapons/disc_fire.wav", "weapons/shieldha.wav", 
	"weapons/spiritbomb_fire.wav", "piccolo/specialbeamcannon.wav", "vegeta/bigbang.wav",
    "cell/specialbeamcannon.wav", "krillin/scatterbeamha.wav", "krillin/destructodisc.wav"};


char *LaserSounds[LaserSoundsNumber] = {
	"weapons/fingerlaser.wav", "weapons/candyattack.wav", "weapons/eyebeam_fire.wav"};

// here is the bot hearing system handled. if a sound is played
// the sound gets analyzed and stored in the array SoundStorage
// this should be optimized whith a proper hear distance
void SoundAttachToThreat(edict_t *pEdict,const char *pszSample,float fVolume)
{
	if(!pEdict)
		return;

	//Vector vecPosition;
	int iIndex = 0;
    int i = 0;
	
    for (i = 1; i <= gpGlobals->maxClients; i++)
    {
  	   edict_t *pPlayer = INDEXENT(i);
	   if (pPlayer == pEdict)
	   {
		   iIndex = i;
		   break;
	   }

	}

    //fp=fopen("bot.txt","a"); fprintf(fp,"Sound: %s\nedict: %x\n", pszSample, pEdict); fclose(fp);
	
	if ( pEdict == NULL)
		return;

	for (i=0;i<LaserSoundsNumber;i++)
	{
		if (strcmp(pszSample, LaserSounds[i]) == 0)
        {
		   if (strcmp(pszSample, "weapons/candyattack.wav") == 0)
           {
               SoundStorage[iIndex].SoundDistance = 200.0;// * fVolume;
		       SoundStorage[iIndex].SoundDuration = gpGlobals->time + 1;
           }
           else
           {
               SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		       SoundStorage[iIndex].SoundDuration = gpGlobals->time + 1.5;
           }
 
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = LaserSoundAction;
		   return;
		}
	}		

    for (i=0;i<ChargeSoundLightNumber;i++)
    {
		if (strcmp(pszSample, ChargeLightBeamSounds[i]) == 0)
        {
		   SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		   SoundStorage[iIndex].SoundDuration = gpGlobals->time + 3.5;
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ChargeLightAction;
		   return;
		}
	}
    for (i=0;i<ChargeSoundMediumNumber;i++)
    {
		if (strcmp(pszSample, ChargeLightBeamSounds[i]) == 0)
        {
		   SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		   SoundStorage[iIndex].SoundDuration = gpGlobals->time + 3.5;
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ChargeMediumAction;
		   return;
		}
	}
    for (i=0;i<ChargeSoundHeavyNumber;i++)
    {
		if (strcmp(pszSample, ChargeLightBeamSounds[i]) == 0)
        {
		   SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		   SoundStorage[iIndex].SoundDuration = gpGlobals->time + 3.5;
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ChargeHeavyAction;
		   return;
		}
	}
    for (i=0;i<ChargeSoundNonBeam;i++)
    {
		if (strcmp(pszSample, ChargeNonBeamSounds[i]) == 0)
        {
		   SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		   SoundStorage[iIndex].SoundDuration = gpGlobals->time + 3.5;
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ChargeNonBeamAction;
		   return;
		}
	}
    for (i=0;i<ReleaseMostBlockNumber;i++)
    {
		if (strcmp(pszSample, ReleaseFireMostBlockSounds[i]) == 0)
        {
		   SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		   SoundStorage[iIndex].SoundDuration = gpGlobals->time + 1.5;
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ReleaseMostBlockAction;
		   return;
		}
	}
    for (i=0;i<ReleaseHalfBlockNumber;i++)
    {
		if (strcmp(pszSample, ReleaseFireHalfBlockSounds[i]) == 0)
        {
		   SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		   SoundStorage[iIndex].SoundDuration = gpGlobals->time + 1.5;
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ReleaseHalfBlockAction;
		   return;
		}
	}
    for (i=0;i<ReleaseNeverBlockNumber;i++)
    {
		if (strcmp(pszSample, ReleaseFireNeverBlockSounds[i]) == 0)
        {
		   if (strcmp(pszSample, "weapons/candyattack.wav") == 0)
           {
               SoundStorage[iIndex].SoundDistance = 300.0;// * fVolume;
		       SoundStorage[iIndex].SoundDuration = gpGlobals->time + 1;
           }
           else
           {
               SoundStorage[iIndex].SoundDistance = 3000.0;// * fVolume;
		       SoundStorage[iIndex].SoundDuration = gpGlobals->time + 1.5;
           }
 
		   SoundStorage[iIndex].SoundPosition = pEdict->v.origin;
		   SoundStorage[iIndex].pEdict = pEdict;
		   SoundStorage[iIndex].Action = ReleaseNeverBlockAction;
		   return;
		}
	}
}

// the reaction on a sound is handled here (like blocking)
edict_t *BotCheckForSounds (bot_t *pBot)
{
	if ((b_botdontshoot) || (BotDontSearchEnemy))
		return NULL; // Rick 13/10/03: Might fix the bug where bots use melee when they shouldn't

	//return NULL; // to turn off
	int i = 0;

	edict_t *pNewEnemy = NULL;
	edict_t *pEdict = pBot->pEdict;

    float NearestDistance = 9999.0;
    bool IsVisible = false;
    bool IsOnScouter = false;
	bool IsInViewCone = false;
	int RandNr=0;
	bool ShouldSkipOtherPlayers = (((pBot->bot_skill > 1) || (pBot->f_max_speed == 0)) && 
		                            (UTIL_IsValidPlayer(pBot->pBotEnemy)) && (pBot->BlockTime >= gpGlobals->time));

    Vector vecEnemyEnd;

	//return (NULL);

	if (UTIL_IsValidPlayer(pBot->pBotEnemy))
	{
        Vector v_enemy = pBot->pBotEnemy->v.origin - pEdict->v.origin;
		NearestDistance = v_enemy.Length();
		//pNewEnemy = pBot->pBotEnemy;
	}

    for (i = 1; i <= gpGlobals->maxClients; i++)
	{
	   edict_t *pPlayer = INDEXENT(i);

	   if ((pBot->pBotEnemy != pPlayer) && (ShouldSkipOtherPlayers))
		   continue;

	   if (!UTIL_IsValidPlayer(pPlayer))
		    continue;

	   if (pPlayer == pEdict)
		   continue;

       // is team play enabled?
       if (isesfteamplay)
	   {
          int player_team = UTIL_GetTeam(pPlayer);
          int bot_team = UTIL_GetTeam(pEdict);

          // don't target your teammates...
          if (bot_team == player_team)
              continue;
	   }

	   vecEnemyEnd = pEdict->v.origin + pEdict->v.view_ofs;
       if (!FInViewCone( &vecEnemyEnd, pPlayer ))
	 	   continue;

	   if ((SoundStorage[i].SoundDistance != 0.0) && 
			(SoundStorage[i].SoundDuration >= gpGlobals->time))
	   {
	 	   float Distance = (SoundStorage[i].SoundPosition - pEdict->v.origin).Length();
           Vector vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;        
           //fp=fopen("bot.txt","a"); fprintf(fp,"heard something\n");fclose(fp);
		   if ((Distance > SoundStorage[i].SoundDistance) && (pBot->bot_skill > 1))
		 	   continue;

           if ((Distance > SoundStorage[i].SoundDistance) && (SoundStorage[i].SoundDistance == 200))
               continue;

		   //fp=fopen("bot.txt","a"); fprintf(fp,"distance: %f\n", Distance); fclose(fp);

		   IsInViewCone = ((FInViewCone( &vecEnd, pEdict )));
		   IsVisible = FVisible( vecEnd, pEdict );
           IsOnScouter = (Distance < 2100.0); 

		   if ((Distance < NearestDistance) && ((IsInViewCone) || (IsOnScouter)) && (IsVisible))
		   {
		  	   NearestDistance = Distance;
  	 	       pNewEnemy = SoundStorage[i].pEdict;
			}
            
		}
	}

	if (UTIL_IsValidPlayer(pBot->pBotEnemy))
	{
        Vector v_enemy = pBot->pBotEnemy->v.origin - pEdict->v.origin;
		NearestDistance = v_enemy.Length();
		//pNewEnemy = pBot->pBotEnemy;
	}
    else
		NearestDistance = 9999.0;

	if (pNewEnemy == NULL)
	{
         for (i = 1; i <= gpGlobals->maxClients; i++)
		 {
	         edict_t *pPlayer = INDEXENT(i);

	         if (pPlayer == pEdict)
		        continue;

    	     if ((pBot->pBotEnemy != pPlayer) && (ShouldSkipOtherPlayers))
		        continue;

	         if (!UTIL_IsValidPlayer(pPlayer))
		       continue;

             // is team play enabled?
             if (isesfteamplay)
			 {
                int player_team = UTIL_GetTeam(pPlayer);
                int bot_team = UTIL_GetTeam(pEdict);

                // don't target your teammates...
                if (bot_team == player_team)
                    continue;
			 }

			 if ((SoundStorage[i].SoundDistance != 0.0) && 
		  	     (SoundStorage[i].SoundDuration >= gpGlobals->time))
			 {
	 	         float Distance = (SoundStorage[i].SoundPosition - pEdict->v.origin).Length();
                 //fp=fopen("bot.txt","a"); fprintf(fp,"heard something\n");fclose(fp);
         	     Vector vecEnd = pPlayer->v.origin + pPlayer->v.view_ofs;

	  	         //fp=fopen("bot.txt","a"); fprintf(fp,"distance: %f\n", Distance); fclose(fp);

			     IsInViewCone = ((FInViewCone( &vecEnd, pEdict )));
				 IsVisible = FVisible( vecEnd, pEdict );
				 IsOnScouter = (Distance < 2100.0); 

		         if ((Distance > SoundStorage[i].SoundDistance) && (pBot->bot_skill > 1) &&
				 (!IsInViewCone))
		 	         continue; 

                 if ((Distance > SoundStorage[i].SoundDistance) && (SoundStorage[i].SoundDistance == 200))
                     continue;

		         if ((Distance < NearestDistance) && (((IsVisible) && ((IsOnScouter) || (IsInViewCone)))))
				 {
		  	         NearestDistance = Distance;
		 	         pNewEnemy = SoundStorage[i].pEdict;
				 }
			 }	 
		 } 
	}

    if (pNewEnemy)
    {
       int PlayerInd = 0;

	   // face the enemy
       Vector v_enemy = pNewEnemy->v.origin - pEdict->v.origin;
       Vector bot_angles = WrapAngles(UTIL_VecToAngles( v_enemy ));
 
       pBot->AimVec = WrapAngles(bot_angles);
       
       Vector vecEnd = pEdict->v.origin + pEdict->v.view_ofs;        
 
	   bool IsBotVisible = (FInViewCone( &vecEnd, pNewEnemy ));
       if (!IsBotVisible)
	      return (pNewEnemy); // don't react on the sound if the enemy isn't facing the bot

	   if (!(pBot->action.subchecks & check_for_sound_reaction))
		   return pNewEnemy; // don't react when we don't want react :-)

       for (i=1;i<=gpGlobals->maxClients;i++)
	   {
		   edict_t *pPlayer = INDEXENT(i);
		   if (pPlayer == pNewEnemy)
		   {
			   PlayerInd = i;
			   break;
		   }
	   }

	   RandNr = RANDOM_LONG(1, 100);

	   int DoCharge = 0;
	   int DoCombo = 0;

	   if (RandNr < 50)
		DoCharge++;
	   else
	      DoCombo++;

	   if (RandNr < pBot->TeleportPercent)
	      DoCombo+=4;
	   else
	      DoCharge+=4;

	   if (RandNr < pBot->MeleePercent)
	      DoCombo+=3;
	   else
	      DoCharge+=3;

	   if ((pEdict->v.frags+RANDOM_LONG(0, 10)) >= pNewEnemy->v.frags)
	      DoCharge++;
	   else
	      DoCombo++;

	   int ClInd = UTIL_GetClientIndex(pNewEnemy);

	   if (ClInd != -1)
		  if (pBot->PL >= (ClientInfo[ClInd].PL - RANDOM_LONG(50000, 90000)))
			  DoCharge++;

       switch (SoundStorage[PlayerInd].Action)
	   {		 
	   case LaserSoundAction:
			Make_Action(pBot,task_teleport);
			pBot->f_shoot_time = gpGlobals->time + 2;
			ResetChargeAttacks(pBot);
			break;

	   case ChargeLightAction:
		   if (RANDOM_LONG(0, 1))
		   {
/*			   if (DoCharge < DoCombo)
               {
                   if (RANDOM_LONG(1, 100) < 50)
				      MakeCombo(pBot,telemelee1); 
               }
		       else*/
			   {
				  Reset_Actions(pBot);
			      BotFireWeapon(v_enemy,pBot,UTIL_GetRandLightBeamAttack(pBot));
			   }
		   }
		   break;
	   case ChargeMediumAction:
		   if (RANDOM_LONG(0, 1))
		   {
/*			   if (DoCharge < DoCombo)
               {
                          if (RANDOM_LONG(1, 100) < 50)
				      MakeCombo(pBot,telemelee1);
               }
		       else*/
			   {
				  Reset_Actions(pBot);
			      BotFireWeapon(v_enemy,pBot,UTIL_GetRandMediumBeamAttack(pBot));
			   }
		   }
		   break;
	   case ChargeHeavyAction:
		   if (RANDOM_LONG(0, 1))
		   {
/*			   if (DoCharge < DoCombo)
               {
                          if (RANDOM_LONG(1, 100) < 50)
				      MakeCombo(pBot,telemelee1);
               }
		       else*/
			   {
				  Reset_Actions(pBot);
			      BotFireWeapon(v_enemy,pBot,UTIL_GetRandHeavyBeamAttack(pBot));
			   }
		   }
		   break;
	   case ChargeNonBeamAction:
		   if (RANDOM_LONG(0, 1))
		   {
/*			   if (DoCharge < DoCombo)
                     {
                          if (RANDOM_LONG(1, 100) < 50)
				      MakeCombo(pBot,telemelee1);
                     }
		       else*/
			   {
				  Reset_Actions(pBot);
			      BotFireWeapon(v_enemy,pBot,UTIL_GetRandNonBeamAttack(pBot));
			   }
		   }
		   break;
	   }
	   if (PlayerInd != -1)
	     ResetSound(PlayerInd);
	}
	else
		pNewEnemy = pBot->pBotEnemy; // if no new enemy found return the 'old' one (if exists)

    return (pNewEnemy);
}

void ResetSound(int index)
{
	SoundStorage[index].pEdict = NULL;
	SoundStorage[index].SoundDistance = 0;
	SoundStorage[index].SoundDuration = 0;
	SoundStorage[index].Action = 0;
}
