#include "general_header.h"
#include "studio.h"

extern ClientInfo_t ClientInfo[32];
extern edict_t *listenserver_edict;
extern bot_t bots[32];
extern bool CheckForDBSpot;
#ifdef _DEBUG
extern int FVisibleCalls;
#endif

edict_t *pHostViewPlayer = NULL;
CBaseEntity *pHostCam = NULL;
edict_t *pBeamViewEnt = NULL;
CBaseEntity *pBeamCam = NULL;

#ifdef classstuff
CClientManager *pClientManager = NULL;


CClient::CClient(edict_t *pPlayer) : pEdict(pPlayer), m_lPL(1000000), m_bPowerUps(false),
									 m_bChargeValue(0), m_fAscendTime(0.0), m_sPSVal(127),
									 m_fBlindedTime(0.0), m_bIsAutoPunching(false),
									 m_bGetAutoPunched(false), m_bIsInMeleeMode(false),
									 m_bAscends(false), m_bPowerstruggles(false),
									 m_bChargesAttack(false), m_bFlysAfterHit(false),
									 m_bChargesWallJump(false), m_bWallJumps(false),
									 m_bSwoops(false), m_bMeleeStruggles(false),
									 m_bIsStuckAgainstWall(false), m_bLaysOnGround(false),
									 m_bControlsAttack(false), m_bBeamJumps(false),
									 m_bIsBlinded(false), m_bBlocks(false), 
									 m_bBlockStruggles(false), m_fFrozenTime(0.0),
									 m_fLastSoundTime(0.0), m_fLastOldPosCheck(0.0),
									 m_bIsIngame(false)
{
	strcpy(m_szSoundName, "");
	memset(m_OldPositions, 0, sizeof(m_OldPositions));
}

void CClient::Think()
{
	if (m_bIsIngame == false)
		return; // This player is not ingame yet.

	if (IsNull(pEdict))
		throw CBadEdictException(this); // throw an exception so we can remove this player

	UpdateOldPositions(); // Save old locations of this player so bots can hunt him down.
	UpdateStatus(); // Fill bools so bots can easily see what this player is doing.
	UpdateFrozenStatus(); // See if this player needs to be freed after an super bot froze him.
}

// Save old locations of this player so bots can hunt him down.
void CClient::UpdateOldPositions()
{
	if (m_fLastOldPosCheck < gpGlobals->time)
	{
		m_fLastOldPosCheck = gpGlobals->time + 0.2;
		
		Vector v_src = pEdict->v.origin;
		Vector v_old = m_OldPositions[0].Place;
		float Dist = UTIL_Distance(v_src, v_old);

		if (Dist > MinNewPositionDistance)
		{
			for (short j=(MaxOldPositions-1);j>0;j--)
				m_OldPositions[j] = m_OldPositions[j-1];
				  
			m_OldPositions[0].Place = v_src;
			m_OldPositions[0].CreateTime = gpGlobals->time;
		}
	}
}

// Determine what this player is doing...
void CClient::UpdateStatus()
{
	m_bIsAutoPunching = false;
	m_bGetAutoPunched = false;
	m_bAscends = (m_fAscendTime >= gpGlobals->time);
	m_bPowerstruggles = (m_sPSVal < 127);
	m_bChargesAttack = (m_bChargeValue > 0);
	m_bFlysAfterHit = false;
	m_bChargesWallJump = false;
	m_bWallJumps = false;
	m_bSwoops = false;
	m_bMeleeStruggles = false;
	m_bIsStuckAgainstWall = false;
	m_bLaysOnGround = false;
	m_bControlsAttack = false;
	m_bBeamJumps = false;
	m_bIsBlinded = (m_fBlindedTime >= gpGlobals->time);
	m_bBlocks = false;
	m_bBlockStruggles = false;
	m_bIsInMeleeMode = false;

	void *pModel = GET_MODEL_PTR(pEdict);
	mstudioseqdesc_t *pseqdesc;
	studiohdr_t *pstudiohdr;
	
	pstudiohdr = (studiohdr_t *)pModel;

	if (pstudiohdr)
	{
		pseqdesc = (mstudioseqdesc_t *)((byte *)pstudiohdr + pstudiohdr->seqindex);

		// Just in case...
		if ((pEdict->v.sequence >= 0) && 
			(pEdict->v.sequence < pstudiohdr->numseq))
		{
			char CurrentAni[32];
			strcpy(CurrentAni, pseqdesc[pEdict->v.sequence].label);

			if (stricmp(CurrentAni, "ref_autopunch") == 0)
			{
				if (m_bPowerstruggles)
					m_bMeleeStruggles = true;
				else
					m_bIsAutoPunching = true;
			}
			else if ((stricmp(CurrentAni, "ref_autopunch_hit") == 0) ||
					 (stricmp(CurrentAni, "wall_autopunched") == 0) ||
					 (stricmp(CurrentAni, "ref_autopunch_hit_back") == 0) ||
					 (stricmp(CurrentAni, "ref_autopunch_block") == 0) ||
					 (stricmp(CurrentAni, "ref_autopunch_spin") == 0))
				m_bGetAutoPunched = true;
			else if ((stricmp(CurrentAni, "hit_blow_back") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_front") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_down") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_up") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_left") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_right") == 0) ||
					 (stricmp(CurrentAni, "tumble_forward") == 0) ||
					 (stricmp(CurrentAni, "tumble_back") == 0) ||
					 (stricmp(CurrentAni, "tumble_left") == 0) ||
					 (stricmp(CurrentAni, "tumble_right") == 0) ||
					 (stricmp(CurrentAni, "blow_hit_ground") == 0) ||
					 (stricmp(CurrentAni, "wall_fall") == 0))
				m_bFlysAfterHit = true;
			else if (stricmp(CurrentAni, "wall_idle") == 0)
				m_bIsStuckAgainstWall = true;
			else if ((stricmp(CurrentAni, "lay_ground") == 0) ||
					 (stricmp(CurrentAni, "lay_ground2") == 0))
				m_bLaysOnGround = true;
			else if ((stricmp(CurrentAni, "grabwall_forward") == 0) ||
					 (stricmp(CurrentAni, "grabwall_back") == 0) ||
					 (stricmp(CurrentAni, "grabwall_left") == 0) ||
					 (stricmp(CurrentAni, "grabwall_right") == 0))
				m_bChargesWallJump = true;
			else if ((stricmp(CurrentAni, "walljump_forward") == 0) ||
					 (stricmp(CurrentAni, "walljump_back") == 0) ||
					 (stricmp(CurrentAni, "walljump_left") == 0) ||
					 (stricmp(CurrentAni, "walljump_right") == 0))
				m_bWallJumps = true;
			else if ((stricmp(CurrentAni, "swoop") == 0) ||
					 (stricmp(CurrentAni, "swoop_up") == 0) ||
					 (stricmp(CurrentAni, "swoop_down") == 0) ||
					 (stricmp(CurrentAni, "swoop_left") == 0) ||
					 (stricmp(CurrentAni, "swoop_right") == 0) ||
					 (stricmp(CurrentAni, "swoop_forward") == 0) ||
					 (stricmp(CurrentAni, "swoop_backward") == 0))
				m_bSwoops = true;
			else if ((stricmp(CurrentAni, "ref_control_genericbeam") == 0) ||
					 (stricmp(CurrentAni, "ref_control_gallitgun") == 0) ||
					 (stricmp(CurrentAni, "ref_control_finalflash") == 0) ||
					 (stricmp(CurrentAni, "ref_control_kamehameha") == 0) ||
					 (stricmp(CurrentAni, "ref_control_burningattack") == 0) ||
					 (stricmp(CurrentAni, "ref_control_powerbeam") == 0) ||
					 (stricmp(CurrentAni, "ref_control_masenko") == 0) ||
					 (stricmp(CurrentAni, "ref_control_mouthblast") == 0))
				m_bControlsAttack = true;
			else if ((stricmp(CurrentAni, "ref_beam_push") == 0) &&
					 (m_bChargesAttack == false))
				m_bBeamJumps = true;
			else if ((stricmp(CurrentAni, "ref_block") == 0) ||
					 (stricmp(CurrentAni, "fly_block") == 0))
				m_bBlocks = true;
		}
	}

	if (*((int *)pEdict->pvPrivateData + MELEE_OFFSET) == 1)
	{
		if ((m_bIsAutoPunching) || (m_bMeleeStruggles) || (m_bFlysAfterHit))
			m_bIsInMeleeMode = false;
		else
			m_bIsInMeleeMode = true;
	}

	if ((m_bBlocks) && (m_bPowerstruggles))
		m_bBlockStruggles = true;
}

void CClient::UpdateFrozenStatus()
{
	if ((m_fFrozenTime > 0.0) && (m_fFrozenTime < gpGlobals->time))
	{
		pEdict->v.flags &= ~FL_FROZEN;
		m_fFrozenTime = 0.0;
	}
}

void CClient::GetModel(char *Output)
{
	char *infobuffer;
    infobuffer = (*g_engfuncs.pfnGetInfoKeyBuffer)(pEdict);
    strcpy(Output, (g_engfuncs.pfnInfoKeyValue(infobuffer, "model")));
}

void CClient::ToggleTurbo(ESwitch OnOff)
{
	if (OnOff == ON)
	{
		if (!IsTurboOn(pEdict))
			FakeClientCommand(pEdict,"turbo",NULL,NULL);
	}
	else
	{
		if (IsTurboOn(pEdict))
			FakeClientCommand(pEdict,"turbo",NULL,NULL);
	}
}

void CClient::SetTeam(short Team)
{
	char szTeam[8] = "";
	itoa(Team, szTeam, 10);
	FakeClientCommand(pEdict, "jointeam", szTeam, NULL);
}

bool CClient::FInViewCone(Vector *pOrigin)
{
	static Vector2D vec2LOS;

    UTIL_MakeVectors ( pEdict->v.angles );

    vec2LOS = ( *pOrigin - pEdict->v.origin ).Make2D();
    vec2LOS = vec2LOS.Normalize();

	return (DotProduct (vec2LOS , gpGlobals->v_forward.Make2D() ) > 0.50);
}


bool CClient::FVisible(const Vector &vecOrigin)
{
	static TraceResult tr;

    if (UTIL_VecIsInLava(vecOrigin))
		return false;

#ifdef _DEBUG
    FVisibleCalls++;
#endif

    UTIL_TraceLine(GetGunPosition(), vecOrigin, ignore_monsters, ignore_glass, pEdict, &tr);

	return (tr.flFraction == 1.0);
}

void CClient::ClientMsgScreenFade(void *pValue)
{
	static int state = 0;   // current state machine state
    static int duration;
    static int hold_time;
    static int fade_flags;
    int length;

    if (state == 0)
    {
		state++;
		duration = *(int *)pValue;
    }
    else if (state == 1)
    {
		state++;
		hold_time = *(int *)pValue;
    }
    else if (state == 2)
    {
		state++;
		fade_flags = *(int *)pValue;
    }
    else if (state == 6)
    {
		state = 0;

        length = (duration + hold_time) / 4096;
        m_fBlindedTime = gpGlobals->time + length - 2.0;
    }
    else
    {
		state++;
    }
}

void CClient::ClientMsgVGUI(void *pValue)
{
   if ((*(int *)pValue) == 2)  // is it a team select menu?
	   TeamMenuShowedUp = true;
   if ((*(int *)pValue) == 3)  // is it a class select menu?
	   ClassMenuShowedUp = true;
}

bool CClient::IsAlive()
{
	return ((pEdict->v.deadflag == DEAD_NO) &&
            (pEdict->v.health > 0) && !(pEdict->v.flags & FL_NOTARGET) &&
	 	    (pEdict->v.takedamage != 0) && !(pEdict->v.flags & EF_NODRAW) &&
		    (pEdict->v.iuser1 != 1));
}

void CClient::ClearOldPositions()
{
	memset(m_OldPositions, 0, sizeof(m_OldPositions));
}

// Return the name of the class of the player. Trys to filter out custom model changing as much as
// possible...
void CClient::PlayerClassify(char *ClassName)
{
	char model[32] = "";

	GetModel(model);

	switch (GetClass())
	{
	case 1:
		if (FStrEq(model,"fatbuu"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "buu");
		break;
	case 2:
		if (FStrEq(model,"ssjgoku"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "goku");
		break;
	case 3:
		if (FStrEq(model,"ssjgohan"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "gohan");
		break;
	case 4:
		if (FStrEq(model,"krillin2"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "krillin");
		break;
	case 5:
		if (FStrEq(model,"frieza2"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "frieza");
		break;
	case 6:
		if (FStrEq(model,"piccolo2"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "piccolo");
		break;
	case 7:
		if (FStrEq(model,"ssjtrunks"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "trunks");
		break;
	case 8:
		if (FStrEq(model,"ssjvegeta"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "vegeta");
		break;
	case 9:
		if (FStrEq(model,"cell2"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "cell");
		break;
	}

	if (FStrEq(ClassName, ""))
		sprintf(ClassName, "goku");
}

void LogCLList(CClient *pClient)
{
	clog << "Logging player " << STRING(pClient->pEdict->v.netname) << "\n";
	clog << "Is a bot: " << pClient->IsBot() << "\n";
	clog << "Is the host " << (pClientManager->GetHost() == pClient) << "\n";
}


CClientManager::CClientManager() : pHost(NULL), PlayerCount(0)
{
	pClientList = new TLinkedList<CClient*>;
}

CClientManager::~CClientManager()
{
	if (pClientList)
	{
		while (pClientList->Empty() == false)
			delete pClientList->Pop();
			
		delete pClientList;
		pClientList = NULL;
	}
}

// Filter all bad clients before clients 'think' so that they won't have to check if the player is
// valid.
void CClientManager::FilterBadClients(CClient *pClient)
{
	// Is this player valid?
	if ((!pClient) || (IsNull(pClient->pEdict)) ||
		(FStrEq(STRING(pClient->pEdict->v.netname), "")))
		pClientList->DeleteEntry(pClient);

	return;
}
	
void CClientManager::LetClientsThink(CClient *pClient)
{
	try
	{
		pClient->Think();
	}
	catch (CBadEdictException& ex)
	{
		clog << "Exception @ " << STRING(pClient->pEdict->v.netname) << "\n";
		DisconnectPlayer(ex.pClient->pEdict);
	}
}

void CClientManager::ConnectPlayer(edict_t *pEdict)
{
	if (!pEdict)
		return;

	CClient *pClient = new CClient(pEdict);
	pClientList->AddNode(pClient);
	PlayerCount++;
}

void CClientManager::ConnectBot(edict_t *pEdict)
{
	if (!pEdict)
		return;

	CClient *pClient = new CBot(pEdict);
	pClientList->AddNode(pClient);
	PlayerCount++;
}

void CClientManager::DisconnectPlayer(edict_t *pEdict)
{
	if (!pEdict)
	{
		clog << "No edict in Disconnect player!\n";
		return;
	}

	char szName[64];
	strcpy(szName, STRING(pEdict->v.netname));

	if ((pHost) && (pEdict == pHost->pEdict))
		pHost = NULL;

	CClient *pClient = GetClientFromEdict(pEdict);

	if (!pClient)
	{
		clog << "No pClient in Disconnect player!\n";
		return;
	}

	pClientList->DeleteEntry(pClient);
	delete pClient;
	PlayerCount--;
}

CClient *CClientManager::GetClientFromEdict(edict_t *pEdict)
{
	return (pClientList->FindIf(this, &CClientManager::EdictIsFromClient, pEdict));
}

bool CClientManager::EdictIsFromClient(CClient *pClient, edict_t *pEdict)
{
	if (!pClient)
		return false;

	return (pClient->pEdict == pEdict);
}

void CClientManager::GlobalNetworkMsgPL(void *pValue)
{
	static int state = 0;
	static int PlayerIndex = -1;

	if (state == 0)
	{
		state++;
		PlayerIndex = *(int *)pValue;
	}
	else
	{
		state = 0;

		if ((PlayerIndex > 0) && (PlayerIndex < 33))
		{
		    edict_t *pPlayer = INDEXENT(PlayerIndex);
			CClient *pClient = GetClientFromEdict(pPlayer);
			long NewPl = *(long *)pValue;

			if ((IsNull(pPlayer) == false) && (pClient))
			{
				pClient->m_lPL = NewPl;
			}
		}
		PlayerIndex = -1;
	}
}


void CClientManager::GlobalNetworkMsgStartPowerUp(void *pValue)
{
	static int state = 0;
	
	if (state == 0)
	{
		state++;

		int PlayerIndex = *(int *)pValue;
        edict_t *pPlayer = INDEXENT(PlayerIndex);
		CClient *pClient = GetClientFromEdict(pPlayer);

		if ((IsNull(pPlayer) == false) && (pClient))
			pClient->m_bPowerUps = true;	
	}
    else if (state == 1)
    {
        state ++;
    }
    else if (state == 2)
    {
        state ++;
    }
    else if (state == 3)
    {
        state = 0;
	}
}


void CClientManager::GlobalNetworkMsgStopPowerUp(void *pValue)
{
	int PlayerIndex = *(int *)pValue;

    edict_t *pPlayer = INDEXENT(PlayerIndex);
	CClient *pClient = GetClientFromEdict(pPlayer);

	if ((IsNull(pPlayer) == false) && (pClient))
		pClient->m_bPowerUps = false;	
}


void CClientManager::GlobalNetworkMsgTransformFX(void *pValue)
{
	static int state = 0;
	static int PlayerIndex = -1;

	if (state == 0)
	{
		state++;

		PlayerIndex = *(int *)pValue;
	}
    else if (state == 1)
    {
        state = 0;
		edict_t *pPlayer = INDEXENT(PlayerIndex);
		CClient *pClient = GetClientFromEdict(pPlayer);

		if ((IsNull(pPlayer) == false) && (pClient))
			pClient->m_fAscendTime = *(float *)pValue + gpGlobals->time;
    }
}


void CClientManager::GlobalNetworkMsgStopTransFX(void *pValue)
{
	int PlayerIndex = *(int *)pValue;
    edict_t *pPlayer = INDEXENT(PlayerIndex);
	CClient *pClient = GetClientFromEdict(pPlayer);

	if ((IsNull(pPlayer) == false) && (pClient))
		pClient->m_fAscendTime = 0.0;
}

// List operation functions of CClientManager
void CClientManager::CountTeams(CClient *pClient, byte *GoodCount, byte *EvilCount)
{
	if (pClient->GetTeam() == 1)
		*GoodCount++;
	else
		*EvilCount++;
}

#endif

bool PlayerIsAutoPunching(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].IsAutoPunching);

	return false;
}

bool PlayerGetAutoPunched(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].GetAutoPunched);

	return false;
}

bool PlayerIsInMeleeMode(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].IsInMeleeMode);

	return false;
}

bool PlayerPowerstruggles(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].Powerstruggles);

	return false;
}

bool PlayerChargesAttack(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].ChargesAttack);

	return false;
}

bool PlayerAscends(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].Ascends);

	return false;
}

bool PlayerFlysAfterHit(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].FlysAfterHit);

	return false;
}

bool PlayerIsStuckAgainstWall(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].IsStuckAgainstWall);

	return false;

}

bool PlayerLaysOnGround(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].LaysOnGround);

	return false;

}

bool PlayerChargesWallJump(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].ChargesWallJump);

	return false;
}

bool PlayerWallJumps(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].WallJumps);

	return false;
}

bool PlayerSwoops(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].Swoops);

	return false;
}

bool PlayerMeleeStruggles(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].MeleeStruggles);

	return false;
}	

bool PlayerControlsAttack(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].ControlsAttack);

	return false;
}

bool PlayerBeamJumps(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].BeamJumps);

	return false;

}

bool PlayerIsBlinded(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].IsBlinded);

	return false;
}

bool PlayerBlocks(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].Blocks);

	return false;
}

bool PlayerBlockStruggles(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].BlockStruggles);

	return false;
}

bool PlayerHasADB(edict_t *pEdict)
{
	short ClInd = UTIL_GetClientIndex(pEdict);
	if (ClInd > -1)
		return (ClientInfo[ClInd].HasDB);

	return false;
}

// This function might need some explanation :)
void ClientThink(ClientInfo_t *pClient)
{
	void *pModel = GET_MODEL_PTR(pClient->pEdict);
	if (!pModel)
		return; // Just in case

	mstudioseqdesc_t *pseqdesc;
	studiohdr_t *pstudiohdr;
	
	pstudiohdr = (studiohdr_t *)pModel;

	pClient->IsAutoPunching = false;
	pClient->GetAutoPunched = false;
	pClient->HasThrowLanded = false;
	pClient->GetSwung = false;
	pClient->Ascends = (pClient->AscendTime >= gpGlobals->time);
	pClient->Powerstruggles = (pClient->PSVal < 127);
	pClient->ChargesAttack = (pClient->ChargeBeamVal > 0);
	pClient->FlysAfterHit = false;
	pClient->ChargesWallJump = false;
	pClient->WallJumps = false;
	pClient->Swoops = false;
	pClient->MeleeStruggles = false;
	pClient->DoesComboStruggle = false;
	pClient->IsStuckAgainstWall = false;
	pClient->LaysOnGround = false;
	pClient->ControlsAttack = false;
	pClient->BeamJumps = false;
	pClient->IsBlinded = (pClient->BlindedTime >= gpGlobals->time);
	pClient->Blocks = false;
	pClient->BlockStruggles = false;
	pClient->IsInMeleeMode = false;
	pClient->HasDB = false;
	pClient->IsInMeleeMode = false;
	pClient->IsStunnedByMelee = false;

	if (pstudiohdr)
	{
		pseqdesc = (mstudioseqdesc_t *)((byte *)pstudiohdr + pstudiohdr->seqindex);

		// Just in case...
		if ((pClient->pEdict->v.sequence >= 0) && 
			(pClient->pEdict->v.sequence < pstudiohdr->numseq))
		{
			char CurrentAni[32];
			strcpy(CurrentAni, pseqdesc[pClient->pEdict->v.sequence].label);

			if ((stricmp(CurrentAni, "ref_stance") == 0) ||
			    (stricmp(CurrentAni, "ref_stun") == 0) ||
				(stricmp(CurrentAni, "ref_autopunch_spin") == 0))
			{
				pClient->IsInMeleeMode = true;
				pClient->IsStunnedByMelee = true;
			}
			else if ((stricmp(CurrentAni, "throw_land") == 0) ||
					 (stricmp(CurrentAni, "throw_recover_jump") == 0) ||
					 (stricmp(CurrentAni, "throw_recover_forward") == 0) ||
					 (stricmp(CurrentAni, "throw_recover_backward") == 0) ||
					 (stricmp(CurrentAni, "throw_recover_left") == 0) ||
					 (stricmp(CurrentAni, "throw_recover_right") == 0))
				pClient->HasThrowLanded = true;
			else if (stricmp(CurrentAni, "ref_autopunch") == 0)
			{
				if (pClient->Powerstruggles)
					pClient->MeleeStruggles = true;
				else
					pClient->IsAutoPunching = true;
			}
			else if ((stricmp(CurrentAni, "ref_autopunch_hit") == 0) ||
					 (stricmp(CurrentAni, "wall_autopunched") == 0) ||
					 (stricmp(CurrentAni, "ref_autopunch_hit_back") == 0) ||
					 (stricmp(CurrentAni, "ref_autopunch_block") == 0))
				pClient->GetAutoPunched = true;
			else if ((stricmp(CurrentAni, "hit_blow_back") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_front") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_down") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_up") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_left") == 0) ||
					 (stricmp(CurrentAni, "hit_blow_right") == 0) ||
					 (stricmp(CurrentAni, "tumble_forward") == 0) ||
					 (stricmp(CurrentAni, "tumble_back") == 0) ||
					 (stricmp(CurrentAni, "tumble_left") == 0) ||
					 (stricmp(CurrentAni, "tumble_right") == 0) ||
					 (stricmp(CurrentAni, "blow_hit_ground") == 0) ||
					 (stricmp(CurrentAni, "wall_fall") == 0) ||
					 (stricmp(CurrentAni, "ref_start_swung") == 0))
				pClient->FlysAfterHit = true;
			else if ((stricmp(CurrentAni, "wall_idle") == 0) ||
					 (stricmp(CurrentAni, "wall_attacked") == 0) ||
					 (stricmp(CurrentAni, "wall_collide") == 0))
				pClient->IsStuckAgainstWall = true;
			else if ((stricmp(CurrentAni, "lay_ground") == 0) ||
					 (stricmp(CurrentAni, "lay_ground2") == 0))
				pClient->LaysOnGround = true;
			else if ((stricmp(CurrentAni, "grabwall_forward") == 0) ||
					 (stricmp(CurrentAni, "grabwall_back") == 0) ||
					 (stricmp(CurrentAni, "grabwall_left") == 0) ||
					 (stricmp(CurrentAni, "grabwall_right") == 0))
				pClient->ChargesWallJump = true;
			else if ((stricmp(CurrentAni, "walljump_forward") == 0) ||
					 (stricmp(CurrentAni, "walljump_back") == 0) ||
					 (stricmp(CurrentAni, "walljump_left") == 0) ||
					 (stricmp(CurrentAni, "walljump_right") == 0) ||
					 (stricmp(CurrentAni, "wall_recover") == 0))
				pClient->WallJumps = true;
			else if ((stricmp(CurrentAni, "swoop") == 0) ||
					 (stricmp(CurrentAni, "swoop_up") == 0) ||
					 (stricmp(CurrentAni, "swoop_down") == 0) ||
					 (stricmp(CurrentAni, "swoop_left") == 0) ||
					 (stricmp(CurrentAni, "swoop_right") == 0) ||
					 (stricmp(CurrentAni, "swoop_forward") == 0) ||
					 (stricmp(CurrentAni, "swoop_backward") == 0))
				pClient->Swoops = true;
			else if ((stricmp(CurrentAni, "ref_control_genericbeam") == 0) ||
					 (stricmp(CurrentAni, "ref_control_gallitgun") == 0) ||
					 (stricmp(CurrentAni, "ref_control_finalflash") == 0) ||
					 (stricmp(CurrentAni, "ref_control_kamehameha") == 0) ||
					 (stricmp(CurrentAni, "ref_control_burningattack") == 0) ||
					 (stricmp(CurrentAni, "ref_control_powerbeam") == 0) ||
					 (stricmp(CurrentAni, "ref_control_masenko") == 0) ||
					 (stricmp(CurrentAni, "ref_control_mouthblast") == 0))
				pClient->ControlsAttack = true;
			else if ((stricmp(CurrentAni, "ref_beam_push") == 0) &&
					 (pClient->ChargesAttack == false))
				pClient->BeamJumps = true;
			else if ((stricmp(CurrentAni, "ref_block") == 0) ||
					 (stricmp(CurrentAni, "fly_block") == 0))
				pClient->Blocks = true;
			else if (stricmp(CurrentAni, "ref_aim_dragonball") == 0)
				pClient->HasDB = true;
			else if (stricmp(CurrentAni, "ref_grapple") == 0)
				pClient->DoesComboStruggle = true;
			else if ((stricmp(CurrentAni, "ref_swung") == 0) ||
					 (stricmp(CurrentAni, "ref_start_swung") == 0))
					 pClient->GetSwung = true;
		}
	}

	if ((!pClient->IsInMeleeMode) && 
		(*((int *)pClient->pEdict->pvPrivateData + MELEE_OFFSET) == 1))
	{
//		if ((pClient->IsAutoPunching) || (pClient->MeleeStruggles) || (pClient->FlysAfterHit) ||
//			(pClient->GetAutoPunched))
//			pClient->IsInMeleeMode = false;
//		else
		{
			pClient->IsInMeleeMode = true;
		}
	}

	if ((pClient->Blocks) && (pClient->Powerstruggles))
		pClient->BlockStruggles = true;

	if (pClient->LastOldPosCheck < gpGlobals->time)
	{
		pClient->LastOldPosCheck = gpGlobals->time + 0.2;
		
		Vector v_src = pClient->pEdict->v.origin;
		Vector v_old = pClient->OldPositions[0].Place;
		float Dist = UTIL_Distance(v_src, v_old);

		if (Dist > MinNewPositionDistance)
		{
			for (short j=(MaxOldPositions-1);j>0;j--)
				pClient->OldPositions[j] = pClient->OldPositions[j-1];
				  
			pClient->OldPositions[0].Place = v_src;
			pClient->OldPositions[0].CreateTime = gpGlobals->time;
		}
	}

	if ((pClient->FrozenTime > 0.0) && (pClient->FrozenTime < gpGlobals->time))
	{
		pClient->pEdict->v.flags &= ~FL_FROZEN;
		pClient->FrozenTime = 0.0;
	}

#ifdef usestats
	if (pClient->flRefreshStatTime < gpGlobals->time)
	{
		pClient->WeaponStatistics.MakeWeaponStats();
		LogAllWeaponStatistics();
		pClient->WeaponStatistics.ResetVars();
		pClient->flRefreshStatTime = gpGlobals->time + 60.0f;
		pClient->DamageCausedLastMinut = 0;
	}
#endif
}

long GetPlayerPl(edict_t *pEdict)
{
	int ClInd = UTIL_GetClientIndex(pEdict);

	if (ClInd > -1)
	{
		return ClientInfo[ClInd].PL;
	}

	return 1000000;
}

long GetPlayerActualPl(edict_t *pEdict)
{
	return (*(int *)pEdict->pvPrivateData + ACTUAL_PL_OFFSET);
}


Vector PredictEntityPos(edict_t *pEntity, float Time, bool UseTraceLine)
{
	if (pEntity->v.velocity.Length() < 10.0)
		return pEntity->v.origin; // don't bother with low velocities...

	float speed = pEntity->v.velocity.Length() * Time;

	Vector v_src = pEntity->v.origin;
	Vector v_end = v_src + pEntity->v.velocity.Normalize() * speed;

	if (UseTraceLine)
	{
		TraceResult tr;
		UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEntity,&tr);
		return tr.vecEndPos;
	}
	else
		return v_end;
}

void PlayerClient_ESF_ChargeBeam(void *p, int player_ind)
{
	if ((player_ind != -1) && (player_ind < 32))
		ClientInfo[player_ind].ChargeBeamVal = *(int*)p;
}

void PlayerClient_ESF_PL(void *p, int player_ind)
{
	static int state = 0;
	static int playerindex = -1;

	if (state == 0)
	{
		state++;
		playerindex = *(int *)p;
	}
	else
	{
		state = 0;

		if ((playerindex > 0) && (playerindex < 33))
		{
		    edict_t *pPlayer = INDEXENT(playerindex);
			
		    int Ind = UTIL_GetClientIndex(pPlayer);

			if (Ind > -1)
				ClientInfo[Ind].PL = *(long*)p;

			Ind = UTIL_GetBotIndex(pPlayer);
			if (Ind > -1)
			{
/*					if (bots[Ind].SBotType > 0)
					{
						if ((bots[Ind].PL > *(long*)p) && ((bots[Ind].PL/1.25) != *(long*)p))
							UTIL_ChangePl(bots[Ind].pEdict, bots[Ind].PL);
					}*/

				bots[Ind].PL = *(long*)p;
			}
		}
		playerindex = -1;
	}
}

void PlayerClient_ESF_StartPowerUp(void *p, int player_ind)
{
	static int state = 0;
	int playerindex = -1;

	if (state == 0)
	{
		state++;

		playerindex = *(int *)p;
        edict_t *pPlayer = INDEXENT(playerindex);

        int Ind = UTIL_GetClientIndex(pPlayer);

        if (Ind > -1)
           ClientInfo[Ind].PowerUp = true;

		Ind = UTIL_GetBotIndex(pPlayer);
		if (Ind > -1)
			bots[Ind].BotPowerUps = true;
	}
    else if (state == 1)
    {
        state ++;
    }
    else if (state == 2)
    {
        state ++;
    }
    else if (state == 3)
    {
        state = 0;
	}
}

void PlayerClient_ESF_StopPowerUp(void *p, int player_ind)
{
	int playerindex = -1;

	playerindex = *(int *)p;
    edict_t *pPlayer = INDEXENT(playerindex);
    int Ind = UTIL_GetClientIndex(pPlayer);

    if (Ind > -1)
        ClientInfo[Ind].PowerUp = false;

	Ind = UTIL_GetBotIndex(pPlayer);
	if (Ind > -1)
		bots[Ind].BotPowerUps = false;
}

void PlayerClient_ESF_TransformFX(void *p, int player_ind)
{
	static int state = 0;
	static int playerindex = -1;

	if (state == 0)
	{
		state++;

		playerindex = *(int *)p;
	}
    else if (state == 1)
    {
        state = 0;

		edict_t *pPlayer = INDEXENT(playerindex);

        int Ind = UTIL_GetClientIndex(pPlayer);

        if (Ind > -1)
           ClientInfo[Ind].AscendTime = *(float *)p + gpGlobals->time;

		Ind = UTIL_GetBotIndex(pPlayer);
		if (Ind > -1)
			bots[Ind].AscendTime = *(float *)p + gpGlobals->time;

    }
}

void PlayerClient_ESF_StopTransFX(void *p, int player_ind)
{
	int playerindex = -1;

	playerindex = *(int *)p;
    edict_t *pPlayer = INDEXENT(playerindex);
    int Ind = UTIL_GetClientIndex(pPlayer);

    if (Ind > -1)
        ClientInfo[Ind].AscendTime = 0.0;

	Ind = UTIL_GetBotIndex(pPlayer);
	if (Ind > -1)
		bots[Ind].AscendTime = 0.0;
}

void PlayerClient_ESF_Ki(void *p, int player_ind)
{
	if ((player_ind != -1) && (player_ind < 32))
		ClientInfo[player_ind].ki = *(int*)p;
}

void PlayerClient_ESF_Powerstruggle(void *p, int player_ind)
{
	if ((player_ind != -1) && (player_ind < 32))
		ClientInfo[player_ind].PSVal = *(int*)p;
}

void PlayerClient_ESF_ScreenFade(void *p, int player_ind)
{
	static int state = 0;   // current state machine state
    static int duration;
    static int hold_time;
    static int fade_flags;
    int length;

    if (state == 0)
    {
		state++;
		duration = *(int *)p;
    }
    else if (state == 1)
    {
		state++;
		hold_time = *(int *)p;
    }
    else if (state == 2)
    {
		state++;
		fade_flags = *(int *)p;
    }
    else if (state == 6)
    {
		state = 0;

        length = (duration + hold_time) / 4096;
        ClientInfo[player_ind].BlindedTime = gpGlobals->time + length - 2.0;
    }
    else
    {
		state++;
    }
}

void PlayerClient_ESF_VGUI(void *p, int player_index)
{
   if ((*(int *)p) == 2)  // is it a team select menu?
	   TeamMenuShowedUp = true;
   if ((*(int *)p) == 3)  // is it a class select menu?
	   ClassMenuShowedUp = true;
   if ((*(int *)p) == 31) // is it a wish select menu?
	   CheckForDBSpot = true;

}

void PlayerClient_ESF_MeleeHud(void *p, int player_index)
{
	static byte state = 0;
	static byte msg_type = 0;

	// Handle message end stuff
	if (!p)
	{
		state = 0;
		return;
	}

	if (state == 0)
	{
		int Value = *(byte *)p;

		// Is the current message type about clearing the hud?
		if (Value == 0)
		{
			ClientInfo[player_index].MaxComboChargeTime = 0.0f;
			ClientInfo[player_index].Attacker = false;
			ClientInfo[player_index].Defender = false;

#ifdef _DEBUG
			if (ClientInfo[player_index].pEdict != listenserver_edict)
			{
				char s[250] = "";
				sprintf(s, "Buttons random: %d\nButtons missed: %d\nButton count: %d\n", 
						ClientInfo[player_index].ButtonsRandom,
						ClientInfo[player_index].ButtonsMissed,
						ClientInfo[player_index].DefendButtonCount);
				ALERT(at_console, s);
			}
#endif

			ClientInfo[player_index].ButtonsMissed = 0;
			ClientInfo[player_index].ButtonsRandom = 0;
			ClientInfo[player_index].DefendButtonCount = 0;
			ClientInfo[player_index].PrepunchHits = 0;
		}
		else if (Value == 4) // Is the current message about starting a combo
		{
			ClientInfo[player_index].Attacker = true; // if so the this player is the attacker
		}

		msg_type = Value;

		state++;
	}
	else if (state == 1)
	{
		state++;
		int Value = *(int *)p;

		if ((msg_type == 1) || (msg_type == 6)) //msg for attacker?
		{
			if (ClientInfo[player_index].DefendButtonsList.Empty() == false)
				ClientInfo[player_index].DefendButtonsList.DeleteAllNodes();

			if (!ClientInfo[player_index].Attacker)
				ClientInfo[player_index].Attacker = true;
			if (ClientInfo[player_index].Defender)
				ClientInfo[player_index].Defender = false;
		}
		else if (msg_type == 2) //msg for defender?
		{
			if (IsComboChargeButton(Value))
			{
				if (Value == 16)
					ClientInfo[player_index].ButtonsRandom++;

				ClientInfo[player_index].DefendButtonCount++;

				ClientInfo[player_index].DefendButtonsList.AddNode(GetComboChargeButtonFromInt(Value));
			}

			if (ClientInfo[player_index].Attacker)
				ClientInfo[player_index].Attacker = false;
			if (!ClientInfo[player_index].Defender)
				ClientInfo[player_index].Defender = true;
		}
		else if (msg_type == 3)
		{
			if (Value == 2)
				ClientInfo[player_index].ButtonsMissed++;

			ClientInfo[player_index].Attacker = false;
			ClientInfo[player_index].Defender = false;
		}
		else if (msg_type == 4)
		{
			// Set the max weak button charge time(seems to change dunno why :-\)
			ClientInfo[player_index].WeakButtonChargeTime = float(*(short *)p / 100.0f);
		}
	}
	else if (state == 2)
	{
		state++;
		// Is the current message type about ending an arrow on the hud?
		if (msg_type == 5)
		{
			if (ClientInfo[player_index].Attacker)
				ClientInfo[player_index].Attacker = false;
			if (ClientInfo[player_index].Defender)
				ClientInfo[player_index].Defender = false;
		}
		else if (msg_type == 4)
		{
			// Set the max medium button charge time(seems to change dunno why :-\)
			ClientInfo[player_index].MediumButtonChargeTime = float(*(short *)p / 100.0f);
		}
	}
	else if (state == 3)
	{
		if (msg_type == 4)
		{
			// Set the max strong button charge time(seems to change dunno why :-\)
			ClientInfo[player_index].StrongButtonChargeTime = float(*(short *)p / 100.0f);
		}

		state++;
	}
	else if (state == 4)
	{
		state++;

		if (msg_type == 4) // Message about starting a combo?
		{
			// Set the max charge time
			ClientInfo[player_index].MaxComboChargeTime = gpGlobals->time + float(*(short *)p / 100.0f);
		}
	}
}

void PlayerClient_ESF_MeleeHudTxt(void *p, int player_index)
{
	static byte state = 0;
	static byte msg_type;

	if (state == 0)
	{
		state++;
		msg_type = *(byte *)p;
	}
	else if (state == 1)
	{
		if (msg_type == 0)
			ClientInfo[player_index].PrepunchHits = 1;
		else if (msg_type == 1)
			ClientInfo[player_index].PrepunchHits = *(byte *)p;

		state = msg_type = 0;
	}
}

void PlayerClient_ESF_ManipModel(void *p, int player_index)
{
	static byte state = 0;
	static short msg_type = -1;
	static short PlayerToAttachInd = -1;
	static short AttachingPlayerInd = -1;

	// Reset all stuff(the message has ended)
	if (!p)
	{
		state = 0;
		msg_type = -1;
		PlayerToAttachInd = -1;
		AttachingPlayerInd = -1;
		return;
	}

	if (state == 0)
	{
		// Store which type of message this is
		msg_type = *(byte *)p;
		state++;
	}
	else if (state == 1)
	{
		// Is the current message type about attaching 2 players?
		if (msg_type == 1)
		{
			PlayerToAttachInd = *(short *)p;
		}/*
		else if (msg_type == 0)
		{
			short PlayerInd = *(short *)p;
			if ((PlayerInd > 0) && (PlayerInd < 33))
			{
				ClientInfo_t *pClient = UTIL_GetClientPointer(INDEXENT(PlayerInd));
				if (pClient)
					pClient->pAttachedPlayer = NULL;
			}
		}*/
		state++;
	}
	else if (state == 2)
	{
		// Is the current message type about attaching 2 players?
		if ((msg_type == 1) && (PlayerToAttachInd >= 1) && (PlayerToAttachInd <= 32))
		{
			AttachingPlayerInd = *(short *)p;
		}
		state++;
	}
	else if (state == 3)
	{
		// Is the current message type about attaching 2 players?
		if ((msg_type == 1) && (PlayerToAttachInd >= 1) && (PlayerToAttachInd <= 32) &&
			(AttachingPlayerInd >= 1) && (AttachingPlayerInd <= 32) && (*(short *)p == 11))
		{
			ClientInfo_t *pClient = UTIL_GetClientPointer(INDEXENT(AttachingPlayerInd));
			if (pClient)
			{
				// Save the edict of the attached player for this client
				pClient->pAttachedPlayer = INDEXENT(PlayerToAttachInd);
			}
		}
		state++;
	}
}

void PlayerClient_ESF_SayTextMsg(void *p, int player_index)
{
	static int state = 0;

	if (state == 0)
		state++;
	else if (state == 1)
	{
		state = 0;
		pChatClass->StoreTextMsg((char*)p);
	}
}

void PlayerClient_ESF_CurrentWeapon(void *p, int player_index)
{
	static int state = 0;   // current state machine state
      static int iState;
      static int iId;
      static int iClip;

   if (state == 0)
   {
      state++;
      iState = *(int *)p;  // state of the current weapon
   }
   else if (state == 1)
   {
      state++;
      iId = *(int *)p;  // weapon ID of current weapon
   }
   else if (state == 2)
   {
      state = 0;

      iClip = *(int *)p;  // ammo currently in the clip for this weapon

      if (iId <= 31)
      {
         if (iState == 1)
         {
            ClientInfo[player_index].CurrentWeapon.iId = iId;
            ClientInfo[player_index].CurrentWeapon.iClip = iClip;
         }
      }
   }
}

#ifdef usestats
void PlayerClient_ESF_Health(void *p, int player_index)
{
	int OldHealth = ClientInfo[player_index].Health;
	int NewHealth = *(int *)p;

    if (OldHealth > NewHealth)
	{
		edict_t *pEdict = ClientInfo[player_index].pEdict; // Shortcut
		if (IsNull(pEdict->v.dmg_inflictor) == false)
		{
			int Damage = OldHealth - NewHealth;
			char szAttack[32] = "";

			IdentifyAttack(pEdict, szAttack);
			if ((szAttack) && (*szAttack))
			{
				ClientInfo[player_index].WeaponStatistics.AddWeaponDamageHit(szAttack, Damage);

				edict_t *pDamager = NULL;

				if (pEdict->v.dmg_inflictor->v.flags & FL_CLIENT)
					pDamager = pEdict->v.dmg_inflictor;
				else if ((IsNull(pEdict->v.dmg_inflictor->v.owner) == false) &&
						 (pEdict->v.dmg_inflictor->v.owner->v.flags & FL_CLIENT))
					pDamager = pEdict->v.dmg_inflictor->v.owner;

				ClientInfo_t *pClient = UTIL_GetClientPointer(pDamager);
				if (pClient)
				{
					pClient->WeaponStatistics.AddWeaponDamageCaused(szAttack, Damage);
					pClient->DamageCausedLastMinut += Damage;
				}
			}
		}
	}
	ClientInfo[player_index].Health = NewHealth;  // health ammount
}
#endif

void PlayerClient_ESF_DeathMsg(void *p, int bot_index)
{
	static int state = 0;   // current state machine state
	static int killer_index;
	static int victim_index;
	static edict_t *killer_edict;
	static edict_t *victim_edict;
	static int index;

	if (state == 0)
      {
		state++;
	      killer_index = *(int *)p;  // ENTINDEX() of killer
   	}
	else if (state == 1)
   	{
      	state++;
	      victim_index = *(int *)p;  // ENTINDEX() of victim
   	}
	else if (state == 2)
   	{
      	state = 0;
#ifdef usestats
		char szAttackName[32] = "";
		strcpy(szAttackName, (char *)p);
#endif
		if ((victim_index > 0) && (victim_index < 33))
			victim_edict = INDEXENT(victim_index);
		else
			victim_edict = NULL;

		if ((killer_index > 0) && (killer_index < 33))
			killer_edict = INDEXENT(killer_index);
		else
			killer_edict = NULL;

		if (killer_index != victim_index) // Player killed not hisself?
	  	{
			// get the bot index of the killer...
			index = UTIL_GetBotIndex(killer_edict);

			// is this message about a bot killing someone?
			if (index != -1)
		  	{
				if ((victim_edict != NULL) && (RANDOM_LONG(1, 100) <= bots[index].taunt_percent))
			  	{
					pChatClass->LetBotTaunt(&bots[index], victim_edict);
			  	}
		  	}
#ifdef usestats
			if ((szAttackName) && (*szAttackName))
			{
				ClientInfo_t *pClient = UTIL_GetClientPointer(killer_edict);
				if (pClient)
					pClient->WeaponStatistics.AddWeaponKillsCaused(szAttackName);
			}
#endif
	  	}
	  	// get the bot index of the victim...
		index = UTIL_GetBotIndex(victim_edict);

		// is this message about a bot being killed?
		if (index != -1)
	  	{
			if ((killer_index == 0) || (killer_index == victim_index))
		  	{
				// bot killed by world (worldspawn) or bot killed self...
				bots[index].killer_edict = NULL;
		  	}
          	else
		  	{
				// store edict of player that killed this bot...
				bots[index].killer_edict = killer_edict;
			  	bots[index].pLastEnemy = killer_edict;
		  	}
	  	}

		ClientInfo_t *pClient = UTIL_GetClientPointer(victim_edict);
		if (pClient)
		{
#ifdef usestats
			if ((szAttackName) && (*szAttackName) && (victim_index != killer_index))
				pClient->WeaponStatistics.AddWeaponKilledBy(szAttackName);
#endif
		    // Clear the traces the player made.....
			memset(pClient->OldPositions, 0, sizeof(pClient->OldPositions));
		}
   	}
}

bool EntityHeadsToPlayer(edict_t *pPlayer, edict_t *pEntity)
{
#ifdef _DEBUG
	extern byte DebugMinHeadPercent;

	if (DebugMinHeadPercent)
		return (UTIL_GetHeadingPercentage(pPlayer, pEntity) >= DebugMinHeadPercent);
	else
#endif
		return (UTIL_GetHeadingPercentage(pPlayer, pEntity) >= 65);

	if (pEntity->v.velocity.Length() < 1.0f)
		return false; // don't bother about low velocities

	float dist1, dist2;
	Vector v_src = pPlayer->v.origin;
	Vector v_predict = PredictEntityPos(pEntity, 1.0, false);

	dist1 = (pEntity->v.origin - v_src).Length();
	dist2 = (v_predict - v_src).Length();

	float MaxDist = dist1 + (pEntity->v.velocity.Length() * 0.75);

	// if the entity is in atleast 1.0 secs 3/4 of his speed in units closer...
	if (dist2 < MaxDist) 
		return true;

	return false;
}

// Return the name of the class of the player. Trys to filter out custom model changing as much as
// possible...
void PlayerClassify(edict_t *pEdict, char *ClassName)
{
	char model[32] = "";

	ClassName[0] = 0;

	UTIL_GetModel(pEdict, model);

	switch (pEdict->v.playerclass)
	{
	case 1:
		if (FStrEq(model,"evilbuu"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "fatbuu");
		break;
	case 2:
		if (FStrEq(model,"ssjgoku"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "goku");
		break;
	case 3:
		if (FStrEq(model,"ssjgohan"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "gohan");
		break;
	case 4:
		if (FStrEq(model,"krillin2"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "krillin");
		break;
	case 5:
		if (FStrEq(model,"frieza2"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "frieza");
		break;
	case 6:
		if (FStrEq(model,"piccolo2"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "piccolo");
		break;
	case 7:
		if (FStrEq(model,"ssjtrunks"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "trunks");
		break;
	case 8:
		if (FStrEq(model,"ssjvegeta"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "vegeta");
		break;
	case 9:
		if (FStrEq(model,"cell2"))
			strcpy(ClassName, model);
		else
			strcpy(ClassName, "cell");
		break;
	}

	if (!ClassName[0])
		strcpy(ClassName, "goku");
}

void PlayerClassifyForSound(edict_t *pEdict, char *ClassName)
{
	char model[32];

	UTIL_GetModel(pEdict, model);

	switch (pEdict->v.playerclass)
	{
	case 1:
		if (FStrEq(model,"fatbuu"))
			sprintf(ClassName, model);
		else
			sprintf(ClassName, "buu");
		break;
	case 2:
		sprintf(ClassName, "goku");
		break;
	case 3:
		sprintf(ClassName, "gohan");
		break;
	case 4:
		sprintf(ClassName, "krillin");
		break;
	case 5:
		sprintf(ClassName, "frieza");
		break;
	case 6:
		sprintf(ClassName, "piccolo");
		break;
	case 7:
		sprintf(ClassName, "trunks");
		break;
	case 8:
		sprintf(ClassName, "vegeta");
		break;
	case 9:
		if (FStrEq(model,"cell2"))
			sprintf(ClassName,model);
		else
			sprintf(ClassName, "cell");
		break;
	}

	if (FStrEq(ClassName, ""))
		sprintf(ClassName, "goku");

	return;
}

void SetCameraToPlayer(edict_t *pPlayer, edict_t *pEntity)
{
	if ((pHostCam) && (pHostCam->pev))
		pHostCam->pev->flags |= FL_KILLME;

	pHostCam = UTIL_CreateEnt("info_target", pPlayer->v.origin, pPlayer->v.v_angle, pPlayer);

	if (!pHostCam)
		return;

	pHostCam->pev->takedamage = DAMAGE_NO;
	pHostCam->pev->solid = SOLID_NOT;
	pHostCam->pev->movetype = MOVETYPE_FLY;
	pHostCam->pev->classname = MAKE_STRING("playercam");
	pHostCam->pev->nextthink = gpGlobals->time;
	pHostCam->pev->renderamt = 0;

	SET_MODEL(pHostCam->edict(), "models/mechgibs.mdl");
	SET_VIEW(pPlayer, pHostCam->edict());

	pHostViewPlayer = pEntity;
}

void DestroyPlayerCamera(edict_t *pPlayer)
{
	pHostCam->pev->flags |= FL_KILLME;

	SET_VIEW(pPlayer, pPlayer);

	pHostViewPlayer = NULL;
}

bool EntIsInFieldOfView(edict_t *pPlayer, edict_t *pEnt)
{
	Vector v_end = pEnt->v.origin;

	return FInViewCone(&v_end, pPlayer);
}

//doesnt work
bool EntIsInTriggerHurt(edict_t *pEdict)
{
	Vector v_src = pEdict->v.origin;

	edict_t *pEnt = NULL;

	while ((IsNull(pEnt = UTIL_FindEntityByClassname(pEnt, "trigger_hurt")) == false))
	{
		if ((v_src.x > pEnt->v.absmin.x) && (v_src.y > pEnt->v.absmin.y) &&
			(v_src.z > pEnt->v.absmin.z) && (v_src.x < pEnt->v.absmax.x) &&
			(v_src.y < pEnt->v.absmax.y) && (v_src.x < pEnt->v.absmax.z))
			return true;
	}

	return false;
}
#ifdef usestats

// ==================================================================
// Code of SWeaponStatData - Begin
// ==================================================================

void SWeaponStatData::AddWeaponScore()
{
	short DamageVal;

	if (DamageCaused > 0)
		DamageVal = DamageCaused / 100;
	else
		DamageVal = 0;

	WeaponScore += (DamageVal + KillsCaused);
}

void SWeaponStatData::AddWeaponDanger()
{
	short DamageVal;

	if (DamageTaken > 0)
		DamageVal = DamageTaken / 100;
	else
		DamageVal = 0;

	WeaponDanger += (DamageVal + KilledBy);
}

// Debug stuff
void SWeaponStatData::LogData()
{
	clog << "\nAttack: " << szWeaponName << "\n";
	clog << "DamageCaused: " << DamageCaused << "\n";
	clog << "DamageTaken: " << DamageTaken << "\n";
	clog << "KillsCaused: " << KillsCaused << "\n";
	clog << "KilledBy: " << KilledBy << "\n";
	clog << "WeaponScore: " << WeaponScore << "\n";
	clog << "WeaponDanger: " << WeaponDanger << "\n";
}

// ==================================================================
// Code of SWeaponStatData - End
// ==================================================================

// ==================================================================
// Code of CWeaponStatistics - Begin
// ==================================================================

void CWeaponStatistics::MakeWeaponStats()
{
	WeaponDataList.CallMemberFuncForEach(&SWeaponStatData::AddWeaponScore);
	WeaponDataList.CallMemberFuncForEach(&SWeaponStatData::AddWeaponDanger);
}
	
void CWeaponStatistics::ResetVars()
{
	WeaponDataList.CallMemberFuncForEach(&SWeaponStatData::ClearTempData);
}

void CWeaponStatistics::AddWeaponDamageCaused(const char *szAttackName, int Damage)
{
	if ((!szAttackName) || (!*szAttackName))
		return;

	SWeaponStatData *pWeaponStatsData = WeaponDataList.FindIf(this, &CWeaponStatistics::FindAttackByName, szAttackName);

	if (!pWeaponStatsData) // Didn't found an attack with this name?
	{
		pWeaponStatsData = new SWeaponStatData(szAttackName); // Make one...
		WeaponDataList.AddNode(pWeaponStatsData);
	}

	pWeaponStatsData->AddDamageCaused(Damage);
}

void CWeaponStatistics::AddWeaponDamageHit(const char *szAttackName, int Damage)
{
	if ((!szAttackName) || (!*szAttackName))
		return;

	SWeaponStatData *pWeaponStatsData = WeaponDataList.FindIf(this, &CWeaponStatistics::FindAttackByName, szAttackName);

	if (!pWeaponStatsData) // Didn't found an attack with this name?
	{
		pWeaponStatsData = new SWeaponStatData(szAttackName); // Make one...
		WeaponDataList.AddNode(pWeaponStatsData);
	}

	pWeaponStatsData->AddDamageTaken(Damage);
}

void CWeaponStatistics::AddWeaponKillsCaused(const char *szAttackName)
{
	if ((!szAttackName) || (!*szAttackName))
		return;

	SWeaponStatData *pWeaponStatsData = WeaponDataList.FindIf(this, &CWeaponStatistics::FindAttackByName, szAttackName);

	if (!pWeaponStatsData) // Didn't found an attack with this name?
	{
		pWeaponStatsData = new SWeaponStatData(szAttackName); // Make one...
		WeaponDataList.AddNode(pWeaponStatsData);
	}

	pWeaponStatsData->AddKillsCaused();

}

void CWeaponStatistics::AddWeaponKilledBy(const char *szAttackName)
{
	if ((!szAttackName) || (!*szAttackName))
		return;

	SWeaponStatData *pWeaponStatsData = WeaponDataList.FindIf(this, &CWeaponStatistics::FindAttackByName, szAttackName);

	if (!pWeaponStatsData) // Didn't found an attack with this name?
	{
		pWeaponStatsData = new SWeaponStatData(szAttackName); // Make one...
		WeaponDataList.AddNode(pWeaponStatsData);
	}

	pWeaponStatsData->AddKilledBy();
}

int CWeaponStatistics::GetAttackThatMostDamageCaused()
{
	return ESF_WEAPON_MELEE;
}

int CWeaponStatistics::GetAttackThatMostHit()
{
	return ESF_WEAPON_MELEE;
}

// Debug stuff
void CWeaponStatistics::LogWeaponStats()
{
	WeaponDataList.CallMemberFuncForEach(&SWeaponStatData::LogData);
}

// ==================================================================
// Code of CWeaponStatistics - End
// ==================================================================

#endif

EComboChargeButton GetComboChargeButtonFromInt(int Value)
{
	// Is it a combo charge button?
	if (IsComboChargeButton(Value))
		return static_cast<EComboChargeButton>(Value);

	return COMBO_BUTTON_INVALID;
}

bool IsComboChargeButton(int Value)
{
	EComboChargeButton CB = static_cast<EComboChargeButton>(Value);

	return ((CB == COMBO_BUTTON_PUNCH_LEFT) || (CB == COMBO_BUTTON_PUNCH_RIGHT) ||
			(CB == COMBO_BUTTON_PUNCH_UP) || (CB == COMBO_BUTTON_PUNCH_DOWN) ||
			(CB == COMBO_BUTTON_PUNCH_LEFT_UP) || (CB == COMBO_BUTTON_PUNCH_RIGHT_UP) ||
			(CB == COMBO_BUTTON_PUNCH_LEFT_DOWN) || (CB == COMBO_BUTTON_PUNCH_RIGHT_DOWN) ||
			(CB == COMBO_BUTTON_KICK_LEFT) || (CB == COMBO_BUTTON_KICK_RIGHT) ||
			(CB == COMBO_BUTTON_KICK_UP) || (CB == COMBO_BUTTON_KICK_DOWN) ||
			(CB == COMBO_BUTTON_KICK_LEFT_UP) || (CB == COMBO_BUTTON_KICK_RIGHT_UP) ||
			(CB == COMBO_BUTTON_KICK_LEFT_DOWN) || (CB == COMBO_BUTTON_KICK_RIGHT_DOWN) ||
			(CB == COMBO_BUTTON_RANDOM));
}

#ifdef usestats
void LogAllWeaponStatistics()
{
	ClientInfo_t *pClient;

	for (byte b=0;b<32;b++)
	{
		pClient = &ClientInfo[b];

		if ((!pClient) || (IsNull(pClient->pEdict)))
			continue;

		clog << "Logging attack statistics for " << STRING(pClient->pEdict->v.netname) << "...\n";
		pClient->WeaponStatistics.LogWeaponStats();
	}
}
#endif

// ==================================================================
// Cheats...
// ==================================================================

// Ala final shine :)
void ExplodePlayer(edict_t *pEdict)
{
	long PL = GetPlayerPl(pEdict);
	float Range = ((PL / 1000000.0) * 1500.0);
	int Damage = ((PL / 1000000) * 75);
	float FallOff = Damage / Range;
	float Dist, flAdjustedDamage;
	edict_t *pPlayer;
	ClientInfo_t *pClient;

	static int gmsgExplosion = 0;

	if (gmsgExplosion == 0)
		gmsgExplosion = REG_USER_MSG( "Explosion", -1 );

	extern bool IsPlayingMessage;

    if (IsPlayingMessage)
    {
		clog << "Tried to explode when there is already a message active;\n";
	    return;
    }
	
	//explosion sphere
	MESSAGE_BEGIN( MSG_ALL, gmsgExplosion, NULL );
		WRITE_COORD( pEdict->v.origin.x );	
		WRITE_COORD( pEdict->v.origin.y );
		WRITE_COORD( pEdict->v.origin.z );
		WRITE_LONG (Range);		//radius
		WRITE_BYTE (4);
	MESSAGE_END();

	// Kill the player
	UTIL_DamagePlayer(pEdict, pEdict ,"Self destruct", pEdict->v.health + 1);

	// Damage everyone in range
	for (byte i=1;i<=gpGlobals->maxClients;i++)
	{
		pPlayer = INDEXENT(i);
		if (UTIL_IsValidPlayer(pPlayer, true, false))
		{
			Dist = UTIL_Distance(pEdict->v.origin, pPlayer->v.origin);
			if (Dist > Range)
				continue;

			if (IsTeamPlay())
			{
				if (pEdict->v.team == pPlayer->v.team)
					continue;
			}

			pClient = UTIL_GetClientPointer(pPlayer);
			if (!pClient)
				continue;

			if (pClient->IsInMeleeMode)
				continue;

			if (pClient->MeleeStruggles)
				continue;

			if (pClient->IsAutoPunching)
				continue;

			if (pClient->Powerstruggles)
				continue;

			if (pClient->GetAutoPunched)
				continue;

			if (FVisible(pPlayer->v.origin, pEdict))
			{
				// decrease damage for an ent that's farther from the bomb.
				flAdjustedDamage = Dist * FallOff;
				flAdjustedDamage = Damage - flAdjustedDamage;

				UTIL_DamagePlayer(pEdict, pPlayer, "Self destruct", Damage);
			}
		}
	}
}

void ActivateBeamCam(edict_t *pEdict)
{
	edict_t *pAttack = pAttackManager->SearchLastAttack(pEdict);

	if (IsNull(pAttack))
		return;

	if (!IsBeamAttack(pAttack))
		return;

	pBeamCam = UTIL_CreateEnt("info_target", pAttack->v.origin, pAttack->v.v_angle,
							   pEdict);

	if (!pBeamCam)
		return;

	pBeamCam->pev->takedamage = DAMAGE_NO;
	pBeamCam->pev->solid = SOLID_NOT;
	pBeamCam->pev->movetype = MOVETYPE_FLY;
	pBeamCam->pev->classname = MAKE_STRING("playercam");
	pBeamCam->pev->nextthink = gpGlobals->time;
	pBeamCam->pev->renderamt = 0;

	SET_MODEL(pBeamCam->edict(), "models/mechgibs.mdl");
	SET_VIEW(pEdict, pBeamCam->edict());

	pBeamViewEnt = pAttack;
}

void DeactivateBeamCam(edict_t *pEdict)
{
	pBeamCam->pev->flags |= FL_KILLME;

	SET_VIEW(pEdict, pEdict);

	pBeamViewEnt = NULL;
}
