/*
    ***********************************************************************************
    *                                      combo.h                                    *
	***********************************************************************************
*/


#ifndef combo_h
#define combo_h

#include "bot.h"
#include "tasks.h"

enum ComboActions
{
	teleport1,
	teleport2,
	teleport3,
	EscapeTeleport,

	ChargeGenBall,
	startswoop,
	stopswoop,
	teleswoop1,
	stopfly,
	kickenemy,

	pressforward,
	pressforward2,
	pressback,
	pressleft,
	pressright,
	pressjump,
	pressduck,

	falldown,
	ascend,
	powerup,
	CheckFOVForAim
};

struct ComboList_t
{
	ComboActions ComboAction;
	float delay;
	int TeleDir;
	float TeleDelay;
	float poweruptime;
	float LifeTime;
	float StartTime;
	ComboList_t *next;

	ComboList_t()
	{
		delay = TeleDelay = poweruptime = LifeTime = StartTime = 0.0;
		TeleDir = 0;
		next = NULL;
	}
};

enum ComboTypes
{
	TeleLeftBackMelee = 1,
	TeleRightBackMelee,
	TeleBackMelee,
	TeleLeftMelee,
	TeleRightMelee,
	TeleUpMelee,
	TeleDownMelee,
	TeleForwardLeftMelee,
	TeleForwardRightMelee,
	MultipleTeleport,
	telemelee1, 
	telemelee2,
	telemelee3,
	telemelee4,
	telemelee5,
	teletwice,
	teleattack,
	teleattack2,
	teleback,
	teleforward,
	powerupmelee,
	powerupattack,
	powerupattack2,
	ChargeGBallSwoop,

	startforwardswoop,
	startbackwardswoop,
	startleftswoop,
	startrightswoop,
	startupswoop,
	startdownswoop,

	fallpowerup,
	fallascend,

	telekick,
	swoopforward
};

class BotCombo
{
	ComboList_t *ComboList;
	ComboList_t *LastCombo;
	bot_t *pBot;

	float SwoopLifeTime;
	short SwoopDir;

public:
	ComboList_t *CurrentCombo;
	bool Activated;
	State state;
	ETaskCode FinishingTask;

	BotCombo(bot_t *pB,ComboTypes CT) : ComboList(NULL), LastCombo(NULL), SwoopLifeTime(0.0),
										pBot(pB), SwoopDir(0), CurrentCombo(NULL),
										Activated(false), state(not_started), 
										FinishingTask(TaskNone)
	{
		MakeComboList(CT);
	};
	~BotCombo(void);

	void AddCombo(ComboList_t *CL);
	bool PushCombo(void);
	void Delete_Combos(ComboList_t *CL);
	void DoCombo(void);
	void MakeComboList(ComboTypes CT);

	//bool MakeLeftTeleports(void);
	//bool MakeRightTeleports(void);

	bool MakeTeleports(TeleDir TeleDirLR, TeleDir TeleDirBF, TeleDir TeleDirUD);
	void MakePowerup(void);

	float GetSwoopLifeTime(short SDir);
	void SetSwoopDir(short SDir);

	void Activate(void);
};

void MakeCombo(bot_t *pBot, ComboTypes CT);
void DeleteCombos(bot_t *pBot);
void DebugComboTeleDirs(int IdealDir);
short GetTeleCountForTeleMelee4(bot_t *pBot);
bool MakeTeleMelee(bot_t *pBot, float flEnemyDist);

#endif
