#include "general_header.h"

// Base sub task
CBaseSubTask::CBaseSubTask(bot_t *pB)
{
	pBot = pB;
	pEdict = pB->pEdict;
}

CBaseSubTask::~CBaseSubTask()
{
	pBot = NULL;
	pEdict = NULL;
}

// Aim at enemy task
CAimAtEnemySubTask::CAimAtEnemySubTask(bot_t *pB) : CBaseSubTask(pB)
{
}
void CAimAtEnemySubTask::TaskThink()
{
	if (UTIL_IsValidPlayer(pBot->pBotEnemy))
	{
		Vector v_src = pEdict->v.origin;

		Vector AimVec = UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - v_src);
		pBot->AimVec = WrapAngles(AimVec);
	}
}

// Combat movement task
CCombatMovementSubTask::CCombatMovementSubTask(bot_t *pB) : CBaseSubTask(pB)
{
}

void CCombatMovementSubTask::TaskThink()
{
	if (UTIL_IsValidPlayer(pBot->pBotEnemy))
	{
		BotCombatMovement(pBot);
	}
}

// Manage best enemy in list sub task
CManageEnemySubTask::CManageEnemySubTask(bot_t *pB) : CBaseSubTask(pB)
{
}

void CManageEnemySubTask::TaskThink()
{
	pBot->pBotEnemy = GetBestEnemyFromList(pBot);
}
